-- ---------------------------------
-- Do not edit this file manually --
-- ---------------------------------



DELETE FROM DATABASECHANGELOG WHERE FILENAME = 'nschema/audit-table-enable.xml' OR FILENAME = 'nschema/audit-table-custom-migrate.xml'
GO

INSERT INTO ekp_audit_version (dblevel) VALUES (2311)
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('audit2311-install', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1030, '8:73144665b094e3664b069462de1b8a01', 'insert tableName=ekp_audit_version', '', 'EXECUTED', '(audit and 93)', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-learningObject::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_learningObject'
			)
			DROP TRIGGER i_learningObject
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_learningObject'
			)
			DROP TRIGGER u_learningObject
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_learningObject'
			)
			DROP TRIGGER d_learningObject
GO

CREATE TABLE learningObject_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_learningObject_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), learningType nvarchar(1), mediaid smallint, subject int, title nvarchar(255), description1 nvarchar(MAX), hyperlink nvarchar(500), assignedChatRoom nvarchar(30), assignedForum numeric(16, 0), editcontrol smallint, showInCatalog nvarchar(1), allowPeerReview nvarchar(1), datecreated datetime, autoDelete nvarchar(1), deleteDate datetime, picture varchar(500), evaluation nvarchar(85), evalRequired nvarchar(1), duration nvarchar(100), policyid nvarchar(15), org_policy_override char(1), prereqcontrol int, testRequired char(1), startAvailabilityDate datetime, endAvailabilityDate datetime, vendorname varchar(100), allowReopen char(1), testEnablesCompletion char(1), enforcePrePostTestOrder char(1), completionTimeLimit int, allowReEnroll char(1), historyExpireWindow int, display_course_interest char(1), wikiURL varchar(255), supervisorAssessment nvarchar(85), allowDappraiserAssess char(1), sticky char(1), creator_uid nvarchar(85), mekp_target char(1), update_meaning nvarchar(8), wiki_key nvarchar(255), wiki_display char(1), archived char(1), auto_archive_date datetime, show_expiration_date datetime, show_begin_date datetime, subject_category_id nvarchar(15), require_esignature char(1), support_contact nvarchar(4000), domain_id nvarchar(15), allow_auto_recommend char(1), allowSupervisorAssess char(1), esig_course_withdraw char(1), esig_course_modify char(1), esig_course_launch char(1), esig_course_import char(1), esig_course_finish char(1), esig_exam_launch char(1), esig_wizard_modify_trans char(1), esig_reviewer_modify_trans char(1), esig_editor_modify_trans char(1), esig_modify_attendance char(1), esig_course_withdraw_meaning nvarchar(MAX), esig_course_modify_meaning nvarchar(MAX), esig_course_launch_meaning nvarchar(MAX), esig_course_import_meaning nvarchar(MAX), esig_course_finish_meaning nvarchar(MAX), esig_exam_launch_meaning nvarchar(MAX), esig_wzrd_modify_trans_meaning nvarchar(MAX), esig_rvwr_modify_trans_meaning nvarchar(MAX), esig_edtr_modify_trans_meaning nvarchar(MAX), esig_modify_attendance_meaning nvarchar(MAX), esig_equi_rule char(1), esig_equi_rule_meaning nvarchar(MAX), title_key nvarchar(85), description_key nvarchar(85), support_contact_key nvarchar(85), display_learning_id nvarchar(85), evaluation_lang_option nvarchar(85), supervisorAssessment_lang_opt nvarchar(85), use_policy_to_select_session char(1), custom_coursepolicy_type nvarchar(5), disable_selfenroll_maxlimit char(1), learning_validity int, assigned_forum_type char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_LEARNINGOBJECT_AUD PRIMARY KEY (aud_id))
GO

insert into learningObject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,learningType
 ,mediaid
 ,subject
 ,title
 ,description1
 ,hyperlink
 ,assignedChatRoom
 ,assignedForum
 ,editcontrol
 ,showInCatalog
 ,allowPeerReview
 ,datecreated
 ,autoDelete
 ,deleteDate
 ,picture
 ,evaluation
 ,evalRequired
 ,duration
 ,policyid
 ,org_policy_override
 ,prereqcontrol
 ,testRequired
 ,startAvailabilityDate
 ,endAvailabilityDate
 ,vendorname
 ,allowReopen
 ,testEnablesCompletion
 ,enforcePrePostTestOrder
 ,completionTimeLimit
 ,allowReEnroll
 ,historyExpireWindow
 ,display_course_interest
 ,wikiURL
 ,supervisorAssessment
 ,allowDappraiserAssess
 ,sticky
 ,creator_uid
 ,mekp_target
 ,update_meaning
 ,wiki_key
 ,wiki_display
 ,archived
 ,auto_archive_date
 ,show_expiration_date
 ,show_begin_date
 ,subject_category_id
 ,require_esignature
 ,support_contact
 ,domain_id
 ,allow_auto_recommend
 ,allowSupervisorAssess
 ,esig_course_withdraw
 ,esig_course_modify
 ,esig_course_launch
 ,esig_course_import
 ,esig_course_finish
 ,esig_exam_launch
 ,esig_wizard_modify_trans
 ,esig_reviewer_modify_trans
 ,esig_editor_modify_trans
 ,esig_modify_attendance
 ,esig_course_withdraw_meaning
 ,esig_course_modify_meaning
 ,esig_course_launch_meaning
 ,esig_course_import_meaning
 ,esig_course_finish_meaning
 ,esig_exam_launch_meaning
 ,esig_wzrd_modify_trans_meaning
 ,esig_rvwr_modify_trans_meaning
 ,esig_edtr_modify_trans_meaning
 ,esig_modify_attendance_meaning
 ,esig_equi_rule
 ,esig_equi_rule_meaning
 ,title_key
 ,description_key
 ,support_contact_key
 ,display_learning_id
 ,evaluation_lang_option
 ,supervisorAssessment_lang_opt
 ,use_policy_to_select_session
 ,custom_coursepolicy_type
 ,disable_selfenroll_maxlimit
 ,learning_validity
 ,assigned_forum_type
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,learningType
 ,mediaid
 ,subject
 ,title
 ,description1
 ,hyperlink
 ,assignedChatRoom
 ,assignedForum
 ,editcontrol
 ,showInCatalog
 ,allowPeerReview
 ,datecreated
 ,autoDelete
 ,deleteDate
 ,picture
 ,evaluation
 ,evalRequired
 ,duration
 ,policyid
 ,org_policy_override
 ,prereqcontrol
 ,testRequired
 ,startAvailabilityDate
 ,endAvailabilityDate
 ,vendorname
 ,allowReopen
 ,testEnablesCompletion
 ,enforcePrePostTestOrder
 ,completionTimeLimit
 ,allowReEnroll
 ,historyExpireWindow
 ,display_course_interest
 ,wikiURL
 ,supervisorAssessment
 ,allowDappraiserAssess
 ,sticky
 ,creator_uid
 ,mekp_target
 ,update_meaning
 ,wiki_key
 ,wiki_display
 ,archived
 ,auto_archive_date
 ,show_expiration_date
 ,show_begin_date
 ,subject_category_id
 ,require_esignature
 ,support_contact
 ,domain_id
 ,allow_auto_recommend
 ,allowSupervisorAssess
 ,esig_course_withdraw
 ,esig_course_modify
 ,esig_course_launch
 ,esig_course_import
 ,esig_course_finish
 ,esig_exam_launch
 ,esig_wizard_modify_trans
 ,esig_reviewer_modify_trans
 ,esig_editor_modify_trans
 ,esig_modify_attendance
 ,esig_course_withdraw_meaning
 ,esig_course_modify_meaning
 ,esig_course_launch_meaning
 ,esig_course_import_meaning
 ,esig_course_finish_meaning
 ,esig_exam_launch_meaning
 ,esig_wzrd_modify_trans_meaning
 ,esig_rvwr_modify_trans_meaning
 ,esig_edtr_modify_trans_meaning
 ,esig_modify_attendance_meaning
 ,esig_equi_rule
 ,esig_equi_rule_meaning
 ,title_key
 ,description_key
 ,support_contact_key
 ,display_learning_id
 ,evaluation_lang_option
 ,supervisorAssessment_lang_opt
 ,use_policy_to_select_session
 ,custom_coursepolicy_type
 ,disable_selfenroll_maxlimit
 ,learning_validity
 ,assigned_forum_type
  from learningObject
GO

CREATE INDEX nuk_learningObject_aud_1 ON learningObject_aud(aud_userid)
GO

CREATE INDEX nuk_learningObject_aud_2 ON learningObject_aud(aud_datetime)
GO

create trigger i_learningObject on learningObject
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into learningObject (
learningid,learningType,mediaid,subject,title,description1,hyperlink,assignedChatRoom,assignedForum,editcontrol,showInCatalog,allowPeerReview,datecreated,autoDelete,deleteDate,picture,evaluation,evalRequired,duration,policyid,org_policy_override,prereqcontrol,testRequired,startAvailabilityDate,endAvailabilityDate,vendorname,allowReopen,testEnablesCompletion,enforcePrePostTestOrder,completionTimeLimit,allowReEnroll,historyExpireWindow,display_course_interest,wikiURL,supervisorAssessment,allowDappraiserAssess,sticky,creator_uid,last_updated,last_updater_uid,mekp_target,update_meaning,wiki_key,wiki_display,archived,updater_legal_name,update_meaning_text,auto_archive_date,show_expiration_date,show_begin_date,subject_category_id,require_esignature,support_contact,domain_id,allow_auto_recommend,allowSupervisorAssess,esig_course_withdraw,esig_course_modify,esig_course_launch,esig_course_import,esig_course_finish,esig_exam_launch,esig_wizard_modify_trans,esig_reviewer_modify_trans,esig_editor_modify_trans,esig_modify_attendance,esig_course_withdraw_meaning,esig_course_modify_meaning,esig_course_launch_meaning,esig_course_import_meaning,esig_course_finish_meaning,esig_exam_launch_meaning,esig_wzrd_modify_trans_meaning,esig_rvwr_modify_trans_meaning,esig_edtr_modify_trans_meaning,esig_modify_attendance_meaning,esig_equi_rule,esig_equi_rule_meaning,title_key,description_key,support_contact_key,display_learning_id,evaluation_lang_option,supervisorAssessment_lang_opt,use_policy_to_select_session,custom_coursepolicy_type,disable_selfenroll_maxlimit,learning_validity,assigned_forum_type) select learningid,learningType,mediaid,subject,title,description1,hyperlink,assignedChatRoom,assignedForum,editcontrol,showInCatalog,allowPeerReview,datecreated,autoDelete,deleteDate,picture,evaluation,evalRequired,duration,policyid,org_policy_override,prereqcontrol,testRequired,startAvailabilityDate,endAvailabilityDate,vendorname,allowReopen,testEnablesCompletion,enforcePrePostTestOrder,completionTimeLimit,allowReEnroll,historyExpireWindow,display_course_interest,wikiURL,supervisorAssessment,allowDappraiserAssess,sticky,creator_uid,last_updated,last_updater_uid,mekp_target,update_meaning,wiki_key,wiki_display,archived,updater_legal_name,update_meaning_text,auto_archive_date,show_expiration_date,show_begin_date,subject_category_id,require_esignature,support_contact,domain_id,allow_auto_recommend,allowSupervisorAssess,esig_course_withdraw,esig_course_modify,esig_course_launch,esig_course_import,esig_course_finish,esig_exam_launch,esig_wizard_modify_trans,esig_reviewer_modify_trans,esig_editor_modify_trans,esig_modify_attendance,esig_course_withdraw_meaning,esig_course_modify_meaning,esig_course_launch_meaning,esig_course_import_meaning,esig_course_finish_meaning,esig_exam_launch_meaning,esig_wzrd_modify_trans_meaning,esig_rvwr_modify_trans_meaning,esig_edtr_modify_trans_meaning,esig_modify_attendance_meaning,esig_equi_rule,esig_equi_rule_meaning,title_key,description_key,support_contact_key,display_learning_id,evaluation_lang_option,supervisorAssessment_lang_opt,use_policy_to_select_session,custom_coursepolicy_type,disable_selfenroll_maxlimit,learning_validity,assigned_forum_type from inserted
insert into learningObject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,learningType
 ,mediaid
 ,subject
 ,title
 ,description1
 ,hyperlink
 ,assignedChatRoom
 ,assignedForum
 ,editcontrol
 ,showInCatalog
 ,allowPeerReview
 ,datecreated
 ,autoDelete
 ,deleteDate
 ,picture
 ,evaluation
 ,evalRequired
 ,duration
 ,policyid
 ,org_policy_override
 ,prereqcontrol
 ,testRequired
 ,startAvailabilityDate
 ,endAvailabilityDate
 ,vendorname
 ,allowReopen
 ,testEnablesCompletion
 ,enforcePrePostTestOrder
 ,completionTimeLimit
 ,allowReEnroll
 ,historyExpireWindow
 ,display_course_interest
 ,wikiURL
 ,supervisorAssessment
 ,allowDappraiserAssess
 ,sticky
 ,creator_uid
 ,mekp_target
 ,update_meaning
 ,wiki_key
 ,wiki_display
 ,archived
 ,auto_archive_date
 ,show_expiration_date
 ,show_begin_date
 ,subject_category_id
 ,require_esignature
 ,support_contact
 ,domain_id
 ,allow_auto_recommend
 ,allowSupervisorAssess
 ,esig_course_withdraw
 ,esig_course_modify
 ,esig_course_launch
 ,esig_course_import
 ,esig_course_finish
 ,esig_exam_launch
 ,esig_wizard_modify_trans
 ,esig_reviewer_modify_trans
 ,esig_editor_modify_trans
 ,esig_modify_attendance
 ,esig_course_withdraw_meaning
 ,esig_course_modify_meaning
 ,esig_course_launch_meaning
 ,esig_course_import_meaning
 ,esig_course_finish_meaning
 ,esig_exam_launch_meaning
 ,esig_wzrd_modify_trans_meaning
 ,esig_rvwr_modify_trans_meaning
 ,esig_edtr_modify_trans_meaning
 ,esig_modify_attendance_meaning
 ,esig_equi_rule
 ,esig_equi_rule_meaning
 ,title_key
 ,description_key
 ,support_contact_key
 ,display_learning_id
 ,evaluation_lang_option
 ,supervisorAssessment_lang_opt
 ,use_policy_to_select_session
 ,custom_coursepolicy_type
 ,disable_selfenroll_maxlimit
 ,learning_validity
 ,assigned_forum_type
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,learningType
 ,mediaid
 ,subject
 ,title
 ,description1
 ,hyperlink
 ,assignedChatRoom
 ,assignedForum
 ,editcontrol
 ,showInCatalog
 ,allowPeerReview
 ,datecreated
 ,autoDelete
 ,deleteDate
 ,picture
 ,evaluation
 ,evalRequired
 ,duration
 ,policyid
 ,org_policy_override
 ,prereqcontrol
 ,testRequired
 ,startAvailabilityDate
 ,endAvailabilityDate
 ,vendorname
 ,allowReopen
 ,testEnablesCompletion
 ,enforcePrePostTestOrder
 ,completionTimeLimit
 ,allowReEnroll
 ,historyExpireWindow
 ,display_course_interest
 ,wikiURL
 ,supervisorAssessment
 ,allowDappraiserAssess
 ,sticky
 ,creator_uid
 ,mekp_target
 ,update_meaning
 ,wiki_key
 ,wiki_display
 ,archived
 ,auto_archive_date
 ,show_expiration_date
 ,show_begin_date
 ,subject_category_id
 ,require_esignature
 ,support_contact
 ,domain_id
 ,allow_auto_recommend
 ,allowSupervisorAssess
 ,esig_course_withdraw
 ,esig_course_modify
 ,esig_course_launch
 ,esig_course_import
 ,esig_course_finish
 ,esig_exam_launch
 ,esig_wizard_modify_trans
 ,esig_reviewer_modify_trans
 ,esig_editor_modify_trans
 ,esig_modify_attendance
 ,esig_course_withdraw_meaning
 ,esig_course_modify_meaning
 ,esig_course_launch_meaning
 ,esig_course_import_meaning
 ,esig_course_finish_meaning
 ,esig_exam_launch_meaning
 ,esig_wzrd_modify_trans_meaning
 ,esig_rvwr_modify_trans_meaning
 ,esig_edtr_modify_trans_meaning
 ,esig_modify_attendance_meaning
 ,esig_equi_rule
 ,esig_equi_rule_meaning
 ,title_key
 ,description_key
 ,support_contact_key
 ,display_learning_id
 ,evaluation_lang_option
 ,supervisorAssessment_lang_opt
 ,use_policy_to_select_session
 ,custom_coursepolicy_type
 ,disable_selfenroll_maxlimit
 ,learning_validity
 ,assigned_forum_type
  from inserted
end
GO

create trigger u_learningObject on learningObject
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update learningObject set
learningObject.learningid = inserted.learningid,learningObject.learningType = inserted.learningType,learningObject.mediaid = inserted.mediaid,learningObject.subject = inserted.subject,learningObject.title = inserted.title,learningObject.description1 = inserted.description1,learningObject.hyperlink = inserted.hyperlink,learningObject.assignedChatRoom = inserted.assignedChatRoom,learningObject.assignedForum = inserted.assignedForum,learningObject.editcontrol = inserted.editcontrol,learningObject.showInCatalog = inserted.showInCatalog,learningObject.allowPeerReview = inserted.allowPeerReview,learningObject.datecreated = inserted.datecreated,learningObject.autoDelete = inserted.autoDelete,learningObject.deleteDate = inserted.deleteDate,learningObject.picture = inserted.picture,learningObject.evaluation = inserted.evaluation,learningObject.evalRequired = inserted.evalRequired,learningObject.duration = inserted.duration,learningObject.policyid = inserted.policyid,learningObject.org_policy_override = inserted.org_policy_override,learningObject.prereqcontrol = inserted.prereqcontrol,learningObject.testRequired = inserted.testRequired,learningObject.startAvailabilityDate = inserted.startAvailabilityDate,learningObject.endAvailabilityDate = inserted.endAvailabilityDate,learningObject.vendorname = inserted.vendorname,learningObject.allowReopen = inserted.allowReopen,learningObject.testEnablesCompletion = inserted.testEnablesCompletion,learningObject.enforcePrePostTestOrder = inserted.enforcePrePostTestOrder,learningObject.completionTimeLimit = inserted.completionTimeLimit,learningObject.allowReEnroll = inserted.allowReEnroll,learningObject.historyExpireWindow = inserted.historyExpireWindow,learningObject.display_course_interest = inserted.display_course_interest,learningObject.wikiURL = inserted.wikiURL,learningObject.supervisorAssessment = inserted.supervisorAssessment,learningObject.allowDappraiserAssess = inserted.allowDappraiserAssess,learningObject.sticky = inserted.sticky,learningObject.creator_uid = inserted.creator_uid,learningObject.last_updated = inserted.last_updated,learningObject.last_updater_uid = inserted.last_updater_uid,learningObject.mekp_target = inserted.mekp_target,learningObject.update_meaning = inserted.update_meaning,learningObject.wiki_key = inserted.wiki_key,learningObject.wiki_display = inserted.wiki_display,learningObject.archived = inserted.archived,learningObject.updater_legal_name = inserted.updater_legal_name,learningObject.update_meaning_text = inserted.update_meaning_text,learningObject.auto_archive_date = inserted.auto_archive_date,learningObject.show_expiration_date = inserted.show_expiration_date,learningObject.show_begin_date = inserted.show_begin_date,learningObject.subject_category_id = inserted.subject_category_id,learningObject.require_esignature = inserted.require_esignature,learningObject.support_contact = inserted.support_contact,learningObject.domain_id = inserted.domain_id,learningObject.allow_auto_recommend = inserted.allow_auto_recommend,learningObject.allowSupervisorAssess = inserted.allowSupervisorAssess,learningObject.esig_course_withdraw = inserted.esig_course_withdraw,learningObject.esig_course_modify = inserted.esig_course_modify,learningObject.esig_course_launch = inserted.esig_course_launch,learningObject.esig_course_import = inserted.esig_course_import,learningObject.esig_course_finish = inserted.esig_course_finish,learningObject.esig_exam_launch = inserted.esig_exam_launch,learningObject.esig_wizard_modify_trans = inserted.esig_wizard_modify_trans,learningObject.esig_reviewer_modify_trans = inserted.esig_reviewer_modify_trans,learningObject.esig_editor_modify_trans = inserted.esig_editor_modify_trans,learningObject.esig_modify_attendance = inserted.esig_modify_attendance,learningObject.esig_course_withdraw_meaning = inserted.esig_course_withdraw_meaning,learningObject.esig_course_modify_meaning = inserted.esig_course_modify_meaning,learningObject.esig_course_launch_meaning = inserted.esig_course_launch_meaning,learningObject.esig_course_import_meaning = inserted.esig_course_import_meaning,learningObject.esig_course_finish_meaning = inserted.esig_course_finish_meaning,learningObject.esig_exam_launch_meaning = inserted.esig_exam_launch_meaning,learningObject.esig_wzrd_modify_trans_meaning = inserted.esig_wzrd_modify_trans_meaning,learningObject.esig_rvwr_modify_trans_meaning = inserted.esig_rvwr_modify_trans_meaning,learningObject.esig_edtr_modify_trans_meaning = inserted.esig_edtr_modify_trans_meaning,learningObject.esig_modify_attendance_meaning = inserted.esig_modify_attendance_meaning,learningObject.esig_equi_rule = inserted.esig_equi_rule,learningObject.esig_equi_rule_meaning = inserted.esig_equi_rule_meaning,learningObject.title_key = inserted.title_key,learningObject.description_key = inserted.description_key,learningObject.support_contact_key = inserted.support_contact_key,learningObject.display_learning_id = inserted.display_learning_id,learningObject.evaluation_lang_option = inserted.evaluation_lang_option,learningObject.supervisorAssessment_lang_opt = inserted.supervisorAssessment_lang_opt,learningObject.use_policy_to_select_session = inserted.use_policy_to_select_session,learningObject.custom_coursepolicy_type = inserted.custom_coursepolicy_type,learningObject.disable_selfenroll_maxlimit = inserted.disable_selfenroll_maxlimit,learningObject.learning_validity = inserted.learning_validity,learningObject.assigned_forum_type = inserted.assigned_forum_type
from learningObject inner join deleted on learningObject.learningid = deleted.learningid inner join inserted on learningObject.learningid = inserted.learningid
insert into learningObject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,learningType
 ,mediaid
 ,subject
 ,title
 ,description1
 ,hyperlink
 ,assignedChatRoom
 ,assignedForum
 ,editcontrol
 ,showInCatalog
 ,allowPeerReview
 ,datecreated
 ,autoDelete
 ,deleteDate
 ,picture
 ,evaluation
 ,evalRequired
 ,duration
 ,policyid
 ,org_policy_override
 ,prereqcontrol
 ,testRequired
 ,startAvailabilityDate
 ,endAvailabilityDate
 ,vendorname
 ,allowReopen
 ,testEnablesCompletion
 ,enforcePrePostTestOrder
 ,completionTimeLimit
 ,allowReEnroll
 ,historyExpireWindow
 ,display_course_interest
 ,wikiURL
 ,supervisorAssessment
 ,allowDappraiserAssess
 ,sticky
 ,creator_uid
 ,mekp_target
 ,update_meaning
 ,wiki_key
 ,wiki_display
 ,archived
 ,auto_archive_date
 ,show_expiration_date
 ,show_begin_date
 ,subject_category_id
 ,require_esignature
 ,support_contact
 ,domain_id
 ,allow_auto_recommend
 ,allowSupervisorAssess
 ,esig_course_withdraw
 ,esig_course_modify
 ,esig_course_launch
 ,esig_course_import
 ,esig_course_finish
 ,esig_exam_launch
 ,esig_wizard_modify_trans
 ,esig_reviewer_modify_trans
 ,esig_editor_modify_trans
 ,esig_modify_attendance
 ,esig_course_withdraw_meaning
 ,esig_course_modify_meaning
 ,esig_course_launch_meaning
 ,esig_course_import_meaning
 ,esig_course_finish_meaning
 ,esig_exam_launch_meaning
 ,esig_wzrd_modify_trans_meaning
 ,esig_rvwr_modify_trans_meaning
 ,esig_edtr_modify_trans_meaning
 ,esig_modify_attendance_meaning
 ,esig_equi_rule
 ,esig_equi_rule_meaning
 ,title_key
 ,description_key
 ,support_contact_key
 ,display_learning_id
 ,evaluation_lang_option
 ,supervisorAssessment_lang_opt
 ,use_policy_to_select_session
 ,custom_coursepolicy_type
 ,disable_selfenroll_maxlimit
 ,learning_validity
 ,assigned_forum_type
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,learningType
 ,mediaid
 ,subject
 ,title
 ,description1
 ,hyperlink
 ,assignedChatRoom
 ,assignedForum
 ,editcontrol
 ,showInCatalog
 ,allowPeerReview
 ,datecreated
 ,autoDelete
 ,deleteDate
 ,picture
 ,evaluation
 ,evalRequired
 ,duration
 ,policyid
 ,org_policy_override
 ,prereqcontrol
 ,testRequired
 ,startAvailabilityDate
 ,endAvailabilityDate
 ,vendorname
 ,allowReopen
 ,testEnablesCompletion
 ,enforcePrePostTestOrder
 ,completionTimeLimit
 ,allowReEnroll
 ,historyExpireWindow
 ,display_course_interest
 ,wikiURL
 ,supervisorAssessment
 ,allowDappraiserAssess
 ,sticky
 ,creator_uid
 ,mekp_target
 ,update_meaning
 ,wiki_key
 ,wiki_display
 ,archived
 ,auto_archive_date
 ,show_expiration_date
 ,show_begin_date
 ,subject_category_id
 ,require_esignature
 ,support_contact
 ,domain_id
 ,allow_auto_recommend
 ,allowSupervisorAssess
 ,esig_course_withdraw
 ,esig_course_modify
 ,esig_course_launch
 ,esig_course_import
 ,esig_course_finish
 ,esig_exam_launch
 ,esig_wizard_modify_trans
 ,esig_reviewer_modify_trans
 ,esig_editor_modify_trans
 ,esig_modify_attendance
 ,esig_course_withdraw_meaning
 ,esig_course_modify_meaning
 ,esig_course_launch_meaning
 ,esig_course_import_meaning
 ,esig_course_finish_meaning
 ,esig_exam_launch_meaning
 ,esig_wzrd_modify_trans_meaning
 ,esig_rvwr_modify_trans_meaning
 ,esig_edtr_modify_trans_meaning
 ,esig_modify_attendance_meaning
 ,esig_equi_rule
 ,esig_equi_rule_meaning
 ,title_key
 ,description_key
 ,support_contact_key
 ,display_learning_id
 ,evaluation_lang_option
 ,supervisorAssessment_lang_opt
 ,use_policy_to_select_session
 ,custom_coursepolicy_type
 ,disable_selfenroll_maxlimit
 ,learning_validity
 ,assigned_forum_type
  from inserted
end
GO

create trigger d_learningObject on learningObject
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from learningObject where exists (
select 1 from deleted where learningObject.learningid = deleted.learningid)
insert into learningObject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,learningType
 ,mediaid
 ,subject
 ,title
 ,description1
 ,hyperlink
 ,assignedChatRoom
 ,assignedForum
 ,editcontrol
 ,showInCatalog
 ,allowPeerReview
 ,datecreated
 ,autoDelete
 ,deleteDate
 ,picture
 ,evaluation
 ,evalRequired
 ,duration
 ,policyid
 ,org_policy_override
 ,prereqcontrol
 ,testRequired
 ,startAvailabilityDate
 ,endAvailabilityDate
 ,vendorname
 ,allowReopen
 ,testEnablesCompletion
 ,enforcePrePostTestOrder
 ,completionTimeLimit
 ,allowReEnroll
 ,historyExpireWindow
 ,display_course_interest
 ,wikiURL
 ,supervisorAssessment
 ,allowDappraiserAssess
 ,sticky
 ,creator_uid
 ,mekp_target
 ,update_meaning
 ,wiki_key
 ,wiki_display
 ,archived
 ,auto_archive_date
 ,show_expiration_date
 ,show_begin_date
 ,subject_category_id
 ,require_esignature
 ,support_contact
 ,domain_id
 ,allow_auto_recommend
 ,allowSupervisorAssess
 ,esig_course_withdraw
 ,esig_course_modify
 ,esig_course_launch
 ,esig_course_import
 ,esig_course_finish
 ,esig_exam_launch
 ,esig_wizard_modify_trans
 ,esig_reviewer_modify_trans
 ,esig_editor_modify_trans
 ,esig_modify_attendance
 ,esig_course_withdraw_meaning
 ,esig_course_modify_meaning
 ,esig_course_launch_meaning
 ,esig_course_import_meaning
 ,esig_course_finish_meaning
 ,esig_exam_launch_meaning
 ,esig_wzrd_modify_trans_meaning
 ,esig_rvwr_modify_trans_meaning
 ,esig_edtr_modify_trans_meaning
 ,esig_modify_attendance_meaning
 ,esig_equi_rule
 ,esig_equi_rule_meaning
 ,title_key
 ,description_key
 ,support_contact_key
 ,display_learning_id
 ,evaluation_lang_option
 ,supervisorAssessment_lang_opt
 ,use_policy_to_select_session
 ,custom_coursepolicy_type
 ,disable_selfenroll_maxlimit
 ,learning_validity
 ,assigned_forum_type
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,learningType
 ,mediaid
 ,subject
 ,title
 ,description1
 ,hyperlink
 ,assignedChatRoom
 ,assignedForum
 ,editcontrol
 ,showInCatalog
 ,allowPeerReview
 ,datecreated
 ,autoDelete
 ,deleteDate
 ,picture
 ,evaluation
 ,evalRequired
 ,duration
 ,policyid
 ,org_policy_override
 ,prereqcontrol
 ,testRequired
 ,startAvailabilityDate
 ,endAvailabilityDate
 ,vendorname
 ,allowReopen
 ,testEnablesCompletion
 ,enforcePrePostTestOrder
 ,completionTimeLimit
 ,allowReEnroll
 ,historyExpireWindow
 ,display_course_interest
 ,wikiURL
 ,supervisorAssessment
 ,allowDappraiserAssess
 ,sticky
 ,creator_uid
 ,mekp_target
 ,update_meaning
 ,wiki_key
 ,wiki_display
 ,archived
 ,auto_archive_date
 ,show_expiration_date
 ,show_begin_date
 ,subject_category_id
 ,require_esignature
 ,support_contact
 ,domain_id
 ,allow_auto_recommend
 ,allowSupervisorAssess
 ,esig_course_withdraw
 ,esig_course_modify
 ,esig_course_launch
 ,esig_course_import
 ,esig_course_finish
 ,esig_exam_launch
 ,esig_wizard_modify_trans
 ,esig_reviewer_modify_trans
 ,esig_editor_modify_trans
 ,esig_modify_attendance
 ,esig_course_withdraw_meaning
 ,esig_course_modify_meaning
 ,esig_course_launch_meaning
 ,esig_course_import_meaning
 ,esig_course_finish_meaning
 ,esig_exam_launch_meaning
 ,esig_wzrd_modify_trans_meaning
 ,esig_rvwr_modify_trans_meaning
 ,esig_edtr_modify_trans_meaning
 ,esig_modify_attendance_meaning
 ,esig_equi_rule
 ,esig_equi_rule_meaning
 ,title_key
 ,description_key
 ,support_contact_key
 ,display_learning_id
 ,evaluation_lang_option
 ,supervisorAssessment_lang_opt
 ,use_policy_to_select_session
 ,custom_coursepolicy_type
 ,disable_selfenroll_maxlimit
 ,learning_validity
 ,assigned_forum_type
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-learningObject', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1031, '8:b716039ed525d157384d58c84ffb3a07', 'enableAuditTable auditTableName=learningObject_aud, tableName=learningObject', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-transcript::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_transcript'
			)
			DROP TRIGGER i_transcript
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_transcript'
			)
			DROP TRIGGER u_transcript
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_transcript'
			)
			DROP TRIGGER d_transcript
GO

CREATE TABLE transcript_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_transcript_aud_aud_datetime DEFAULT GETDATE() NOT NULL, transcriptid nvarchar(15), userid nvarchar(85), learningid nvarchar(85), currid nvarchar(85), learningType nvarchar(1), eventid nvarchar(15), startdate datetime, finishdate datetime, finalgrade float(53), studentstatus int, progress nvarchar(10), assessDate datetime, attendance nvarchar(1), perfGradeid smallint, sessionid nvarchar(15), creditTranscriptLink nvarchar(15), curriculumTranscriptLink nvarchar(15), assessmentscore nvarchar(20), requestSource int, contentSessionID nvarchar(15), certSessionID nvarchar(15), enrollmentDate datetime, remindercount int, costcenter nvarchar(45), confirmation_status int, reopen char(1), isOpen char(1), pre_assess_score float(53), post_assess_score float(53), settings_as_of_date datetime, quick_eval int, notifyemail char(85), completion_deadline datetime, deadline_expired nvarchar(1), revision_number int, ntraininghours float(53), allowDappraiserAssess char(1), offline_key nvarchar(32), mekp_sync datetime, send_notif_ew char(1), update_meaning nvarchar(8), creator_uid nvarchar(85), datecreated datetime, curr_total_time nvarchar(25), attempts_allowed int, grading_method char(1), attempts_count int, completion_method char(1), final_score nvarchar(20), allowSupervisorAssess char(1), weightedscore float(53), weighting float(53), sub_learning char(1), actual_training_time_sec int, student_substatus nvarchar(85), is_reqd_custom_attr_complete char(1), bundle_id nvarchar(85), allowBundleSwitch char(1), restricted_start_date datetime, root_transcriptid nvarchar(15), registration char(36), reserve_seat nvarchar(1), percent_completion int, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TRANSCRIPT_AUD PRIMARY KEY (aud_id))
GO

CREATE INDEX nuk_transcript_aud_1 ON transcript_aud(aud_userid)
GO

CREATE INDEX nuk_transcript_aud_2 ON transcript_aud(aud_datetime)
GO

create trigger i_transcript on transcript
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into transcript (
transcriptid,userid,learningid,currid,learningType,eventid,startdate,finishdate,finalgrade,studentstatus,progress,assessDate,attendance,perfGradeid,sessionid,creditTranscriptLink,curriculumTranscriptLink,assessmentscore,requestSource,contentSessionID,certSessionID,enrollmentDate,remindercount,costcenter,confirmation_status,reopen,isOpen,pre_assess_score,post_assess_score,settings_as_of_date,quick_eval,notifyemail,completion_deadline,deadline_expired,revision_number,ntraininghours,allowDappraiserAssess,offline_key,mekp_sync,send_notif_ew,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,creator_uid,datecreated,curr_total_time,attempts_allowed,grading_method,attempts_count,completion_method,final_score,allowSupervisorAssess,weightedscore,weighting,sub_learning,actual_training_time_sec,student_substatus,is_reqd_custom_attr_complete,bundle_id,allowBundleSwitch,restricted_start_date,root_transcriptid,registration,reserve_seat,percent_completion) select transcriptid,userid,learningid,currid,learningType,eventid,startdate,finishdate,finalgrade,studentstatus,progress,assessDate,attendance,perfGradeid,sessionid,creditTranscriptLink,curriculumTranscriptLink,assessmentscore,requestSource,contentSessionID,certSessionID,enrollmentDate,remindercount,costcenter,confirmation_status,reopen,isOpen,pre_assess_score,post_assess_score,settings_as_of_date,quick_eval,notifyemail,completion_deadline,deadline_expired,revision_number,ntraininghours,allowDappraiserAssess,offline_key,mekp_sync,send_notif_ew,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,creator_uid,datecreated,curr_total_time,attempts_allowed,grading_method,attempts_count,completion_method,final_score,allowSupervisorAssess,weightedscore,weighting,sub_learning,actual_training_time_sec,student_substatus,is_reqd_custom_attr_complete,bundle_id,allowBundleSwitch,restricted_start_date,root_transcriptid,registration,reserve_seat,percent_completion from inserted
insert into transcript_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,userid
 ,learningid
 ,currid
 ,learningType
 ,eventid
 ,startdate
 ,finishdate
 ,finalgrade
 ,studentstatus
 ,progress
 ,assessDate
 ,attendance
 ,perfGradeid
 ,sessionid
 ,creditTranscriptLink
 ,curriculumTranscriptLink
 ,assessmentscore
 ,requestSource
 ,contentSessionID
 ,certSessionID
 ,enrollmentDate
 ,remindercount
 ,costcenter
 ,confirmation_status
 ,reopen
 ,isOpen
 ,pre_assess_score
 ,post_assess_score
 ,settings_as_of_date
 ,quick_eval
 ,notifyemail
 ,completion_deadline
 ,deadline_expired
 ,revision_number
 ,ntraininghours
 ,allowDappraiserAssess
 ,offline_key
 ,mekp_sync
 ,send_notif_ew
 ,update_meaning
 ,creator_uid
 ,datecreated
 ,curr_total_time
 ,attempts_allowed
 ,grading_method
 ,attempts_count
 ,completion_method
 ,final_score
 ,allowSupervisorAssess
 ,weightedscore
 ,weighting
 ,sub_learning
 ,actual_training_time_sec
 ,student_substatus
 ,is_reqd_custom_attr_complete
 ,bundle_id
 ,allowBundleSwitch
 ,restricted_start_date
 ,root_transcriptid
 ,registration
 ,reserve_seat
 ,percent_completion
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,userid
 ,learningid
 ,currid
 ,learningType
 ,eventid
 ,startdate
 ,finishdate
 ,finalgrade
 ,studentstatus
 ,progress
 ,assessDate
 ,attendance
 ,perfGradeid
 ,sessionid
 ,creditTranscriptLink
 ,curriculumTranscriptLink
 ,assessmentscore
 ,requestSource
 ,contentSessionID
 ,certSessionID
 ,enrollmentDate
 ,remindercount
 ,costcenter
 ,confirmation_status
 ,reopen
 ,isOpen
 ,pre_assess_score
 ,post_assess_score
 ,settings_as_of_date
 ,quick_eval
 ,notifyemail
 ,completion_deadline
 ,deadline_expired
 ,revision_number
 ,ntraininghours
 ,allowDappraiserAssess
 ,offline_key
 ,mekp_sync
 ,send_notif_ew
 ,update_meaning
 ,creator_uid
 ,datecreated
 ,curr_total_time
 ,attempts_allowed
 ,grading_method
 ,attempts_count
 ,completion_method
 ,final_score
 ,allowSupervisorAssess
 ,weightedscore
 ,weighting
 ,sub_learning
 ,actual_training_time_sec
 ,student_substatus
 ,is_reqd_custom_attr_complete
 ,bundle_id
 ,allowBundleSwitch
 ,restricted_start_date
 ,root_transcriptid
 ,registration
 ,reserve_seat
 ,percent_completion
  from inserted
end
GO

create trigger u_transcript on transcript
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update transcript set
transcript.transcriptid = inserted.transcriptid,transcript.userid = inserted.userid,transcript.learningid = inserted.learningid,transcript.currid = inserted.currid,transcript.learningType = inserted.learningType,transcript.eventid = inserted.eventid,transcript.startdate = inserted.startdate,transcript.finishdate = inserted.finishdate,transcript.finalgrade = inserted.finalgrade,transcript.studentstatus = inserted.studentstatus,transcript.progress = inserted.progress,transcript.assessDate = inserted.assessDate,transcript.attendance = inserted.attendance,transcript.perfGradeid = inserted.perfGradeid,transcript.sessionid = inserted.sessionid,transcript.creditTranscriptLink = inserted.creditTranscriptLink,transcript.curriculumTranscriptLink = inserted.curriculumTranscriptLink,transcript.assessmentscore = inserted.assessmentscore,transcript.requestSource = inserted.requestSource,transcript.contentSessionID = inserted.contentSessionID,transcript.certSessionID = inserted.certSessionID,transcript.enrollmentDate = inserted.enrollmentDate,transcript.remindercount = inserted.remindercount,transcript.costcenter = inserted.costcenter,transcript.confirmation_status = inserted.confirmation_status,transcript.reopen = inserted.reopen,transcript.isOpen = inserted.isOpen,transcript.pre_assess_score = inserted.pre_assess_score,transcript.post_assess_score = inserted.post_assess_score,transcript.settings_as_of_date = inserted.settings_as_of_date,transcript.quick_eval = inserted.quick_eval,transcript.notifyemail = inserted.notifyemail,transcript.completion_deadline = inserted.completion_deadline,transcript.deadline_expired = inserted.deadline_expired,transcript.revision_number = inserted.revision_number,transcript.ntraininghours = inserted.ntraininghours,transcript.allowDappraiserAssess = inserted.allowDappraiserAssess,transcript.offline_key = inserted.offline_key,transcript.mekp_sync = inserted.mekp_sync,transcript.send_notif_ew = inserted.send_notif_ew,transcript.update_meaning = inserted.update_meaning,transcript.last_updated = inserted.last_updated,transcript.updater_legal_name = inserted.updater_legal_name,transcript.update_meaning_text = inserted.update_meaning_text,transcript.last_updater_uid = inserted.last_updater_uid,transcript.creator_uid = inserted.creator_uid,transcript.datecreated = inserted.datecreated,transcript.curr_total_time = inserted.curr_total_time,transcript.attempts_allowed = inserted.attempts_allowed,transcript.grading_method = inserted.grading_method,transcript.attempts_count = inserted.attempts_count,transcript.completion_method = inserted.completion_method,transcript.final_score = inserted.final_score,transcript.allowSupervisorAssess = inserted.allowSupervisorAssess,transcript.weightedscore = inserted.weightedscore,transcript.weighting = inserted.weighting,transcript.sub_learning = inserted.sub_learning,transcript.actual_training_time_sec = inserted.actual_training_time_sec,transcript.student_substatus = inserted.student_substatus,transcript.is_reqd_custom_attr_complete = inserted.is_reqd_custom_attr_complete,transcript.bundle_id = inserted.bundle_id,transcript.allowBundleSwitch = inserted.allowBundleSwitch,transcript.restricted_start_date = inserted.restricted_start_date,transcript.root_transcriptid = inserted.root_transcriptid,transcript.registration = inserted.registration,transcript.reserve_seat = inserted.reserve_seat,transcript.percent_completion = inserted.percent_completion
from transcript inner join deleted on transcript.transcriptid = deleted.transcriptid inner join inserted on transcript.transcriptid = inserted.transcriptid
insert into transcript_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,userid
 ,learningid
 ,currid
 ,learningType
 ,eventid
 ,startdate
 ,finishdate
 ,finalgrade
 ,studentstatus
 ,progress
 ,assessDate
 ,attendance
 ,perfGradeid
 ,sessionid
 ,creditTranscriptLink
 ,curriculumTranscriptLink
 ,assessmentscore
 ,requestSource
 ,contentSessionID
 ,certSessionID
 ,enrollmentDate
 ,remindercount
 ,costcenter
 ,confirmation_status
 ,reopen
 ,isOpen
 ,pre_assess_score
 ,post_assess_score
 ,settings_as_of_date
 ,quick_eval
 ,notifyemail
 ,completion_deadline
 ,deadline_expired
 ,revision_number
 ,ntraininghours
 ,allowDappraiserAssess
 ,offline_key
 ,mekp_sync
 ,send_notif_ew
 ,update_meaning
 ,creator_uid
 ,datecreated
 ,curr_total_time
 ,attempts_allowed
 ,grading_method
 ,attempts_count
 ,completion_method
 ,final_score
 ,allowSupervisorAssess
 ,weightedscore
 ,weighting
 ,sub_learning
 ,actual_training_time_sec
 ,student_substatus
 ,is_reqd_custom_attr_complete
 ,bundle_id
 ,allowBundleSwitch
 ,restricted_start_date
 ,root_transcriptid
 ,registration
 ,reserve_seat
 ,percent_completion
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,userid
 ,learningid
 ,currid
 ,learningType
 ,eventid
 ,startdate
 ,finishdate
 ,finalgrade
 ,studentstatus
 ,progress
 ,assessDate
 ,attendance
 ,perfGradeid
 ,sessionid
 ,creditTranscriptLink
 ,curriculumTranscriptLink
 ,assessmentscore
 ,requestSource
 ,contentSessionID
 ,certSessionID
 ,enrollmentDate
 ,remindercount
 ,costcenter
 ,confirmation_status
 ,reopen
 ,isOpen
 ,pre_assess_score
 ,post_assess_score
 ,settings_as_of_date
 ,quick_eval
 ,notifyemail
 ,completion_deadline
 ,deadline_expired
 ,revision_number
 ,ntraininghours
 ,allowDappraiserAssess
 ,offline_key
 ,mekp_sync
 ,send_notif_ew
 ,update_meaning
 ,creator_uid
 ,datecreated
 ,curr_total_time
 ,attempts_allowed
 ,grading_method
 ,attempts_count
 ,completion_method
 ,final_score
 ,allowSupervisorAssess
 ,weightedscore
 ,weighting
 ,sub_learning
 ,actual_training_time_sec
 ,student_substatus
 ,is_reqd_custom_attr_complete
 ,bundle_id
 ,allowBundleSwitch
 ,restricted_start_date
 ,root_transcriptid
 ,registration
 ,reserve_seat
 ,percent_completion
  from inserted
end
GO

create trigger d_transcript on transcript
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from transcript where exists (
select 1 from deleted where transcript.transcriptid = deleted.transcriptid)
insert into transcript_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,userid
 ,learningid
 ,currid
 ,learningType
 ,eventid
 ,startdate
 ,finishdate
 ,finalgrade
 ,studentstatus
 ,progress
 ,assessDate
 ,attendance
 ,perfGradeid
 ,sessionid
 ,creditTranscriptLink
 ,curriculumTranscriptLink
 ,assessmentscore
 ,requestSource
 ,contentSessionID
 ,certSessionID
 ,enrollmentDate
 ,remindercount
 ,costcenter
 ,confirmation_status
 ,reopen
 ,isOpen
 ,pre_assess_score
 ,post_assess_score
 ,settings_as_of_date
 ,quick_eval
 ,notifyemail
 ,completion_deadline
 ,deadline_expired
 ,revision_number
 ,ntraininghours
 ,allowDappraiserAssess
 ,offline_key
 ,mekp_sync
 ,send_notif_ew
 ,update_meaning
 ,creator_uid
 ,datecreated
 ,curr_total_time
 ,attempts_allowed
 ,grading_method
 ,attempts_count
 ,completion_method
 ,final_score
 ,allowSupervisorAssess
 ,weightedscore
 ,weighting
 ,sub_learning
 ,actual_training_time_sec
 ,student_substatus
 ,is_reqd_custom_attr_complete
 ,bundle_id
 ,allowBundleSwitch
 ,restricted_start_date
 ,root_transcriptid
 ,registration
 ,reserve_seat
 ,percent_completion
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,userid
 ,learningid
 ,currid
 ,learningType
 ,eventid
 ,startdate
 ,finishdate
 ,finalgrade
 ,studentstatus
 ,progress
 ,assessDate
 ,attendance
 ,perfGradeid
 ,sessionid
 ,creditTranscriptLink
 ,curriculumTranscriptLink
 ,assessmentscore
 ,requestSource
 ,contentSessionID
 ,certSessionID
 ,enrollmentDate
 ,remindercount
 ,costcenter
 ,confirmation_status
 ,reopen
 ,isOpen
 ,pre_assess_score
 ,post_assess_score
 ,settings_as_of_date
 ,quick_eval
 ,notifyemail
 ,completion_deadline
 ,deadline_expired
 ,revision_number
 ,ntraininghours
 ,allowDappraiserAssess
 ,offline_key
 ,mekp_sync
 ,send_notif_ew
 ,update_meaning
 ,creator_uid
 ,datecreated
 ,curr_total_time
 ,attempts_allowed
 ,grading_method
 ,attempts_count
 ,completion_method
 ,final_score
 ,allowSupervisorAssess
 ,weightedscore
 ,weighting
 ,sub_learning
 ,actual_training_time_sec
 ,student_substatus
 ,is_reqd_custom_attr_complete
 ,bundle_id
 ,allowBundleSwitch
 ,restricted_start_date
 ,root_transcriptid
 ,registration
 ,reserve_seat
 ,percent_completion
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-transcript', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1032, '8:9687712eda2472b1f031066f70da9177', 'enableAuditTable auditTableName=transcript_aud, tableName=transcript', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-AICC_Core_Vendor::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_AICC_Core_Vendor'
			)
			DROP TRIGGER i_AICC_Core_Vendor
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_AICC_Core_Vendor'
			)
			DROP TRIGGER u_AICC_Core_Vendor
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_AICC_Core_Vendor'
			)
			DROP TRIGGER d_AICC_Core_Vendor
GO

CREATE TABLE AICC_Core_Vendor_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_AICC_Core_Vendor_aud_aud_datetime DEFAULT GETDATE() NOT NULL, courseid nvarchar(85), core_vendor nvarchar(MAX), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_AICC_CORE_VENDOR_AUD PRIMARY KEY (aud_id))
GO

insert into AICC_Core_Vendor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,core_vendor
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,courseid
 ,core_vendor
 ,update_meaning
  from AICC_Core_Vendor
GO

CREATE INDEX nuk_AICC_Core_Vendor_aud_1 ON AICC_Core_Vendor_aud(aud_userid)
GO

CREATE INDEX nuk_AICC_Core_Vendor_aud_2 ON AICC_Core_Vendor_aud(aud_datetime)
GO

create trigger i_AICC_Core_Vendor on AICC_Core_Vendor
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into AICC_Core_Vendor (
courseid,core_vendor,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select courseid,core_vendor,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into AICC_Core_Vendor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,core_vendor
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,core_vendor
 ,update_meaning
  from inserted
end
GO

create trigger u_AICC_Core_Vendor on AICC_Core_Vendor
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update AICC_Core_Vendor set
AICC_Core_Vendor.courseid = inserted.courseid,AICC_Core_Vendor.core_vendor = inserted.core_vendor,AICC_Core_Vendor.update_meaning = inserted.update_meaning,AICC_Core_Vendor.last_updated = inserted.last_updated,AICC_Core_Vendor.updater_legal_name = inserted.updater_legal_name,AICC_Core_Vendor.update_meaning_text = inserted.update_meaning_text,AICC_Core_Vendor.last_updater_uid = inserted.last_updater_uid
from AICC_Core_Vendor inner join deleted on AICC_Core_Vendor.courseid = deleted.courseid inner join inserted on AICC_Core_Vendor.courseid = inserted.courseid
insert into AICC_Core_Vendor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,core_vendor
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,core_vendor
 ,update_meaning
  from inserted
end
GO

create trigger d_AICC_Core_Vendor on AICC_Core_Vendor
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from AICC_Core_Vendor where exists (
select 1 from deleted where AICC_Core_Vendor.courseid = deleted.courseid)
insert into AICC_Core_Vendor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,core_vendor
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,core_vendor
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-AICC_Core_Vendor', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1033, '8:1a88ca7362af93ae045ad8de2c6b9232', 'enableAuditTable auditTableName=AICC_Core_Vendor_aud, tableName=AICC_Core_Vendor', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-AICC_au::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_AICC_au'
			)
			DROP TRIGGER i_AICC_au
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_AICC_au'
			)
			DROP TRIGGER u_AICC_au
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_AICC_au'
			)
			DROP TRIGGER d_AICC_au
GO

CREATE TABLE AICC_au_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_AICC_au_aud_aud_datetime DEFAULT GETDATE() NOT NULL, courseid nvarchar(85), systemid nvarchar(40), itemtype nvarchar(40), commandline varchar(255), filename varchar(255), maxscore float(53), masteryscore int, maxtimeallowed nvarchar(8), timelimitaction nvarchar(20), systemvendor varchar(255), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_AICC_AU_AUD PRIMARY KEY (aud_id))
GO

insert into AICC_au_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,systemid
 ,itemtype
 ,commandline
 ,filename
 ,maxscore
 ,masteryscore
 ,maxtimeallowed
 ,timelimitaction
 ,systemvendor
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,courseid
 ,systemid
 ,itemtype
 ,commandline
 ,filename
 ,maxscore
 ,masteryscore
 ,maxtimeallowed
 ,timelimitaction
 ,systemvendor
 ,update_meaning
  from AICC_au
GO

CREATE INDEX nuk_AICC_au_aud_1 ON AICC_au_aud(aud_userid)
GO

CREATE INDEX nuk_AICC_au_aud_2 ON AICC_au_aud(aud_datetime)
GO

create trigger i_AICC_au on AICC_au
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into AICC_au (
courseid,systemid,itemtype,commandline,filename,maxscore,masteryscore,maxtimeallowed,timelimitaction,systemvendor,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select courseid,systemid,itemtype,commandline,filename,maxscore,masteryscore,maxtimeallowed,timelimitaction,systemvendor,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into AICC_au_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,systemid
 ,itemtype
 ,commandline
 ,filename
 ,maxscore
 ,masteryscore
 ,maxtimeallowed
 ,timelimitaction
 ,systemvendor
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,systemid
 ,itemtype
 ,commandline
 ,filename
 ,maxscore
 ,masteryscore
 ,maxtimeallowed
 ,timelimitaction
 ,systemvendor
 ,update_meaning
  from inserted
end
GO

create trigger u_AICC_au on AICC_au
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update AICC_au set
AICC_au.courseid = inserted.courseid,AICC_au.systemid = inserted.systemid,AICC_au.itemtype = inserted.itemtype,AICC_au.commandline = inserted.commandline,AICC_au.filename = inserted.filename,AICC_au.maxscore = inserted.maxscore,AICC_au.masteryscore = inserted.masteryscore,AICC_au.maxtimeallowed = inserted.maxtimeallowed,AICC_au.timelimitaction = inserted.timelimitaction,AICC_au.systemvendor = inserted.systemvendor,AICC_au.update_meaning = inserted.update_meaning,AICC_au.last_updated = inserted.last_updated,AICC_au.updater_legal_name = inserted.updater_legal_name,AICC_au.update_meaning_text = inserted.update_meaning_text,AICC_au.last_updater_uid = inserted.last_updater_uid
from AICC_au inner join deleted on AICC_au.courseid = deleted.courseid inner join inserted on AICC_au.courseid = inserted.courseid
insert into AICC_au_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,systemid
 ,itemtype
 ,commandline
 ,filename
 ,maxscore
 ,masteryscore
 ,maxtimeallowed
 ,timelimitaction
 ,systemvendor
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,systemid
 ,itemtype
 ,commandline
 ,filename
 ,maxscore
 ,masteryscore
 ,maxtimeallowed
 ,timelimitaction
 ,systemvendor
 ,update_meaning
  from inserted
end
GO

create trigger d_AICC_au on AICC_au
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from AICC_au where exists (
select 1 from deleted where AICC_au.courseid = deleted.courseid)
insert into AICC_au_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,systemid
 ,itemtype
 ,commandline
 ,filename
 ,maxscore
 ,masteryscore
 ,maxtimeallowed
 ,timelimitaction
 ,systemvendor
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,systemid
 ,itemtype
 ,commandline
 ,filename
 ,maxscore
 ,masteryscore
 ,maxtimeallowed
 ,timelimitaction
 ,systemvendor
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-AICC_au', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1034, '8:e42ebe31d2e226c20af3d94307976ad0', 'enableAuditTable auditTableName=AICC_au_aud, tableName=AICC_au', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-AICC_des::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_AICC_des'
			)
			DROP TRIGGER i_AICC_des
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_AICC_des'
			)
			DROP TRIGGER u_AICC_des
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_AICC_des'
			)
			DROP TRIGGER d_AICC_des
GO

CREATE TABLE AICC_des_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_AICC_des_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), courseid nvarchar(85), systemid nvarchar(40), developerid nvarchar(40), title nvarchar(1000), description nvarchar(2000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_AICC_DES_AUD PRIMARY KEY (aud_id))
GO

insert into AICC_des_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,courseid
 ,systemid
 ,developerid
 ,title
 ,description
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,courseid
 ,systemid
 ,developerid
 ,title
 ,description
 ,update_meaning
  from AICC_des
GO

CREATE INDEX nuk_AICC_des_aud_1 ON AICC_des_aud(aud_userid)
GO

CREATE INDEX nuk_AICC_des_aud_2 ON AICC_des_aud(aud_datetime)
GO

create trigger i_AICC_des on AICC_des
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into AICC_des (
id,courseid,systemid,developerid,title,description,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select id,courseid,systemid,developerid,title,description,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into AICC_des_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,courseid
 ,systemid
 ,developerid
 ,title
 ,description
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,courseid
 ,systemid
 ,developerid
 ,title
 ,description
 ,update_meaning
  from inserted
end
GO

create trigger u_AICC_des on AICC_des
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update AICC_des set
AICC_des.id = inserted.id,AICC_des.courseid = inserted.courseid,AICC_des.systemid = inserted.systemid,AICC_des.developerid = inserted.developerid,AICC_des.title = inserted.title,AICC_des.description = inserted.description,AICC_des.update_meaning = inserted.update_meaning,AICC_des.last_updated = inserted.last_updated,AICC_des.updater_legal_name = inserted.updater_legal_name,AICC_des.update_meaning_text = inserted.update_meaning_text,AICC_des.last_updater_uid = inserted.last_updater_uid
from AICC_des inner join deleted on AICC_des.id = deleted.id inner join inserted on AICC_des.id = inserted.id
insert into AICC_des_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,courseid
 ,systemid
 ,developerid
 ,title
 ,description
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,courseid
 ,systemid
 ,developerid
 ,title
 ,description
 ,update_meaning
  from inserted
end
GO

create trigger d_AICC_des on AICC_des
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from AICC_des where exists (
select 1 from deleted where AICC_des.id = deleted.id)
insert into AICC_des_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,courseid
 ,systemid
 ,developerid
 ,title
 ,description
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,courseid
 ,systemid
 ,developerid
 ,title
 ,description
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-AICC_des', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1035, '8:8f31b6d94a8f173bda6d526825e8bda4', 'enableAuditTable auditTableName=AICC_des_aud, tableName=AICC_des', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-AICC_launch_options::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_AICC_launch_options'
			)
			DROP TRIGGER i_AICC_launch_options
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_AICC_launch_options'
			)
			DROP TRIGGER u_AICC_launch_options
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_AICC_launch_options'
			)
			DROP TRIGGER d_AICC_launch_options
GO

CREATE TABLE AICC_launch_options_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_AICC_launch_options_aud_aud_datetime DEFAULT GETDATE() NOT NULL, courseid nvarchar(85), comments nvarchar(1), evaluation nvarchar(1), objective_status nvarchar(1), student_data nvarchar(1), student_data_full nvarchar(1), student_demographics nvarchar(1), student_preferences nvarchar(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_AICC_LAUNCH_OPTIONS_AUD PRIMARY KEY (aud_id))
GO

insert into AICC_launch_options_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,comments
 ,evaluation
 ,objective_status
 ,student_data
 ,student_data_full
 ,student_demographics
 ,student_preferences
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,courseid
 ,comments
 ,evaluation
 ,objective_status
 ,student_data
 ,student_data_full
 ,student_demographics
 ,student_preferences
 ,update_meaning
  from AICC_launch_options
GO

CREATE INDEX nuk_AICC_launch_options_aud_1 ON AICC_launch_options_aud(aud_userid)
GO

CREATE INDEX nuk_AICC_launch_options_aud_2 ON AICC_launch_options_aud(aud_datetime)
GO

create trigger i_AICC_launch_options on AICC_launch_options
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into AICC_launch_options (
courseid,comments,evaluation,objective_status,student_data,student_data_full,student_demographics,student_preferences,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select courseid,comments,evaluation,objective_status,student_data,student_data_full,student_demographics,student_preferences,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into AICC_launch_options_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,comments
 ,evaluation
 ,objective_status
 ,student_data
 ,student_data_full
 ,student_demographics
 ,student_preferences
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,comments
 ,evaluation
 ,objective_status
 ,student_data
 ,student_data_full
 ,student_demographics
 ,student_preferences
 ,update_meaning
  from inserted
end
GO

create trigger u_AICC_launch_options on AICC_launch_options
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update AICC_launch_options set
AICC_launch_options.courseid = inserted.courseid,AICC_launch_options.comments = inserted.comments,AICC_launch_options.evaluation = inserted.evaluation,AICC_launch_options.objective_status = inserted.objective_status,AICC_launch_options.student_data = inserted.student_data,AICC_launch_options.student_data_full = inserted.student_data_full,AICC_launch_options.student_demographics = inserted.student_demographics,AICC_launch_options.student_preferences = inserted.student_preferences,AICC_launch_options.update_meaning = inserted.update_meaning,AICC_launch_options.last_updated = inserted.last_updated,AICC_launch_options.updater_legal_name = inserted.updater_legal_name,AICC_launch_options.update_meaning_text = inserted.update_meaning_text,AICC_launch_options.last_updater_uid = inserted.last_updater_uid
from AICC_launch_options inner join deleted on AICC_launch_options.courseid = deleted.courseid inner join inserted on AICC_launch_options.courseid = inserted.courseid
insert into AICC_launch_options_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,comments
 ,evaluation
 ,objective_status
 ,student_data
 ,student_data_full
 ,student_demographics
 ,student_preferences
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,comments
 ,evaluation
 ,objective_status
 ,student_data
 ,student_data_full
 ,student_demographics
 ,student_preferences
 ,update_meaning
  from inserted
end
GO

create trigger d_AICC_launch_options on AICC_launch_options
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from AICC_launch_options where exists (
select 1 from deleted where AICC_launch_options.courseid = deleted.courseid)
insert into AICC_launch_options_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,comments
 ,evaluation
 ,objective_status
 ,student_data
 ,student_data_full
 ,student_demographics
 ,student_preferences
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,comments
 ,evaluation
 ,objective_status
 ,student_data
 ,student_data_full
 ,student_demographics
 ,student_preferences
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-AICC_launch_options', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1036, '8:cab7688d509c90418b3463a9097b8dca', 'enableAuditTable auditTableName=AICC_launch_options_aud, tableName=AICC_launch_options', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-ContentObject::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_ContentObject'
			)
			DROP TRIGGER i_ContentObject
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_ContentObject'
			)
			DROP TRIGGER u_ContentObject
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_ContentObject'
			)
			DROP TRIGGER d_ContentObject
GO

CREATE TABLE ContentObject_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_ContentObject_aud_aud_datetime DEFAULT GETDATE() NOT NULL, contentID nvarchar(15), href nvarchar(MAX), installDate datetime, ownerID nvarchar(85), packageID nvarchar(85), testID nvarchar(100), type char(1), ims_type nvarchar(85), update_meaning nvarchar(8), tincan_activity_id nvarchar(2000), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CONTENTOBJECT_AUD PRIMARY KEY (aud_id))
GO

insert into ContentObject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,contentID
 ,href
 ,installDate
 ,ownerID
 ,packageID
 ,testID
 ,type
 ,ims_type
 ,update_meaning
 ,tincan_activity_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,contentID
 ,href
 ,installDate
 ,ownerID
 ,packageID
 ,testID
 ,type
 ,ims_type
 ,update_meaning
 ,tincan_activity_id
  from ContentObject
GO

CREATE INDEX nuk_ContentObject_aud_1 ON ContentObject_aud(aud_userid)
GO

CREATE INDEX nuk_ContentObject_aud_2 ON ContentObject_aud(aud_datetime)
GO

create trigger i_ContentObject on ContentObject
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into ContentObject (
contentID,href,installDate,ownerID,packageID,testID,type,ims_type,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,tincan_activity_id) select contentID,href,installDate,ownerID,packageID,testID,type,ims_type,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,tincan_activity_id from inserted
insert into ContentObject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,contentID
 ,href
 ,installDate
 ,ownerID
 ,packageID
 ,testID
 ,type
 ,ims_type
 ,update_meaning
 ,tincan_activity_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,contentID
 ,href
 ,installDate
 ,ownerID
 ,packageID
 ,testID
 ,type
 ,ims_type
 ,update_meaning
 ,tincan_activity_id
  from inserted
end
GO

create trigger u_ContentObject on ContentObject
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update ContentObject set
ContentObject.contentID = inserted.contentID,ContentObject.href = inserted.href,ContentObject.installDate = inserted.installDate,ContentObject.ownerID = inserted.ownerID,ContentObject.packageID = inserted.packageID,ContentObject.testID = inserted.testID,ContentObject.type = inserted.type,ContentObject.ims_type = inserted.ims_type,ContentObject.update_meaning = inserted.update_meaning,ContentObject.last_updated = inserted.last_updated,ContentObject.updater_legal_name = inserted.updater_legal_name,ContentObject.update_meaning_text = inserted.update_meaning_text,ContentObject.last_updater_uid = inserted.last_updater_uid,ContentObject.tincan_activity_id = inserted.tincan_activity_id
from ContentObject inner join deleted on ContentObject.contentID = deleted.contentID inner join inserted on ContentObject.contentID = inserted.contentID
insert into ContentObject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,contentID
 ,href
 ,installDate
 ,ownerID
 ,packageID
 ,testID
 ,type
 ,ims_type
 ,update_meaning
 ,tincan_activity_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,contentID
 ,href
 ,installDate
 ,ownerID
 ,packageID
 ,testID
 ,type
 ,ims_type
 ,update_meaning
 ,tincan_activity_id
  from inserted
end
GO

create trigger d_ContentObject on ContentObject
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from ContentObject where exists (
select 1 from deleted where ContentObject.contentID = deleted.contentID)
insert into ContentObject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,contentID
 ,href
 ,installDate
 ,ownerID
 ,packageID
 ,testID
 ,type
 ,ims_type
 ,update_meaning
 ,tincan_activity_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,contentID
 ,href
 ,installDate
 ,ownerID
 ,packageID
 ,testID
 ,type
 ,ims_type
 ,update_meaning
 ,tincan_activity_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-ContentObject', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1037, '8:d1f8c3bbf7a1327d35f6636518654a49', 'enableAuditTable auditTableName=ContentObject_aud, tableName=ContentObject', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-ContentItem::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_ContentItem'
			)
			DROP TRIGGER i_ContentItem
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_ContentItem'
			)
			DROP TRIGGER u_ContentItem
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_ContentItem'
			)
			DROP TRIGGER d_ContentItem
GO

CREATE TABLE ContentItem_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_ContentItem_aud_aud_datetime DEFAULT GETDATE() NOT NULL, contentID nvarchar(15), itemID nvarchar(15), launchData nvarchar(MAX), masteryScore nvarchar(MAX), maxTimeAllowed nvarchar(13), parameters nvarchar(MAX), timeLimitAction char(1), requires_cost_center_email char(1), completionThreshold nvarchar(20), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CONTENTITEM_AUD PRIMARY KEY (aud_id))
GO

insert into ContentItem_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,contentID
 ,itemID
 ,launchData
 ,masteryScore
 ,maxTimeAllowed
 ,parameters
 ,timeLimitAction
 ,requires_cost_center_email
 ,completionThreshold
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,contentID
 ,itemID
 ,launchData
 ,masteryScore
 ,maxTimeAllowed
 ,parameters
 ,timeLimitAction
 ,requires_cost_center_email
 ,completionThreshold
 ,update_meaning
  from ContentItem
GO

CREATE INDEX nuk_ContentItem_aud_1 ON ContentItem_aud(aud_userid)
GO

CREATE INDEX nuk_ContentItem_aud_2 ON ContentItem_aud(aud_datetime)
GO

create trigger i_ContentItem on ContentItem
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into ContentItem (
contentID,itemID,launchData,masteryScore,maxTimeAllowed,parameters,timeLimitAction,requires_cost_center_email,completionThreshold,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select contentID,itemID,launchData,masteryScore,maxTimeAllowed,parameters,timeLimitAction,requires_cost_center_email,completionThreshold,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into ContentItem_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,contentID
 ,itemID
 ,launchData
 ,masteryScore
 ,maxTimeAllowed
 ,parameters
 ,timeLimitAction
 ,requires_cost_center_email
 ,completionThreshold
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,contentID
 ,itemID
 ,launchData
 ,masteryScore
 ,maxTimeAllowed
 ,parameters
 ,timeLimitAction
 ,requires_cost_center_email
 ,completionThreshold
 ,update_meaning
  from inserted
end
GO

create trigger u_ContentItem on ContentItem
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update ContentItem set
ContentItem.contentID = inserted.contentID,ContentItem.itemID = inserted.itemID,ContentItem.launchData = inserted.launchData,ContentItem.masteryScore = inserted.masteryScore,ContentItem.maxTimeAllowed = inserted.maxTimeAllowed,ContentItem.parameters = inserted.parameters,ContentItem.timeLimitAction = inserted.timeLimitAction,ContentItem.requires_cost_center_email = inserted.requires_cost_center_email,ContentItem.completionThreshold = inserted.completionThreshold,ContentItem.update_meaning = inserted.update_meaning,ContentItem.last_updated = inserted.last_updated,ContentItem.updater_legal_name = inserted.updater_legal_name,ContentItem.update_meaning_text = inserted.update_meaning_text,ContentItem.last_updater_uid = inserted.last_updater_uid
from ContentItem inner join deleted on ContentItem.itemID = deleted.itemID inner join inserted on ContentItem.itemID = inserted.itemID
insert into ContentItem_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,contentID
 ,itemID
 ,launchData
 ,masteryScore
 ,maxTimeAllowed
 ,parameters
 ,timeLimitAction
 ,requires_cost_center_email
 ,completionThreshold
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,contentID
 ,itemID
 ,launchData
 ,masteryScore
 ,maxTimeAllowed
 ,parameters
 ,timeLimitAction
 ,requires_cost_center_email
 ,completionThreshold
 ,update_meaning
  from inserted
end
GO

create trigger d_ContentItem on ContentItem
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from ContentItem where exists (
select 1 from deleted where ContentItem.itemID = deleted.itemID)
insert into ContentItem_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,contentID
 ,itemID
 ,launchData
 ,masteryScore
 ,maxTimeAllowed
 ,parameters
 ,timeLimitAction
 ,requires_cost_center_email
 ,completionThreshold
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,contentID
 ,itemID
 ,launchData
 ,masteryScore
 ,maxTimeAllowed
 ,parameters
 ,timeLimitAction
 ,requires_cost_center_email
 ,completionThreshold
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-ContentItem', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1038, '8:3a06d30790d276b19637d7adc9e65714', 'enableAuditTable auditTableName=ContentItem_aud, tableName=ContentItem', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-Sequencing::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_Sequencing'
			)
			DROP TRIGGER i_Sequencing
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_Sequencing'
			)
			DROP TRIGGER u_Sequencing
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_Sequencing'
			)
			DROP TRIGGER d_Sequencing
GO

CREATE TABLE Sequencing_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_Sequencing_aud_aud_datetime DEFAULT GETDATE() NOT NULL, sequencingID nvarchar(15), choice char(1), flow char(1), forwardOnly char(1), choiceExit char(1), maxAttempts int, maxTimeAllowed nvarchar(30), preventChoice char(1), constrainChoice char(1), rollupObjectiveSatisfied char(1), rollupProgressCompletion char(1), objectiveMeasureWeight nvarchar(20), tracked char(1), completionSetByContent char(1), objectiveSetByContent char(1), rollupSatisfied char(1), rollupNotSatisfied char(1), rollupCompleted char(1), rollupIncomplete char(1), rollupMeasureSatisfied char(1), randomizeTiming char(1), randomizeChildren char(1), useCurrentAttemptObjective char(1), useCurrentAttemptProgress char(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SEQUENCING_AUD PRIMARY KEY (aud_id))
GO

insert into Sequencing_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,choice
 ,flow
 ,forwardOnly
 ,choiceExit
 ,maxAttempts
 ,maxTimeAllowed
 ,preventChoice
 ,constrainChoice
 ,rollupObjectiveSatisfied
 ,rollupProgressCompletion
 ,objectiveMeasureWeight
 ,tracked
 ,completionSetByContent
 ,objectiveSetByContent
 ,rollupSatisfied
 ,rollupNotSatisfied
 ,rollupCompleted
 ,rollupIncomplete
 ,rollupMeasureSatisfied
 ,randomizeTiming
 ,randomizeChildren
 ,useCurrentAttemptObjective
 ,useCurrentAttemptProgress
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,sequencingID
 ,choice
 ,flow
 ,forwardOnly
 ,choiceExit
 ,maxAttempts
 ,maxTimeAllowed
 ,preventChoice
 ,constrainChoice
 ,rollupObjectiveSatisfied
 ,rollupProgressCompletion
 ,objectiveMeasureWeight
 ,tracked
 ,completionSetByContent
 ,objectiveSetByContent
 ,rollupSatisfied
 ,rollupNotSatisfied
 ,rollupCompleted
 ,rollupIncomplete
 ,rollupMeasureSatisfied
 ,randomizeTiming
 ,randomizeChildren
 ,useCurrentAttemptObjective
 ,useCurrentAttemptProgress
 ,update_meaning
  from Sequencing
GO

CREATE INDEX nuk_Sequencing_aud_1 ON Sequencing_aud(aud_userid)
GO

CREATE INDEX nuk_Sequencing_aud_2 ON Sequencing_aud(aud_datetime)
GO

create trigger i_Sequencing on Sequencing
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into Sequencing (
sequencingID,choice,flow,forwardOnly,choiceExit,maxAttempts,maxTimeAllowed,preventChoice,constrainChoice,rollupObjectiveSatisfied,rollupProgressCompletion,objectiveMeasureWeight,tracked,completionSetByContent,objectiveSetByContent,rollupSatisfied,rollupNotSatisfied,rollupCompleted,rollupIncomplete,rollupMeasureSatisfied,randomizeTiming,randomizeChildren,useCurrentAttemptObjective,useCurrentAttemptProgress,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select sequencingID,choice,flow,forwardOnly,choiceExit,maxAttempts,maxTimeAllowed,preventChoice,constrainChoice,rollupObjectiveSatisfied,rollupProgressCompletion,objectiveMeasureWeight,tracked,completionSetByContent,objectiveSetByContent,rollupSatisfied,rollupNotSatisfied,rollupCompleted,rollupIncomplete,rollupMeasureSatisfied,randomizeTiming,randomizeChildren,useCurrentAttemptObjective,useCurrentAttemptProgress,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into Sequencing_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,choice
 ,flow
 ,forwardOnly
 ,choiceExit
 ,maxAttempts
 ,maxTimeAllowed
 ,preventChoice
 ,constrainChoice
 ,rollupObjectiveSatisfied
 ,rollupProgressCompletion
 ,objectiveMeasureWeight
 ,tracked
 ,completionSetByContent
 ,objectiveSetByContent
 ,rollupSatisfied
 ,rollupNotSatisfied
 ,rollupCompleted
 ,rollupIncomplete
 ,rollupMeasureSatisfied
 ,randomizeTiming
 ,randomizeChildren
 ,useCurrentAttemptObjective
 ,useCurrentAttemptProgress
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,choice
 ,flow
 ,forwardOnly
 ,choiceExit
 ,maxAttempts
 ,maxTimeAllowed
 ,preventChoice
 ,constrainChoice
 ,rollupObjectiveSatisfied
 ,rollupProgressCompletion
 ,objectiveMeasureWeight
 ,tracked
 ,completionSetByContent
 ,objectiveSetByContent
 ,rollupSatisfied
 ,rollupNotSatisfied
 ,rollupCompleted
 ,rollupIncomplete
 ,rollupMeasureSatisfied
 ,randomizeTiming
 ,randomizeChildren
 ,useCurrentAttemptObjective
 ,useCurrentAttemptProgress
 ,update_meaning
  from inserted
end
GO

create trigger u_Sequencing on Sequencing
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update Sequencing set
Sequencing.sequencingID = inserted.sequencingID,Sequencing.choice = inserted.choice,Sequencing.flow = inserted.flow,Sequencing.forwardOnly = inserted.forwardOnly,Sequencing.choiceExit = inserted.choiceExit,Sequencing.maxAttempts = inserted.maxAttempts,Sequencing.maxTimeAllowed = inserted.maxTimeAllowed,Sequencing.preventChoice = inserted.preventChoice,Sequencing.constrainChoice = inserted.constrainChoice,Sequencing.rollupObjectiveSatisfied = inserted.rollupObjectiveSatisfied,Sequencing.rollupProgressCompletion = inserted.rollupProgressCompletion,Sequencing.objectiveMeasureWeight = inserted.objectiveMeasureWeight,Sequencing.tracked = inserted.tracked,Sequencing.completionSetByContent = inserted.completionSetByContent,Sequencing.objectiveSetByContent = inserted.objectiveSetByContent,Sequencing.rollupSatisfied = inserted.rollupSatisfied,Sequencing.rollupNotSatisfied = inserted.rollupNotSatisfied,Sequencing.rollupCompleted = inserted.rollupCompleted,Sequencing.rollupIncomplete = inserted.rollupIncomplete,Sequencing.rollupMeasureSatisfied = inserted.rollupMeasureSatisfied,Sequencing.randomizeTiming = inserted.randomizeTiming,Sequencing.randomizeChildren = inserted.randomizeChildren,Sequencing.useCurrentAttemptObjective = inserted.useCurrentAttemptObjective,Sequencing.useCurrentAttemptProgress = inserted.useCurrentAttemptProgress,Sequencing.update_meaning = inserted.update_meaning,Sequencing.last_updated = inserted.last_updated,Sequencing.updater_legal_name = inserted.updater_legal_name,Sequencing.update_meaning_text = inserted.update_meaning_text,Sequencing.last_updater_uid = inserted.last_updater_uid
from Sequencing inner join deleted on Sequencing.sequencingID = deleted.sequencingID inner join inserted on Sequencing.sequencingID = inserted.sequencingID
insert into Sequencing_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,choice
 ,flow
 ,forwardOnly
 ,choiceExit
 ,maxAttempts
 ,maxTimeAllowed
 ,preventChoice
 ,constrainChoice
 ,rollupObjectiveSatisfied
 ,rollupProgressCompletion
 ,objectiveMeasureWeight
 ,tracked
 ,completionSetByContent
 ,objectiveSetByContent
 ,rollupSatisfied
 ,rollupNotSatisfied
 ,rollupCompleted
 ,rollupIncomplete
 ,rollupMeasureSatisfied
 ,randomizeTiming
 ,randomizeChildren
 ,useCurrentAttemptObjective
 ,useCurrentAttemptProgress
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,choice
 ,flow
 ,forwardOnly
 ,choiceExit
 ,maxAttempts
 ,maxTimeAllowed
 ,preventChoice
 ,constrainChoice
 ,rollupObjectiveSatisfied
 ,rollupProgressCompletion
 ,objectiveMeasureWeight
 ,tracked
 ,completionSetByContent
 ,objectiveSetByContent
 ,rollupSatisfied
 ,rollupNotSatisfied
 ,rollupCompleted
 ,rollupIncomplete
 ,rollupMeasureSatisfied
 ,randomizeTiming
 ,randomizeChildren
 ,useCurrentAttemptObjective
 ,useCurrentAttemptProgress
 ,update_meaning
  from inserted
end
GO

create trigger d_Sequencing on Sequencing
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from Sequencing where exists (
select 1 from deleted where Sequencing.sequencingID = deleted.sequencingID)
insert into Sequencing_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,choice
 ,flow
 ,forwardOnly
 ,choiceExit
 ,maxAttempts
 ,maxTimeAllowed
 ,preventChoice
 ,constrainChoice
 ,rollupObjectiveSatisfied
 ,rollupProgressCompletion
 ,objectiveMeasureWeight
 ,tracked
 ,completionSetByContent
 ,objectiveSetByContent
 ,rollupSatisfied
 ,rollupNotSatisfied
 ,rollupCompleted
 ,rollupIncomplete
 ,rollupMeasureSatisfied
 ,randomizeTiming
 ,randomizeChildren
 ,useCurrentAttemptObjective
 ,useCurrentAttemptProgress
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,choice
 ,flow
 ,forwardOnly
 ,choiceExit
 ,maxAttempts
 ,maxTimeAllowed
 ,preventChoice
 ,constrainChoice
 ,rollupObjectiveSatisfied
 ,rollupProgressCompletion
 ,objectiveMeasureWeight
 ,tracked
 ,completionSetByContent
 ,objectiveSetByContent
 ,rollupSatisfied
 ,rollupNotSatisfied
 ,rollupCompleted
 ,rollupIncomplete
 ,rollupMeasureSatisfied
 ,randomizeTiming
 ,randomizeChildren
 ,useCurrentAttemptObjective
 ,useCurrentAttemptProgress
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-Sequencing', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1039, '8:fd8f42fdd0cdbe355c73266b86bdc4c4', 'enableAuditTable auditTableName=Sequencing_aud, tableName=Sequencing', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-SequenceRule::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_SequenceRule'
			)
			DROP TRIGGER i_SequenceRule
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_SequenceRule'
			)
			DROP TRIGGER u_SequenceRule
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_SequenceRule'
			)
			DROP TRIGGER d_SequenceRule
GO

CREATE TABLE SequenceRule_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_SequenceRule_aud_aud_datetime DEFAULT GETDATE() NOT NULL, sequencingID nvarchar(15), ruleIndex int, type char(1), combination char(1), action char(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SEQUENCERULE_AUD PRIMARY KEY (aud_id))
GO

insert into SequenceRule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,type
 ,combination
 ,action
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,sequencingID
 ,ruleIndex
 ,type
 ,combination
 ,action
 ,update_meaning
  from SequenceRule
GO

CREATE INDEX nuk_SequenceRule_aud_1 ON SequenceRule_aud(aud_userid)
GO

CREATE INDEX nuk_SequenceRule_aud_2 ON SequenceRule_aud(aud_datetime)
GO

create trigger i_SequenceRule on SequenceRule
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into SequenceRule (
sequencingID,ruleIndex,type,combination,action,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select sequencingID,ruleIndex,type,combination,action,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into SequenceRule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,type
 ,combination
 ,action
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,type
 ,combination
 ,action
 ,update_meaning
  from inserted
end
GO

create trigger u_SequenceRule on SequenceRule
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update SequenceRule set
SequenceRule.sequencingID = inserted.sequencingID,SequenceRule.ruleIndex = inserted.ruleIndex,SequenceRule.type = inserted.type,SequenceRule.combination = inserted.combination,SequenceRule.action = inserted.action,SequenceRule.update_meaning = inserted.update_meaning,SequenceRule.last_updated = inserted.last_updated,SequenceRule.updater_legal_name = inserted.updater_legal_name,SequenceRule.update_meaning_text = inserted.update_meaning_text,SequenceRule.last_updater_uid = inserted.last_updater_uid
from SequenceRule inner join deleted on SequenceRule.sequencingID = deleted.sequencingID and SequenceRule.ruleIndex = deleted.ruleIndex inner join inserted on SequenceRule.sequencingID = inserted.sequencingID and SequenceRule.ruleIndex = inserted.ruleIndex
insert into SequenceRule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,type
 ,combination
 ,action
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,type
 ,combination
 ,action
 ,update_meaning
  from inserted
end
GO

create trigger d_SequenceRule on SequenceRule
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from SequenceRule where exists (
select 1 from deleted where SequenceRule.sequencingID = deleted.sequencingID and SequenceRule.ruleIndex = deleted.ruleIndex)
insert into SequenceRule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,type
 ,combination
 ,action
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,type
 ,combination
 ,action
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-SequenceRule', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1040, '8:21585b51e0f7c332b37adce831f02c1b', 'enableAuditTable auditTableName=SequenceRule_aud, tableName=SequenceRule', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-SeqRuleCondition::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_SeqRuleCondition'
			)
			DROP TRIGGER i_SeqRuleCondition
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_SeqRuleCondition'
			)
			DROP TRIGGER u_SeqRuleCondition
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_SeqRuleCondition'
			)
			DROP TRIGGER d_SeqRuleCondition
GO

CREATE TABLE SeqRuleCondition_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_SeqRuleCondition_aud_aud_datetime DEFAULT GETDATE() NOT NULL, sequencingID nvarchar(15), ruleIndex int, conditionIndex int, ruleCondition char(1), referencedObjective nvarchar(2000), measureThreshold nvarchar(20), operator char(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SEQRULECONDITION_AUD PRIMARY KEY (aud_id))
GO

insert into SeqRuleCondition_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,ruleCondition
 ,referencedObjective
 ,measureThreshold
 ,operator
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,ruleCondition
 ,referencedObjective
 ,measureThreshold
 ,operator
 ,update_meaning
  from SeqRuleCondition
GO

CREATE INDEX nuk_SeqRuleCondition_aud_1 ON SeqRuleCondition_aud(aud_userid)
GO

CREATE INDEX nuk_SeqRuleCondition_aud_2 ON SeqRuleCondition_aud(aud_datetime)
GO

create trigger i_SeqRuleCondition on SeqRuleCondition
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into SeqRuleCondition (
sequencingID,ruleIndex,conditionIndex,ruleCondition,referencedObjective,measureThreshold,operator,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select sequencingID,ruleIndex,conditionIndex,ruleCondition,referencedObjective,measureThreshold,operator,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into SeqRuleCondition_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,ruleCondition
 ,referencedObjective
 ,measureThreshold
 ,operator
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,ruleCondition
 ,referencedObjective
 ,measureThreshold
 ,operator
 ,update_meaning
  from inserted
end
GO

create trigger u_SeqRuleCondition on SeqRuleCondition
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update SeqRuleCondition set
SeqRuleCondition.sequencingID = inserted.sequencingID,SeqRuleCondition.ruleIndex = inserted.ruleIndex,SeqRuleCondition.conditionIndex = inserted.conditionIndex,SeqRuleCondition.ruleCondition = inserted.ruleCondition,SeqRuleCondition.referencedObjective = inserted.referencedObjective,SeqRuleCondition.measureThreshold = inserted.measureThreshold,SeqRuleCondition.operator = inserted.operator,SeqRuleCondition.update_meaning = inserted.update_meaning,SeqRuleCondition.last_updated = inserted.last_updated,SeqRuleCondition.updater_legal_name = inserted.updater_legal_name,SeqRuleCondition.update_meaning_text = inserted.update_meaning_text,SeqRuleCondition.last_updater_uid = inserted.last_updater_uid
from SeqRuleCondition inner join deleted on SeqRuleCondition.sequencingID = deleted.sequencingID and SeqRuleCondition.ruleIndex = deleted.ruleIndex and SeqRuleCondition.conditionIndex = deleted.conditionIndex inner join inserted on SeqRuleCondition.sequencingID = inserted.sequencingID and SeqRuleCondition.ruleIndex = inserted.ruleIndex and SeqRuleCondition.conditionIndex = inserted.conditionIndex
insert into SeqRuleCondition_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,ruleCondition
 ,referencedObjective
 ,measureThreshold
 ,operator
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,ruleCondition
 ,referencedObjective
 ,measureThreshold
 ,operator
 ,update_meaning
  from inserted
end
GO

create trigger d_SeqRuleCondition on SeqRuleCondition
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from SeqRuleCondition where exists (
select 1 from deleted where SeqRuleCondition.sequencingID = deleted.sequencingID and SeqRuleCondition.ruleIndex = deleted.ruleIndex and SeqRuleCondition.conditionIndex = deleted.conditionIndex)
insert into SeqRuleCondition_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,ruleCondition
 ,referencedObjective
 ,measureThreshold
 ,operator
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,ruleCondition
 ,referencedObjective
 ,measureThreshold
 ,operator
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-SeqRuleCondition', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1041, '8:33676e5f164464bff0d393364ff66171', 'enableAuditTable auditTableName=SeqRuleCondition_aud, tableName=SeqRuleCondition', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-SequenceObjective::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_SequenceObjective'
			)
			DROP TRIGGER i_SequenceObjective
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_SequenceObjective'
			)
			DROP TRIGGER u_SequenceObjective
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_SequenceObjective'
			)
			DROP TRIGGER d_SequenceObjective
GO

CREATE TABLE SequenceObjective_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_SequenceObjective_aud_aud_datetime DEFAULT GETDATE() NOT NULL, sequencingID nvarchar(15), objectiveIndex int, objectiveID nvarchar(2000), satisfiedByMeasure char(1), minNormalizedMeasure nvarchar(20), isPrimary char(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SEQUENCEOBJECTIVE_AUD PRIMARY KEY (aud_id))
GO

insert into SequenceObjective_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,objectiveIndex
 ,objectiveID
 ,satisfiedByMeasure
 ,minNormalizedMeasure
 ,isPrimary
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,sequencingID
 ,objectiveIndex
 ,objectiveID
 ,satisfiedByMeasure
 ,minNormalizedMeasure
 ,isPrimary
 ,update_meaning
  from SequenceObjective
GO

CREATE INDEX nuk_SequenceObjective_aud_1 ON SequenceObjective_aud(aud_userid)
GO

CREATE INDEX nuk_SequenceObjective_aud_2 ON SequenceObjective_aud(aud_datetime)
GO

create trigger i_SequenceObjective on SequenceObjective
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into SequenceObjective (
sequencingID,objectiveIndex,objectiveID,satisfiedByMeasure,minNormalizedMeasure,isPrimary,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select sequencingID,objectiveIndex,objectiveID,satisfiedByMeasure,minNormalizedMeasure,isPrimary,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into SequenceObjective_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,objectiveIndex
 ,objectiveID
 ,satisfiedByMeasure
 ,minNormalizedMeasure
 ,isPrimary
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,objectiveIndex
 ,objectiveID
 ,satisfiedByMeasure
 ,minNormalizedMeasure
 ,isPrimary
 ,update_meaning
  from inserted
end
GO

create trigger u_SequenceObjective on SequenceObjective
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update SequenceObjective set
SequenceObjective.sequencingID = inserted.sequencingID,SequenceObjective.objectiveIndex = inserted.objectiveIndex,SequenceObjective.objectiveID = inserted.objectiveID,SequenceObjective.satisfiedByMeasure = inserted.satisfiedByMeasure,SequenceObjective.minNormalizedMeasure = inserted.minNormalizedMeasure,SequenceObjective.isPrimary = inserted.isPrimary,SequenceObjective.update_meaning = inserted.update_meaning,SequenceObjective.last_updated = inserted.last_updated,SequenceObjective.updater_legal_name = inserted.updater_legal_name,SequenceObjective.update_meaning_text = inserted.update_meaning_text,SequenceObjective.last_updater_uid = inserted.last_updater_uid
from SequenceObjective inner join deleted on SequenceObjective.sequencingID = deleted.sequencingID and SequenceObjective.objectiveIndex = deleted.objectiveIndex inner join inserted on SequenceObjective.sequencingID = inserted.sequencingID and SequenceObjective.objectiveIndex = inserted.objectiveIndex
insert into SequenceObjective_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,objectiveIndex
 ,objectiveID
 ,satisfiedByMeasure
 ,minNormalizedMeasure
 ,isPrimary
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,objectiveIndex
 ,objectiveID
 ,satisfiedByMeasure
 ,minNormalizedMeasure
 ,isPrimary
 ,update_meaning
  from inserted
end
GO

create trigger d_SequenceObjective on SequenceObjective
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from SequenceObjective where exists (
select 1 from deleted where SequenceObjective.sequencingID = deleted.sequencingID and SequenceObjective.objectiveIndex = deleted.objectiveIndex)
insert into SequenceObjective_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,objectiveIndex
 ,objectiveID
 ,satisfiedByMeasure
 ,minNormalizedMeasure
 ,isPrimary
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,objectiveIndex
 ,objectiveID
 ,satisfiedByMeasure
 ,minNormalizedMeasure
 ,isPrimary
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-SequenceObjective', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1042, '8:9582988e01339bda021274c11924c3ec', 'enableAuditTable auditTableName=SequenceObjective_aud, tableName=SequenceObjective', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-SeqObjectiveMap::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_SeqObjectiveMap'
			)
			DROP TRIGGER i_SeqObjectiveMap
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_SeqObjectiveMap'
			)
			DROP TRIGGER u_SeqObjectiveMap
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_SeqObjectiveMap'
			)
			DROP TRIGGER d_SeqObjectiveMap
GO

CREATE TABLE SeqObjectiveMap_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_SeqObjectiveMap_aud_aud_datetime DEFAULT GETDATE() NOT NULL, sequencingID nvarchar(15), objectiveIndex int, mapIndex int, targetObjectiveID nvarchar(2000), readSatisfiedStatus char(1), readNormalizedMeasure char(1), writeSatisfiedStatus char(1), writeNormalizedMeasure char(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SEQOBJECTIVEMAP_AUD PRIMARY KEY (aud_id))
GO

insert into SeqObjectiveMap_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,objectiveIndex
 ,mapIndex
 ,targetObjectiveID
 ,readSatisfiedStatus
 ,readNormalizedMeasure
 ,writeSatisfiedStatus
 ,writeNormalizedMeasure
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,sequencingID
 ,objectiveIndex
 ,mapIndex
 ,targetObjectiveID
 ,readSatisfiedStatus
 ,readNormalizedMeasure
 ,writeSatisfiedStatus
 ,writeNormalizedMeasure
 ,update_meaning
  from SeqObjectiveMap
GO

CREATE INDEX nuk_SeqObjectiveMap_aud_1 ON SeqObjectiveMap_aud(aud_userid)
GO

CREATE INDEX nuk_SeqObjectiveMap_aud_2 ON SeqObjectiveMap_aud(aud_datetime)
GO

create trigger i_SeqObjectiveMap on SeqObjectiveMap
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into SeqObjectiveMap (
sequencingID,objectiveIndex,mapIndex,targetObjectiveID,readSatisfiedStatus,readNormalizedMeasure,writeSatisfiedStatus,writeNormalizedMeasure,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select sequencingID,objectiveIndex,mapIndex,targetObjectiveID,readSatisfiedStatus,readNormalizedMeasure,writeSatisfiedStatus,writeNormalizedMeasure,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into SeqObjectiveMap_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,objectiveIndex
 ,mapIndex
 ,targetObjectiveID
 ,readSatisfiedStatus
 ,readNormalizedMeasure
 ,writeSatisfiedStatus
 ,writeNormalizedMeasure
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,objectiveIndex
 ,mapIndex
 ,targetObjectiveID
 ,readSatisfiedStatus
 ,readNormalizedMeasure
 ,writeSatisfiedStatus
 ,writeNormalizedMeasure
 ,update_meaning
  from inserted
end
GO

create trigger u_SeqObjectiveMap on SeqObjectiveMap
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update SeqObjectiveMap set
SeqObjectiveMap.sequencingID = inserted.sequencingID,SeqObjectiveMap.objectiveIndex = inserted.objectiveIndex,SeqObjectiveMap.mapIndex = inserted.mapIndex,SeqObjectiveMap.targetObjectiveID = inserted.targetObjectiveID,SeqObjectiveMap.readSatisfiedStatus = inserted.readSatisfiedStatus,SeqObjectiveMap.readNormalizedMeasure = inserted.readNormalizedMeasure,SeqObjectiveMap.writeSatisfiedStatus = inserted.writeSatisfiedStatus,SeqObjectiveMap.writeNormalizedMeasure = inserted.writeNormalizedMeasure,SeqObjectiveMap.update_meaning = inserted.update_meaning,SeqObjectiveMap.last_updated = inserted.last_updated,SeqObjectiveMap.updater_legal_name = inserted.updater_legal_name,SeqObjectiveMap.update_meaning_text = inserted.update_meaning_text,SeqObjectiveMap.last_updater_uid = inserted.last_updater_uid
from SeqObjectiveMap inner join deleted on SeqObjectiveMap.sequencingID = deleted.sequencingID and SeqObjectiveMap.objectiveIndex = deleted.objectiveIndex and SeqObjectiveMap.mapIndex = deleted.mapIndex inner join inserted on SeqObjectiveMap.sequencingID = inserted.sequencingID and SeqObjectiveMap.objectiveIndex = inserted.objectiveIndex and SeqObjectiveMap.mapIndex = inserted.mapIndex
insert into SeqObjectiveMap_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,objectiveIndex
 ,mapIndex
 ,targetObjectiveID
 ,readSatisfiedStatus
 ,readNormalizedMeasure
 ,writeSatisfiedStatus
 ,writeNormalizedMeasure
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,objectiveIndex
 ,mapIndex
 ,targetObjectiveID
 ,readSatisfiedStatus
 ,readNormalizedMeasure
 ,writeSatisfiedStatus
 ,writeNormalizedMeasure
 ,update_meaning
  from inserted
end
GO

create trigger d_SeqObjectiveMap on SeqObjectiveMap
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from SeqObjectiveMap where exists (
select 1 from deleted where SeqObjectiveMap.sequencingID = deleted.sequencingID and SeqObjectiveMap.objectiveIndex = deleted.objectiveIndex and SeqObjectiveMap.mapIndex = deleted.mapIndex)
insert into SeqObjectiveMap_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,objectiveIndex
 ,mapIndex
 ,targetObjectiveID
 ,readSatisfiedStatus
 ,readNormalizedMeasure
 ,writeSatisfiedStatus
 ,writeNormalizedMeasure
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,objectiveIndex
 ,mapIndex
 ,targetObjectiveID
 ,readSatisfiedStatus
 ,readNormalizedMeasure
 ,writeSatisfiedStatus
 ,writeNormalizedMeasure
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-SeqObjectiveMap', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1043, '8:fab0b4eb273c0c1fc573f58c78d77982', 'enableAuditTable auditTableName=SeqObjectiveMap_aud, tableName=SeqObjectiveMap', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-RollupRule::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_RollupRule'
			)
			DROP TRIGGER i_RollupRule
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_RollupRule'
			)
			DROP TRIGGER u_RollupRule
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_RollupRule'
			)
			DROP TRIGGER d_RollupRule
GO

CREATE TABLE RollupRule_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_RollupRule_aud_aud_datetime DEFAULT GETDATE() NOT NULL, sequencingID nvarchar(15), ruleIndex int, childActivitySet char(1), minimumCount int, minimumPercent nvarchar(20), action char(1), conditionCombi char(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_ROLLUPRULE_AUD PRIMARY KEY (aud_id))
GO

insert into RollupRule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,childActivitySet
 ,minimumCount
 ,minimumPercent
 ,action
 ,conditionCombi
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,sequencingID
 ,ruleIndex
 ,childActivitySet
 ,minimumCount
 ,minimumPercent
 ,action
 ,conditionCombi
 ,update_meaning
  from RollupRule
GO

CREATE INDEX nuk_RollupRule_aud_1 ON RollupRule_aud(aud_userid)
GO

CREATE INDEX nuk_RollupRule_aud_2 ON RollupRule_aud(aud_datetime)
GO

create trigger i_RollupRule on RollupRule
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into RollupRule (
sequencingID,ruleIndex,childActivitySet,minimumCount,minimumPercent,action,conditionCombi,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select sequencingID,ruleIndex,childActivitySet,minimumCount,minimumPercent,action,conditionCombi,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into RollupRule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,childActivitySet
 ,minimumCount
 ,minimumPercent
 ,action
 ,conditionCombi
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,childActivitySet
 ,minimumCount
 ,minimumPercent
 ,action
 ,conditionCombi
 ,update_meaning
  from inserted
end
GO

create trigger u_RollupRule on RollupRule
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update RollupRule set
RollupRule.sequencingID = inserted.sequencingID,RollupRule.ruleIndex = inserted.ruleIndex,RollupRule.childActivitySet = inserted.childActivitySet,RollupRule.minimumCount = inserted.minimumCount,RollupRule.minimumPercent = inserted.minimumPercent,RollupRule.action = inserted.action,RollupRule.conditionCombi = inserted.conditionCombi,RollupRule.update_meaning = inserted.update_meaning,RollupRule.last_updated = inserted.last_updated,RollupRule.updater_legal_name = inserted.updater_legal_name,RollupRule.update_meaning_text = inserted.update_meaning_text,RollupRule.last_updater_uid = inserted.last_updater_uid
from RollupRule inner join deleted on RollupRule.sequencingID = deleted.sequencingID and RollupRule.ruleIndex = deleted.ruleIndex inner join inserted on RollupRule.sequencingID = inserted.sequencingID and RollupRule.ruleIndex = inserted.ruleIndex
insert into RollupRule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,childActivitySet
 ,minimumCount
 ,minimumPercent
 ,action
 ,conditionCombi
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,childActivitySet
 ,minimumCount
 ,minimumPercent
 ,action
 ,conditionCombi
 ,update_meaning
  from inserted
end
GO

create trigger d_RollupRule on RollupRule
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from RollupRule where exists (
select 1 from deleted where RollupRule.sequencingID = deleted.sequencingID and RollupRule.ruleIndex = deleted.ruleIndex)
insert into RollupRule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,childActivitySet
 ,minimumCount
 ,minimumPercent
 ,action
 ,conditionCombi
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,childActivitySet
 ,minimumCount
 ,minimumPercent
 ,action
 ,conditionCombi
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-RollupRule', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1044, '8:5ddeea0e2daf411284e1f9f0db210616', 'enableAuditTable auditTableName=RollupRule_aud, tableName=RollupRule', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-RollupCondition::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_RollupCondition'
			)
			DROP TRIGGER i_RollupCondition
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_RollupCondition'
			)
			DROP TRIGGER u_RollupCondition
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_RollupCondition'
			)
			DROP TRIGGER d_RollupCondition
GO

CREATE TABLE RollupCondition_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_RollupCondition_aud_aud_datetime DEFAULT GETDATE() NOT NULL, sequencingID nvarchar(15), ruleIndex int, conditionIndex int, rollupCondition char(1), operator char(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_ROLLUPCONDITION_AUD PRIMARY KEY (aud_id))
GO

insert into RollupCondition_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,rollupCondition
 ,operator
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,rollupCondition
 ,operator
 ,update_meaning
  from RollupCondition
GO

CREATE INDEX nuk_RollupCondition_aud_1 ON RollupCondition_aud(aud_userid)
GO

CREATE INDEX nuk_RollupCondition_aud_2 ON RollupCondition_aud(aud_datetime)
GO

create trigger i_RollupCondition on RollupCondition
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into RollupCondition (
sequencingID,ruleIndex,conditionIndex,rollupCondition,operator,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select sequencingID,ruleIndex,conditionIndex,rollupCondition,operator,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into RollupCondition_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,rollupCondition
 ,operator
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,rollupCondition
 ,operator
 ,update_meaning
  from inserted
end
GO

create trigger u_RollupCondition on RollupCondition
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update RollupCondition set
RollupCondition.sequencingID = inserted.sequencingID,RollupCondition.ruleIndex = inserted.ruleIndex,RollupCondition.conditionIndex = inserted.conditionIndex,RollupCondition.rollupCondition = inserted.rollupCondition,RollupCondition.operator = inserted.operator,RollupCondition.update_meaning = inserted.update_meaning,RollupCondition.last_updated = inserted.last_updated,RollupCondition.updater_legal_name = inserted.updater_legal_name,RollupCondition.update_meaning_text = inserted.update_meaning_text,RollupCondition.last_updater_uid = inserted.last_updater_uid
from RollupCondition inner join deleted on RollupCondition.sequencingID = deleted.sequencingID and RollupCondition.ruleIndex = deleted.ruleIndex and RollupCondition.conditionIndex = deleted.conditionIndex inner join inserted on RollupCondition.sequencingID = inserted.sequencingID and RollupCondition.ruleIndex = inserted.ruleIndex and RollupCondition.conditionIndex = inserted.conditionIndex
insert into RollupCondition_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,rollupCondition
 ,operator
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,rollupCondition
 ,operator
 ,update_meaning
  from inserted
end
GO

create trigger d_RollupCondition on RollupCondition
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from RollupCondition where exists (
select 1 from deleted where RollupCondition.sequencingID = deleted.sequencingID and RollupCondition.ruleIndex = deleted.ruleIndex and RollupCondition.conditionIndex = deleted.conditionIndex)
insert into RollupCondition_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,rollupCondition
 ,operator
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,sequencingID
 ,ruleIndex
 ,conditionIndex
 ,rollupCondition
 ,operator
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-RollupCondition', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1045, '8:19b2407d246c5f95c2b3536057b3ee34', 'enableAuditTable auditTableName=RollupCondition_aud, tableName=RollupCondition', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-ContentOrganization::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_ContentOrganization'
			)
			DROP TRIGGER i_ContentOrganization
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_ContentOrganization'
			)
			DROP TRIGGER u_ContentOrganization
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_ContentOrganization'
			)
			DROP TRIGGER d_ContentOrganization
GO

CREATE TABLE ContentOrganization_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_ContentOrganization_aud_aud_datetime DEFAULT GETDATE() NOT NULL, installDate datetime, organizationID nvarchar(15), ownerID nvarchar(85), packageID nvarchar(85), title nvarchar(MAX), description nvarchar(MAX), duration varchar(100), course_id nvarchar(85), course_template_id nvarchar(15), is_master char(1), course_creator nvarchar(100), sequencingID nvarchar(15), objectivesGlobalToSystem char(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CONTENTORGANIZATION_AUD PRIMARY KEY (aud_id))
GO

insert into ContentOrganization_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,installDate
 ,organizationID
 ,ownerID
 ,packageID
 ,title
 ,description
 ,duration
 ,course_id
 ,course_template_id
 ,is_master
 ,course_creator
 ,sequencingID
 ,objectivesGlobalToSystem
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,installDate
 ,organizationID
 ,ownerID
 ,packageID
 ,title
 ,description
 ,duration
 ,course_id
 ,course_template_id
 ,is_master
 ,course_creator
 ,sequencingID
 ,objectivesGlobalToSystem
 ,update_meaning
  from ContentOrganization
GO

CREATE INDEX nuk_ContentOrganization_aud_1 ON ContentOrganization_aud(aud_userid)
GO

CREATE INDEX nuk_ContentOrganization_aud_2 ON ContentOrganization_aud(aud_datetime)
GO

create trigger i_ContentOrganization on ContentOrganization
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into ContentOrganization (
installDate,organizationID,ownerID,packageID,title,description,duration,course_id,course_template_id,is_master,course_creator,sequencingID,objectivesGlobalToSystem,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select installDate,organizationID,ownerID,packageID,title,description,duration,course_id,course_template_id,is_master,course_creator,sequencingID,objectivesGlobalToSystem,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into ContentOrganization_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,installDate
 ,organizationID
 ,ownerID
 ,packageID
 ,title
 ,description
 ,duration
 ,course_id
 ,course_template_id
 ,is_master
 ,course_creator
 ,sequencingID
 ,objectivesGlobalToSystem
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,installDate
 ,organizationID
 ,ownerID
 ,packageID
 ,title
 ,description
 ,duration
 ,course_id
 ,course_template_id
 ,is_master
 ,course_creator
 ,sequencingID
 ,objectivesGlobalToSystem
 ,update_meaning
  from inserted
end
GO

create trigger u_ContentOrganization on ContentOrganization
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update ContentOrganization set
ContentOrganization.installDate = inserted.installDate,ContentOrganization.organizationID = inserted.organizationID,ContentOrganization.ownerID = inserted.ownerID,ContentOrganization.packageID = inserted.packageID,ContentOrganization.title = inserted.title,ContentOrganization.description = inserted.description,ContentOrganization.duration = inserted.duration,ContentOrganization.course_id = inserted.course_id,ContentOrganization.course_template_id = inserted.course_template_id,ContentOrganization.is_master = inserted.is_master,ContentOrganization.course_creator = inserted.course_creator,ContentOrganization.sequencingID = inserted.sequencingID,ContentOrganization.objectivesGlobalToSystem = inserted.objectivesGlobalToSystem,ContentOrganization.update_meaning = inserted.update_meaning,ContentOrganization.last_updated = inserted.last_updated,ContentOrganization.updater_legal_name = inserted.updater_legal_name,ContentOrganization.update_meaning_text = inserted.update_meaning_text,ContentOrganization.last_updater_uid = inserted.last_updater_uid
from ContentOrganization inner join deleted on ContentOrganization.organizationID = deleted.organizationID inner join inserted on ContentOrganization.organizationID = inserted.organizationID
insert into ContentOrganization_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,installDate
 ,organizationID
 ,ownerID
 ,packageID
 ,title
 ,description
 ,duration
 ,course_id
 ,course_template_id
 ,is_master
 ,course_creator
 ,sequencingID
 ,objectivesGlobalToSystem
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,installDate
 ,organizationID
 ,ownerID
 ,packageID
 ,title
 ,description
 ,duration
 ,course_id
 ,course_template_id
 ,is_master
 ,course_creator
 ,sequencingID
 ,objectivesGlobalToSystem
 ,update_meaning
  from inserted
end
GO

create trigger d_ContentOrganization on ContentOrganization
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from ContentOrganization where exists (
select 1 from deleted where ContentOrganization.organizationID = deleted.organizationID)
insert into ContentOrganization_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,installDate
 ,organizationID
 ,ownerID
 ,packageID
 ,title
 ,description
 ,duration
 ,course_id
 ,course_template_id
 ,is_master
 ,course_creator
 ,sequencingID
 ,objectivesGlobalToSystem
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,installDate
 ,organizationID
 ,ownerID
 ,packageID
 ,title
 ,description
 ,duration
 ,course_id
 ,course_template_id
 ,is_master
 ,course_creator
 ,sequencingID
 ,objectivesGlobalToSystem
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-ContentOrganization', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1046, '8:17fa9f99aa83da52a092ec77bfbcb13b', 'enableAuditTable auditTableName=ContentOrganization_aud, tableName=ContentOrganization', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-ContentOrganizationNode::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_ContentOrganizationNode'
			)
			DROP TRIGGER i_ContentOrganizationNode
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_ContentOrganizationNode'
			)
			DROP TRIGGER u_ContentOrganizationNode
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_ContentOrganizationNode'
			)
			DROP TRIGGER d_ContentOrganizationNode
GO

CREATE TABLE ContentOrgNode_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_ContentOrgNode_aud_aud_datetime DEFAULT GETDATE() NOT NULL, isVisible nvarchar(1), itemID nvarchar(15), nodeID nvarchar(2000), nodeIndex int, organizationID nvarchar(15), parentID nvarchar(85), prerequisites nvarchar(MAX), title nvarchar(MAX), hideNavUi nvarchar(10), sequencingID nvarchar(15), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CONTENTORGNODE_AUD PRIMARY KEY (aud_id))
GO

insert into ContentOrgNode_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,isVisible
 ,itemID
 ,nodeID
 ,nodeIndex
 ,organizationID
 ,parentID
 ,prerequisites
 ,title
 ,hideNavUi
 ,sequencingID
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,isVisible
 ,itemID
 ,nodeID
 ,nodeIndex
 ,organizationID
 ,parentID
 ,prerequisites
 ,title
 ,hideNavUi
 ,sequencingID
 ,update_meaning
  from ContentOrganizationNode
GO

CREATE INDEX nuk_ContentOrgNode_aud_1 ON ContentOrgNode_aud(aud_userid)
GO

CREATE INDEX nuk_ContentOrgNode_aud_2 ON ContentOrgNode_aud(aud_datetime)
GO

create trigger i_ContentOrganizationNode on ContentOrganizationNode
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into ContentOrganizationNode (
isVisible,itemID,nodeID,nodeIndex,organizationID,parentID,prerequisites,title,hideNavUi,sequencingID,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select isVisible,itemID,nodeID,nodeIndex,organizationID,parentID,prerequisites,title,hideNavUi,sequencingID,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into ContentOrgNode_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,isVisible
 ,itemID
 ,nodeID
 ,nodeIndex
 ,organizationID
 ,parentID
 ,prerequisites
 ,title
 ,hideNavUi
 ,sequencingID
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,isVisible
 ,itemID
 ,nodeID
 ,nodeIndex
 ,organizationID
 ,parentID
 ,prerequisites
 ,title
 ,hideNavUi
 ,sequencingID
 ,update_meaning
  from inserted
end
GO

create trigger u_ContentOrganizationNode on ContentOrganizationNode
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update ContentOrganizationNode set
ContentOrganizationNode.isVisible = inserted.isVisible,ContentOrganizationNode.itemID = inserted.itemID,ContentOrganizationNode.nodeID = inserted.nodeID,ContentOrganizationNode.nodeIndex = inserted.nodeIndex,ContentOrganizationNode.organizationID = inserted.organizationID,ContentOrganizationNode.parentID = inserted.parentID,ContentOrganizationNode.prerequisites = inserted.prerequisites,ContentOrganizationNode.title = inserted.title,ContentOrganizationNode.hideNavUi = inserted.hideNavUi,ContentOrganizationNode.sequencingID = inserted.sequencingID,ContentOrganizationNode.update_meaning = inserted.update_meaning,ContentOrganizationNode.last_updated = inserted.last_updated,ContentOrganizationNode.updater_legal_name = inserted.updater_legal_name,ContentOrganizationNode.update_meaning_text = inserted.update_meaning_text,ContentOrganizationNode.last_updater_uid = inserted.last_updater_uid
from ContentOrganizationNode inner join deleted on ContentOrganizationNode.organizationID = deleted.organizationID and ContentOrganizationNode.nodeID = deleted.nodeID inner join inserted on ContentOrganizationNode.organizationID = inserted.organizationID and ContentOrganizationNode.nodeID = inserted.nodeID
insert into ContentOrgNode_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,isVisible
 ,itemID
 ,nodeID
 ,nodeIndex
 ,organizationID
 ,parentID
 ,prerequisites
 ,title
 ,hideNavUi
 ,sequencingID
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,isVisible
 ,itemID
 ,nodeID
 ,nodeIndex
 ,organizationID
 ,parentID
 ,prerequisites
 ,title
 ,hideNavUi
 ,sequencingID
 ,update_meaning
  from inserted
end
GO

create trigger d_ContentOrganizationNode on ContentOrganizationNode
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from ContentOrganizationNode where exists (
select 1 from deleted where ContentOrganizationNode.organizationID = deleted.organizationID and ContentOrganizationNode.nodeID = deleted.nodeID)
insert into ContentOrgNode_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,isVisible
 ,itemID
 ,nodeID
 ,nodeIndex
 ,organizationID
 ,parentID
 ,prerequisites
 ,title
 ,hideNavUi
 ,sequencingID
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,isVisible
 ,itemID
 ,nodeID
 ,nodeIndex
 ,organizationID
 ,parentID
 ,prerequisites
 ,title
 ,hideNavUi
 ,sequencingID
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-ContentOrganizationNode', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1047, '8:0572b4165e9ddbfd4f1bb894dc23be80', 'enableAuditTable auditTableName=ContentOrgNode_aud, tableName=ContentOrganizationNode', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-ContentOrganizationObjective::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_ContentOrganizationObjective'
			)
			DROP TRIGGER i_ContentOrganizationObjective
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_ContentOrganizationObjective'
			)
			DROP TRIGGER u_ContentOrganizationObjective
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_ContentOrganizationObjective'
			)
			DROP TRIGGER d_ContentOrganizationObjective
GO

CREATE TABLE ContentOrgObj_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_ContentOrgObj_aud_aud_datetime DEFAULT GETDATE() NOT NULL, organizationID nvarchar(15), objectiveIndex int, description nvarchar(MAX), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CONTENTORGOBJ_AUD PRIMARY KEY (aud_id))
GO

insert into ContentOrgObj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,organizationID
 ,objectiveIndex
 ,description
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,organizationID
 ,objectiveIndex
 ,description
 ,update_meaning
  from ContentOrganizationObjective
GO

CREATE INDEX nuk_ContentOrgObj_aud_1 ON ContentOrgObj_aud(aud_userid)
GO

CREATE INDEX nuk_ContentOrgObj_aud_2 ON ContentOrgObj_aud(aud_datetime)
GO

create trigger i_ContentOrganizationObjective on ContentOrganizationObjective
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into ContentOrganizationObjective (
organizationID,objectiveIndex,description,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select organizationID,objectiveIndex,description,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into ContentOrgObj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,organizationID
 ,objectiveIndex
 ,description
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,organizationID
 ,objectiveIndex
 ,description
 ,update_meaning
  from inserted
end
GO

create trigger u_ContentOrganizationObjective on ContentOrganizationObjective
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update ContentOrganizationObjective set
ContentOrganizationObjective.organizationID = inserted.organizationID,ContentOrganizationObjective.objectiveIndex = inserted.objectiveIndex,ContentOrganizationObjective.description = inserted.description,ContentOrganizationObjective.update_meaning = inserted.update_meaning,ContentOrganizationObjective.last_updated = inserted.last_updated,ContentOrganizationObjective.updater_legal_name = inserted.updater_legal_name,ContentOrganizationObjective.update_meaning_text = inserted.update_meaning_text,ContentOrganizationObjective.last_updater_uid = inserted.last_updater_uid
from ContentOrganizationObjective inner join deleted on ContentOrganizationObjective.organizationID = deleted.organizationID and ContentOrganizationObjective.objectiveIndex = deleted.objectiveIndex inner join inserted on ContentOrganizationObjective.organizationID = inserted.organizationID and ContentOrganizationObjective.objectiveIndex = inserted.objectiveIndex
insert into ContentOrgObj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,organizationID
 ,objectiveIndex
 ,description
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,organizationID
 ,objectiveIndex
 ,description
 ,update_meaning
  from inserted
end
GO

create trigger d_ContentOrganizationObjective on ContentOrganizationObjective
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from ContentOrganizationObjective where exists (
select 1 from deleted where ContentOrganizationObjective.organizationID = deleted.organizationID and ContentOrganizationObjective.objectiveIndex = deleted.objectiveIndex)
insert into ContentOrgObj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,organizationID
 ,objectiveIndex
 ,description
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,organizationID
 ,objectiveIndex
 ,description
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-ContentOrganizationObjective', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1048, '8:e2798eba182ed34d8a65c5da7f28da72', 'enableAuditTable auditTableName=ContentOrgObj_aud, tableName=ContentOrganizationObjective', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-ContentPackage::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_ContentPackage'
			)
			DROP TRIGGER i_ContentPackage
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_ContentPackage'
			)
			DROP TRIGGER u_ContentPackage
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_ContentPackage'
			)
			DROP TRIGGER d_ContentPackage
GO

CREATE TABLE ContentPackage_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_ContentPackage_aud_aud_datetime DEFAULT GETDATE() NOT NULL, filename nvarchar(MAX), installDate datetime, ownerID nvarchar(85), packageID nvarchar(85), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CONTENTPACKAGE_AUD PRIMARY KEY (aud_id))
GO

insert into ContentPackage_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,filename
 ,installDate
 ,ownerID
 ,packageID
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,filename
 ,installDate
 ,ownerID
 ,packageID
 ,update_meaning
  from ContentPackage
GO

CREATE INDEX nuk_ContentPackage_aud_1 ON ContentPackage_aud(aud_userid)
GO

CREATE INDEX nuk_ContentPackage_aud_2 ON ContentPackage_aud(aud_datetime)
GO

create trigger i_ContentPackage on ContentPackage
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into ContentPackage (
filename,installDate,ownerID,packageID,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select filename,installDate,ownerID,packageID,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into ContentPackage_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,filename
 ,installDate
 ,ownerID
 ,packageID
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,filename
 ,installDate
 ,ownerID
 ,packageID
 ,update_meaning
  from inserted
end
GO

create trigger u_ContentPackage on ContentPackage
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update ContentPackage set
ContentPackage.filename = inserted.filename,ContentPackage.installDate = inserted.installDate,ContentPackage.ownerID = inserted.ownerID,ContentPackage.packageID = inserted.packageID,ContentPackage.update_meaning = inserted.update_meaning,ContentPackage.last_updated = inserted.last_updated,ContentPackage.updater_legal_name = inserted.updater_legal_name,ContentPackage.update_meaning_text = inserted.update_meaning_text,ContentPackage.last_updater_uid = inserted.last_updater_uid
from ContentPackage inner join deleted on ContentPackage.packageID = deleted.packageID inner join inserted on ContentPackage.packageID = inserted.packageID
insert into ContentPackage_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,filename
 ,installDate
 ,ownerID
 ,packageID
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,filename
 ,installDate
 ,ownerID
 ,packageID
 ,update_meaning
  from inserted
end
GO

create trigger d_ContentPackage on ContentPackage
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from ContentPackage where exists (
select 1 from deleted where ContentPackage.packageID = deleted.packageID)
insert into ContentPackage_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,filename
 ,installDate
 ,ownerID
 ,packageID
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,filename
 ,installDate
 ,ownerID
 ,packageID
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-ContentPackage', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1049, '8:6be47b0d0762fca9c465bd288ac8e52d', 'enableAuditTable auditTableName=ContentPackage_aud, tableName=ContentPackage', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-approval_queue::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_approval_queue'
			)
			DROP TRIGGER i_approval_queue
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_approval_queue'
			)
			DROP TRIGGER u_approval_queue
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_approval_queue'
			)
			DROP TRIGGER d_approval_queue
GO

CREATE TABLE approval_queue_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_approval_queue_aud_aud_datetime DEFAULT GETDATE() NOT NULL, transcriptid nvarchar(15), request_date datetime, user_remarks nvarchar(4000), policy_id nvarchar(15), learner_orgid nvarchar(15), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_APPROVAL_QUEUE_AUD PRIMARY KEY (aud_id))
GO

insert into approval_queue_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,request_date
 ,user_remarks
 ,policy_id
 ,learner_orgid
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,transcriptid
 ,request_date
 ,user_remarks
 ,policy_id
 ,learner_orgid
 ,update_meaning
  from approval_queue
GO

CREATE INDEX nuk_approval_queue_aud_1 ON approval_queue_aud(aud_userid)
GO

CREATE INDEX nuk_approval_queue_aud_2 ON approval_queue_aud(aud_datetime)
GO

create trigger i_approval_queue on approval_queue
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into approval_queue (
transcriptid,request_date,user_remarks,policy_id,learner_orgid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select transcriptid,request_date,user_remarks,policy_id,learner_orgid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into approval_queue_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,request_date
 ,user_remarks
 ,policy_id
 ,learner_orgid
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,request_date
 ,user_remarks
 ,policy_id
 ,learner_orgid
 ,update_meaning
  from inserted
end
GO

create trigger u_approval_queue on approval_queue
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update approval_queue set
approval_queue.transcriptid = inserted.transcriptid,approval_queue.request_date = inserted.request_date,approval_queue.user_remarks = inserted.user_remarks,approval_queue.policy_id = inserted.policy_id,approval_queue.learner_orgid = inserted.learner_orgid,approval_queue.update_meaning = inserted.update_meaning,approval_queue.last_updated = inserted.last_updated,approval_queue.updater_legal_name = inserted.updater_legal_name,approval_queue.update_meaning_text = inserted.update_meaning_text,approval_queue.last_updater_uid = inserted.last_updater_uid
from approval_queue inner join deleted on approval_queue.transcriptid = deleted.transcriptid inner join inserted on approval_queue.transcriptid = inserted.transcriptid
insert into approval_queue_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,request_date
 ,user_remarks
 ,policy_id
 ,learner_orgid
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,request_date
 ,user_remarks
 ,policy_id
 ,learner_orgid
 ,update_meaning
  from inserted
end
GO

create trigger d_approval_queue on approval_queue
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from approval_queue where exists (
select 1 from deleted where approval_queue.transcriptid = deleted.transcriptid)
insert into approval_queue_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,request_date
 ,user_remarks
 ,policy_id
 ,learner_orgid
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,request_date
 ,user_remarks
 ,policy_id
 ,learner_orgid
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-approval_queue', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1050, '8:1548dbda58bab9a56a77f58b71b67968', 'enableAuditTable auditTableName=approval_queue_aud, tableName=approval_queue', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-approval_queue_step::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_approval_queue_step'
			)
			DROP TRIGGER i_approval_queue_step
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_approval_queue_step'
			)
			DROP TRIGGER u_approval_queue_step
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_approval_queue_step'
			)
			DROP TRIGGER d_approval_queue_step
GO

CREATE TABLE approval_queue_step_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_approval_queue_step_aud_aud_datetime DEFAULT GETDATE() NOT NULL, approval_step_id nvarchar(15), policy_id nvarchar(15), policy_step_id nvarchar(15), sequence_no int, step_status char(1), transcriptid nvarchar(15), approver_id nvarchar(85), external_approver_email nvarchar(85), approver_remarks nvarchar(255), approval_date datetime, remind_date datetime, expire_date datetime, remind_sent_date datetime, expire_sent_date datetime, charged_costcenter nvarchar(45), charged_email nvarchar(85), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_APPROVAL_QUEUE_STEP_AUD PRIMARY KEY (aud_id))
GO

insert into approval_queue_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,approval_step_id
 ,policy_id
 ,policy_step_id
 ,sequence_no
 ,step_status
 ,transcriptid
 ,approver_id
 ,external_approver_email
 ,approver_remarks
 ,approval_date
 ,remind_date
 ,expire_date
 ,remind_sent_date
 ,expire_sent_date
 ,charged_costcenter
 ,charged_email
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,approval_step_id
 ,policy_id
 ,policy_step_id
 ,sequence_no
 ,step_status
 ,transcriptid
 ,approver_id
 ,external_approver_email
 ,approver_remarks
 ,approval_date
 ,remind_date
 ,expire_date
 ,remind_sent_date
 ,expire_sent_date
 ,charged_costcenter
 ,charged_email
 ,update_meaning
  from approval_queue_step
GO

CREATE INDEX nuk_approval_queue_step_aud_1 ON approval_queue_step_aud(aud_userid)
GO

CREATE INDEX nuk_approval_queue_step_aud_2 ON approval_queue_step_aud(aud_datetime)
GO

create trigger i_approval_queue_step on approval_queue_step
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into approval_queue_step (
approval_step_id,policy_id,policy_step_id,sequence_no,step_status,transcriptid,approver_id,external_approver_email,approver_remarks,approval_date,remind_date,expire_date,remind_sent_date,expire_sent_date,charged_costcenter,charged_email,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select approval_step_id,policy_id,policy_step_id,sequence_no,step_status,transcriptid,approver_id,external_approver_email,approver_remarks,approval_date,remind_date,expire_date,remind_sent_date,expire_sent_date,charged_costcenter,charged_email,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into approval_queue_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,approval_step_id
 ,policy_id
 ,policy_step_id
 ,sequence_no
 ,step_status
 ,transcriptid
 ,approver_id
 ,external_approver_email
 ,approver_remarks
 ,approval_date
 ,remind_date
 ,expire_date
 ,remind_sent_date
 ,expire_sent_date
 ,charged_costcenter
 ,charged_email
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,approval_step_id
 ,policy_id
 ,policy_step_id
 ,sequence_no
 ,step_status
 ,transcriptid
 ,approver_id
 ,external_approver_email
 ,approver_remarks
 ,approval_date
 ,remind_date
 ,expire_date
 ,remind_sent_date
 ,expire_sent_date
 ,charged_costcenter
 ,charged_email
 ,update_meaning
  from inserted
end
GO

create trigger u_approval_queue_step on approval_queue_step
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update approval_queue_step set
approval_queue_step.approval_step_id = inserted.approval_step_id,approval_queue_step.policy_id = inserted.policy_id,approval_queue_step.policy_step_id = inserted.policy_step_id,approval_queue_step.sequence_no = inserted.sequence_no,approval_queue_step.step_status = inserted.step_status,approval_queue_step.transcriptid = inserted.transcriptid,approval_queue_step.approver_id = inserted.approver_id,approval_queue_step.external_approver_email = inserted.external_approver_email,approval_queue_step.approver_remarks = inserted.approver_remarks,approval_queue_step.approval_date = inserted.approval_date,approval_queue_step.remind_date = inserted.remind_date,approval_queue_step.expire_date = inserted.expire_date,approval_queue_step.remind_sent_date = inserted.remind_sent_date,approval_queue_step.expire_sent_date = inserted.expire_sent_date,approval_queue_step.charged_costcenter = inserted.charged_costcenter,approval_queue_step.charged_email = inserted.charged_email,approval_queue_step.update_meaning = inserted.update_meaning,approval_queue_step.last_updated = inserted.last_updated,approval_queue_step.updater_legal_name = inserted.updater_legal_name,approval_queue_step.update_meaning_text = inserted.update_meaning_text,approval_queue_step.last_updater_uid = inserted.last_updater_uid
from approval_queue_step inner join deleted on approval_queue_step.approval_step_id = deleted.approval_step_id inner join inserted on approval_queue_step.approval_step_id = inserted.approval_step_id
insert into approval_queue_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,approval_step_id
 ,policy_id
 ,policy_step_id
 ,sequence_no
 ,step_status
 ,transcriptid
 ,approver_id
 ,external_approver_email
 ,approver_remarks
 ,approval_date
 ,remind_date
 ,expire_date
 ,remind_sent_date
 ,expire_sent_date
 ,charged_costcenter
 ,charged_email
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,approval_step_id
 ,policy_id
 ,policy_step_id
 ,sequence_no
 ,step_status
 ,transcriptid
 ,approver_id
 ,external_approver_email
 ,approver_remarks
 ,approval_date
 ,remind_date
 ,expire_date
 ,remind_sent_date
 ,expire_sent_date
 ,charged_costcenter
 ,charged_email
 ,update_meaning
  from inserted
end
GO

create trigger d_approval_queue_step on approval_queue_step
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from approval_queue_step where exists (
select 1 from deleted where approval_queue_step.approval_step_id = deleted.approval_step_id)
insert into approval_queue_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,approval_step_id
 ,policy_id
 ,policy_step_id
 ,sequence_no
 ,step_status
 ,transcriptid
 ,approver_id
 ,external_approver_email
 ,approver_remarks
 ,approval_date
 ,remind_date
 ,expire_date
 ,remind_sent_date
 ,expire_sent_date
 ,charged_costcenter
 ,charged_email
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,approval_step_id
 ,policy_id
 ,policy_step_id
 ,sequence_no
 ,step_status
 ,transcriptid
 ,approver_id
 ,external_approver_email
 ,approver_remarks
 ,approval_date
 ,remind_date
 ,expire_date
 ,remind_sent_date
 ,expire_sent_date
 ,charged_costcenter
 ,charged_email
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-approval_queue_step', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1051, '8:e0e67837b92dbe676bfe8363cda12355', 'enableAuditTable auditTableName=approval_queue_step_aud, tableName=approval_queue_step', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-audience::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_audience'
			)
			DROP TRIGGER i_audience
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_audience'
			)
			DROP TRIGGER u_audience
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_audience'
			)
			DROP TRIGGER d_audience
GO

CREATE TABLE audience_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_audience_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), learningid nvarchar(85), description nvarchar(1200), listorder int, update_meaning nvarchar(8), description_key nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_AUDIENCE_AUD PRIMARY KEY (aud_id))
GO

insert into audience_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,description
 ,listorder
 ,update_meaning
 ,description_key
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,learningid
 ,description
 ,listorder
 ,update_meaning
 ,description_key
  from audience
GO

CREATE INDEX nuk_audience_aud_1 ON audience_aud(aud_userid)
GO

CREATE INDEX nuk_audience_aud_2 ON audience_aud(aud_datetime)
GO

create trigger i_audience on audience
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into audience (
id,learningid,description,listorder,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,description_key) select id,learningid,description,listorder,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,description_key from inserted
insert into audience_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,description
 ,listorder
 ,update_meaning
 ,description_key
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,description
 ,listorder
 ,update_meaning
 ,description_key
  from inserted
end
GO

create trigger u_audience on audience
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update audience set
audience.id = inserted.id,audience.learningid = inserted.learningid,audience.description = inserted.description,audience.listorder = inserted.listorder,audience.update_meaning = inserted.update_meaning,audience.last_updated = inserted.last_updated,audience.updater_legal_name = inserted.updater_legal_name,audience.update_meaning_text = inserted.update_meaning_text,audience.last_updater_uid = inserted.last_updater_uid,audience.description_key = inserted.description_key
from audience inner join deleted on audience.id = deleted.id inner join inserted on audience.id = inserted.id
insert into audience_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,description
 ,listorder
 ,update_meaning
 ,description_key
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,description
 ,listorder
 ,update_meaning
 ,description_key
  from inserted
end
GO

create trigger d_audience on audience
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from audience where exists (
select 1 from deleted where audience.id = deleted.id)
insert into audience_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,description
 ,listorder
 ,update_meaning
 ,description_key
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,description
 ,listorder
 ,update_meaning
 ,description_key
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-audience', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1052, '8:39eac2945463d82fc30d14bd8349a24c', 'enableAuditTable auditTableName=audience_aud, tableName=audience', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-autoenroll::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_autoenroll'
			)
			DROP TRIGGER i_autoenroll
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_autoenroll'
			)
			DROP TRIGGER u_autoenroll
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_autoenroll'
			)
			DROP TRIGGER d_autoenroll
GO

CREATE TABLE autoenroll_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_autoenroll_aud_aud_datetime DEFAULT GETDATE() NOT NULL, targetType nvarchar(15), targetValue nvarchar(85), learningid nvarchar(85), learningType nvarchar(1), eventid nvarchar(15), startdate datetime, enddate datetime, durationenabled char(1), durationamount int, durationunit smallint, exclusion_flag char(1), update_meaning nvarchar(8), durationType nvarchar(10), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_AUTOENROLL_AUD PRIMARY KEY (aud_id))
GO

insert into autoenroll_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,targetType
 ,targetValue
 ,learningid
 ,learningType
 ,eventid
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,exclusion_flag
 ,update_meaning
 ,durationType
) select 'U', null
, null
, GETDATE(), null
, null
 ,targetType
 ,targetValue
 ,learningid
 ,learningType
 ,eventid
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,exclusion_flag
 ,update_meaning
 ,durationType
  from autoenroll
GO

CREATE INDEX nuk_autoenroll_aud_1 ON autoenroll_aud(aud_userid)
GO

CREATE INDEX nuk_autoenroll_aud_2 ON autoenroll_aud(aud_datetime)
GO

create trigger i_autoenroll on autoenroll
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into autoenroll (
targetType,targetValue,learningid,learningType,eventid,startdate,enddate,durationenabled,durationamount,durationunit,exclusion_flag,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,durationType) select targetType,targetValue,learningid,learningType,eventid,startdate,enddate,durationenabled,durationamount,durationunit,exclusion_flag,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,durationType from inserted
insert into autoenroll_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,targetType
 ,targetValue
 ,learningid
 ,learningType
 ,eventid
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,exclusion_flag
 ,update_meaning
 ,durationType
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,targetType
 ,targetValue
 ,learningid
 ,learningType
 ,eventid
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,exclusion_flag
 ,update_meaning
 ,durationType
  from inserted
end
GO

create trigger u_autoenroll on autoenroll
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update autoenroll set
autoenroll.targetType = inserted.targetType,autoenroll.targetValue = inserted.targetValue,autoenroll.learningid = inserted.learningid,autoenroll.learningType = inserted.learningType,autoenroll.eventid = inserted.eventid,autoenroll.startdate = inserted.startdate,autoenroll.enddate = inserted.enddate,autoenroll.durationenabled = inserted.durationenabled,autoenroll.durationamount = inserted.durationamount,autoenroll.durationunit = inserted.durationunit,autoenroll.exclusion_flag = inserted.exclusion_flag,autoenroll.update_meaning = inserted.update_meaning,autoenroll.last_updated = inserted.last_updated,autoenroll.updater_legal_name = inserted.updater_legal_name,autoenroll.update_meaning_text = inserted.update_meaning_text,autoenroll.last_updater_uid = inserted.last_updater_uid,autoenroll.durationType = inserted.durationType
from autoenroll inner join deleted on autoenroll.learningid = deleted.learningid and autoenroll.eventid = deleted.eventid and autoenroll.targetType = deleted.targetType and autoenroll.targetValue = deleted.targetValue and autoenroll.learningType = deleted.learningType inner join inserted on autoenroll.learningid = inserted.learningid and autoenroll.eventid = inserted.eventid and autoenroll.targetType = inserted.targetType and autoenroll.targetValue = inserted.targetValue and autoenroll.learningType = inserted.learningType
insert into autoenroll_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,targetType
 ,targetValue
 ,learningid
 ,learningType
 ,eventid
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,exclusion_flag
 ,update_meaning
 ,durationType
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,targetType
 ,targetValue
 ,learningid
 ,learningType
 ,eventid
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,exclusion_flag
 ,update_meaning
 ,durationType
  from inserted
end
GO

create trigger d_autoenroll on autoenroll
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from autoenroll where exists (
select 1 from deleted where autoenroll.learningid = deleted.learningid and autoenroll.eventid = deleted.eventid and autoenroll.targetType = deleted.targetType and autoenroll.targetValue = deleted.targetValue and autoenroll.learningType = deleted.learningType)
insert into autoenroll_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,targetType
 ,targetValue
 ,learningid
 ,learningType
 ,eventid
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,exclusion_flag
 ,update_meaning
 ,durationType
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,targetType
 ,targetValue
 ,learningid
 ,learningType
 ,eventid
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,exclusion_flag
 ,update_meaning
 ,durationType
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-autoenroll', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1053, '8:582a450ea3b3f0621e8ea61beb496b88', 'enableAuditTable auditTableName=autoenroll_aud, tableName=autoenroll', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-contactList::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_contactList'
			)
			DROP TRIGGER i_contactList
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_contactList'
			)
			DROP TRIGGER u_contactList
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_contactList'
			)
			DROP TRIGGER d_contactList
GO

CREATE TABLE contactList_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_contactList_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), event_session nvarchar(15), userid nvarchar(85), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CONTACTLIST_AUD PRIMARY KEY (aud_id))
GO

insert into contactList_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,event_session
 ,userid
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,event_session
 ,userid
 ,update_meaning
  from contactList
GO

CREATE INDEX nuk_contactList_aud_1 ON contactList_aud(aud_userid)
GO

CREATE INDEX nuk_contactList_aud_2 ON contactList_aud(aud_datetime)
GO

create trigger i_contactList on contactList
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into contactList (
learningid,event_session,userid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select learningid,event_session,userid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into contactList_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,event_session
 ,userid
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,event_session
 ,userid
 ,update_meaning
  from inserted
end
GO

create trigger u_contactList on contactList
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update contactList set
contactList.learningid = inserted.learningid,contactList.event_session = inserted.event_session,contactList.userid = inserted.userid,contactList.update_meaning = inserted.update_meaning,contactList.last_updated = inserted.last_updated,contactList.updater_legal_name = inserted.updater_legal_name,contactList.update_meaning_text = inserted.update_meaning_text,contactList.last_updater_uid = inserted.last_updater_uid
from contactList inner join deleted on contactList.learningid = deleted.learningid and contactList.event_session = deleted.event_session and contactList.userid = deleted.userid inner join inserted on contactList.learningid = inserted.learningid and contactList.event_session = inserted.event_session and contactList.userid = inserted.userid
insert into contactList_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,event_session
 ,userid
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,event_session
 ,userid
 ,update_meaning
  from inserted
end
GO

create trigger d_contactList on contactList
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from contactList where exists (
select 1 from deleted where contactList.learningid = deleted.learningid and contactList.event_session = deleted.event_session and contactList.userid = deleted.userid)
insert into contactList_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,event_session
 ,userid
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,event_session
 ,userid
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-contactList', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1054, '8:37c48c4fb14e1b27cdfb83bd1a76626b', 'enableAuditTable auditTableName=contactList_aud, tableName=contactList', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-course::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_course'
			)
			DROP TRIGGER i_course
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_course'
			)
			DROP TRIGGER u_course
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_course'
			)
			DROP TRIGGER d_course
GO

CREATE TABLE course_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_course_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), courseid nvarchar(85), vendorid nvarchar(15), usageTotal int, launchpage nvarchar(MAX), launchInterface smallint, launchParms varchar(255), useDefaultViewer nvarchar(1), viewerpage varchar(100), reserved1 nvarchar(15), reserved2 nvarchar(1), credits float(53), nAttachments smallint, nTests smallint, cversion datetime, allowUserStatusChg nvarchar(1), prompt_for_withdraw_reason char(1), instantAccess nvarchar(1), duration nvarchar(100), contentServer nvarchar(20), bookmark char(1), navigationTreeVisible char(1), organizationID nvarchar(15), previousNextButtonsVisible char(1), itemID nvarchar(15), certid numeric(8, 0), accumulateTime char(1), skillsoft_course_type int, show_toolbars char(1), show_on_other_resources_tab char(1), mekp_download char(1), update_meaning nvarchar(8), launched_win_width int, launched_win_height int, attempts_allowed int, grading_method char(1), completion_method char(1), ieCompatibilityMode char(1), effective_revision int, approved_revision int, allow_self_enroll char(1), allow_session_transfer nvarchar(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSE_AUD PRIMARY KEY (aud_id))
GO

insert into course_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,courseid
 ,vendorid
 ,usageTotal
 ,launchpage
 ,launchInterface
 ,launchParms
 ,useDefaultViewer
 ,viewerpage
 ,reserved1
 ,reserved2
 ,credits
 ,nAttachments
 ,nTests
 ,cversion
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,instantAccess
 ,duration
 ,contentServer
 ,bookmark
 ,navigationTreeVisible
 ,organizationID
 ,previousNextButtonsVisible
 ,itemID
 ,certid
 ,accumulateTime
 ,skillsoft_course_type
 ,show_toolbars
 ,show_on_other_resources_tab
 ,mekp_download
 ,update_meaning
 ,launched_win_width
 ,launched_win_height
 ,attempts_allowed
 ,grading_method
 ,completion_method
 ,ieCompatibilityMode
 ,effective_revision
 ,approved_revision
 ,allow_self_enroll
 ,allow_session_transfer
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,courseid
 ,vendorid
 ,usageTotal
 ,launchpage
 ,launchInterface
 ,launchParms
 ,useDefaultViewer
 ,viewerpage
 ,reserved1
 ,reserved2
 ,credits
 ,nAttachments
 ,nTests
 ,cversion
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,instantAccess
 ,duration
 ,contentServer
 ,bookmark
 ,navigationTreeVisible
 ,organizationID
 ,previousNextButtonsVisible
 ,itemID
 ,certid
 ,accumulateTime
 ,skillsoft_course_type
 ,show_toolbars
 ,show_on_other_resources_tab
 ,mekp_download
 ,update_meaning
 ,launched_win_width
 ,launched_win_height
 ,attempts_allowed
 ,grading_method
 ,completion_method
 ,ieCompatibilityMode
 ,effective_revision
 ,approved_revision
 ,allow_self_enroll
 ,allow_session_transfer
  from course
GO

CREATE INDEX nuk_course_aud_1 ON course_aud(aud_userid)
GO

CREATE INDEX nuk_course_aud_2 ON course_aud(aud_datetime)
GO

create trigger i_course on course
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into course (
id,courseid,vendorid,usageTotal,launchpage,launchInterface,launchParms,useDefaultViewer,viewerpage,reserved1,reserved2,credits,nAttachments,nTests,cversion,allowUserStatusChg,prompt_for_withdraw_reason,instantAccess,duration,contentServer,bookmark,navigationTreeVisible,organizationID,previousNextButtonsVisible,itemID,certid,accumulateTime,skillsoft_course_type,show_toolbars,show_on_other_resources_tab,mekp_download,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,launched_win_width,launched_win_height,attempts_allowed,grading_method,completion_method,ieCompatibilityMode,effective_revision,approved_revision,allow_self_enroll,allow_session_transfer) select id,courseid,vendorid,usageTotal,launchpage,launchInterface,launchParms,useDefaultViewer,viewerpage,reserved1,reserved2,credits,nAttachments,nTests,cversion,allowUserStatusChg,prompt_for_withdraw_reason,instantAccess,duration,contentServer,bookmark,navigationTreeVisible,organizationID,previousNextButtonsVisible,itemID,certid,accumulateTime,skillsoft_course_type,show_toolbars,show_on_other_resources_tab,mekp_download,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,launched_win_width,launched_win_height,attempts_allowed,grading_method,completion_method,ieCompatibilityMode,effective_revision,approved_revision,allow_self_enroll,allow_session_transfer from inserted
insert into course_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,courseid
 ,vendorid
 ,usageTotal
 ,launchpage
 ,launchInterface
 ,launchParms
 ,useDefaultViewer
 ,viewerpage
 ,reserved1
 ,reserved2
 ,credits
 ,nAttachments
 ,nTests
 ,cversion
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,instantAccess
 ,duration
 ,contentServer
 ,bookmark
 ,navigationTreeVisible
 ,organizationID
 ,previousNextButtonsVisible
 ,itemID
 ,certid
 ,accumulateTime
 ,skillsoft_course_type
 ,show_toolbars
 ,show_on_other_resources_tab
 ,mekp_download
 ,update_meaning
 ,launched_win_width
 ,launched_win_height
 ,attempts_allowed
 ,grading_method
 ,completion_method
 ,ieCompatibilityMode
 ,effective_revision
 ,approved_revision
 ,allow_self_enroll
 ,allow_session_transfer
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,courseid
 ,vendorid
 ,usageTotal
 ,launchpage
 ,launchInterface
 ,launchParms
 ,useDefaultViewer
 ,viewerpage
 ,reserved1
 ,reserved2
 ,credits
 ,nAttachments
 ,nTests
 ,cversion
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,instantAccess
 ,duration
 ,contentServer
 ,bookmark
 ,navigationTreeVisible
 ,organizationID
 ,previousNextButtonsVisible
 ,itemID
 ,certid
 ,accumulateTime
 ,skillsoft_course_type
 ,show_toolbars
 ,show_on_other_resources_tab
 ,mekp_download
 ,update_meaning
 ,launched_win_width
 ,launched_win_height
 ,attempts_allowed
 ,grading_method
 ,completion_method
 ,ieCompatibilityMode
 ,effective_revision
 ,approved_revision
 ,allow_self_enroll
 ,allow_session_transfer
  from inserted
end
GO

create trigger u_course on course
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update course set
course.id = inserted.id,course.courseid = inserted.courseid,course.vendorid = inserted.vendorid,course.usageTotal = inserted.usageTotal,course.launchpage = inserted.launchpage,course.launchInterface = inserted.launchInterface,course.launchParms = inserted.launchParms,course.useDefaultViewer = inserted.useDefaultViewer,course.viewerpage = inserted.viewerpage,course.reserved1 = inserted.reserved1,course.reserved2 = inserted.reserved2,course.credits = inserted.credits,course.nAttachments = inserted.nAttachments,course.nTests = inserted.nTests,course.cversion = inserted.cversion,course.allowUserStatusChg = inserted.allowUserStatusChg,course.prompt_for_withdraw_reason = inserted.prompt_for_withdraw_reason,course.instantAccess = inserted.instantAccess,course.duration = inserted.duration,course.contentServer = inserted.contentServer,course.bookmark = inserted.bookmark,course.navigationTreeVisible = inserted.navigationTreeVisible,course.organizationID = inserted.organizationID,course.previousNextButtonsVisible = inserted.previousNextButtonsVisible,course.itemID = inserted.itemID,course.certid = inserted.certid,course.accumulateTime = inserted.accumulateTime,course.skillsoft_course_type = inserted.skillsoft_course_type,course.show_toolbars = inserted.show_toolbars,course.show_on_other_resources_tab = inserted.show_on_other_resources_tab,course.mekp_download = inserted.mekp_download,course.update_meaning = inserted.update_meaning,course.last_updated = inserted.last_updated,course.updater_legal_name = inserted.updater_legal_name,course.update_meaning_text = inserted.update_meaning_text,course.last_updater_uid = inserted.last_updater_uid,course.launched_win_width = inserted.launched_win_width,course.launched_win_height = inserted.launched_win_height,course.attempts_allowed = inserted.attempts_allowed,course.grading_method = inserted.grading_method,course.completion_method = inserted.completion_method,course.ieCompatibilityMode = inserted.ieCompatibilityMode,course.effective_revision = inserted.effective_revision,course.approved_revision = inserted.approved_revision,course.allow_self_enroll = inserted.allow_self_enroll,course.allow_session_transfer = inserted.allow_session_transfer
from course inner join deleted on course.id = deleted.id inner join inserted on course.id = inserted.id
insert into course_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,courseid
 ,vendorid
 ,usageTotal
 ,launchpage
 ,launchInterface
 ,launchParms
 ,useDefaultViewer
 ,viewerpage
 ,reserved1
 ,reserved2
 ,credits
 ,nAttachments
 ,nTests
 ,cversion
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,instantAccess
 ,duration
 ,contentServer
 ,bookmark
 ,navigationTreeVisible
 ,organizationID
 ,previousNextButtonsVisible
 ,itemID
 ,certid
 ,accumulateTime
 ,skillsoft_course_type
 ,show_toolbars
 ,show_on_other_resources_tab
 ,mekp_download
 ,update_meaning
 ,launched_win_width
 ,launched_win_height
 ,attempts_allowed
 ,grading_method
 ,completion_method
 ,ieCompatibilityMode
 ,effective_revision
 ,approved_revision
 ,allow_self_enroll
 ,allow_session_transfer
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,courseid
 ,vendorid
 ,usageTotal
 ,launchpage
 ,launchInterface
 ,launchParms
 ,useDefaultViewer
 ,viewerpage
 ,reserved1
 ,reserved2
 ,credits
 ,nAttachments
 ,nTests
 ,cversion
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,instantAccess
 ,duration
 ,contentServer
 ,bookmark
 ,navigationTreeVisible
 ,organizationID
 ,previousNextButtonsVisible
 ,itemID
 ,certid
 ,accumulateTime
 ,skillsoft_course_type
 ,show_toolbars
 ,show_on_other_resources_tab
 ,mekp_download
 ,update_meaning
 ,launched_win_width
 ,launched_win_height
 ,attempts_allowed
 ,grading_method
 ,completion_method
 ,ieCompatibilityMode
 ,effective_revision
 ,approved_revision
 ,allow_self_enroll
 ,allow_session_transfer
  from inserted
end
GO

create trigger d_course on course
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from course where exists (
select 1 from deleted where course.id = deleted.id)
insert into course_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,courseid
 ,vendorid
 ,usageTotal
 ,launchpage
 ,launchInterface
 ,launchParms
 ,useDefaultViewer
 ,viewerpage
 ,reserved1
 ,reserved2
 ,credits
 ,nAttachments
 ,nTests
 ,cversion
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,instantAccess
 ,duration
 ,contentServer
 ,bookmark
 ,navigationTreeVisible
 ,organizationID
 ,previousNextButtonsVisible
 ,itemID
 ,certid
 ,accumulateTime
 ,skillsoft_course_type
 ,show_toolbars
 ,show_on_other_resources_tab
 ,mekp_download
 ,update_meaning
 ,launched_win_width
 ,launched_win_height
 ,attempts_allowed
 ,grading_method
 ,completion_method
 ,ieCompatibilityMode
 ,effective_revision
 ,approved_revision
 ,allow_self_enroll
 ,allow_session_transfer
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,courseid
 ,vendorid
 ,usageTotal
 ,launchpage
 ,launchInterface
 ,launchParms
 ,useDefaultViewer
 ,viewerpage
 ,reserved1
 ,reserved2
 ,credits
 ,nAttachments
 ,nTests
 ,cversion
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,instantAccess
 ,duration
 ,contentServer
 ,bookmark
 ,navigationTreeVisible
 ,organizationID
 ,previousNextButtonsVisible
 ,itemID
 ,certid
 ,accumulateTime
 ,skillsoft_course_type
 ,show_toolbars
 ,show_on_other_resources_tab
 ,mekp_download
 ,update_meaning
 ,launched_win_width
 ,launched_win_height
 ,attempts_allowed
 ,grading_method
 ,completion_method
 ,ieCompatibilityMode
 ,effective_revision
 ,approved_revision
 ,allow_self_enroll
 ,allow_session_transfer
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-course', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1055, '8:ff0ef79998228dac9f7c4aefca266109', 'enableAuditTable auditTableName=course_aud, tableName=course', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-courseAccessLevel::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_courseAccessLevel'
			)
			DROP TRIGGER i_courseAccessLevel
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_courseAccessLevel'
			)
			DROP TRIGGER u_courseAccessLevel
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_courseAccessLevel'
			)
			DROP TRIGGER d_courseAccessLevel
GO

CREATE TABLE courseAccessLevel_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_courseAccessLevel_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), sessionid nvarchar(85), levelid nvarchar(15), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSEACCESSLEVEL_AUD PRIMARY KEY (aud_id))
GO

insert into courseAccessLevel_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,sessionid
 ,levelid
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,sessionid
 ,levelid
 ,update_meaning
  from courseAccessLevel
GO

CREATE INDEX nuk_courseAccessLevel_aud_1 ON courseAccessLevel_aud(aud_userid)
GO

CREATE INDEX nuk_courseAccessLevel_aud_2 ON courseAccessLevel_aud(aud_datetime)
GO

create trigger i_courseAccessLevel on courseAccessLevel
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into courseAccessLevel (
learningid,sessionid,levelid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select learningid,sessionid,levelid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into courseAccessLevel_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,sessionid
 ,levelid
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,sessionid
 ,levelid
 ,update_meaning
  from inserted
end
GO

create trigger u_courseAccessLevel on courseAccessLevel
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update courseAccessLevel set
courseAccessLevel.learningid = inserted.learningid,courseAccessLevel.sessionid = inserted.sessionid,courseAccessLevel.levelid = inserted.levelid,courseAccessLevel.update_meaning = inserted.update_meaning,courseAccessLevel.last_updated = inserted.last_updated,courseAccessLevel.updater_legal_name = inserted.updater_legal_name,courseAccessLevel.update_meaning_text = inserted.update_meaning_text,courseAccessLevel.last_updater_uid = inserted.last_updater_uid
from courseAccessLevel inner join deleted on courseAccessLevel.learningid = deleted.learningid and courseAccessLevel.sessionid = deleted.sessionid and courseAccessLevel.levelid = deleted.levelid inner join inserted on courseAccessLevel.learningid = inserted.learningid and courseAccessLevel.sessionid = inserted.sessionid and courseAccessLevel.levelid = inserted.levelid
insert into courseAccessLevel_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,sessionid
 ,levelid
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,sessionid
 ,levelid
 ,update_meaning
  from inserted
end
GO

create trigger d_courseAccessLevel on courseAccessLevel
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from courseAccessLevel where exists (
select 1 from deleted where courseAccessLevel.learningid = deleted.learningid and courseAccessLevel.sessionid = deleted.sessionid and courseAccessLevel.levelid = deleted.levelid)
insert into courseAccessLevel_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,sessionid
 ,levelid
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,sessionid
 ,levelid
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-courseAccessLevel', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1056, '8:37ee45984bba1edf9b3e39b73af9f73f', 'enableAuditTable auditTableName=courseAccessLevel_aud, tableName=courseAccessLevel', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-courseAccessUser::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_courseAccessUser'
			)
			DROP TRIGGER i_courseAccessUser
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_courseAccessUser'
			)
			DROP TRIGGER u_courseAccessUser
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_courseAccessUser'
			)
			DROP TRIGGER d_courseAccessUser
GO

CREATE TABLE courseAccessUser_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_courseAccessUser_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), userid nvarchar(85), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSEACCESSUSER_AUD PRIMARY KEY (aud_id))
GO

insert into courseAccessUser_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,userid
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,userid
 ,update_meaning
  from courseAccessUser
GO

CREATE INDEX nuk_courseAccessUser_aud_1 ON courseAccessUser_aud(aud_userid)
GO

CREATE INDEX nuk_courseAccessUser_aud_2 ON courseAccessUser_aud(aud_datetime)
GO

create trigger i_courseAccessUser on courseAccessUser
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into courseAccessUser (
learningid,userid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select learningid,userid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into courseAccessUser_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,userid
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,userid
 ,update_meaning
  from inserted
end
GO

create trigger u_courseAccessUser on courseAccessUser
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update courseAccessUser set
courseAccessUser.learningid = inserted.learningid,courseAccessUser.userid = inserted.userid,courseAccessUser.update_meaning = inserted.update_meaning,courseAccessUser.last_updated = inserted.last_updated,courseAccessUser.updater_legal_name = inserted.updater_legal_name,courseAccessUser.update_meaning_text = inserted.update_meaning_text,courseAccessUser.last_updater_uid = inserted.last_updater_uid
from courseAccessUser inner join deleted on courseAccessUser.learningid = deleted.learningid and courseAccessUser.userid = deleted.userid inner join inserted on courseAccessUser.learningid = inserted.learningid and courseAccessUser.userid = inserted.userid
insert into courseAccessUser_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,userid
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,userid
 ,update_meaning
  from inserted
end
GO

create trigger d_courseAccessUser on courseAccessUser
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from courseAccessUser where exists (
select 1 from deleted where courseAccessUser.learningid = deleted.learningid and courseAccessUser.userid = deleted.userid)
insert into courseAccessUser_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,userid
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,userid
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-courseAccessUser', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1057, '8:b07ef2310f84327973f8fb2b8e21da81', 'enableAuditTable auditTableName=courseAccessUser_aud, tableName=courseAccessUser', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-courseDownloads::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_courseDownloads'
			)
			DROP TRIGGER i_courseDownloads
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_courseDownloads'
			)
			DROP TRIGGER u_courseDownloads
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_courseDownloads'
			)
			DROP TRIGGER d_courseDownloads
GO

CREATE TABLE courseDownloads_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_courseDownloads_aud_aud_datetime DEFAULT GETDATE() NOT NULL, downloadid numeric(8, 0), courseid nvarchar(85), fileURL nvarchar(1000), URLType smallint, description nvarchar(255), prePostType nvarchar(10), ordering int, update_meaning nvarchar(8), ekpfiles_revision_id nvarchar(85), allowRefAccess char(1), session_id nvarchar(15), bundle_id nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSEDOWNLOADS_AUD PRIMARY KEY (aud_id))
GO

insert into courseDownloads_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,downloadid
 ,courseid
 ,fileURL
 ,URLType
 ,description
 ,prePostType
 ,ordering
 ,update_meaning
 ,ekpfiles_revision_id
 ,allowRefAccess
 ,session_id
 ,bundle_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,downloadid
 ,courseid
 ,fileURL
 ,URLType
 ,description
 ,prePostType
 ,ordering
 ,update_meaning
 ,ekpfiles_revision_id
 ,allowRefAccess
 ,session_id
 ,bundle_id
  from courseDownloads
GO

CREATE INDEX nuk_courseDownloads_aud_1 ON courseDownloads_aud(aud_userid)
GO

CREATE INDEX nuk_courseDownloads_aud_2 ON courseDownloads_aud(aud_datetime)
GO

create trigger i_courseDownloads on courseDownloads
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into courseDownloads (
downloadid,courseid,fileURL,URLType,description,prePostType,ordering,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,ekpfiles_revision_id,allowRefAccess,session_id,bundle_id) select downloadid,courseid,fileURL,URLType,description,prePostType,ordering,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,ekpfiles_revision_id,allowRefAccess,session_id,bundle_id from inserted
insert into courseDownloads_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,downloadid
 ,courseid
 ,fileURL
 ,URLType
 ,description
 ,prePostType
 ,ordering
 ,update_meaning
 ,ekpfiles_revision_id
 ,allowRefAccess
 ,session_id
 ,bundle_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,downloadid
 ,courseid
 ,fileURL
 ,URLType
 ,description
 ,prePostType
 ,ordering
 ,update_meaning
 ,ekpfiles_revision_id
 ,allowRefAccess
 ,session_id
 ,bundle_id
  from inserted
end
GO

create trigger u_courseDownloads on courseDownloads
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update courseDownloads set
courseDownloads.downloadid = inserted.downloadid,courseDownloads.courseid = inserted.courseid,courseDownloads.fileURL = inserted.fileURL,courseDownloads.URLType = inserted.URLType,courseDownloads.description = inserted.description,courseDownloads.prePostType = inserted.prePostType,courseDownloads.ordering = inserted.ordering,courseDownloads.update_meaning = inserted.update_meaning,courseDownloads.last_updated = inserted.last_updated,courseDownloads.updater_legal_name = inserted.updater_legal_name,courseDownloads.update_meaning_text = inserted.update_meaning_text,courseDownloads.last_updater_uid = inserted.last_updater_uid,courseDownloads.ekpfiles_revision_id = inserted.ekpfiles_revision_id,courseDownloads.allowRefAccess = inserted.allowRefAccess,courseDownloads.session_id = inserted.session_id,courseDownloads.bundle_id = inserted.bundle_id
from courseDownloads inner join deleted on courseDownloads.downloadid = deleted.downloadid inner join inserted on courseDownloads.downloadid = inserted.downloadid
insert into courseDownloads_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,downloadid
 ,courseid
 ,fileURL
 ,URLType
 ,description
 ,prePostType
 ,ordering
 ,update_meaning
 ,ekpfiles_revision_id
 ,allowRefAccess
 ,session_id
 ,bundle_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,downloadid
 ,courseid
 ,fileURL
 ,URLType
 ,description
 ,prePostType
 ,ordering
 ,update_meaning
 ,ekpfiles_revision_id
 ,allowRefAccess
 ,session_id
 ,bundle_id
  from inserted
end
GO

create trigger d_courseDownloads on courseDownloads
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from courseDownloads where exists (
select 1 from deleted where courseDownloads.downloadid = deleted.downloadid)
insert into courseDownloads_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,downloadid
 ,courseid
 ,fileURL
 ,URLType
 ,description
 ,prePostType
 ,ordering
 ,update_meaning
 ,ekpfiles_revision_id
 ,allowRefAccess
 ,session_id
 ,bundle_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,downloadid
 ,courseid
 ,fileURL
 ,URLType
 ,description
 ,prePostType
 ,ordering
 ,update_meaning
 ,ekpfiles_revision_id
 ,allowRefAccess
 ,session_id
 ,bundle_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-courseDownloads', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1058, '8:c6683e3a42a9da2f78f4f786cd08c07b', 'enableAuditTable auditTableName=courseDownloads_aud, tableName=courseDownloads', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-course_session_cost::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_course_session_cost'
			)
			DROP TRIGGER i_course_session_cost
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_course_session_cost'
			)
			DROP TRIGGER u_course_session_cost
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_course_session_cost'
			)
			DROP TRIGGER d_course_session_cost
GO

CREATE TABLE course_session_cost_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_course_session_cost_aud_aud_datetime DEFAULT GETDATE() NOT NULL, eventid nvarchar(15), session_cost_id nvarchar(15), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSE_SESSION_COST_AUD PRIMARY KEY (aud_id))
GO

insert into course_session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,session_cost_id
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,eventid
 ,session_cost_id
 ,update_meaning
  from course_session_cost
GO

CREATE INDEX nuk_course_session_cost_aud_1 ON course_session_cost_aud(aud_userid)
GO

CREATE INDEX nuk_course_session_cost_aud_2 ON course_session_cost_aud(aud_datetime)
GO

create trigger i_course_session_cost on course_session_cost
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into course_session_cost (
eventid,session_cost_id,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select eventid,session_cost_id,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into course_session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,session_cost_id
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,session_cost_id
 ,update_meaning
  from inserted
end
GO

create trigger u_course_session_cost on course_session_cost
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update course_session_cost set
course_session_cost.eventid = inserted.eventid,course_session_cost.session_cost_id = inserted.session_cost_id,course_session_cost.update_meaning = inserted.update_meaning,course_session_cost.last_updated = inserted.last_updated,course_session_cost.updater_legal_name = inserted.updater_legal_name,course_session_cost.update_meaning_text = inserted.update_meaning_text,course_session_cost.last_updater_uid = inserted.last_updater_uid
from course_session_cost inner join deleted on course_session_cost.eventid = deleted.eventid and course_session_cost.session_cost_id = deleted.session_cost_id inner join inserted on course_session_cost.eventid = inserted.eventid and course_session_cost.session_cost_id = inserted.session_cost_id
insert into course_session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,session_cost_id
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,session_cost_id
 ,update_meaning
  from inserted
end
GO

create trigger d_course_session_cost on course_session_cost
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from course_session_cost where exists (
select 1 from deleted where course_session_cost.eventid = deleted.eventid and course_session_cost.session_cost_id = deleted.session_cost_id)
insert into course_session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,session_cost_id
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,session_cost_id
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-course_session_cost', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1059, '8:f369374704dc812dbd0b37c991980c23', 'enableAuditTable auditTableName=course_session_cost_aud, tableName=course_session_cost', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-coursetest::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_coursetest'
			)
			DROP TRIGGER i_coursetest
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_coursetest'
			)
			DROP TRIGGER u_coursetest
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_coursetest'
			)
			DROP TRIGGER d_coursetest
GO

CREATE TABLE coursetest_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_coursetest_aud_aud_datetime DEFAULT GETDATE() NOT NULL, courseid nvarchar(85), testid nvarchar(100), exam_type char(1), update_meaning nvarchar(8), lang_option nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSETEST_AUD PRIMARY KEY (aud_id))
GO

insert into coursetest_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,testid
 ,exam_type
 ,update_meaning
 ,lang_option
) select 'U', null
, null
, GETDATE(), null
, null
 ,courseid
 ,testid
 ,exam_type
 ,update_meaning
 ,lang_option
  from coursetest
GO

CREATE INDEX nuk_coursetest_aud_1 ON coursetest_aud(aud_userid)
GO

CREATE INDEX nuk_coursetest_aud_2 ON coursetest_aud(aud_datetime)
GO

create trigger i_coursetest on coursetest
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into coursetest (
courseid,testid,exam_type,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,lang_option) select courseid,testid,exam_type,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,lang_option from inserted
insert into coursetest_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,testid
 ,exam_type
 ,update_meaning
 ,lang_option
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,testid
 ,exam_type
 ,update_meaning
 ,lang_option
  from inserted
end
GO

create trigger u_coursetest on coursetest
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update coursetest set
coursetest.courseid = inserted.courseid,coursetest.testid = inserted.testid,coursetest.exam_type = inserted.exam_type,coursetest.update_meaning = inserted.update_meaning,coursetest.last_updated = inserted.last_updated,coursetest.updater_legal_name = inserted.updater_legal_name,coursetest.update_meaning_text = inserted.update_meaning_text,coursetest.last_updater_uid = inserted.last_updater_uid,coursetest.lang_option = inserted.lang_option
from coursetest inner join deleted on coursetest.courseid = deleted.courseid and coursetest.testid = deleted.testid inner join inserted on coursetest.courseid = inserted.courseid and coursetest.testid = inserted.testid
insert into coursetest_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,testid
 ,exam_type
 ,update_meaning
 ,lang_option
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,testid
 ,exam_type
 ,update_meaning
 ,lang_option
  from inserted
end
GO

create trigger d_coursetest on coursetest
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from coursetest where exists (
select 1 from deleted where coursetest.courseid = deleted.courseid and coursetest.testid = deleted.testid)
insert into coursetest_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,testid
 ,exam_type
 ,update_meaning
 ,lang_option
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,testid
 ,exam_type
 ,update_meaning
 ,lang_option
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-coursetest', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1060, '8:fafe945facdf0434b9894ec06206aa47', 'enableAuditTable auditTableName=coursetest_aud, tableName=coursetest', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-cschedule::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_cschedule'
			)
			DROP TRIGGER i_cschedule
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_cschedule'
			)
			DROP TRIGGER u_cschedule
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_cschedule'
			)
			DROP TRIGGER d_cschedule
GO

CREATE TABLE cschedule_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_cschedule_aud_aud_datetime DEFAULT GETDATE() NOT NULL, eventid nvarchar(15), courseid nvarchar(85), eventstatus smallint, availability nvarchar(1), startdate datetime, enddate datetime, timezone varchar(50), vcchannel nvarchar(85), contactinfo nvarchar(255), comments nvarchar(255), seat_limit_rule varchar(1), seatlimit int, min_size int, facilityid nvarchar(15), location nvarchar(255), enrollDeadline datetime, institution nvarchar(50), approverid1 nvarchar(85), regcontrol1 smallint, approverid2 nvarchar(85), regcontrol2 smallint, currency nvarchar(15), billed char(1), ntraininghours float(53), usage_expiration_date datetime, n_allowed_usage_days int, enrollBeginDate datetime, withdrawn_nday int, completionDateLimit datetime, scheduleComments nvarchar(255), useCustomText nvarchar(1), geographic_region nvarchar(255), hw_duedate datetime, use_nday int, cpd_credits float(53), complete_by_date datetime, complete_in_days int, enforce_deadline nvarchar(1), sequence int, description nvarchar(MAX), session_title nvarchar(255), session_code nvarchar(85), ew_id nvarchar(15), is_wf_assign_disabled char(1), tutor_select_type char(1), update_meaning nvarchar(8), attendance_sheet_url nvarchar(255), create_date datetime, dept_enroll_limit int, bundle_id nvarchar(85), set_endedstatus_on_enddate char(1), is_allow_update_total_time char(1), session_selector nvarchar(2), exchange_server_id nvarchar(15), enroll_cnt_method nvarchar(1), allow_self_enroll_to_prompt nvarchar(1), assigned_forum numeric(16, 0), assigned_forum_type nvarchar(1), show_session_sel_rmdr nvarchar(1), transfer_dropped_to_session nvarchar(15), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CSCHEDULE_AUD PRIMARY KEY (aud_id))
GO

insert into cschedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,courseid
 ,eventstatus
 ,availability
 ,startdate
 ,enddate
 ,timezone
 ,vcchannel
 ,contactinfo
 ,comments
 ,seat_limit_rule
 ,seatlimit
 ,min_size
 ,facilityid
 ,location
 ,enrollDeadline
 ,institution
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,currency
 ,billed
 ,ntraininghours
 ,usage_expiration_date
 ,n_allowed_usage_days
 ,enrollBeginDate
 ,withdrawn_nday
 ,completionDateLimit
 ,scheduleComments
 ,useCustomText
 ,geographic_region
 ,hw_duedate
 ,use_nday
 ,cpd_credits
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,sequence
 ,description
 ,session_title
 ,session_code
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,attendance_sheet_url
 ,create_date
 ,dept_enroll_limit
 ,bundle_id
 ,set_endedstatus_on_enddate
 ,is_allow_update_total_time
 ,session_selector
 ,exchange_server_id
 ,enroll_cnt_method
 ,allow_self_enroll_to_prompt
 ,assigned_forum
 ,assigned_forum_type
 ,show_session_sel_rmdr
 ,transfer_dropped_to_session
) select 'U', null
, null
, GETDATE(), null
, null
 ,eventid
 ,courseid
 ,eventstatus
 ,availability
 ,startdate
 ,enddate
 ,timezone
 ,vcchannel
 ,contactinfo
 ,comments
 ,seat_limit_rule
 ,seatlimit
 ,min_size
 ,facilityid
 ,location
 ,enrollDeadline
 ,institution
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,currency
 ,billed
 ,ntraininghours
 ,usage_expiration_date
 ,n_allowed_usage_days
 ,enrollBeginDate
 ,withdrawn_nday
 ,completionDateLimit
 ,scheduleComments
 ,useCustomText
 ,geographic_region
 ,hw_duedate
 ,use_nday
 ,cpd_credits
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,sequence
 ,description
 ,session_title
 ,session_code
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,attendance_sheet_url
 ,create_date
 ,dept_enroll_limit
 ,bundle_id
 ,set_endedstatus_on_enddate
 ,is_allow_update_total_time
 ,session_selector
 ,exchange_server_id
 ,enroll_cnt_method
 ,allow_self_enroll_to_prompt
 ,assigned_forum
 ,assigned_forum_type
 ,show_session_sel_rmdr
 ,transfer_dropped_to_session
  from cschedule
GO

CREATE INDEX nuk_cschedule_aud_1 ON cschedule_aud(aud_userid)
GO

CREATE INDEX nuk_cschedule_aud_2 ON cschedule_aud(aud_datetime)
GO

create trigger i_cschedule on cschedule
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into cschedule (
eventid,courseid,eventstatus,availability,startdate,enddate,timezone,vcchannel,contactinfo,comments,seat_limit_rule,seatlimit,min_size,facilityid,location,enrollDeadline,institution,approverid1,regcontrol1,approverid2,regcontrol2,currency,billed,ntraininghours,usage_expiration_date,n_allowed_usage_days,enrollBeginDate,withdrawn_nday,completionDateLimit,scheduleComments,useCustomText,geographic_region,hw_duedate,use_nday,cpd_credits,complete_by_date,complete_in_days,enforce_deadline,sequence,description,session_title,session_code,ew_id,is_wf_assign_disabled,tutor_select_type,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,attendance_sheet_url,create_date,dept_enroll_limit,bundle_id,set_endedstatus_on_enddate,is_allow_update_total_time,session_selector,exchange_server_id,enroll_cnt_method,allow_self_enroll_to_prompt,assigned_forum,assigned_forum_type,show_session_sel_rmdr,transfer_dropped_to_session) select eventid,courseid,eventstatus,availability,startdate,enddate,timezone,vcchannel,contactinfo,comments,seat_limit_rule,seatlimit,min_size,facilityid,location,enrollDeadline,institution,approverid1,regcontrol1,approverid2,regcontrol2,currency,billed,ntraininghours,usage_expiration_date,n_allowed_usage_days,enrollBeginDate,withdrawn_nday,completionDateLimit,scheduleComments,useCustomText,geographic_region,hw_duedate,use_nday,cpd_credits,complete_by_date,complete_in_days,enforce_deadline,sequence,description,session_title,session_code,ew_id,is_wf_assign_disabled,tutor_select_type,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,attendance_sheet_url,create_date,dept_enroll_limit,bundle_id,set_endedstatus_on_enddate,is_allow_update_total_time,session_selector,exchange_server_id,enroll_cnt_method,allow_self_enroll_to_prompt,assigned_forum,assigned_forum_type,show_session_sel_rmdr,transfer_dropped_to_session from inserted
insert into cschedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,courseid
 ,eventstatus
 ,availability
 ,startdate
 ,enddate
 ,timezone
 ,vcchannel
 ,contactinfo
 ,comments
 ,seat_limit_rule
 ,seatlimit
 ,min_size
 ,facilityid
 ,location
 ,enrollDeadline
 ,institution
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,currency
 ,billed
 ,ntraininghours
 ,usage_expiration_date
 ,n_allowed_usage_days
 ,enrollBeginDate
 ,withdrawn_nday
 ,completionDateLimit
 ,scheduleComments
 ,useCustomText
 ,geographic_region
 ,hw_duedate
 ,use_nday
 ,cpd_credits
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,sequence
 ,description
 ,session_title
 ,session_code
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,attendance_sheet_url
 ,create_date
 ,dept_enroll_limit
 ,bundle_id
 ,set_endedstatus_on_enddate
 ,is_allow_update_total_time
 ,session_selector
 ,exchange_server_id
 ,enroll_cnt_method
 ,allow_self_enroll_to_prompt
 ,assigned_forum
 ,assigned_forum_type
 ,show_session_sel_rmdr
 ,transfer_dropped_to_session
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,courseid
 ,eventstatus
 ,availability
 ,startdate
 ,enddate
 ,timezone
 ,vcchannel
 ,contactinfo
 ,comments
 ,seat_limit_rule
 ,seatlimit
 ,min_size
 ,facilityid
 ,location
 ,enrollDeadline
 ,institution
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,currency
 ,billed
 ,ntraininghours
 ,usage_expiration_date
 ,n_allowed_usage_days
 ,enrollBeginDate
 ,withdrawn_nday
 ,completionDateLimit
 ,scheduleComments
 ,useCustomText
 ,geographic_region
 ,hw_duedate
 ,use_nday
 ,cpd_credits
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,sequence
 ,description
 ,session_title
 ,session_code
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,attendance_sheet_url
 ,create_date
 ,dept_enroll_limit
 ,bundle_id
 ,set_endedstatus_on_enddate
 ,is_allow_update_total_time
 ,session_selector
 ,exchange_server_id
 ,enroll_cnt_method
 ,allow_self_enroll_to_prompt
 ,assigned_forum
 ,assigned_forum_type
 ,show_session_sel_rmdr
 ,transfer_dropped_to_session
  from inserted
end
GO

create trigger u_cschedule on cschedule
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update cschedule set
cschedule.eventid = inserted.eventid,cschedule.courseid = inserted.courseid,cschedule.eventstatus = inserted.eventstatus,cschedule.availability = inserted.availability,cschedule.startdate = inserted.startdate,cschedule.enddate = inserted.enddate,cschedule.timezone = inserted.timezone,cschedule.vcchannel = inserted.vcchannel,cschedule.contactinfo = inserted.contactinfo,cschedule.comments = inserted.comments,cschedule.seat_limit_rule = inserted.seat_limit_rule,cschedule.seatlimit = inserted.seatlimit,cschedule.min_size = inserted.min_size,cschedule.facilityid = inserted.facilityid,cschedule.location = inserted.location,cschedule.enrollDeadline = inserted.enrollDeadline,cschedule.institution = inserted.institution,cschedule.approverid1 = inserted.approverid1,cschedule.regcontrol1 = inserted.regcontrol1,cschedule.approverid2 = inserted.approverid2,cschedule.regcontrol2 = inserted.regcontrol2,cschedule.currency = inserted.currency,cschedule.billed = inserted.billed,cschedule.ntraininghours = inserted.ntraininghours,cschedule.usage_expiration_date = inserted.usage_expiration_date,cschedule.n_allowed_usage_days = inserted.n_allowed_usage_days,cschedule.enrollBeginDate = inserted.enrollBeginDate,cschedule.withdrawn_nday = inserted.withdrawn_nday,cschedule.completionDateLimit = inserted.completionDateLimit,cschedule.scheduleComments = inserted.scheduleComments,cschedule.useCustomText = inserted.useCustomText,cschedule.geographic_region = inserted.geographic_region,cschedule.hw_duedate = inserted.hw_duedate,cschedule.use_nday = inserted.use_nday,cschedule.cpd_credits = inserted.cpd_credits,cschedule.complete_by_date = inserted.complete_by_date,cschedule.complete_in_days = inserted.complete_in_days,cschedule.enforce_deadline = inserted.enforce_deadline,cschedule.sequence = inserted.sequence,cschedule.description = inserted.description,cschedule.session_title = inserted.session_title,cschedule.session_code = inserted.session_code,cschedule.ew_id = inserted.ew_id,cschedule.is_wf_assign_disabled = inserted.is_wf_assign_disabled,cschedule.tutor_select_type = inserted.tutor_select_type,cschedule.update_meaning = inserted.update_meaning,cschedule.last_updated = inserted.last_updated,cschedule.updater_legal_name = inserted.updater_legal_name,cschedule.update_meaning_text = inserted.update_meaning_text,cschedule.last_updater_uid = inserted.last_updater_uid,cschedule.attendance_sheet_url = inserted.attendance_sheet_url,cschedule.create_date = inserted.create_date,cschedule.dept_enroll_limit = inserted.dept_enroll_limit,cschedule.bundle_id = inserted.bundle_id,cschedule.set_endedstatus_on_enddate = inserted.set_endedstatus_on_enddate,cschedule.is_allow_update_total_time = inserted.is_allow_update_total_time,cschedule.session_selector = inserted.session_selector,cschedule.exchange_server_id = inserted.exchange_server_id,cschedule.enroll_cnt_method = inserted.enroll_cnt_method,cschedule.allow_self_enroll_to_prompt = inserted.allow_self_enroll_to_prompt,cschedule.assigned_forum = inserted.assigned_forum,cschedule.assigned_forum_type = inserted.assigned_forum_type,cschedule.show_session_sel_rmdr = inserted.show_session_sel_rmdr,cschedule.transfer_dropped_to_session = inserted.transfer_dropped_to_session
from cschedule inner join deleted on cschedule.eventid = deleted.eventid inner join inserted on cschedule.eventid = inserted.eventid
insert into cschedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,courseid
 ,eventstatus
 ,availability
 ,startdate
 ,enddate
 ,timezone
 ,vcchannel
 ,contactinfo
 ,comments
 ,seat_limit_rule
 ,seatlimit
 ,min_size
 ,facilityid
 ,location
 ,enrollDeadline
 ,institution
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,currency
 ,billed
 ,ntraininghours
 ,usage_expiration_date
 ,n_allowed_usage_days
 ,enrollBeginDate
 ,withdrawn_nday
 ,completionDateLimit
 ,scheduleComments
 ,useCustomText
 ,geographic_region
 ,hw_duedate
 ,use_nday
 ,cpd_credits
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,sequence
 ,description
 ,session_title
 ,session_code
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,attendance_sheet_url
 ,create_date
 ,dept_enroll_limit
 ,bundle_id
 ,set_endedstatus_on_enddate
 ,is_allow_update_total_time
 ,session_selector
 ,exchange_server_id
 ,enroll_cnt_method
 ,allow_self_enroll_to_prompt
 ,assigned_forum
 ,assigned_forum_type
 ,show_session_sel_rmdr
 ,transfer_dropped_to_session
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,courseid
 ,eventstatus
 ,availability
 ,startdate
 ,enddate
 ,timezone
 ,vcchannel
 ,contactinfo
 ,comments
 ,seat_limit_rule
 ,seatlimit
 ,min_size
 ,facilityid
 ,location
 ,enrollDeadline
 ,institution
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,currency
 ,billed
 ,ntraininghours
 ,usage_expiration_date
 ,n_allowed_usage_days
 ,enrollBeginDate
 ,withdrawn_nday
 ,completionDateLimit
 ,scheduleComments
 ,useCustomText
 ,geographic_region
 ,hw_duedate
 ,use_nday
 ,cpd_credits
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,sequence
 ,description
 ,session_title
 ,session_code
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,attendance_sheet_url
 ,create_date
 ,dept_enroll_limit
 ,bundle_id
 ,set_endedstatus_on_enddate
 ,is_allow_update_total_time
 ,session_selector
 ,exchange_server_id
 ,enroll_cnt_method
 ,allow_self_enroll_to_prompt
 ,assigned_forum
 ,assigned_forum_type
 ,show_session_sel_rmdr
 ,transfer_dropped_to_session
  from inserted
end
GO

create trigger d_cschedule on cschedule
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from cschedule where exists (
select 1 from deleted where cschedule.eventid = deleted.eventid)
insert into cschedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,courseid
 ,eventstatus
 ,availability
 ,startdate
 ,enddate
 ,timezone
 ,vcchannel
 ,contactinfo
 ,comments
 ,seat_limit_rule
 ,seatlimit
 ,min_size
 ,facilityid
 ,location
 ,enrollDeadline
 ,institution
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,currency
 ,billed
 ,ntraininghours
 ,usage_expiration_date
 ,n_allowed_usage_days
 ,enrollBeginDate
 ,withdrawn_nday
 ,completionDateLimit
 ,scheduleComments
 ,useCustomText
 ,geographic_region
 ,hw_duedate
 ,use_nday
 ,cpd_credits
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,sequence
 ,description
 ,session_title
 ,session_code
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,attendance_sheet_url
 ,create_date
 ,dept_enroll_limit
 ,bundle_id
 ,set_endedstatus_on_enddate
 ,is_allow_update_total_time
 ,session_selector
 ,exchange_server_id
 ,enroll_cnt_method
 ,allow_self_enroll_to_prompt
 ,assigned_forum
 ,assigned_forum_type
 ,show_session_sel_rmdr
 ,transfer_dropped_to_session
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,courseid
 ,eventstatus
 ,availability
 ,startdate
 ,enddate
 ,timezone
 ,vcchannel
 ,contactinfo
 ,comments
 ,seat_limit_rule
 ,seatlimit
 ,min_size
 ,facilityid
 ,location
 ,enrollDeadline
 ,institution
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,currency
 ,billed
 ,ntraininghours
 ,usage_expiration_date
 ,n_allowed_usage_days
 ,enrollBeginDate
 ,withdrawn_nday
 ,completionDateLimit
 ,scheduleComments
 ,useCustomText
 ,geographic_region
 ,hw_duedate
 ,use_nday
 ,cpd_credits
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,sequence
 ,description
 ,session_title
 ,session_code
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,attendance_sheet_url
 ,create_date
 ,dept_enroll_limit
 ,bundle_id
 ,set_endedstatus_on_enddate
 ,is_allow_update_total_time
 ,session_selector
 ,exchange_server_id
 ,enroll_cnt_method
 ,allow_self_enroll_to_prompt
 ,assigned_forum
 ,assigned_forum_type
 ,show_session_sel_rmdr
 ,transfer_dropped_to_session
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-cschedule', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1061, '8:40a7cded9fd38aa297add9d5a07a63da', 'enableAuditTable auditTableName=cschedule_aud, tableName=cschedule', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-module_session_schedule::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_module_session_schedule'
			)
			DROP TRIGGER i_module_session_schedule
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_module_session_schedule'
			)
			DROP TRIGGER u_module_session_schedule
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_module_session_schedule'
			)
			DROP TRIGGER d_module_session_schedule
GO

CREATE TABLE module_sess_schedule_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_module_sess_schedule_aud_aud_datetime DEFAULT GETDATE() NOT NULL, eventid nvarchar(15), sessionid nvarchar(15), startdate datetime, enddate datetime, utc_start_date datetime, utc_end_date datetime, facilityid nvarchar(15), location nvarchar(255), ignore_conflict char(1), room_name nvarchar(255), update_meaning nvarchar(8), seating_arrangement nvarchar(20), exchange_item_id nvarchar(200), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_MODULE_SESS_SCHEDULE_AUD PRIMARY KEY (aud_id))
GO

insert into module_sess_schedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,sessionid
 ,startdate
 ,enddate
 ,utc_start_date
 ,utc_end_date
 ,facilityid
 ,location
 ,ignore_conflict
 ,room_name
 ,update_meaning
 ,seating_arrangement
 ,exchange_item_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,eventid
 ,sessionid
 ,startdate
 ,enddate
 ,utc_start_date
 ,utc_end_date
 ,facilityid
 ,location
 ,ignore_conflict
 ,room_name
 ,update_meaning
 ,seating_arrangement
 ,exchange_item_id
  from module_session_schedule
GO

CREATE INDEX nuk_module_sess_schedule_aud_1 ON module_sess_schedule_aud(aud_userid)
GO

CREATE INDEX nuk_module_sess_schedule_aud_2 ON module_sess_schedule_aud(aud_datetime)
GO

create trigger i_module_session_schedule on module_session_schedule
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into module_session_schedule (
eventid,sessionid,startdate,enddate,utc_start_date,utc_end_date,facilityid,location,ignore_conflict,room_name,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,seating_arrangement,exchange_item_id) select eventid,sessionid,startdate,enddate,utc_start_date,utc_end_date,facilityid,location,ignore_conflict,room_name,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,seating_arrangement,exchange_item_id from inserted
insert into module_sess_schedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,sessionid
 ,startdate
 ,enddate
 ,utc_start_date
 ,utc_end_date
 ,facilityid
 ,location
 ,ignore_conflict
 ,room_name
 ,update_meaning
 ,seating_arrangement
 ,exchange_item_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,sessionid
 ,startdate
 ,enddate
 ,utc_start_date
 ,utc_end_date
 ,facilityid
 ,location
 ,ignore_conflict
 ,room_name
 ,update_meaning
 ,seating_arrangement
 ,exchange_item_id
  from inserted
end
GO

create trigger u_module_session_schedule on module_session_schedule
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update module_session_schedule set
module_session_schedule.eventid = inserted.eventid,module_session_schedule.sessionid = inserted.sessionid,module_session_schedule.startdate = inserted.startdate,module_session_schedule.enddate = inserted.enddate,module_session_schedule.utc_start_date = inserted.utc_start_date,module_session_schedule.utc_end_date = inserted.utc_end_date,module_session_schedule.facilityid = inserted.facilityid,module_session_schedule.location = inserted.location,module_session_schedule.ignore_conflict = inserted.ignore_conflict,module_session_schedule.room_name = inserted.room_name,module_session_schedule.update_meaning = inserted.update_meaning,module_session_schedule.last_updated = inserted.last_updated,module_session_schedule.updater_legal_name = inserted.updater_legal_name,module_session_schedule.update_meaning_text = inserted.update_meaning_text,module_session_schedule.last_updater_uid = inserted.last_updater_uid,module_session_schedule.seating_arrangement = inserted.seating_arrangement,module_session_schedule.exchange_item_id = inserted.exchange_item_id
from module_session_schedule inner join deleted on module_session_schedule.eventid = deleted.eventid inner join inserted on module_session_schedule.eventid = inserted.eventid
insert into module_sess_schedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,sessionid
 ,startdate
 ,enddate
 ,utc_start_date
 ,utc_end_date
 ,facilityid
 ,location
 ,ignore_conflict
 ,room_name
 ,update_meaning
 ,seating_arrangement
 ,exchange_item_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,sessionid
 ,startdate
 ,enddate
 ,utc_start_date
 ,utc_end_date
 ,facilityid
 ,location
 ,ignore_conflict
 ,room_name
 ,update_meaning
 ,seating_arrangement
 ,exchange_item_id
  from inserted
end
GO

create trigger d_module_session_schedule on module_session_schedule
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from module_session_schedule where exists (
select 1 from deleted where module_session_schedule.eventid = deleted.eventid)
insert into module_sess_schedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,sessionid
 ,startdate
 ,enddate
 ,utc_start_date
 ,utc_end_date
 ,facilityid
 ,location
 ,ignore_conflict
 ,room_name
 ,update_meaning
 ,seating_arrangement
 ,exchange_item_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,sessionid
 ,startdate
 ,enddate
 ,utc_start_date
 ,utc_end_date
 ,facilityid
 ,location
 ,ignore_conflict
 ,room_name
 ,update_meaning
 ,seating_arrangement
 ,exchange_item_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-module_session_schedule', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1062, '8:5d6708956c28da8c0c05d717a6aac3f7', 'enableAuditTable auditTableName=module_sess_schedule_aud, tableName=module_session_schedule', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-currcourses::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_currcourses'
			)
			DROP TRIGGER i_currcourses
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_currcourses'
			)
			DROP TRIGGER u_currcourses
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_currcourses'
			)
			DROP TRIGGER d_currcourses
GO

CREATE TABLE currcourses_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_currcourses_aud_aud_datetime DEFAULT GETDATE() NOT NULL, currid nvarchar(85), sessionid nvarchar(15), courseOrder tinyint, courseid nvarchar(85), eventid nvarchar(15), required char(1), enrollbydefault char(1), update_meaning nvarchar(8), modulecredits float(53), weighting float(53), complete_by_date datetime, complete_in_days int, complete_days_flag char(1), enrollAvailableDate datetime, start_on_date datetime, start_in_days int, enrollDateFlag char(1), enrollNDays int, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CURRCOURSES_AUD PRIMARY KEY (aud_id))
GO

insert into currcourses_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,courseOrder
 ,courseid
 ,eventid
 ,required
 ,enrollbydefault
 ,update_meaning
 ,modulecredits
 ,weighting
 ,complete_by_date
 ,complete_in_days
 ,complete_days_flag
 ,enrollAvailableDate
 ,start_on_date
 ,start_in_days
 ,enrollDateFlag
 ,enrollNDays
) select 'U', null
, null
, GETDATE(), null
, null
 ,currid
 ,sessionid
 ,courseOrder
 ,courseid
 ,eventid
 ,required
 ,enrollbydefault
 ,update_meaning
 ,modulecredits
 ,weighting
 ,complete_by_date
 ,complete_in_days
 ,complete_days_flag
 ,enrollAvailableDate
 ,start_on_date
 ,start_in_days
 ,enrollDateFlag
 ,enrollNDays
  from currcourses
GO

CREATE INDEX nuk_currcourses_aud_1 ON currcourses_aud(aud_userid)
GO

CREATE INDEX nuk_currcourses_aud_2 ON currcourses_aud(aud_datetime)
GO

create trigger i_currcourses on currcourses
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into currcourses (
currid,sessionid,courseOrder,courseid,eventid,required,enrollbydefault,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,modulecredits,weighting,complete_by_date,complete_in_days,complete_days_flag,enrollAvailableDate,start_on_date,start_in_days,enrollDateFlag,enrollNDays) select currid,sessionid,courseOrder,courseid,eventid,required,enrollbydefault,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,modulecredits,weighting,complete_by_date,complete_in_days,complete_days_flag,enrollAvailableDate,start_on_date,start_in_days,enrollDateFlag,enrollNDays from inserted
insert into currcourses_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,courseOrder
 ,courseid
 ,eventid
 ,required
 ,enrollbydefault
 ,update_meaning
 ,modulecredits
 ,weighting
 ,complete_by_date
 ,complete_in_days
 ,complete_days_flag
 ,enrollAvailableDate
 ,start_on_date
 ,start_in_days
 ,enrollDateFlag
 ,enrollNDays
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,sessionid
 ,courseOrder
 ,courseid
 ,eventid
 ,required
 ,enrollbydefault
 ,update_meaning
 ,modulecredits
 ,weighting
 ,complete_by_date
 ,complete_in_days
 ,complete_days_flag
 ,enrollAvailableDate
 ,start_on_date
 ,start_in_days
 ,enrollDateFlag
 ,enrollNDays
  from inserted
end
GO

create trigger u_currcourses on currcourses
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update currcourses set
currcourses.currid = inserted.currid,currcourses.sessionid = inserted.sessionid,currcourses.courseOrder = inserted.courseOrder,currcourses.courseid = inserted.courseid,currcourses.eventid = inserted.eventid,currcourses.required = inserted.required,currcourses.enrollbydefault = inserted.enrollbydefault,currcourses.update_meaning = inserted.update_meaning,currcourses.last_updated = inserted.last_updated,currcourses.updater_legal_name = inserted.updater_legal_name,currcourses.update_meaning_text = inserted.update_meaning_text,currcourses.last_updater_uid = inserted.last_updater_uid,currcourses.modulecredits = inserted.modulecredits,currcourses.weighting = inserted.weighting,currcourses.complete_by_date = inserted.complete_by_date,currcourses.complete_in_days = inserted.complete_in_days,currcourses.complete_days_flag = inserted.complete_days_flag,currcourses.enrollAvailableDate = inserted.enrollAvailableDate,currcourses.start_on_date = inserted.start_on_date,currcourses.start_in_days = inserted.start_in_days,currcourses.enrollDateFlag = inserted.enrollDateFlag,currcourses.enrollNDays = inserted.enrollNDays
from currcourses inner join deleted on currcourses.currid = deleted.currid and currcourses.sessionid = deleted.sessionid and currcourses.courseid = deleted.courseid and currcourses.eventid = deleted.eventid inner join inserted on currcourses.currid = inserted.currid and currcourses.sessionid = inserted.sessionid and currcourses.courseid = inserted.courseid and currcourses.eventid = inserted.eventid
insert into currcourses_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,courseOrder
 ,courseid
 ,eventid
 ,required
 ,enrollbydefault
 ,update_meaning
 ,modulecredits
 ,weighting
 ,complete_by_date
 ,complete_in_days
 ,complete_days_flag
 ,enrollAvailableDate
 ,start_on_date
 ,start_in_days
 ,enrollDateFlag
 ,enrollNDays
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,sessionid
 ,courseOrder
 ,courseid
 ,eventid
 ,required
 ,enrollbydefault
 ,update_meaning
 ,modulecredits
 ,weighting
 ,complete_by_date
 ,complete_in_days
 ,complete_days_flag
 ,enrollAvailableDate
 ,start_on_date
 ,start_in_days
 ,enrollDateFlag
 ,enrollNDays
  from inserted
end
GO

create trigger d_currcourses on currcourses
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from currcourses where exists (
select 1 from deleted where currcourses.currid = deleted.currid and currcourses.sessionid = deleted.sessionid and currcourses.courseid = deleted.courseid and currcourses.eventid = deleted.eventid)
insert into currcourses_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,courseOrder
 ,courseid
 ,eventid
 ,required
 ,enrollbydefault
 ,update_meaning
 ,modulecredits
 ,weighting
 ,complete_by_date
 ,complete_in_days
 ,complete_days_flag
 ,enrollAvailableDate
 ,start_on_date
 ,start_in_days
 ,enrollDateFlag
 ,enrollNDays
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,sessionid
 ,courseOrder
 ,courseid
 ,eventid
 ,required
 ,enrollbydefault
 ,update_meaning
 ,modulecredits
 ,weighting
 ,complete_by_date
 ,complete_in_days
 ,complete_days_flag
 ,enrollAvailableDate
 ,start_on_date
 ,start_in_days
 ,enrollDateFlag
 ,enrollNDays
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-currcourses', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1063, '8:0dced3a435bf13c0d50d04ae233aa680', 'enableAuditTable auditTableName=currcourses_aud, tableName=currcourses', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-curriculum::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_curriculum'
			)
			DROP TRIGGER i_curriculum
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_curriculum'
			)
			DROP TRIGGER u_curriculum
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_curriculum'
			)
			DROP TRIGGER d_curriculum
GO

CREATE TABLE curriculum_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_curriculum_aud_aud_datetime DEFAULT GETDATE() NOT NULL, currid nvarchar(85), certid numeric(8, 0), certtestid nvarchar(100), allowSelfEnrollment nvarchar(1), allowUserStatusChg nvarchar(1), prompt_for_withdraw_reason char(1), approverid1 nvarchar(85), regcontrol1 smallint, approverid2 nvarchar(85), regcontrol2 smallint, update_meaning nvarchar(8), progress_tracker char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CURRICULUM_AUD PRIMARY KEY (aud_id))
GO

insert into curriculum_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,certid
 ,certtestid
 ,allowSelfEnrollment
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,update_meaning
 ,progress_tracker
) select 'U', null
, null
, GETDATE(), null
, null
 ,currid
 ,certid
 ,certtestid
 ,allowSelfEnrollment
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,update_meaning
 ,progress_tracker
  from curriculum
GO

CREATE INDEX nuk_curriculum_aud_1 ON curriculum_aud(aud_userid)
GO

CREATE INDEX nuk_curriculum_aud_2 ON curriculum_aud(aud_datetime)
GO

create trigger i_curriculum on curriculum
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into curriculum (
currid,certid,certtestid,allowSelfEnrollment,allowUserStatusChg,prompt_for_withdraw_reason,approverid1,regcontrol1,approverid2,regcontrol2,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,progress_tracker) select currid,certid,certtestid,allowSelfEnrollment,allowUserStatusChg,prompt_for_withdraw_reason,approverid1,regcontrol1,approverid2,regcontrol2,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,progress_tracker from inserted
insert into curriculum_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,certid
 ,certtestid
 ,allowSelfEnrollment
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,update_meaning
 ,progress_tracker
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,certid
 ,certtestid
 ,allowSelfEnrollment
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,update_meaning
 ,progress_tracker
  from inserted
end
GO

create trigger u_curriculum on curriculum
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update curriculum set
curriculum.currid = inserted.currid,curriculum.certid = inserted.certid,curriculum.certtestid = inserted.certtestid,curriculum.allowSelfEnrollment = inserted.allowSelfEnrollment,curriculum.allowUserStatusChg = inserted.allowUserStatusChg,curriculum.prompt_for_withdraw_reason = inserted.prompt_for_withdraw_reason,curriculum.approverid1 = inserted.approverid1,curriculum.regcontrol1 = inserted.regcontrol1,curriculum.approverid2 = inserted.approverid2,curriculum.regcontrol2 = inserted.regcontrol2,curriculum.update_meaning = inserted.update_meaning,curriculum.last_updated = inserted.last_updated,curriculum.updater_legal_name = inserted.updater_legal_name,curriculum.update_meaning_text = inserted.update_meaning_text,curriculum.last_updater_uid = inserted.last_updater_uid,curriculum.progress_tracker = inserted.progress_tracker
from curriculum inner join deleted on curriculum.currid = deleted.currid inner join inserted on curriculum.currid = inserted.currid
insert into curriculum_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,certid
 ,certtestid
 ,allowSelfEnrollment
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,update_meaning
 ,progress_tracker
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,certid
 ,certtestid
 ,allowSelfEnrollment
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,update_meaning
 ,progress_tracker
  from inserted
end
GO

create trigger d_curriculum on curriculum
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from curriculum where exists (
select 1 from deleted where curriculum.currid = deleted.currid)
insert into curriculum_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,certid
 ,certtestid
 ,allowSelfEnrollment
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,update_meaning
 ,progress_tracker
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,certid
 ,certtestid
 ,allowSelfEnrollment
 ,allowUserStatusChg
 ,prompt_for_withdraw_reason
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,update_meaning
 ,progress_tracker
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-curriculum', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1064, '8:cb4648dda96336923c01e8b3f090031c', 'enableAuditTable auditTableName=curriculum_aud, tableName=curriculum', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-enrollment_policy::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_enrollment_policy'
			)
			DROP TRIGGER i_enrollment_policy
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_enrollment_policy'
			)
			DROP TRIGGER u_enrollment_policy
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_enrollment_policy'
			)
			DROP TRIGGER d_enrollment_policy
GO

CREATE TABLE enrollment_policy_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_enrollment_policy_aud_aud_datetime DEFAULT GETDATE() NOT NULL, policy_id nvarchar(15), policy_name nvarchar(50), remarks nvarchar(255), is_active char(1), withdraw_email_profile_id nvarchar(15), approved_email_profile_id nvarchar(15), send_group_enroll char(1), send_auto_enroll char(1), send_self_enroll char(1), reject_email_profile_id nvarchar(15), enroll_email_profile_id nvarchar(15), allow_approval_withdrawal char(1), prompt_for_withdraw_reason char(1), consider_pay_plan char(1), all_parallel_steps_must_approv char(1), policyDetails nvarchar(MAX), waitedListed_email_profile_id nvarchar(15), enroll_pend_email_profile_id nvarchar(15), session_trans_email_profile_id nvarchar(15), creator_uid nvarchar(85), datecreated datetime, update_meaning nvarchar(8), domain_id nvarchar(15), new_ses_avail_email_profile_id nvarchar(15), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_ENROLLMENT_POLICY_AUD PRIMARY KEY (aud_id))
GO

insert into enrollment_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,policy_name
 ,remarks
 ,is_active
 ,withdraw_email_profile_id
 ,approved_email_profile_id
 ,send_group_enroll
 ,send_auto_enroll
 ,send_self_enroll
 ,reject_email_profile_id
 ,enroll_email_profile_id
 ,allow_approval_withdrawal
 ,prompt_for_withdraw_reason
 ,consider_pay_plan
 ,all_parallel_steps_must_approv
 ,policyDetails
 ,waitedListed_email_profile_id
 ,enroll_pend_email_profile_id
 ,session_trans_email_profile_id
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,domain_id
 ,new_ses_avail_email_profile_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,policy_id
 ,policy_name
 ,remarks
 ,is_active
 ,withdraw_email_profile_id
 ,approved_email_profile_id
 ,send_group_enroll
 ,send_auto_enroll
 ,send_self_enroll
 ,reject_email_profile_id
 ,enroll_email_profile_id
 ,allow_approval_withdrawal
 ,prompt_for_withdraw_reason
 ,consider_pay_plan
 ,all_parallel_steps_must_approv
 ,policyDetails
 ,waitedListed_email_profile_id
 ,enroll_pend_email_profile_id
 ,session_trans_email_profile_id
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,domain_id
 ,new_ses_avail_email_profile_id
  from enrollment_policy
GO

CREATE INDEX nuk_enrollment_policy_aud_1 ON enrollment_policy_aud(aud_userid)
GO

CREATE INDEX nuk_enrollment_policy_aud_2 ON enrollment_policy_aud(aud_datetime)
GO

create trigger i_enrollment_policy on enrollment_policy
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into enrollment_policy (
policy_id,policy_name,remarks,is_active,withdraw_email_profile_id,approved_email_profile_id,send_group_enroll,send_auto_enroll,send_self_enroll,reject_email_profile_id,enroll_email_profile_id,allow_approval_withdrawal,prompt_for_withdraw_reason,consider_pay_plan,all_parallel_steps_must_approv,policyDetails,waitedListed_email_profile_id,enroll_pend_email_profile_id,session_trans_email_profile_id,creator_uid,datecreated,last_updated,last_updater_uid,updater_legal_name,update_meaning_text,update_meaning,domain_id,new_ses_avail_email_profile_id) select policy_id,policy_name,remarks,is_active,withdraw_email_profile_id,approved_email_profile_id,send_group_enroll,send_auto_enroll,send_self_enroll,reject_email_profile_id,enroll_email_profile_id,allow_approval_withdrawal,prompt_for_withdraw_reason,consider_pay_plan,all_parallel_steps_must_approv,policyDetails,waitedListed_email_profile_id,enroll_pend_email_profile_id,session_trans_email_profile_id,creator_uid,datecreated,last_updated,last_updater_uid,updater_legal_name,update_meaning_text,update_meaning,domain_id,new_ses_avail_email_profile_id from inserted
insert into enrollment_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,policy_name
 ,remarks
 ,is_active
 ,withdraw_email_profile_id
 ,approved_email_profile_id
 ,send_group_enroll
 ,send_auto_enroll
 ,send_self_enroll
 ,reject_email_profile_id
 ,enroll_email_profile_id
 ,allow_approval_withdrawal
 ,prompt_for_withdraw_reason
 ,consider_pay_plan
 ,all_parallel_steps_must_approv
 ,policyDetails
 ,waitedListed_email_profile_id
 ,enroll_pend_email_profile_id
 ,session_trans_email_profile_id
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,domain_id
 ,new_ses_avail_email_profile_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,policy_name
 ,remarks
 ,is_active
 ,withdraw_email_profile_id
 ,approved_email_profile_id
 ,send_group_enroll
 ,send_auto_enroll
 ,send_self_enroll
 ,reject_email_profile_id
 ,enroll_email_profile_id
 ,allow_approval_withdrawal
 ,prompt_for_withdraw_reason
 ,consider_pay_plan
 ,all_parallel_steps_must_approv
 ,policyDetails
 ,waitedListed_email_profile_id
 ,enroll_pend_email_profile_id
 ,session_trans_email_profile_id
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,domain_id
 ,new_ses_avail_email_profile_id
  from inserted
end
GO

create trigger u_enrollment_policy on enrollment_policy
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update enrollment_policy set
enrollment_policy.policy_id = inserted.policy_id,enrollment_policy.policy_name = inserted.policy_name,enrollment_policy.remarks = inserted.remarks,enrollment_policy.is_active = inserted.is_active,enrollment_policy.withdraw_email_profile_id = inserted.withdraw_email_profile_id,enrollment_policy.approved_email_profile_id = inserted.approved_email_profile_id,enrollment_policy.send_group_enroll = inserted.send_group_enroll,enrollment_policy.send_auto_enroll = inserted.send_auto_enroll,enrollment_policy.send_self_enroll = inserted.send_self_enroll,enrollment_policy.reject_email_profile_id = inserted.reject_email_profile_id,enrollment_policy.enroll_email_profile_id = inserted.enroll_email_profile_id,enrollment_policy.allow_approval_withdrawal = inserted.allow_approval_withdrawal,enrollment_policy.prompt_for_withdraw_reason = inserted.prompt_for_withdraw_reason,enrollment_policy.consider_pay_plan = inserted.consider_pay_plan,enrollment_policy.all_parallel_steps_must_approv = inserted.all_parallel_steps_must_approv,enrollment_policy.policyDetails = inserted.policyDetails,enrollment_policy.waitedListed_email_profile_id = inserted.waitedListed_email_profile_id,enrollment_policy.enroll_pend_email_profile_id = inserted.enroll_pend_email_profile_id,enrollment_policy.session_trans_email_profile_id = inserted.session_trans_email_profile_id,enrollment_policy.creator_uid = inserted.creator_uid,enrollment_policy.datecreated = inserted.datecreated,enrollment_policy.last_updated = inserted.last_updated,enrollment_policy.last_updater_uid = inserted.last_updater_uid,enrollment_policy.updater_legal_name = inserted.updater_legal_name,enrollment_policy.update_meaning_text = inserted.update_meaning_text,enrollment_policy.update_meaning = inserted.update_meaning,enrollment_policy.domain_id = inserted.domain_id,enrollment_policy.new_ses_avail_email_profile_id = inserted.new_ses_avail_email_profile_id
from enrollment_policy inner join deleted on enrollment_policy.policy_id = deleted.policy_id inner join inserted on enrollment_policy.policy_id = inserted.policy_id
insert into enrollment_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,policy_name
 ,remarks
 ,is_active
 ,withdraw_email_profile_id
 ,approved_email_profile_id
 ,send_group_enroll
 ,send_auto_enroll
 ,send_self_enroll
 ,reject_email_profile_id
 ,enroll_email_profile_id
 ,allow_approval_withdrawal
 ,prompt_for_withdraw_reason
 ,consider_pay_plan
 ,all_parallel_steps_must_approv
 ,policyDetails
 ,waitedListed_email_profile_id
 ,enroll_pend_email_profile_id
 ,session_trans_email_profile_id
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,domain_id
 ,new_ses_avail_email_profile_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,policy_name
 ,remarks
 ,is_active
 ,withdraw_email_profile_id
 ,approved_email_profile_id
 ,send_group_enroll
 ,send_auto_enroll
 ,send_self_enroll
 ,reject_email_profile_id
 ,enroll_email_profile_id
 ,allow_approval_withdrawal
 ,prompt_for_withdraw_reason
 ,consider_pay_plan
 ,all_parallel_steps_must_approv
 ,policyDetails
 ,waitedListed_email_profile_id
 ,enroll_pend_email_profile_id
 ,session_trans_email_profile_id
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,domain_id
 ,new_ses_avail_email_profile_id
  from inserted
end
GO

create trigger d_enrollment_policy on enrollment_policy
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from enrollment_policy where exists (
select 1 from deleted where enrollment_policy.policy_id = deleted.policy_id)
insert into enrollment_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,policy_name
 ,remarks
 ,is_active
 ,withdraw_email_profile_id
 ,approved_email_profile_id
 ,send_group_enroll
 ,send_auto_enroll
 ,send_self_enroll
 ,reject_email_profile_id
 ,enroll_email_profile_id
 ,allow_approval_withdrawal
 ,prompt_for_withdraw_reason
 ,consider_pay_plan
 ,all_parallel_steps_must_approv
 ,policyDetails
 ,waitedListed_email_profile_id
 ,enroll_pend_email_profile_id
 ,session_trans_email_profile_id
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,domain_id
 ,new_ses_avail_email_profile_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,policy_name
 ,remarks
 ,is_active
 ,withdraw_email_profile_id
 ,approved_email_profile_id
 ,send_group_enroll
 ,send_auto_enroll
 ,send_self_enroll
 ,reject_email_profile_id
 ,enroll_email_profile_id
 ,allow_approval_withdrawal
 ,prompt_for_withdraw_reason
 ,consider_pay_plan
 ,all_parallel_steps_must_approv
 ,policyDetails
 ,waitedListed_email_profile_id
 ,enroll_pend_email_profile_id
 ,session_trans_email_profile_id
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,domain_id
 ,new_ses_avail_email_profile_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-enrollment_policy', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1065, '8:cf9bc0eaa3ef4b5582b2edf7ef939270', 'enableAuditTable auditTableName=enrollment_policy_aud, tableName=enrollment_policy', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-enrollment_policy_step::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_enrollment_policy_step'
			)
			DROP TRIGGER i_enrollment_policy_step
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_enrollment_policy_step'
			)
			DROP TRIGGER u_enrollment_policy_step
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_enrollment_policy_step'
			)
			DROP TRIGGER d_enrollment_policy_step
GO

CREATE TABLE enroll_policy_step_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_enroll_policy_step_aud_aud_datetime DEFAULT GETDATE() NOT NULL, step_id nvarchar(15), policy_id nvarchar(15), sequence_no int, step_name nvarchar(50), remarks nvarchar(255), remind_day int, remind_email_id nvarchar(15), expire_day int, expire_action char(1), email_profile_id nvarchar(15), expire_email_id nvarchar(15), update_meaning nvarchar(8), manual char(1), approverid1 nvarchar(85), regcontrol1 int, parallel_step char(1), include_costcenter char(1), include_email char(1), notify_email_id nvarchar(15), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_ENROLL_POLICY_STEP_AUD PRIMARY KEY (aud_id))
GO

insert into enroll_policy_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,step_id
 ,policy_id
 ,sequence_no
 ,step_name
 ,remarks
 ,remind_day
 ,remind_email_id
 ,expire_day
 ,expire_action
 ,email_profile_id
 ,expire_email_id
 ,update_meaning
 ,manual
 ,approverid1
 ,regcontrol1
 ,parallel_step
 ,include_costcenter
 ,include_email
 ,notify_email_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,step_id
 ,policy_id
 ,sequence_no
 ,step_name
 ,remarks
 ,remind_day
 ,remind_email_id
 ,expire_day
 ,expire_action
 ,email_profile_id
 ,expire_email_id
 ,update_meaning
 ,manual
 ,approverid1
 ,regcontrol1
 ,parallel_step
 ,include_costcenter
 ,include_email
 ,notify_email_id
  from enrollment_policy_step
GO

CREATE INDEX nuk_enroll_policy_step_aud_1 ON enroll_policy_step_aud(aud_userid)
GO

CREATE INDEX nuk_enroll_policy_step_aud_2 ON enroll_policy_step_aud(aud_datetime)
GO

create trigger i_enrollment_policy_step on enrollment_policy_step
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into enrollment_policy_step (
step_id,policy_id,sequence_no,step_name,remarks,remind_day,remind_email_id,expire_day,expire_action,email_profile_id,expire_email_id,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,manual,approverid1,regcontrol1,parallel_step,include_costcenter,include_email,notify_email_id) select step_id,policy_id,sequence_no,step_name,remarks,remind_day,remind_email_id,expire_day,expire_action,email_profile_id,expire_email_id,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,manual,approverid1,regcontrol1,parallel_step,include_costcenter,include_email,notify_email_id from inserted
insert into enroll_policy_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,step_id
 ,policy_id
 ,sequence_no
 ,step_name
 ,remarks
 ,remind_day
 ,remind_email_id
 ,expire_day
 ,expire_action
 ,email_profile_id
 ,expire_email_id
 ,update_meaning
 ,manual
 ,approverid1
 ,regcontrol1
 ,parallel_step
 ,include_costcenter
 ,include_email
 ,notify_email_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,step_id
 ,policy_id
 ,sequence_no
 ,step_name
 ,remarks
 ,remind_day
 ,remind_email_id
 ,expire_day
 ,expire_action
 ,email_profile_id
 ,expire_email_id
 ,update_meaning
 ,manual
 ,approverid1
 ,regcontrol1
 ,parallel_step
 ,include_costcenter
 ,include_email
 ,notify_email_id
  from inserted
end
GO

create trigger u_enrollment_policy_step on enrollment_policy_step
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update enrollment_policy_step set
enrollment_policy_step.step_id = inserted.step_id,enrollment_policy_step.policy_id = inserted.policy_id,enrollment_policy_step.sequence_no = inserted.sequence_no,enrollment_policy_step.step_name = inserted.step_name,enrollment_policy_step.remarks = inserted.remarks,enrollment_policy_step.remind_day = inserted.remind_day,enrollment_policy_step.remind_email_id = inserted.remind_email_id,enrollment_policy_step.expire_day = inserted.expire_day,enrollment_policy_step.expire_action = inserted.expire_action,enrollment_policy_step.email_profile_id = inserted.email_profile_id,enrollment_policy_step.expire_email_id = inserted.expire_email_id,enrollment_policy_step.update_meaning = inserted.update_meaning,enrollment_policy_step.last_updated = inserted.last_updated,enrollment_policy_step.updater_legal_name = inserted.updater_legal_name,enrollment_policy_step.update_meaning_text = inserted.update_meaning_text,enrollment_policy_step.last_updater_uid = inserted.last_updater_uid,enrollment_policy_step.manual = inserted.manual,enrollment_policy_step.approverid1 = inserted.approverid1,enrollment_policy_step.regcontrol1 = inserted.regcontrol1,enrollment_policy_step.parallel_step = inserted.parallel_step,enrollment_policy_step.include_costcenter = inserted.include_costcenter,enrollment_policy_step.include_email = inserted.include_email,enrollment_policy_step.notify_email_id = inserted.notify_email_id
from enrollment_policy_step inner join deleted on enrollment_policy_step.step_id = deleted.step_id inner join inserted on enrollment_policy_step.step_id = inserted.step_id
insert into enroll_policy_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,step_id
 ,policy_id
 ,sequence_no
 ,step_name
 ,remarks
 ,remind_day
 ,remind_email_id
 ,expire_day
 ,expire_action
 ,email_profile_id
 ,expire_email_id
 ,update_meaning
 ,manual
 ,approverid1
 ,regcontrol1
 ,parallel_step
 ,include_costcenter
 ,include_email
 ,notify_email_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,step_id
 ,policy_id
 ,sequence_no
 ,step_name
 ,remarks
 ,remind_day
 ,remind_email_id
 ,expire_day
 ,expire_action
 ,email_profile_id
 ,expire_email_id
 ,update_meaning
 ,manual
 ,approverid1
 ,regcontrol1
 ,parallel_step
 ,include_costcenter
 ,include_email
 ,notify_email_id
  from inserted
end
GO

create trigger d_enrollment_policy_step on enrollment_policy_step
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from enrollment_policy_step where exists (
select 1 from deleted where enrollment_policy_step.step_id = deleted.step_id)
insert into enroll_policy_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,step_id
 ,policy_id
 ,sequence_no
 ,step_name
 ,remarks
 ,remind_day
 ,remind_email_id
 ,expire_day
 ,expire_action
 ,email_profile_id
 ,expire_email_id
 ,update_meaning
 ,manual
 ,approverid1
 ,regcontrol1
 ,parallel_step
 ,include_costcenter
 ,include_email
 ,notify_email_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,step_id
 ,policy_id
 ,sequence_no
 ,step_name
 ,remarks
 ,remind_day
 ,remind_email_id
 ,expire_day
 ,expire_action
 ,email_profile_id
 ,expire_email_id
 ,update_meaning
 ,manual
 ,approverid1
 ,regcontrol1
 ,parallel_step
 ,include_costcenter
 ,include_email
 ,notify_email_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-enrollment_policy_step', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1066, '8:48b97a67bc47b2521ef03282273e2297', 'enableAuditTable auditTableName=enroll_policy_step_aud, tableName=enrollment_policy_step', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-exam_comment::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_exam_comment'
			)
			DROP TRIGGER i_exam_comment
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_exam_comment'
			)
			DROP TRIGGER u_exam_comment
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_exam_comment'
			)
			DROP TRIGGER d_exam_comment
GO

CREATE TABLE exam_comment_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_exam_comment_aud_aud_datetime DEFAULT GETDATE() NOT NULL, instanceid nvarchar(15), update_meaning nvarchar(8), ctype char(1), userid nvarchar(85), dateprepared datetime, preparedby nvarchar(85), commenttext nvarchar(MAX), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_EXAM_COMMENT_AUD PRIMARY KEY (aud_id))
GO

insert into exam_comment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,update_meaning
 ,ctype
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
) select 'U', null
, null
, GETDATE(), null
, null
 ,instanceid
 ,update_meaning
 ,ctype
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
  from exam_comment
GO

CREATE INDEX nuk_exam_comment_aud_1 ON exam_comment_aud(aud_userid)
GO

CREATE INDEX nuk_exam_comment_aud_2 ON exam_comment_aud(aud_datetime)
GO

create trigger i_exam_comment on exam_comment
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into exam_comment (
instanceid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,ctype,userid,dateprepared,preparedby,commenttext) select instanceid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,ctype,userid,dateprepared,preparedby,commenttext from inserted
insert into exam_comment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,update_meaning
 ,ctype
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,update_meaning
 ,ctype
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
  from inserted
end
GO

create trigger u_exam_comment on exam_comment
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update exam_comment set
exam_comment.instanceid = inserted.instanceid,exam_comment.update_meaning = inserted.update_meaning,exam_comment.last_updated = inserted.last_updated,exam_comment.updater_legal_name = inserted.updater_legal_name,exam_comment.update_meaning_text = inserted.update_meaning_text,exam_comment.last_updater_uid = inserted.last_updater_uid,exam_comment.ctype = inserted.ctype,exam_comment.userid = inserted.userid,exam_comment.dateprepared = inserted.dateprepared,exam_comment.preparedby = inserted.preparedby,exam_comment.commenttext = inserted.commenttext
from exam_comment inner join deleted on exam_comment.instanceid = deleted.instanceid and exam_comment.ctype = deleted.ctype inner join inserted on exam_comment.instanceid = inserted.instanceid and exam_comment.ctype = inserted.ctype
insert into exam_comment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,update_meaning
 ,ctype
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,update_meaning
 ,ctype
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
  from inserted
end
GO

create trigger d_exam_comment on exam_comment
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from exam_comment where exists (
select 1 from deleted where exam_comment.instanceid = deleted.instanceid and exam_comment.ctype = deleted.ctype)
insert into exam_comment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,update_meaning
 ,ctype
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,update_meaning
 ,ctype
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-exam_comment', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1067, '8:d81dab374e61521485a4c0670a608dbf', 'enableAuditTable auditTableName=exam_comment_aud, tableName=exam_comment', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-evaluation::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_evaluation'
			)
			DROP TRIGGER i_evaluation
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_evaluation'
			)
			DROP TRIGGER u_evaluation
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_evaluation'
			)
			DROP TRIGGER d_evaluation
GO

CREATE TABLE evaluation_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_evaluation_aud_aud_datetime DEFAULT GETDATE() NOT NULL, courseid nvarchar(85), eventid nvarchar(15), userid nvarchar(85), testid nvarchar(100), instanceid nvarchar(15), datecreated datetime, evalstatus smallint, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_EVALUATION_AUD PRIMARY KEY (aud_id))
GO

insert into evaluation_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,eventid
 ,userid
 ,testid
 ,instanceid
 ,datecreated
 ,evalstatus
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,courseid
 ,eventid
 ,userid
 ,testid
 ,instanceid
 ,datecreated
 ,evalstatus
 ,update_meaning
  from evaluation
GO

CREATE INDEX nuk_evaluation_aud_1 ON evaluation_aud(aud_userid)
GO

CREATE INDEX nuk_evaluation_aud_2 ON evaluation_aud(aud_datetime)
GO

create trigger i_evaluation on evaluation
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into evaluation (
courseid,eventid,userid,testid,instanceid,datecreated,evalstatus,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select courseid,eventid,userid,testid,instanceid,datecreated,evalstatus,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into evaluation_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,eventid
 ,userid
 ,testid
 ,instanceid
 ,datecreated
 ,evalstatus
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,eventid
 ,userid
 ,testid
 ,instanceid
 ,datecreated
 ,evalstatus
 ,update_meaning
  from inserted
end
GO

create trigger u_evaluation on evaluation
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update evaluation set
evaluation.courseid = inserted.courseid,evaluation.eventid = inserted.eventid,evaluation.userid = inserted.userid,evaluation.testid = inserted.testid,evaluation.instanceid = inserted.instanceid,evaluation.datecreated = inserted.datecreated,evaluation.evalstatus = inserted.evalstatus,evaluation.update_meaning = inserted.update_meaning,evaluation.last_updated = inserted.last_updated,evaluation.updater_legal_name = inserted.updater_legal_name,evaluation.update_meaning_text = inserted.update_meaning_text,evaluation.last_updater_uid = inserted.last_updater_uid
from evaluation inner join deleted on evaluation.instanceid = deleted.instanceid inner join inserted on evaluation.instanceid = inserted.instanceid
insert into evaluation_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,eventid
 ,userid
 ,testid
 ,instanceid
 ,datecreated
 ,evalstatus
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,eventid
 ,userid
 ,testid
 ,instanceid
 ,datecreated
 ,evalstatus
 ,update_meaning
  from inserted
end
GO

create trigger d_evaluation on evaluation
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from evaluation where exists (
select 1 from deleted where evaluation.instanceid = deleted.instanceid)
insert into evaluation_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,eventid
 ,userid
 ,testid
 ,instanceid
 ,datecreated
 ,evalstatus
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,eventid
 ,userid
 ,testid
 ,instanceid
 ,datecreated
 ,evalstatus
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-evaluation', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1068, '8:0c59d6ab6873b3bde0909aa4ca2144ea', 'enableAuditTable auditTableName=evaluation_aud, tableName=evaluation', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-external_training::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_external_training'
			)
			DROP TRIGGER i_external_training
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_external_training'
			)
			DROP TRIGGER u_external_training
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_external_training'
			)
			DROP TRIGGER d_external_training
GO

CREATE TABLE external_training_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_external_training_aud_aud_datetime DEFAULT GETDATE() NOT NULL, recordid nvarchar(15), userid nvarchar(85), title nvarchar(255), startdate datetime, enddate datetime, grade nvarchar(30), score nvarchar(30), comments nvarchar(1024), training_hours float(53), course_type nvarchar(100), subject nvarchar(100), duration float(53), duration_unit nvarchar(50), language int, cost numeric(15, 2), currency nvarchar(15), vendor_info1 nvarchar(255), vendor_info2 nvarchar(255), other_info nvarchar(255), venue nvarchar(512), studentstatus int, update_meaning nvarchar(8), display_filename nvarchar(85), path varchar(255), upload_date datetime, uploaded_by nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_EXTERNAL_TRAINING_AUD PRIMARY KEY (aud_id))
GO

insert into external_training_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,recordid
 ,userid
 ,title
 ,startdate
 ,enddate
 ,grade
 ,score
 ,comments
 ,training_hours
 ,course_type
 ,subject
 ,duration
 ,duration_unit
 ,language
 ,cost
 ,currency
 ,vendor_info1
 ,vendor_info2
 ,other_info
 ,venue
 ,studentstatus
 ,update_meaning
 ,display_filename
 ,path
 ,upload_date
 ,uploaded_by
) select 'U', null
, null
, GETDATE(), null
, null
 ,recordid
 ,userid
 ,title
 ,startdate
 ,enddate
 ,grade
 ,score
 ,comments
 ,training_hours
 ,course_type
 ,subject
 ,duration
 ,duration_unit
 ,language
 ,cost
 ,currency
 ,vendor_info1
 ,vendor_info2
 ,other_info
 ,venue
 ,studentstatus
 ,update_meaning
 ,display_filename
 ,path
 ,upload_date
 ,uploaded_by
  from external_training
GO

CREATE INDEX nuk_external_training_aud_1 ON external_training_aud(aud_userid)
GO

CREATE INDEX nuk_external_training_aud_2 ON external_training_aud(aud_datetime)
GO

create trigger i_external_training on external_training
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into external_training (
recordid,userid,title,startdate,enddate,grade,score,comments,training_hours,course_type,subject,duration,duration_unit,language,cost,currency,vendor_info1,vendor_info2,other_info,venue,studentstatus,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,display_filename,path,upload_date,uploaded_by) select recordid,userid,title,startdate,enddate,grade,score,comments,training_hours,course_type,subject,duration,duration_unit,language,cost,currency,vendor_info1,vendor_info2,other_info,venue,studentstatus,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,display_filename,path,upload_date,uploaded_by from inserted
insert into external_training_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,recordid
 ,userid
 ,title
 ,startdate
 ,enddate
 ,grade
 ,score
 ,comments
 ,training_hours
 ,course_type
 ,subject
 ,duration
 ,duration_unit
 ,language
 ,cost
 ,currency
 ,vendor_info1
 ,vendor_info2
 ,other_info
 ,venue
 ,studentstatus
 ,update_meaning
 ,display_filename
 ,path
 ,upload_date
 ,uploaded_by
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,recordid
 ,userid
 ,title
 ,startdate
 ,enddate
 ,grade
 ,score
 ,comments
 ,training_hours
 ,course_type
 ,subject
 ,duration
 ,duration_unit
 ,language
 ,cost
 ,currency
 ,vendor_info1
 ,vendor_info2
 ,other_info
 ,venue
 ,studentstatus
 ,update_meaning
 ,display_filename
 ,path
 ,upload_date
 ,uploaded_by
  from inserted
end
GO

create trigger u_external_training on external_training
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update external_training set
external_training.recordid = inserted.recordid,external_training.userid = inserted.userid,external_training.title = inserted.title,external_training.startdate = inserted.startdate,external_training.enddate = inserted.enddate,external_training.grade = inserted.grade,external_training.score = inserted.score,external_training.comments = inserted.comments,external_training.training_hours = inserted.training_hours,external_training.course_type = inserted.course_type,external_training.subject = inserted.subject,external_training.duration = inserted.duration,external_training.duration_unit = inserted.duration_unit,external_training.language = inserted.language,external_training.cost = inserted.cost,external_training.currency = inserted.currency,external_training.vendor_info1 = inserted.vendor_info1,external_training.vendor_info2 = inserted.vendor_info2,external_training.other_info = inserted.other_info,external_training.venue = inserted.venue,external_training.studentstatus = inserted.studentstatus,external_training.update_meaning = inserted.update_meaning,external_training.last_updated = inserted.last_updated,external_training.updater_legal_name = inserted.updater_legal_name,external_training.update_meaning_text = inserted.update_meaning_text,external_training.last_updater_uid = inserted.last_updater_uid,external_training.display_filename = inserted.display_filename,external_training.path = inserted.path,external_training.upload_date = inserted.upload_date,external_training.uploaded_by = inserted.uploaded_by
from external_training inner join deleted on external_training.recordid = deleted.recordid inner join inserted on external_training.recordid = inserted.recordid
insert into external_training_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,recordid
 ,userid
 ,title
 ,startdate
 ,enddate
 ,grade
 ,score
 ,comments
 ,training_hours
 ,course_type
 ,subject
 ,duration
 ,duration_unit
 ,language
 ,cost
 ,currency
 ,vendor_info1
 ,vendor_info2
 ,other_info
 ,venue
 ,studentstatus
 ,update_meaning
 ,display_filename
 ,path
 ,upload_date
 ,uploaded_by
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,recordid
 ,userid
 ,title
 ,startdate
 ,enddate
 ,grade
 ,score
 ,comments
 ,training_hours
 ,course_type
 ,subject
 ,duration
 ,duration_unit
 ,language
 ,cost
 ,currency
 ,vendor_info1
 ,vendor_info2
 ,other_info
 ,venue
 ,studentstatus
 ,update_meaning
 ,display_filename
 ,path
 ,upload_date
 ,uploaded_by
  from inserted
end
GO

create trigger d_external_training on external_training
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from external_training where exists (
select 1 from deleted where external_training.recordid = deleted.recordid)
insert into external_training_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,recordid
 ,userid
 ,title
 ,startdate
 ,enddate
 ,grade
 ,score
 ,comments
 ,training_hours
 ,course_type
 ,subject
 ,duration
 ,duration_unit
 ,language
 ,cost
 ,currency
 ,vendor_info1
 ,vendor_info2
 ,other_info
 ,venue
 ,studentstatus
 ,update_meaning
 ,display_filename
 ,path
 ,upload_date
 ,uploaded_by
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,recordid
 ,userid
 ,title
 ,startdate
 ,enddate
 ,grade
 ,score
 ,comments
 ,training_hours
 ,course_type
 ,subject
 ,duration
 ,duration_unit
 ,language
 ,cost
 ,currency
 ,vendor_info1
 ,vendor_info2
 ,other_info
 ,venue
 ,studentstatus
 ,update_meaning
 ,display_filename
 ,path
 ,upload_date
 ,uploaded_by
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-external_training', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1069, '8:74137cfc2cbe58e7db7cc7228bd55ae1', 'enableAuditTable auditTableName=external_training_aud, tableName=external_training', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-sessiondetail::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_sessiondetail'
			)
			DROP TRIGGER i_sessiondetail
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_sessiondetail'
			)
			DROP TRIGGER u_sessiondetail
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_sessiondetail'
			)
			DROP TRIGGER d_sessiondetail
GO

CREATE TABLE sessiondetail_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_sessiondetail_aud_aud_datetime DEFAULT GETDATE() NOT NULL, currid nvarchar(85), sessionid nvarchar(15), approverid1 nvarchar(85), regcontrol1 smallint, approverid2 nvarchar(85), regcontrol2 smallint, contactinfo nvarchar(255), orders int, sessionstatus int, currency nvarchar(15), billed char(1), startdate datetime, completionDateLimit datetime, requiredelectivehours float(53), enddate datetime, enforce_mod_order char(1), complete_by_date datetime, complete_in_days int, enforce_deadline nvarchar(1), availability char(1), enroll_limit int, enforce_mod_pay char(1), description nvarchar(MAX), session_title nvarchar(85), use_program_session_cost char(1), ew_id nvarchar(15), is_wf_assign_disabled char(1), tutor_select_type char(1), update_meaning nvarchar(8), timezone varchar(50), earnedcredits float(53), use_defined_credits char(1), revised_date datetime, create_date datetime, passing_score float(53), enforce_mod_rev char(1), enforce_mod_preq char(1), bundle_id nvarchar(85), enrollBeginDate datetime, enrollDeadline datetime, submodule_fail_action char(1), allow_advance_on_fail char(1), hide_blocked_modules char(1), policyapv_progmod char(1), mod_start_type char(1), first_mod_start_date datetime, session_selector nvarchar(2), assigned_forum numeric(16, 0), assigned_forum_type nvarchar(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SESSIONDETAIL_AUD PRIMARY KEY (aud_id))
GO

insert into sessiondetail_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,contactinfo
 ,orders
 ,sessionstatus
 ,currency
 ,billed
 ,startdate
 ,completionDateLimit
 ,requiredelectivehours
 ,enddate
 ,enforce_mod_order
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,availability
 ,enroll_limit
 ,enforce_mod_pay
 ,description
 ,session_title
 ,use_program_session_cost
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,timezone
 ,earnedcredits
 ,use_defined_credits
 ,revised_date
 ,create_date
 ,passing_score
 ,enforce_mod_rev
 ,enforce_mod_preq
 ,bundle_id
 ,enrollBeginDate
 ,enrollDeadline
 ,submodule_fail_action
 ,allow_advance_on_fail
 ,hide_blocked_modules
 ,policyapv_progmod
 ,mod_start_type
 ,first_mod_start_date
 ,session_selector
 ,assigned_forum
 ,assigned_forum_type
) select 'U', null
, null
, GETDATE(), null
, null
 ,currid
 ,sessionid
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,contactinfo
 ,orders
 ,sessionstatus
 ,currency
 ,billed
 ,startdate
 ,completionDateLimit
 ,requiredelectivehours
 ,enddate
 ,enforce_mod_order
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,availability
 ,enroll_limit
 ,enforce_mod_pay
 ,description
 ,session_title
 ,use_program_session_cost
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,timezone
 ,earnedcredits
 ,use_defined_credits
 ,revised_date
 ,create_date
 ,passing_score
 ,enforce_mod_rev
 ,enforce_mod_preq
 ,bundle_id
 ,enrollBeginDate
 ,enrollDeadline
 ,submodule_fail_action
 ,allow_advance_on_fail
 ,hide_blocked_modules
 ,policyapv_progmod
 ,mod_start_type
 ,first_mod_start_date
 ,session_selector
 ,assigned_forum
 ,assigned_forum_type
  from sessiondetail
GO

CREATE INDEX nuk_sessiondetail_aud_1 ON sessiondetail_aud(aud_userid)
GO

CREATE INDEX nuk_sessiondetail_aud_2 ON sessiondetail_aud(aud_datetime)
GO

create trigger i_sessiondetail on sessiondetail
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into sessiondetail (
currid,sessionid,approverid1,regcontrol1,approverid2,regcontrol2,contactinfo,orders,sessionstatus,currency,billed,startdate,completionDateLimit,requiredelectivehours,enddate,enforce_mod_order,complete_by_date,complete_in_days,enforce_deadline,availability,enroll_limit,enforce_mod_pay,description,session_title,use_program_session_cost,ew_id,is_wf_assign_disabled,tutor_select_type,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,timezone,earnedcredits,use_defined_credits,revised_date,create_date,passing_score,enforce_mod_rev,enforce_mod_preq,bundle_id,enrollBeginDate,enrollDeadline,submodule_fail_action,allow_advance_on_fail,hide_blocked_modules,policyapv_progmod,mod_start_type,first_mod_start_date,session_selector,assigned_forum,assigned_forum_type) select currid,sessionid,approverid1,regcontrol1,approverid2,regcontrol2,contactinfo,orders,sessionstatus,currency,billed,startdate,completionDateLimit,requiredelectivehours,enddate,enforce_mod_order,complete_by_date,complete_in_days,enforce_deadline,availability,enroll_limit,enforce_mod_pay,description,session_title,use_program_session_cost,ew_id,is_wf_assign_disabled,tutor_select_type,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,timezone,earnedcredits,use_defined_credits,revised_date,create_date,passing_score,enforce_mod_rev,enforce_mod_preq,bundle_id,enrollBeginDate,enrollDeadline,submodule_fail_action,allow_advance_on_fail,hide_blocked_modules,policyapv_progmod,mod_start_type,first_mod_start_date,session_selector,assigned_forum,assigned_forum_type from inserted
insert into sessiondetail_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,contactinfo
 ,orders
 ,sessionstatus
 ,currency
 ,billed
 ,startdate
 ,completionDateLimit
 ,requiredelectivehours
 ,enddate
 ,enforce_mod_order
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,availability
 ,enroll_limit
 ,enforce_mod_pay
 ,description
 ,session_title
 ,use_program_session_cost
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,timezone
 ,earnedcredits
 ,use_defined_credits
 ,revised_date
 ,create_date
 ,passing_score
 ,enforce_mod_rev
 ,enforce_mod_preq
 ,bundle_id
 ,enrollBeginDate
 ,enrollDeadline
 ,submodule_fail_action
 ,allow_advance_on_fail
 ,hide_blocked_modules
 ,policyapv_progmod
 ,mod_start_type
 ,first_mod_start_date
 ,session_selector
 ,assigned_forum
 ,assigned_forum_type
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,sessionid
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,contactinfo
 ,orders
 ,sessionstatus
 ,currency
 ,billed
 ,startdate
 ,completionDateLimit
 ,requiredelectivehours
 ,enddate
 ,enforce_mod_order
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,availability
 ,enroll_limit
 ,enforce_mod_pay
 ,description
 ,session_title
 ,use_program_session_cost
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,timezone
 ,earnedcredits
 ,use_defined_credits
 ,revised_date
 ,create_date
 ,passing_score
 ,enforce_mod_rev
 ,enforce_mod_preq
 ,bundle_id
 ,enrollBeginDate
 ,enrollDeadline
 ,submodule_fail_action
 ,allow_advance_on_fail
 ,hide_blocked_modules
 ,policyapv_progmod
 ,mod_start_type
 ,first_mod_start_date
 ,session_selector
 ,assigned_forum
 ,assigned_forum_type
  from inserted
end
GO

create trigger u_sessiondetail on sessiondetail
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update sessiondetail set
sessiondetail.currid = inserted.currid,sessiondetail.sessionid = inserted.sessionid,sessiondetail.approverid1 = inserted.approverid1,sessiondetail.regcontrol1 = inserted.regcontrol1,sessiondetail.approverid2 = inserted.approverid2,sessiondetail.regcontrol2 = inserted.regcontrol2,sessiondetail.contactinfo = inserted.contactinfo,sessiondetail.orders = inserted.orders,sessiondetail.sessionstatus = inserted.sessionstatus,sessiondetail.currency = inserted.currency,sessiondetail.billed = inserted.billed,sessiondetail.startdate = inserted.startdate,sessiondetail.completionDateLimit = inserted.completionDateLimit,sessiondetail.requiredelectivehours = inserted.requiredelectivehours,sessiondetail.enddate = inserted.enddate,sessiondetail.enforce_mod_order = inserted.enforce_mod_order,sessiondetail.complete_by_date = inserted.complete_by_date,sessiondetail.complete_in_days = inserted.complete_in_days,sessiondetail.enforce_deadline = inserted.enforce_deadline,sessiondetail.availability = inserted.availability,sessiondetail.enroll_limit = inserted.enroll_limit,sessiondetail.enforce_mod_pay = inserted.enforce_mod_pay,sessiondetail.description = inserted.description,sessiondetail.session_title = inserted.session_title,sessiondetail.use_program_session_cost = inserted.use_program_session_cost,sessiondetail.ew_id = inserted.ew_id,sessiondetail.is_wf_assign_disabled = inserted.is_wf_assign_disabled,sessiondetail.tutor_select_type = inserted.tutor_select_type,sessiondetail.update_meaning = inserted.update_meaning,sessiondetail.last_updated = inserted.last_updated,sessiondetail.updater_legal_name = inserted.updater_legal_name,sessiondetail.update_meaning_text = inserted.update_meaning_text,sessiondetail.last_updater_uid = inserted.last_updater_uid,sessiondetail.timezone = inserted.timezone,sessiondetail.earnedcredits = inserted.earnedcredits,sessiondetail.use_defined_credits = inserted.use_defined_credits,sessiondetail.revised_date = inserted.revised_date,sessiondetail.create_date = inserted.create_date,sessiondetail.passing_score = inserted.passing_score,sessiondetail.enforce_mod_rev = inserted.enforce_mod_rev,sessiondetail.enforce_mod_preq = inserted.enforce_mod_preq,sessiondetail.bundle_id = inserted.bundle_id,sessiondetail.enrollBeginDate = inserted.enrollBeginDate,sessiondetail.enrollDeadline = inserted.enrollDeadline,sessiondetail.submodule_fail_action = inserted.submodule_fail_action,sessiondetail.allow_advance_on_fail = inserted.allow_advance_on_fail,sessiondetail.hide_blocked_modules = inserted.hide_blocked_modules,sessiondetail.policyapv_progmod = inserted.policyapv_progmod,sessiondetail.mod_start_type = inserted.mod_start_type,sessiondetail.first_mod_start_date = inserted.first_mod_start_date,sessiondetail.session_selector = inserted.session_selector,sessiondetail.assigned_forum = inserted.assigned_forum,sessiondetail.assigned_forum_type = inserted.assigned_forum_type
from sessiondetail inner join deleted on sessiondetail.currid = deleted.currid and sessiondetail.sessionid = deleted.sessionid inner join inserted on sessiondetail.currid = inserted.currid and sessiondetail.sessionid = inserted.sessionid
insert into sessiondetail_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,contactinfo
 ,orders
 ,sessionstatus
 ,currency
 ,billed
 ,startdate
 ,completionDateLimit
 ,requiredelectivehours
 ,enddate
 ,enforce_mod_order
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,availability
 ,enroll_limit
 ,enforce_mod_pay
 ,description
 ,session_title
 ,use_program_session_cost
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,timezone
 ,earnedcredits
 ,use_defined_credits
 ,revised_date
 ,create_date
 ,passing_score
 ,enforce_mod_rev
 ,enforce_mod_preq
 ,bundle_id
 ,enrollBeginDate
 ,enrollDeadline
 ,submodule_fail_action
 ,allow_advance_on_fail
 ,hide_blocked_modules
 ,policyapv_progmod
 ,mod_start_type
 ,first_mod_start_date
 ,session_selector
 ,assigned_forum
 ,assigned_forum_type
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,sessionid
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,contactinfo
 ,orders
 ,sessionstatus
 ,currency
 ,billed
 ,startdate
 ,completionDateLimit
 ,requiredelectivehours
 ,enddate
 ,enforce_mod_order
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,availability
 ,enroll_limit
 ,enforce_mod_pay
 ,description
 ,session_title
 ,use_program_session_cost
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,timezone
 ,earnedcredits
 ,use_defined_credits
 ,revised_date
 ,create_date
 ,passing_score
 ,enforce_mod_rev
 ,enforce_mod_preq
 ,bundle_id
 ,enrollBeginDate
 ,enrollDeadline
 ,submodule_fail_action
 ,allow_advance_on_fail
 ,hide_blocked_modules
 ,policyapv_progmod
 ,mod_start_type
 ,first_mod_start_date
 ,session_selector
 ,assigned_forum
 ,assigned_forum_type
  from inserted
end
GO

create trigger d_sessiondetail on sessiondetail
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from sessiondetail where exists (
select 1 from deleted where sessiondetail.currid = deleted.currid and sessiondetail.sessionid = deleted.sessionid)
insert into sessiondetail_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,contactinfo
 ,orders
 ,sessionstatus
 ,currency
 ,billed
 ,startdate
 ,completionDateLimit
 ,requiredelectivehours
 ,enddate
 ,enforce_mod_order
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,availability
 ,enroll_limit
 ,enforce_mod_pay
 ,description
 ,session_title
 ,use_program_session_cost
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,timezone
 ,earnedcredits
 ,use_defined_credits
 ,revised_date
 ,create_date
 ,passing_score
 ,enforce_mod_rev
 ,enforce_mod_preq
 ,bundle_id
 ,enrollBeginDate
 ,enrollDeadline
 ,submodule_fail_action
 ,allow_advance_on_fail
 ,hide_blocked_modules
 ,policyapv_progmod
 ,mod_start_type
 ,first_mod_start_date
 ,session_selector
 ,assigned_forum
 ,assigned_forum_type
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,sessionid
 ,approverid1
 ,regcontrol1
 ,approverid2
 ,regcontrol2
 ,contactinfo
 ,orders
 ,sessionstatus
 ,currency
 ,billed
 ,startdate
 ,completionDateLimit
 ,requiredelectivehours
 ,enddate
 ,enforce_mod_order
 ,complete_by_date
 ,complete_in_days
 ,enforce_deadline
 ,availability
 ,enroll_limit
 ,enforce_mod_pay
 ,description
 ,session_title
 ,use_program_session_cost
 ,ew_id
 ,is_wf_assign_disabled
 ,tutor_select_type
 ,update_meaning
 ,timezone
 ,earnedcredits
 ,use_defined_credits
 ,revised_date
 ,create_date
 ,passing_score
 ,enforce_mod_rev
 ,enforce_mod_preq
 ,bundle_id
 ,enrollBeginDate
 ,enrollDeadline
 ,submodule_fail_action
 ,allow_advance_on_fail
 ,hide_blocked_modules
 ,policyapv_progmod
 ,mod_start_type
 ,first_mod_start_date
 ,session_selector
 ,assigned_forum
 ,assigned_forum_type
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-sessiondetail', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1070, '8:f5e5cd10bd569c637df1a56bdf54edc0', 'enableAuditTable auditTableName=sessiondetail_aud, tableName=sessiondetail', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-homework_file::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_homework_file'
			)
			DROP TRIGGER i_homework_file
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_homework_file'
			)
			DROP TRIGGER u_homework_file
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_homework_file'
			)
			DROP TRIGGER d_homework_file
GO

CREATE TABLE homework_file_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_homework_file_aud_aud_datetime DEFAULT GETDATE() NOT NULL, currid nvarchar(85), sessionid nvarchar(15), eventid nvarchar(15), path varchar(255), ownerid nvarchar(85), createdate datetime, file_type nvarchar(20), to_userid nvarchar(85), description nvarchar(85), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_HOMEWORK_FILE_AUD PRIMARY KEY (aud_id))
GO

insert into homework_file_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,eventid
 ,path
 ,ownerid
 ,createdate
 ,file_type
 ,to_userid
 ,description
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,currid
 ,sessionid
 ,eventid
 ,path
 ,ownerid
 ,createdate
 ,file_type
 ,to_userid
 ,description
 ,update_meaning
  from homework_file
GO

CREATE INDEX nuk_homework_file_aud_1 ON homework_file_aud(aud_userid)
GO

CREATE INDEX nuk_homework_file_aud_2 ON homework_file_aud(aud_datetime)
GO

create trigger i_homework_file on homework_file
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into homework_file (
currid,sessionid,eventid,path,ownerid,createdate,file_type,to_userid,description,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select currid,sessionid,eventid,path,ownerid,createdate,file_type,to_userid,description,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into homework_file_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,eventid
 ,path
 ,ownerid
 ,createdate
 ,file_type
 ,to_userid
 ,description
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,sessionid
 ,eventid
 ,path
 ,ownerid
 ,createdate
 ,file_type
 ,to_userid
 ,description
 ,update_meaning
  from inserted
end
GO

create trigger u_homework_file on homework_file
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update homework_file set
homework_file.currid = inserted.currid,homework_file.sessionid = inserted.sessionid,homework_file.eventid = inserted.eventid,homework_file.path = inserted.path,homework_file.ownerid = inserted.ownerid,homework_file.createdate = inserted.createdate,homework_file.file_type = inserted.file_type,homework_file.to_userid = inserted.to_userid,homework_file.description = inserted.description,homework_file.update_meaning = inserted.update_meaning,homework_file.last_updated = inserted.last_updated,homework_file.updater_legal_name = inserted.updater_legal_name,homework_file.update_meaning_text = inserted.update_meaning_text,homework_file.last_updater_uid = inserted.last_updater_uid
from homework_file inner join deleted on homework_file.ownerid = deleted.ownerid and homework_file.createdate = deleted.createdate inner join inserted on homework_file.ownerid = inserted.ownerid and homework_file.createdate = inserted.createdate
insert into homework_file_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,eventid
 ,path
 ,ownerid
 ,createdate
 ,file_type
 ,to_userid
 ,description
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,sessionid
 ,eventid
 ,path
 ,ownerid
 ,createdate
 ,file_type
 ,to_userid
 ,description
 ,update_meaning
  from inserted
end
GO

create trigger d_homework_file on homework_file
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from homework_file where exists (
select 1 from deleted where homework_file.ownerid = deleted.ownerid and homework_file.createdate = deleted.createdate)
insert into homework_file_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,currid
 ,sessionid
 ,eventid
 ,path
 ,ownerid
 ,createdate
 ,file_type
 ,to_userid
 ,description
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,currid
 ,sessionid
 ,eventid
 ,path
 ,ownerid
 ,createdate
 ,file_type
 ,to_userid
 ,description
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-homework_file', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1071, '8:268d78b314916a86cf120fae62cdf30b', 'enableAuditTable auditTableName=homework_file_aud, tableName=homework_file', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-iComment::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_iComment'
			)
			DROP TRIGGER i_iComment
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_iComment'
			)
			DROP TRIGGER u_iComment
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_iComment'
			)
			DROP TRIGGER d_iComment
GO

CREATE TABLE iComment_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_iComment_aud_aud_datetime DEFAULT GETDATE() NOT NULL, transcriptid nvarchar(15), cType nvarchar(1), userid nvarchar(85), dateprepared datetime, preparedby nvarchar(85), commenttext nvarchar(MAX), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_ICOMMENT_AUD PRIMARY KEY (aud_id))
GO

insert into iComment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,cType
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,transcriptid
 ,cType
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
 ,update_meaning
  from iComment
GO

CREATE INDEX nuk_iComment_aud_1 ON iComment_aud(aud_userid)
GO

CREATE INDEX nuk_iComment_aud_2 ON iComment_aud(aud_datetime)
GO

create trigger i_iComment on iComment
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into iComment (
transcriptid,cType,userid,dateprepared,preparedby,commenttext,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select transcriptid,cType,userid,dateprepared,preparedby,commenttext,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into iComment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,cType
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,cType
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
 ,update_meaning
  from inserted
end
GO

create trigger u_iComment on iComment
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update iComment set
iComment.transcriptid = inserted.transcriptid,iComment.cType = inserted.cType,iComment.userid = inserted.userid,iComment.dateprepared = inserted.dateprepared,iComment.preparedby = inserted.preparedby,iComment.commenttext = inserted.commenttext,iComment.update_meaning = inserted.update_meaning,iComment.last_updated = inserted.last_updated,iComment.updater_legal_name = inserted.updater_legal_name,iComment.update_meaning_text = inserted.update_meaning_text,iComment.last_updater_uid = inserted.last_updater_uid
from iComment inner join deleted on iComment.transcriptid = deleted.transcriptid and iComment.cType = deleted.cType inner join inserted on iComment.transcriptid = inserted.transcriptid and iComment.cType = inserted.cType
insert into iComment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,cType
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,cType
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
 ,update_meaning
  from inserted
end
GO

create trigger d_iComment on iComment
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from iComment where exists (
select 1 from deleted where iComment.transcriptid = deleted.transcriptid and iComment.cType = deleted.cType)
insert into iComment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,cType
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,cType
 ,userid
 ,dateprepared
 ,preparedby
 ,commenttext
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-iComment', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1072, '8:e60e903eb70f819165068263b81222aa', 'enableAuditTable auditTableName=iComment_aud, tableName=iComment', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-knowledgecenteroptions::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_knowledgecenteroptions'
			)
			DROP TRIGGER i_knowledgecenteroptions
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_knowledgecenteroptions'
			)
			DROP TRIGGER u_knowledgecenteroptions
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_knowledgecenteroptions'
			)
			DROP TRIGGER d_knowledgecenteroptions
GO

CREATE TABLE kc_options_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_kc_options_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), learningid nvarchar(85), picture_url varchar(255), course_summary_area char(1), notepad_area char(1), evaluation_area char(1), test_area char(1), certification_area char(1), peer_comments_area char(1), news_area char(1), status_change_area char(1), instructor_list_area char(1), forum_area char(1), chatroom_area char(1), contact_list_area char(1), course_launch char(1), reference_area char(1), instructor_share_area char(1), picture_area char(1), module_name_launches_kc char(1), instructor_about_me_area char(1), homework_file_share_area char(1), homework_drop_area char(1), homework_marked_area char(1), kc_layout char(1), picture_location char(1), transcript_area char(1), show_module_attributes char(1), exam_wf_area char(1), extended_quick_eval_area varchar(100), use_kc char(1), update_meaning nvarchar(8), sort_sub_modules char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_KC_OPTIONS_AUD PRIMARY KEY (aud_id))
GO

insert into kc_options_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,picture_url
 ,course_summary_area
 ,notepad_area
 ,evaluation_area
 ,test_area
 ,certification_area
 ,peer_comments_area
 ,news_area
 ,status_change_area
 ,instructor_list_area
 ,forum_area
 ,chatroom_area
 ,contact_list_area
 ,course_launch
 ,reference_area
 ,instructor_share_area
 ,picture_area
 ,module_name_launches_kc
 ,instructor_about_me_area
 ,homework_file_share_area
 ,homework_drop_area
 ,homework_marked_area
 ,kc_layout
 ,picture_location
 ,transcript_area
 ,show_module_attributes
 ,exam_wf_area
 ,extended_quick_eval_area
 ,use_kc
 ,update_meaning
 ,sort_sub_modules
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,learningid
 ,picture_url
 ,course_summary_area
 ,notepad_area
 ,evaluation_area
 ,test_area
 ,certification_area
 ,peer_comments_area
 ,news_area
 ,status_change_area
 ,instructor_list_area
 ,forum_area
 ,chatroom_area
 ,contact_list_area
 ,course_launch
 ,reference_area
 ,instructor_share_area
 ,picture_area
 ,module_name_launches_kc
 ,instructor_about_me_area
 ,homework_file_share_area
 ,homework_drop_area
 ,homework_marked_area
 ,kc_layout
 ,picture_location
 ,transcript_area
 ,show_module_attributes
 ,exam_wf_area
 ,extended_quick_eval_area
 ,use_kc
 ,update_meaning
 ,sort_sub_modules
  from knowledgecenteroptions
GO

CREATE INDEX nuk_kc_options_aud_1 ON kc_options_aud(aud_userid)
GO

CREATE INDEX nuk_kc_options_aud_2 ON kc_options_aud(aud_datetime)
GO

create trigger i_knowledgecenteroptions on knowledgecenteroptions
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into knowledgecenteroptions (
id,learningid,picture_url,course_summary_area,notepad_area,evaluation_area,test_area,certification_area,peer_comments_area,news_area,status_change_area,instructor_list_area,forum_area,chatroom_area,contact_list_area,course_launch,reference_area,instructor_share_area,picture_area,module_name_launches_kc,instructor_about_me_area,homework_file_share_area,homework_drop_area,homework_marked_area,kc_layout,picture_location,transcript_area,show_module_attributes,exam_wf_area,extended_quick_eval_area,use_kc,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,sort_sub_modules) select id,learningid,picture_url,course_summary_area,notepad_area,evaluation_area,test_area,certification_area,peer_comments_area,news_area,status_change_area,instructor_list_area,forum_area,chatroom_area,contact_list_area,course_launch,reference_area,instructor_share_area,picture_area,module_name_launches_kc,instructor_about_me_area,homework_file_share_area,homework_drop_area,homework_marked_area,kc_layout,picture_location,transcript_area,show_module_attributes,exam_wf_area,extended_quick_eval_area,use_kc,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,sort_sub_modules from inserted
insert into kc_options_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,picture_url
 ,course_summary_area
 ,notepad_area
 ,evaluation_area
 ,test_area
 ,certification_area
 ,peer_comments_area
 ,news_area
 ,status_change_area
 ,instructor_list_area
 ,forum_area
 ,chatroom_area
 ,contact_list_area
 ,course_launch
 ,reference_area
 ,instructor_share_area
 ,picture_area
 ,module_name_launches_kc
 ,instructor_about_me_area
 ,homework_file_share_area
 ,homework_drop_area
 ,homework_marked_area
 ,kc_layout
 ,picture_location
 ,transcript_area
 ,show_module_attributes
 ,exam_wf_area
 ,extended_quick_eval_area
 ,use_kc
 ,update_meaning
 ,sort_sub_modules
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,picture_url
 ,course_summary_area
 ,notepad_area
 ,evaluation_area
 ,test_area
 ,certification_area
 ,peer_comments_area
 ,news_area
 ,status_change_area
 ,instructor_list_area
 ,forum_area
 ,chatroom_area
 ,contact_list_area
 ,course_launch
 ,reference_area
 ,instructor_share_area
 ,picture_area
 ,module_name_launches_kc
 ,instructor_about_me_area
 ,homework_file_share_area
 ,homework_drop_area
 ,homework_marked_area
 ,kc_layout
 ,picture_location
 ,transcript_area
 ,show_module_attributes
 ,exam_wf_area
 ,extended_quick_eval_area
 ,use_kc
 ,update_meaning
 ,sort_sub_modules
  from inserted
end
GO

create trigger u_knowledgecenteroptions on knowledgecenteroptions
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update knowledgecenteroptions set
knowledgecenteroptions.id = inserted.id,knowledgecenteroptions.learningid = inserted.learningid,knowledgecenteroptions.picture_url = inserted.picture_url,knowledgecenteroptions.course_summary_area = inserted.course_summary_area,knowledgecenteroptions.notepad_area = inserted.notepad_area,knowledgecenteroptions.evaluation_area = inserted.evaluation_area,knowledgecenteroptions.test_area = inserted.test_area,knowledgecenteroptions.certification_area = inserted.certification_area,knowledgecenteroptions.peer_comments_area = inserted.peer_comments_area,knowledgecenteroptions.news_area = inserted.news_area,knowledgecenteroptions.status_change_area = inserted.status_change_area,knowledgecenteroptions.instructor_list_area = inserted.instructor_list_area,knowledgecenteroptions.forum_area = inserted.forum_area,knowledgecenteroptions.chatroom_area = inserted.chatroom_area,knowledgecenteroptions.contact_list_area = inserted.contact_list_area,knowledgecenteroptions.course_launch = inserted.course_launch,knowledgecenteroptions.reference_area = inserted.reference_area,knowledgecenteroptions.instructor_share_area = inserted.instructor_share_area,knowledgecenteroptions.picture_area = inserted.picture_area,knowledgecenteroptions.module_name_launches_kc = inserted.module_name_launches_kc,knowledgecenteroptions.instructor_about_me_area = inserted.instructor_about_me_area,knowledgecenteroptions.homework_file_share_area = inserted.homework_file_share_area,knowledgecenteroptions.homework_drop_area = inserted.homework_drop_area,knowledgecenteroptions.homework_marked_area = inserted.homework_marked_area,knowledgecenteroptions.kc_layout = inserted.kc_layout,knowledgecenteroptions.picture_location = inserted.picture_location,knowledgecenteroptions.transcript_area = inserted.transcript_area,knowledgecenteroptions.show_module_attributes = inserted.show_module_attributes,knowledgecenteroptions.exam_wf_area = inserted.exam_wf_area,knowledgecenteroptions.extended_quick_eval_area = inserted.extended_quick_eval_area,knowledgecenteroptions.use_kc = inserted.use_kc,knowledgecenteroptions.update_meaning = inserted.update_meaning,knowledgecenteroptions.last_updated = inserted.last_updated,knowledgecenteroptions.updater_legal_name = inserted.updater_legal_name,knowledgecenteroptions.update_meaning_text = inserted.update_meaning_text,knowledgecenteroptions.last_updater_uid = inserted.last_updater_uid,knowledgecenteroptions.sort_sub_modules = inserted.sort_sub_modules
from knowledgecenteroptions inner join deleted on knowledgecenteroptions.id = deleted.id inner join inserted on knowledgecenteroptions.id = inserted.id
insert into kc_options_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,picture_url
 ,course_summary_area
 ,notepad_area
 ,evaluation_area
 ,test_area
 ,certification_area
 ,peer_comments_area
 ,news_area
 ,status_change_area
 ,instructor_list_area
 ,forum_area
 ,chatroom_area
 ,contact_list_area
 ,course_launch
 ,reference_area
 ,instructor_share_area
 ,picture_area
 ,module_name_launches_kc
 ,instructor_about_me_area
 ,homework_file_share_area
 ,homework_drop_area
 ,homework_marked_area
 ,kc_layout
 ,picture_location
 ,transcript_area
 ,show_module_attributes
 ,exam_wf_area
 ,extended_quick_eval_area
 ,use_kc
 ,update_meaning
 ,sort_sub_modules
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,picture_url
 ,course_summary_area
 ,notepad_area
 ,evaluation_area
 ,test_area
 ,certification_area
 ,peer_comments_area
 ,news_area
 ,status_change_area
 ,instructor_list_area
 ,forum_area
 ,chatroom_area
 ,contact_list_area
 ,course_launch
 ,reference_area
 ,instructor_share_area
 ,picture_area
 ,module_name_launches_kc
 ,instructor_about_me_area
 ,homework_file_share_area
 ,homework_drop_area
 ,homework_marked_area
 ,kc_layout
 ,picture_location
 ,transcript_area
 ,show_module_attributes
 ,exam_wf_area
 ,extended_quick_eval_area
 ,use_kc
 ,update_meaning
 ,sort_sub_modules
  from inserted
end
GO

create trigger d_knowledgecenteroptions on knowledgecenteroptions
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from knowledgecenteroptions where exists (
select 1 from deleted where knowledgecenteroptions.id = deleted.id)
insert into kc_options_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,picture_url
 ,course_summary_area
 ,notepad_area
 ,evaluation_area
 ,test_area
 ,certification_area
 ,peer_comments_area
 ,news_area
 ,status_change_area
 ,instructor_list_area
 ,forum_area
 ,chatroom_area
 ,contact_list_area
 ,course_launch
 ,reference_area
 ,instructor_share_area
 ,picture_area
 ,module_name_launches_kc
 ,instructor_about_me_area
 ,homework_file_share_area
 ,homework_drop_area
 ,homework_marked_area
 ,kc_layout
 ,picture_location
 ,transcript_area
 ,show_module_attributes
 ,exam_wf_area
 ,extended_quick_eval_area
 ,use_kc
 ,update_meaning
 ,sort_sub_modules
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,picture_url
 ,course_summary_area
 ,notepad_area
 ,evaluation_area
 ,test_area
 ,certification_area
 ,peer_comments_area
 ,news_area
 ,status_change_area
 ,instructor_list_area
 ,forum_area
 ,chatroom_area
 ,contact_list_area
 ,course_launch
 ,reference_area
 ,instructor_share_area
 ,picture_area
 ,module_name_launches_kc
 ,instructor_about_me_area
 ,homework_file_share_area
 ,homework_drop_area
 ,homework_marked_area
 ,kc_layout
 ,picture_location
 ,transcript_area
 ,show_module_attributes
 ,exam_wf_area
 ,extended_quick_eval_area
 ,use_kc
 ,update_meaning
 ,sort_sub_modules
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-knowledgecenteroptions', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1073, '8:fe71a3ee894aa761db04444f57748ca1', 'enableAuditTable auditTableName=kc_options_aud, tableName=knowledgecenteroptions', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-locosts::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_locosts'
			)
			DROP TRIGGER i_locosts
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_locosts'
			)
			DROP TRIGGER u_locosts
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_locosts'
			)
			DROP TRIGGER d_locosts
GO

CREATE TABLE locosts_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_locosts_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), learningid nvarchar(85), cost numeric(15, 2), costtype smallint, currency nvarchar(15), priceinfo nvarchar(300), sessionid nvarchar(15), payment_method char(1), update_meaning nvarchar(8), charged_costcenter nvarchar(45), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_LOCOSTS_AUD PRIMARY KEY (aud_id))
GO

insert into locosts_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,cost
 ,costtype
 ,currency
 ,priceinfo
 ,sessionid
 ,payment_method
 ,update_meaning
 ,charged_costcenter
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,learningid
 ,cost
 ,costtype
 ,currency
 ,priceinfo
 ,sessionid
 ,payment_method
 ,update_meaning
 ,charged_costcenter
  from locosts
GO

CREATE INDEX nuk_locosts_aud_1 ON locosts_aud(aud_userid)
GO

CREATE INDEX nuk_locosts_aud_2 ON locosts_aud(aud_datetime)
GO

create trigger i_locosts on locosts
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into locosts (
id,learningid,cost,costtype,currency,priceinfo,sessionid,payment_method,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,charged_costcenter) select id,learningid,cost,costtype,currency,priceinfo,sessionid,payment_method,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,charged_costcenter from inserted
insert into locosts_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,cost
 ,costtype
 ,currency
 ,priceinfo
 ,sessionid
 ,payment_method
 ,update_meaning
 ,charged_costcenter
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,cost
 ,costtype
 ,currency
 ,priceinfo
 ,sessionid
 ,payment_method
 ,update_meaning
 ,charged_costcenter
  from inserted
end
GO

create trigger u_locosts on locosts
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update locosts set
locosts.id = inserted.id,locosts.learningid = inserted.learningid,locosts.cost = inserted.cost,locosts.costtype = inserted.costtype,locosts.currency = inserted.currency,locosts.priceinfo = inserted.priceinfo,locosts.sessionid = inserted.sessionid,locosts.payment_method = inserted.payment_method,locosts.update_meaning = inserted.update_meaning,locosts.last_updated = inserted.last_updated,locosts.updater_legal_name = inserted.updater_legal_name,locosts.update_meaning_text = inserted.update_meaning_text,locosts.last_updater_uid = inserted.last_updater_uid,locosts.charged_costcenter = inserted.charged_costcenter
from locosts inner join deleted on locosts.id = deleted.id inner join inserted on locosts.id = inserted.id
insert into locosts_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,cost
 ,costtype
 ,currency
 ,priceinfo
 ,sessionid
 ,payment_method
 ,update_meaning
 ,charged_costcenter
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,cost
 ,costtype
 ,currency
 ,priceinfo
 ,sessionid
 ,payment_method
 ,update_meaning
 ,charged_costcenter
  from inserted
end
GO

create trigger d_locosts on locosts
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from locosts where exists (
select 1 from deleted where locosts.id = deleted.id)
insert into locosts_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,cost
 ,costtype
 ,currency
 ,priceinfo
 ,sessionid
 ,payment_method
 ,update_meaning
 ,charged_costcenter
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,cost
 ,costtype
 ,currency
 ,priceinfo
 ,sessionid
 ,payment_method
 ,update_meaning
 ,charged_costcenter
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-locosts', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1074, '8:5e104d0d6a337e62125b55d7b31fdea5', 'enableAuditTable auditTableName=locosts_aud, tableName=locosts', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-lp_session_cost::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_lp_session_cost'
			)
			DROP TRIGGER i_lp_session_cost
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_lp_session_cost'
			)
			DROP TRIGGER u_lp_session_cost
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_lp_session_cost'
			)
			DROP TRIGGER d_lp_session_cost
GO

CREATE TABLE lp_session_cost_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_lp_session_cost_aud_aud_datetime DEFAULT GETDATE() NOT NULL, session_cost_id nvarchar(15), sessionid nvarchar(15), currid nvarchar(85), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_LP_SESSION_COST_AUD PRIMARY KEY (aud_id))
GO

insert into lp_session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,session_cost_id
 ,sessionid
 ,currid
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,session_cost_id
 ,sessionid
 ,currid
 ,update_meaning
  from lp_session_cost
GO

CREATE INDEX nuk_lp_session_cost_aud_1 ON lp_session_cost_aud(aud_userid)
GO

CREATE INDEX nuk_lp_session_cost_aud_2 ON lp_session_cost_aud(aud_datetime)
GO

create trigger i_lp_session_cost on lp_session_cost
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into lp_session_cost (
session_cost_id,sessionid,currid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select session_cost_id,sessionid,currid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into lp_session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,session_cost_id
 ,sessionid
 ,currid
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,session_cost_id
 ,sessionid
 ,currid
 ,update_meaning
  from inserted
end
GO

create trigger u_lp_session_cost on lp_session_cost
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update lp_session_cost set
lp_session_cost.session_cost_id = inserted.session_cost_id,lp_session_cost.sessionid = inserted.sessionid,lp_session_cost.currid = inserted.currid,lp_session_cost.update_meaning = inserted.update_meaning,lp_session_cost.last_updated = inserted.last_updated,lp_session_cost.updater_legal_name = inserted.updater_legal_name,lp_session_cost.update_meaning_text = inserted.update_meaning_text,lp_session_cost.last_updater_uid = inserted.last_updater_uid
from lp_session_cost inner join deleted on lp_session_cost.session_cost_id = deleted.session_cost_id and lp_session_cost.sessionid = deleted.sessionid and lp_session_cost.currid = deleted.currid inner join inserted on lp_session_cost.session_cost_id = inserted.session_cost_id and lp_session_cost.sessionid = inserted.sessionid and lp_session_cost.currid = inserted.currid
insert into lp_session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,session_cost_id
 ,sessionid
 ,currid
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,session_cost_id
 ,sessionid
 ,currid
 ,update_meaning
  from inserted
end
GO

create trigger d_lp_session_cost on lp_session_cost
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from lp_session_cost where exists (
select 1 from deleted where lp_session_cost.session_cost_id = deleted.session_cost_id and lp_session_cost.sessionid = deleted.sessionid and lp_session_cost.currid = deleted.currid)
insert into lp_session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,session_cost_id
 ,sessionid
 ,currid
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,session_cost_id
 ,sessionid
 ,currid
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-lp_session_cost', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1075, '8:0df0a17cf8d844d8364e7f09faf1887f', 'enableAuditTable auditTableName=lp_session_cost_aud, tableName=lp_session_cost', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-masterquestion::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_masterquestion'
			)
			DROP TRIGGER i_masterquestion
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_masterquestion'
			)
			DROP TRIGGER u_masterquestion
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_masterquestion'
			)
			DROP TRIGGER d_masterquestion
GO

CREATE TABLE masterquestion_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_masterquestion_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), testid nvarchar(100), sectionnum smallint, questionnum smallint, pagenum smallint, questionid nvarchar(85), qtype smallint, weight float(53), minuspoints float(53), questionpoolid int, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_MASTERQUESTION_AUD PRIMARY KEY (aud_id))
GO

insert into masterquestion_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,testid
 ,sectionnum
 ,questionnum
 ,pagenum
 ,questionid
 ,qtype
 ,weight
 ,minuspoints
 ,questionpoolid
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,testid
 ,sectionnum
 ,questionnum
 ,pagenum
 ,questionid
 ,qtype
 ,weight
 ,minuspoints
 ,questionpoolid
 ,update_meaning
  from masterquestion
GO

CREATE INDEX nuk_masterquestion_aud_1 ON masterquestion_aud(aud_userid)
GO

CREATE INDEX nuk_masterquestion_aud_2 ON masterquestion_aud(aud_datetime)
GO

create trigger i_masterquestion on masterquestion
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into masterquestion (
id,testid,sectionnum,questionnum,pagenum,questionid,qtype,weight,minuspoints,questionpoolid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select id,testid,sectionnum,questionnum,pagenum,questionid,qtype,weight,minuspoints,questionpoolid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into masterquestion_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,testid
 ,sectionnum
 ,questionnum
 ,pagenum
 ,questionid
 ,qtype
 ,weight
 ,minuspoints
 ,questionpoolid
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,testid
 ,sectionnum
 ,questionnum
 ,pagenum
 ,questionid
 ,qtype
 ,weight
 ,minuspoints
 ,questionpoolid
 ,update_meaning
  from inserted
end
GO

create trigger u_masterquestion on masterquestion
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update masterquestion set
masterquestion.id = inserted.id,masterquestion.testid = inserted.testid,masterquestion.sectionnum = inserted.sectionnum,masterquestion.questionnum = inserted.questionnum,masterquestion.pagenum = inserted.pagenum,masterquestion.questionid = inserted.questionid,masterquestion.qtype = inserted.qtype,masterquestion.weight = inserted.weight,masterquestion.minuspoints = inserted.minuspoints,masterquestion.questionpoolid = inserted.questionpoolid,masterquestion.update_meaning = inserted.update_meaning,masterquestion.last_updated = inserted.last_updated,masterquestion.updater_legal_name = inserted.updater_legal_name,masterquestion.update_meaning_text = inserted.update_meaning_text,masterquestion.last_updater_uid = inserted.last_updater_uid
from masterquestion inner join deleted on masterquestion.id = deleted.id inner join inserted on masterquestion.id = inserted.id
insert into masterquestion_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,testid
 ,sectionnum
 ,questionnum
 ,pagenum
 ,questionid
 ,qtype
 ,weight
 ,minuspoints
 ,questionpoolid
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,testid
 ,sectionnum
 ,questionnum
 ,pagenum
 ,questionid
 ,qtype
 ,weight
 ,minuspoints
 ,questionpoolid
 ,update_meaning
  from inserted
end
GO

create trigger d_masterquestion on masterquestion
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from masterquestion where exists (
select 1 from deleted where masterquestion.id = deleted.id)
insert into masterquestion_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,testid
 ,sectionnum
 ,questionnum
 ,pagenum
 ,questionid
 ,qtype
 ,weight
 ,minuspoints
 ,questionpoolid
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,testid
 ,sectionnum
 ,questionnum
 ,pagenum
 ,questionid
 ,qtype
 ,weight
 ,minuspoints
 ,questionpoolid
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-masterquestion', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1076, '8:ed3910f4067b26765702ff92226c914d', 'enableAuditTable auditTableName=masterquestion_aud, tableName=masterquestion', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-mastersection::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_mastersection'
			)
			DROP TRIGGER i_mastersection
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_mastersection'
			)
			DROP TRIGGER u_mastersection
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_mastersection'
			)
			DROP TRIGGER d_mastersection
GO

CREATE TABLE mastersection_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_mastersection_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), testid nvarchar(100), sectionnum smallint, nquestions int, timelimit int, layouttype smallint, testtype smallint, reqpoints float(53), maxpoints float(53), title nvarchar(255), description nvarchar(255), sectiontype int, markType nvarchar(1), randFixed char(1), weighting_option char(1), update_meaning nvarchar(8), maxtimeperquestion int, maxtimeperquestiontype int, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_MASTERSECTION_AUD PRIMARY KEY (aud_id))
GO

insert into mastersection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,testid
 ,sectionnum
 ,nquestions
 ,timelimit
 ,layouttype
 ,testtype
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,sectiontype
 ,markType
 ,randFixed
 ,weighting_option
 ,update_meaning
 ,maxtimeperquestion
 ,maxtimeperquestiontype
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,testid
 ,sectionnum
 ,nquestions
 ,timelimit
 ,layouttype
 ,testtype
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,sectiontype
 ,markType
 ,randFixed
 ,weighting_option
 ,update_meaning
 ,maxtimeperquestion
 ,maxtimeperquestiontype
  from mastersection
GO

CREATE INDEX nuk_mastersection_aud_1 ON mastersection_aud(aud_userid)
GO

CREATE INDEX nuk_mastersection_aud_2 ON mastersection_aud(aud_datetime)
GO

create trigger i_mastersection on mastersection
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into mastersection (
id,testid,sectionnum,nquestions,timelimit,layouttype,testtype,reqpoints,maxpoints,title,description,sectiontype,markType,randFixed,weighting_option,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,maxtimeperquestion,maxtimeperquestiontype) select id,testid,sectionnum,nquestions,timelimit,layouttype,testtype,reqpoints,maxpoints,title,description,sectiontype,markType,randFixed,weighting_option,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,maxtimeperquestion,maxtimeperquestiontype from inserted
insert into mastersection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,testid
 ,sectionnum
 ,nquestions
 ,timelimit
 ,layouttype
 ,testtype
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,sectiontype
 ,markType
 ,randFixed
 ,weighting_option
 ,update_meaning
 ,maxtimeperquestion
 ,maxtimeperquestiontype
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,testid
 ,sectionnum
 ,nquestions
 ,timelimit
 ,layouttype
 ,testtype
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,sectiontype
 ,markType
 ,randFixed
 ,weighting_option
 ,update_meaning
 ,maxtimeperquestion
 ,maxtimeperquestiontype
  from inserted
end
GO

create trigger u_mastersection on mastersection
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update mastersection set
mastersection.id = inserted.id,mastersection.testid = inserted.testid,mastersection.sectionnum = inserted.sectionnum,mastersection.nquestions = inserted.nquestions,mastersection.timelimit = inserted.timelimit,mastersection.layouttype = inserted.layouttype,mastersection.testtype = inserted.testtype,mastersection.reqpoints = inserted.reqpoints,mastersection.maxpoints = inserted.maxpoints,mastersection.title = inserted.title,mastersection.description = inserted.description,mastersection.sectiontype = inserted.sectiontype,mastersection.markType = inserted.markType,mastersection.randFixed = inserted.randFixed,mastersection.weighting_option = inserted.weighting_option,mastersection.update_meaning = inserted.update_meaning,mastersection.last_updated = inserted.last_updated,mastersection.updater_legal_name = inserted.updater_legal_name,mastersection.update_meaning_text = inserted.update_meaning_text,mastersection.last_updater_uid = inserted.last_updater_uid,mastersection.maxtimeperquestion = inserted.maxtimeperquestion,mastersection.maxtimeperquestiontype = inserted.maxtimeperquestiontype
from mastersection inner join deleted on mastersection.id = deleted.id inner join inserted on mastersection.id = inserted.id
insert into mastersection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,testid
 ,sectionnum
 ,nquestions
 ,timelimit
 ,layouttype
 ,testtype
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,sectiontype
 ,markType
 ,randFixed
 ,weighting_option
 ,update_meaning
 ,maxtimeperquestion
 ,maxtimeperquestiontype
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,testid
 ,sectionnum
 ,nquestions
 ,timelimit
 ,layouttype
 ,testtype
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,sectiontype
 ,markType
 ,randFixed
 ,weighting_option
 ,update_meaning
 ,maxtimeperquestion
 ,maxtimeperquestiontype
  from inserted
end
GO

create trigger d_mastersection on mastersection
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from mastersection where exists (
select 1 from deleted where mastersection.id = deleted.id)
insert into mastersection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,testid
 ,sectionnum
 ,nquestions
 ,timelimit
 ,layouttype
 ,testtype
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,sectiontype
 ,markType
 ,randFixed
 ,weighting_option
 ,update_meaning
 ,maxtimeperquestion
 ,maxtimeperquestiontype
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,testid
 ,sectionnum
 ,nquestions
 ,timelimit
 ,layouttype
 ,testtype
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,sectiontype
 ,markType
 ,randFixed
 ,weighting_option
 ,update_meaning
 ,maxtimeperquestion
 ,maxtimeperquestiontype
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-mastersection', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1077, '8:503f06933419299aa77c249052fcbb8d', 'enableAuditTable auditTableName=mastersection_aud, tableName=mastersection', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-mastertest::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_mastertest'
			)
			DROP TRIGGER i_mastertest
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_mastertest'
			)
			DROP TRIGGER u_mastertest
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_mastertest'
			)
			DROP TRIGGER d_mastertest
GO

CREATE TABLE mastertest_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_mastertest_aud_aud_datetime DEFAULT GETDATE() NOT NULL, testid nvarchar(100), owner nvarchar(85), editcontrol smallint, autoscore nvarchar(1), takelimit int, reviewable nvarchar(1), allowhints nvarchar(1), dateentered datetime, reqpoints float(53), maxpoints float(53), title nvarchar(255), description nvarchar(255), stylesheet nvarchar(30), testuse int, longDescription nvarchar(MAX), maxTimeAllowed decimal(20, 0), validFrom datetime, validTo datetime, allowPrint char(1), allowResume char(1), minimum_retake_interval_amount int, minimum_retake_interval_unit smallint, allowscoredisplay char(1), allowNavigation char(1), allowIdDisplay char(1), password nvarchar(20), disallowAbandon char(1), workflowStatus char(1), isPracticeTest char(1), allowImmediateQFeedback char(1), parenttestid nvarchar(100), resitDifference float(53), resit char(1), resitParentTestId nvarchar(100), mentor_password nvarchar(20), is_template char(1), reviewQuestion char(14), markType nvarchar(1), certid numeric(8, 0), showmark char(1), reviewtype char(1), maxtimeperquestion int, pool_summary_lvl int, fail_email_id nvarchar(15), retake_notif_email_id nvarchar(15), creator_uid nvarchar(85), update_meaning nvarchar(8), allowDownload char(1), disable_right_click char(1), start_based_time_limit char(1), is_anonymous char(1), remaining_time_type char(1), restrict_ip_participants char(1), restrict_ip_reviewers char(1), pass_email_id nvarchar(15), grade_notif_email_id nvarchar(15), rcd_post_compl_attempt char(1), rcd_post_compl_max_score char(1), post_exam_info nvarchar(MAX), missing_answer char(1), allow_unlimited_print char(1), resitForOverallExam char(1), partial_credit char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_MASTERTEST_AUD PRIMARY KEY (aud_id))
GO

insert into mastertest_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,owner
 ,editcontrol
 ,autoscore
 ,takelimit
 ,reviewable
 ,allowhints
 ,dateentered
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,stylesheet
 ,testuse
 ,longDescription
 ,maxTimeAllowed
 ,validFrom
 ,validTo
 ,allowPrint
 ,allowResume
 ,minimum_retake_interval_amount
 ,minimum_retake_interval_unit
 ,allowscoredisplay
 ,allowNavigation
 ,allowIdDisplay
 ,password
 ,disallowAbandon
 ,workflowStatus
 ,isPracticeTest
 ,allowImmediateQFeedback
 ,parenttestid
 ,resitDifference
 ,resit
 ,resitParentTestId
 ,mentor_password
 ,is_template
 ,reviewQuestion
 ,markType
 ,certid
 ,showmark
 ,reviewtype
 ,maxtimeperquestion
 ,pool_summary_lvl
 ,fail_email_id
 ,retake_notif_email_id
 ,creator_uid
 ,update_meaning
 ,allowDownload
 ,disable_right_click
 ,start_based_time_limit
 ,is_anonymous
 ,remaining_time_type
 ,restrict_ip_participants
 ,restrict_ip_reviewers
 ,pass_email_id
 ,grade_notif_email_id
 ,rcd_post_compl_attempt
 ,rcd_post_compl_max_score
 ,post_exam_info
 ,missing_answer
 ,allow_unlimited_print
 ,resitForOverallExam
 ,partial_credit
) select 'U', null
, null
, GETDATE(), null
, null
 ,testid
 ,owner
 ,editcontrol
 ,autoscore
 ,takelimit
 ,reviewable
 ,allowhints
 ,dateentered
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,stylesheet
 ,testuse
 ,longDescription
 ,maxTimeAllowed
 ,validFrom
 ,validTo
 ,allowPrint
 ,allowResume
 ,minimum_retake_interval_amount
 ,minimum_retake_interval_unit
 ,allowscoredisplay
 ,allowNavigation
 ,allowIdDisplay
 ,password
 ,disallowAbandon
 ,workflowStatus
 ,isPracticeTest
 ,allowImmediateQFeedback
 ,parenttestid
 ,resitDifference
 ,resit
 ,resitParentTestId
 ,mentor_password
 ,is_template
 ,reviewQuestion
 ,markType
 ,certid
 ,showmark
 ,reviewtype
 ,maxtimeperquestion
 ,pool_summary_lvl
 ,fail_email_id
 ,retake_notif_email_id
 ,creator_uid
 ,update_meaning
 ,allowDownload
 ,disable_right_click
 ,start_based_time_limit
 ,is_anonymous
 ,remaining_time_type
 ,restrict_ip_participants
 ,restrict_ip_reviewers
 ,pass_email_id
 ,grade_notif_email_id
 ,rcd_post_compl_attempt
 ,rcd_post_compl_max_score
 ,post_exam_info
 ,missing_answer
 ,allow_unlimited_print
 ,resitForOverallExam
 ,partial_credit
  from mastertest
GO

CREATE INDEX nuk_mastertest_aud_1 ON mastertest_aud(aud_userid)
GO

CREATE INDEX nuk_mastertest_aud_2 ON mastertest_aud(aud_datetime)
GO

create trigger i_mastertest on mastertest
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into mastertest (
testid,owner,editcontrol,autoscore,takelimit,reviewable,allowhints,dateentered,reqpoints,maxpoints,title,description,stylesheet,testuse,longDescription,maxTimeAllowed,validFrom,validTo,allowPrint,allowResume,minimum_retake_interval_amount,minimum_retake_interval_unit,allowscoredisplay,allowNavigation,allowIdDisplay,password,disallowAbandon,workflowStatus,isPracticeTest,allowImmediateQFeedback,parenttestid,resitDifference,resit,resitParentTestId,mentor_password,is_template,reviewQuestion,markType,certid,showmark,reviewtype,maxtimeperquestion,pool_summary_lvl,fail_email_id,retake_notif_email_id,creator_uid,last_updated,last_updater_uid,updater_legal_name,update_meaning_text,update_meaning,allowDownload,disable_right_click,start_based_time_limit,is_anonymous,remaining_time_type,restrict_ip_participants,restrict_ip_reviewers,pass_email_id,grade_notif_email_id,rcd_post_compl_attempt,rcd_post_compl_max_score,post_exam_info,missing_answer,allow_unlimited_print,resitForOverallExam,partial_credit) select testid,owner,editcontrol,autoscore,takelimit,reviewable,allowhints,dateentered,reqpoints,maxpoints,title,description,stylesheet,testuse,longDescription,maxTimeAllowed,validFrom,validTo,allowPrint,allowResume,minimum_retake_interval_amount,minimum_retake_interval_unit,allowscoredisplay,allowNavigation,allowIdDisplay,password,disallowAbandon,workflowStatus,isPracticeTest,allowImmediateQFeedback,parenttestid,resitDifference,resit,resitParentTestId,mentor_password,is_template,reviewQuestion,markType,certid,showmark,reviewtype,maxtimeperquestion,pool_summary_lvl,fail_email_id,retake_notif_email_id,creator_uid,last_updated,last_updater_uid,updater_legal_name,update_meaning_text,update_meaning,allowDownload,disable_right_click,start_based_time_limit,is_anonymous,remaining_time_type,restrict_ip_participants,restrict_ip_reviewers,pass_email_id,grade_notif_email_id,rcd_post_compl_attempt,rcd_post_compl_max_score,post_exam_info,missing_answer,allow_unlimited_print,resitForOverallExam,partial_credit from inserted
insert into mastertest_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,owner
 ,editcontrol
 ,autoscore
 ,takelimit
 ,reviewable
 ,allowhints
 ,dateentered
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,stylesheet
 ,testuse
 ,longDescription
 ,maxTimeAllowed
 ,validFrom
 ,validTo
 ,allowPrint
 ,allowResume
 ,minimum_retake_interval_amount
 ,minimum_retake_interval_unit
 ,allowscoredisplay
 ,allowNavigation
 ,allowIdDisplay
 ,password
 ,disallowAbandon
 ,workflowStatus
 ,isPracticeTest
 ,allowImmediateQFeedback
 ,parenttestid
 ,resitDifference
 ,resit
 ,resitParentTestId
 ,mentor_password
 ,is_template
 ,reviewQuestion
 ,markType
 ,certid
 ,showmark
 ,reviewtype
 ,maxtimeperquestion
 ,pool_summary_lvl
 ,fail_email_id
 ,retake_notif_email_id
 ,creator_uid
 ,update_meaning
 ,allowDownload
 ,disable_right_click
 ,start_based_time_limit
 ,is_anonymous
 ,remaining_time_type
 ,restrict_ip_participants
 ,restrict_ip_reviewers
 ,pass_email_id
 ,grade_notif_email_id
 ,rcd_post_compl_attempt
 ,rcd_post_compl_max_score
 ,post_exam_info
 ,missing_answer
 ,allow_unlimited_print
 ,resitForOverallExam
 ,partial_credit
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,testid
 ,owner
 ,editcontrol
 ,autoscore
 ,takelimit
 ,reviewable
 ,allowhints
 ,dateentered
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,stylesheet
 ,testuse
 ,longDescription
 ,maxTimeAllowed
 ,validFrom
 ,validTo
 ,allowPrint
 ,allowResume
 ,minimum_retake_interval_amount
 ,minimum_retake_interval_unit
 ,allowscoredisplay
 ,allowNavigation
 ,allowIdDisplay
 ,password
 ,disallowAbandon
 ,workflowStatus
 ,isPracticeTest
 ,allowImmediateQFeedback
 ,parenttestid
 ,resitDifference
 ,resit
 ,resitParentTestId
 ,mentor_password
 ,is_template
 ,reviewQuestion
 ,markType
 ,certid
 ,showmark
 ,reviewtype
 ,maxtimeperquestion
 ,pool_summary_lvl
 ,fail_email_id
 ,retake_notif_email_id
 ,creator_uid
 ,update_meaning
 ,allowDownload
 ,disable_right_click
 ,start_based_time_limit
 ,is_anonymous
 ,remaining_time_type
 ,restrict_ip_participants
 ,restrict_ip_reviewers
 ,pass_email_id
 ,grade_notif_email_id
 ,rcd_post_compl_attempt
 ,rcd_post_compl_max_score
 ,post_exam_info
 ,missing_answer
 ,allow_unlimited_print
 ,resitForOverallExam
 ,partial_credit
  from inserted
end
GO

create trigger u_mastertest on mastertest
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update mastertest set
mastertest.testid = inserted.testid,mastertest.owner = inserted.owner,mastertest.editcontrol = inserted.editcontrol,mastertest.autoscore = inserted.autoscore,mastertest.takelimit = inserted.takelimit,mastertest.reviewable = inserted.reviewable,mastertest.allowhints = inserted.allowhints,mastertest.dateentered = inserted.dateentered,mastertest.reqpoints = inserted.reqpoints,mastertest.maxpoints = inserted.maxpoints,mastertest.title = inserted.title,mastertest.description = inserted.description,mastertest.stylesheet = inserted.stylesheet,mastertest.testuse = inserted.testuse,mastertest.longDescription = inserted.longDescription,mastertest.maxTimeAllowed = inserted.maxTimeAllowed,mastertest.validFrom = inserted.validFrom,mastertest.validTo = inserted.validTo,mastertest.allowPrint = inserted.allowPrint,mastertest.allowResume = inserted.allowResume,mastertest.minimum_retake_interval_amount = inserted.minimum_retake_interval_amount,mastertest.minimum_retake_interval_unit = inserted.minimum_retake_interval_unit,mastertest.allowscoredisplay = inserted.allowscoredisplay,mastertest.allowNavigation = inserted.allowNavigation,mastertest.allowIdDisplay = inserted.allowIdDisplay,mastertest.password = inserted.password,mastertest.disallowAbandon = inserted.disallowAbandon,mastertest.workflowStatus = inserted.workflowStatus,mastertest.isPracticeTest = inserted.isPracticeTest,mastertest.allowImmediateQFeedback = inserted.allowImmediateQFeedback,mastertest.parenttestid = inserted.parenttestid,mastertest.resitDifference = inserted.resitDifference,mastertest.resit = inserted.resit,mastertest.resitParentTestId = inserted.resitParentTestId,mastertest.mentor_password = inserted.mentor_password,mastertest.is_template = inserted.is_template,mastertest.reviewQuestion = inserted.reviewQuestion,mastertest.markType = inserted.markType,mastertest.certid = inserted.certid,mastertest.showmark = inserted.showmark,mastertest.reviewtype = inserted.reviewtype,mastertest.maxtimeperquestion = inserted.maxtimeperquestion,mastertest.pool_summary_lvl = inserted.pool_summary_lvl,mastertest.fail_email_id = inserted.fail_email_id,mastertest.retake_notif_email_id = inserted.retake_notif_email_id,mastertest.creator_uid = inserted.creator_uid,mastertest.last_updated = inserted.last_updated,mastertest.last_updater_uid = inserted.last_updater_uid,mastertest.updater_legal_name = inserted.updater_legal_name,mastertest.update_meaning_text = inserted.update_meaning_text,mastertest.update_meaning = inserted.update_meaning,mastertest.allowDownload = inserted.allowDownload,mastertest.disable_right_click = inserted.disable_right_click,mastertest.start_based_time_limit = inserted.start_based_time_limit,mastertest.is_anonymous = inserted.is_anonymous,mastertest.remaining_time_type = inserted.remaining_time_type,mastertest.restrict_ip_participants = inserted.restrict_ip_participants,mastertest.restrict_ip_reviewers = inserted.restrict_ip_reviewers,mastertest.pass_email_id = inserted.pass_email_id,mastertest.grade_notif_email_id = inserted.grade_notif_email_id,mastertest.rcd_post_compl_attempt = inserted.rcd_post_compl_attempt,mastertest.rcd_post_compl_max_score = inserted.rcd_post_compl_max_score,mastertest.post_exam_info = inserted.post_exam_info,mastertest.missing_answer = inserted.missing_answer,mastertest.allow_unlimited_print = inserted.allow_unlimited_print,mastertest.resitForOverallExam = inserted.resitForOverallExam,mastertest.partial_credit = inserted.partial_credit
from mastertest inner join deleted on mastertest.testid = deleted.testid inner join inserted on mastertest.testid = inserted.testid
insert into mastertest_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,owner
 ,editcontrol
 ,autoscore
 ,takelimit
 ,reviewable
 ,allowhints
 ,dateentered
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,stylesheet
 ,testuse
 ,longDescription
 ,maxTimeAllowed
 ,validFrom
 ,validTo
 ,allowPrint
 ,allowResume
 ,minimum_retake_interval_amount
 ,minimum_retake_interval_unit
 ,allowscoredisplay
 ,allowNavigation
 ,allowIdDisplay
 ,password
 ,disallowAbandon
 ,workflowStatus
 ,isPracticeTest
 ,allowImmediateQFeedback
 ,parenttestid
 ,resitDifference
 ,resit
 ,resitParentTestId
 ,mentor_password
 ,is_template
 ,reviewQuestion
 ,markType
 ,certid
 ,showmark
 ,reviewtype
 ,maxtimeperquestion
 ,pool_summary_lvl
 ,fail_email_id
 ,retake_notif_email_id
 ,creator_uid
 ,update_meaning
 ,allowDownload
 ,disable_right_click
 ,start_based_time_limit
 ,is_anonymous
 ,remaining_time_type
 ,restrict_ip_participants
 ,restrict_ip_reviewers
 ,pass_email_id
 ,grade_notif_email_id
 ,rcd_post_compl_attempt
 ,rcd_post_compl_max_score
 ,post_exam_info
 ,missing_answer
 ,allow_unlimited_print
 ,resitForOverallExam
 ,partial_credit
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,testid
 ,owner
 ,editcontrol
 ,autoscore
 ,takelimit
 ,reviewable
 ,allowhints
 ,dateentered
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,stylesheet
 ,testuse
 ,longDescription
 ,maxTimeAllowed
 ,validFrom
 ,validTo
 ,allowPrint
 ,allowResume
 ,minimum_retake_interval_amount
 ,minimum_retake_interval_unit
 ,allowscoredisplay
 ,allowNavigation
 ,allowIdDisplay
 ,password
 ,disallowAbandon
 ,workflowStatus
 ,isPracticeTest
 ,allowImmediateQFeedback
 ,parenttestid
 ,resitDifference
 ,resit
 ,resitParentTestId
 ,mentor_password
 ,is_template
 ,reviewQuestion
 ,markType
 ,certid
 ,showmark
 ,reviewtype
 ,maxtimeperquestion
 ,pool_summary_lvl
 ,fail_email_id
 ,retake_notif_email_id
 ,creator_uid
 ,update_meaning
 ,allowDownload
 ,disable_right_click
 ,start_based_time_limit
 ,is_anonymous
 ,remaining_time_type
 ,restrict_ip_participants
 ,restrict_ip_reviewers
 ,pass_email_id
 ,grade_notif_email_id
 ,rcd_post_compl_attempt
 ,rcd_post_compl_max_score
 ,post_exam_info
 ,missing_answer
 ,allow_unlimited_print
 ,resitForOverallExam
 ,partial_credit
  from inserted
end
GO

create trigger d_mastertest on mastertest
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from mastertest where exists (
select 1 from deleted where mastertest.testid = deleted.testid)
insert into mastertest_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,owner
 ,editcontrol
 ,autoscore
 ,takelimit
 ,reviewable
 ,allowhints
 ,dateentered
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,stylesheet
 ,testuse
 ,longDescription
 ,maxTimeAllowed
 ,validFrom
 ,validTo
 ,allowPrint
 ,allowResume
 ,minimum_retake_interval_amount
 ,minimum_retake_interval_unit
 ,allowscoredisplay
 ,allowNavigation
 ,allowIdDisplay
 ,password
 ,disallowAbandon
 ,workflowStatus
 ,isPracticeTest
 ,allowImmediateQFeedback
 ,parenttestid
 ,resitDifference
 ,resit
 ,resitParentTestId
 ,mentor_password
 ,is_template
 ,reviewQuestion
 ,markType
 ,certid
 ,showmark
 ,reviewtype
 ,maxtimeperquestion
 ,pool_summary_lvl
 ,fail_email_id
 ,retake_notif_email_id
 ,creator_uid
 ,update_meaning
 ,allowDownload
 ,disable_right_click
 ,start_based_time_limit
 ,is_anonymous
 ,remaining_time_type
 ,restrict_ip_participants
 ,restrict_ip_reviewers
 ,pass_email_id
 ,grade_notif_email_id
 ,rcd_post_compl_attempt
 ,rcd_post_compl_max_score
 ,post_exam_info
 ,missing_answer
 ,allow_unlimited_print
 ,resitForOverallExam
 ,partial_credit
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,testid
 ,owner
 ,editcontrol
 ,autoscore
 ,takelimit
 ,reviewable
 ,allowhints
 ,dateentered
 ,reqpoints
 ,maxpoints
 ,title
 ,description
 ,stylesheet
 ,testuse
 ,longDescription
 ,maxTimeAllowed
 ,validFrom
 ,validTo
 ,allowPrint
 ,allowResume
 ,minimum_retake_interval_amount
 ,minimum_retake_interval_unit
 ,allowscoredisplay
 ,allowNavigation
 ,allowIdDisplay
 ,password
 ,disallowAbandon
 ,workflowStatus
 ,isPracticeTest
 ,allowImmediateQFeedback
 ,parenttestid
 ,resitDifference
 ,resit
 ,resitParentTestId
 ,mentor_password
 ,is_template
 ,reviewQuestion
 ,markType
 ,certid
 ,showmark
 ,reviewtype
 ,maxtimeperquestion
 ,pool_summary_lvl
 ,fail_email_id
 ,retake_notif_email_id
 ,creator_uid
 ,update_meaning
 ,allowDownload
 ,disable_right_click
 ,start_based_time_limit
 ,is_anonymous
 ,remaining_time_type
 ,restrict_ip_participants
 ,restrict_ip_reviewers
 ,pass_email_id
 ,grade_notif_email_id
 ,rcd_post_compl_attempt
 ,rcd_post_compl_max_score
 ,post_exam_info
 ,missing_answer
 ,allow_unlimited_print
 ,resitForOverallExam
 ,partial_credit
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-mastertest', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1078, '8:4eae0e2418904ea7314be12c1262b9b5', 'enableAuditTable auditTableName=mastertest_aud, tableName=mastertest', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-objectives_topics::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_objectives_topics'
			)
			DROP TRIGGER i_objectives_topics
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_objectives_topics'
			)
			DROP TRIGGER u_objectives_topics
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_objectives_topics'
			)
			DROP TRIGGER d_objectives_topics
GO

CREATE TABLE objectives_topics_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_objectives_topics_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), entrynum tinyint, description nvarchar(2000), update_meaning nvarchar(8), description_key nvarchar(85), id nvarchar(100), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_OBJECTIVES_TOPICS_AUD PRIMARY KEY (aud_id))
GO

insert into objectives_topics_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,entrynum
 ,description
 ,update_meaning
 ,description_key
 ,id
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,entrynum
 ,description
 ,update_meaning
 ,description_key
 ,id
  from objectives_topics
GO

CREATE INDEX nuk_objectives_topics_aud_1 ON objectives_topics_aud(aud_userid)
GO

CREATE INDEX nuk_objectives_topics_aud_2 ON objectives_topics_aud(aud_datetime)
GO

create trigger i_objectives_topics on objectives_topics
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into objectives_topics (
learningid,entrynum,description,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,description_key,id) select learningid,entrynum,description,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,description_key,id from inserted
insert into objectives_topics_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,entrynum
 ,description
 ,update_meaning
 ,description_key
 ,id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,entrynum
 ,description
 ,update_meaning
 ,description_key
 ,id
  from inserted
end
GO

create trigger u_objectives_topics on objectives_topics
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update objectives_topics set
objectives_topics.learningid = inserted.learningid,objectives_topics.entrynum = inserted.entrynum,objectives_topics.description = inserted.description,objectives_topics.update_meaning = inserted.update_meaning,objectives_topics.last_updated = inserted.last_updated,objectives_topics.updater_legal_name = inserted.updater_legal_name,objectives_topics.update_meaning_text = inserted.update_meaning_text,objectives_topics.last_updater_uid = inserted.last_updater_uid,objectives_topics.description_key = inserted.description_key,objectives_topics.id = inserted.id
from objectives_topics inner join deleted on objectives_topics.learningid = deleted.learningid and objectives_topics.entrynum = deleted.entrynum inner join inserted on objectives_topics.learningid = inserted.learningid and objectives_topics.entrynum = inserted.entrynum
insert into objectives_topics_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,entrynum
 ,description
 ,update_meaning
 ,description_key
 ,id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,entrynum
 ,description
 ,update_meaning
 ,description_key
 ,id
  from inserted
end
GO

create trigger d_objectives_topics on objectives_topics
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from objectives_topics where exists (
select 1 from deleted where objectives_topics.learningid = deleted.learningid and objectives_topics.entrynum = deleted.entrynum)
insert into objectives_topics_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,entrynum
 ,description
 ,update_meaning
 ,description_key
 ,id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,entrynum
 ,description
 ,update_meaning
 ,description_key
 ,id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-objectives_topics', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1079, '8:a53db7840b25b6133964f013ecc27ba6', 'enableAuditTable auditTableName=objectives_topics_aud, tableName=objectives_topics', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-otherObjects::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_otherObjects'
			)
			DROP TRIGGER i_otherObjects
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_otherObjects'
			)
			DROP TRIGGER u_otherObjects
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_otherObjects'
			)
			DROP TRIGGER d_otherObjects
GO

CREATE TABLE otherObjects_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_otherObjects_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), learningType nvarchar(1), speaker_author nvarchar(50), publisher_institute nvarchar(50), location nvarchar(255), referenceno nvarchar(40), enrolldeadline datetime, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_OTHEROBJECTS_AUD PRIMARY KEY (aud_id))
GO

insert into otherObjects_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,learningType
 ,speaker_author
 ,publisher_institute
 ,location
 ,referenceno
 ,enrolldeadline
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,learningType
 ,speaker_author
 ,publisher_institute
 ,location
 ,referenceno
 ,enrolldeadline
 ,update_meaning
  from otherObjects
GO

CREATE INDEX nuk_otherObjects_aud_1 ON otherObjects_aud(aud_userid)
GO

CREATE INDEX nuk_otherObjects_aud_2 ON otherObjects_aud(aud_datetime)
GO

create trigger i_otherObjects on otherObjects
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into otherObjects (
learningid,learningType,speaker_author,publisher_institute,location,referenceno,enrolldeadline,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select learningid,learningType,speaker_author,publisher_institute,location,referenceno,enrolldeadline,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into otherObjects_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,learningType
 ,speaker_author
 ,publisher_institute
 ,location
 ,referenceno
 ,enrolldeadline
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,learningType
 ,speaker_author
 ,publisher_institute
 ,location
 ,referenceno
 ,enrolldeadline
 ,update_meaning
  from inserted
end
GO

create trigger u_otherObjects on otherObjects
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update otherObjects set
otherObjects.learningid = inserted.learningid,otherObjects.learningType = inserted.learningType,otherObjects.speaker_author = inserted.speaker_author,otherObjects.publisher_institute = inserted.publisher_institute,otherObjects.location = inserted.location,otherObjects.referenceno = inserted.referenceno,otherObjects.enrolldeadline = inserted.enrolldeadline,otherObjects.update_meaning = inserted.update_meaning,otherObjects.last_updated = inserted.last_updated,otherObjects.updater_legal_name = inserted.updater_legal_name,otherObjects.update_meaning_text = inserted.update_meaning_text,otherObjects.last_updater_uid = inserted.last_updater_uid
from otherObjects inner join deleted on otherObjects.learningid = deleted.learningid inner join inserted on otherObjects.learningid = inserted.learningid
insert into otherObjects_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,learningType
 ,speaker_author
 ,publisher_institute
 ,location
 ,referenceno
 ,enrolldeadline
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,learningType
 ,speaker_author
 ,publisher_institute
 ,location
 ,referenceno
 ,enrolldeadline
 ,update_meaning
  from inserted
end
GO

create trigger d_otherObjects on otherObjects
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from otherObjects where exists (
select 1 from deleted where otherObjects.learningid = deleted.learningid)
insert into otherObjects_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,learningType
 ,speaker_author
 ,publisher_institute
 ,location
 ,referenceno
 ,enrolldeadline
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,learningType
 ,speaker_author
 ,publisher_institute
 ,location
 ,referenceno
 ,enrolldeadline
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-otherObjects', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1080, '8:47526587e5751e4d565ff6f76df27ecb', 'enableAuditTable auditTableName=otherObjects_aud, tableName=otherObjects', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-owners::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_owners'
			)
			DROP TRIGGER i_owners
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_owners'
			)
			DROP TRIGGER u_owners
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_owners'
			)
			DROP TRIGGER d_owners
GO

CREATE TABLE owners_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_owners_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), userid nvarchar(85), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_OWNERS_AUD PRIMARY KEY (aud_id))
GO

insert into owners_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,userid
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,userid
 ,update_meaning
  from owners
GO

CREATE INDEX nuk_owners_aud_1 ON owners_aud(aud_userid)
GO

CREATE INDEX nuk_owners_aud_2 ON owners_aud(aud_datetime)
GO

create trigger i_owners on owners
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into owners (
learningid,userid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select learningid,userid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into owners_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,userid
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,userid
 ,update_meaning
  from inserted
end
GO

create trigger u_owners on owners
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update owners set
owners.learningid = inserted.learningid,owners.userid = inserted.userid,owners.update_meaning = inserted.update_meaning,owners.last_updated = inserted.last_updated,owners.updater_legal_name = inserted.updater_legal_name,owners.update_meaning_text = inserted.update_meaning_text,owners.last_updater_uid = inserted.last_updater_uid
from owners inner join deleted on owners.learningid = deleted.learningid and owners.userid = deleted.userid inner join inserted on owners.learningid = inserted.learningid and owners.userid = inserted.userid
insert into owners_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,userid
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,userid
 ,update_meaning
  from inserted
end
GO

create trigger d_owners on owners
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from owners where exists (
select 1 from deleted where owners.learningid = deleted.learningid and owners.userid = deleted.userid)
insert into owners_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,userid
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,userid
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-owners', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1081, '8:e17a6ae1e2c527d80212e2790bbc727c', 'enableAuditTable auditTableName=owners_aud, tableName=owners', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-prereq::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_prereq'
			)
			DROP TRIGGER i_prereq
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_prereq'
			)
			DROP TRIGGER u_prereq
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_prereq'
			)
			DROP TRIGGER d_prereq
GO

CREATE TABLE prereq_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_prereq_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), prereqid nvarchar(85), update_meaning nvarchar(8), prereqcontrol int, section int, logic char(1), is_mandatory char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_PREREQ_AUD PRIMARY KEY (aud_id))
GO

insert into prereq_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,prereqid
 ,update_meaning
 ,prereqcontrol
 ,section
 ,logic
 ,is_mandatory
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,prereqid
 ,update_meaning
 ,prereqcontrol
 ,section
 ,logic
 ,is_mandatory
  from prereq
GO

CREATE INDEX nuk_prereq_aud_1 ON prereq_aud(aud_userid)
GO

CREATE INDEX nuk_prereq_aud_2 ON prereq_aud(aud_datetime)
GO

create trigger i_prereq on prereq
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into prereq (
learningid,prereqid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,prereqcontrol,section,logic,is_mandatory) select learningid,prereqid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,prereqcontrol,section,logic,is_mandatory from inserted
insert into prereq_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,prereqid
 ,update_meaning
 ,prereqcontrol
 ,section
 ,logic
 ,is_mandatory
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,prereqid
 ,update_meaning
 ,prereqcontrol
 ,section
 ,logic
 ,is_mandatory
  from inserted
end
GO

create trigger u_prereq on prereq
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update prereq set
prereq.learningid = inserted.learningid,prereq.prereqid = inserted.prereqid,prereq.update_meaning = inserted.update_meaning,prereq.last_updated = inserted.last_updated,prereq.updater_legal_name = inserted.updater_legal_name,prereq.update_meaning_text = inserted.update_meaning_text,prereq.last_updater_uid = inserted.last_updater_uid,prereq.prereqcontrol = inserted.prereqcontrol,prereq.section = inserted.section,prereq.logic = inserted.logic,prereq.is_mandatory = inserted.is_mandatory
from prereq inner join deleted on prereq.learningid = deleted.learningid and prereq.prereqid = deleted.prereqid and prereq.section = deleted.section inner join inserted on prereq.learningid = inserted.learningid and prereq.prereqid = inserted.prereqid and prereq.section = inserted.section
insert into prereq_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,prereqid
 ,update_meaning
 ,prereqcontrol
 ,section
 ,logic
 ,is_mandatory
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,prereqid
 ,update_meaning
 ,prereqcontrol
 ,section
 ,logic
 ,is_mandatory
  from inserted
end
GO

create trigger d_prereq on prereq
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from prereq where exists (
select 1 from deleted where prereq.learningid = deleted.learningid and prereq.prereqid = deleted.prereqid and prereq.section = deleted.section)
insert into prereq_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,prereqid
 ,update_meaning
 ,prereqcontrol
 ,section
 ,logic
 ,is_mandatory
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,prereqid
 ,update_meaning
 ,prereqcontrol
 ,section
 ,logic
 ,is_mandatory
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-prereq', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1082, '8:70b65de8ab36878494319a5a58a1e93d', 'enableAuditTable auditTableName=prereq_aud, tableName=prereq', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-qattributes::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_qattributes'
			)
			DROP TRIGGER i_qattributes
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_qattributes'
			)
			DROP TRIGGER u_qattributes
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_qattributes'
			)
			DROP TRIGGER d_qattributes
GO

CREATE TABLE qattributes_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_qattributes_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), imageobject varchar(255), audioobject varchar(255), videoobject varchar(255), otherobject nvarchar(1000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QATTRIBUTES_AUD PRIMARY KEY (aud_id))
GO

insert into qattributes_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,imageobject
 ,audioobject
 ,videoobject
 ,otherobject
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,imageobject
 ,audioobject
 ,videoobject
 ,otherobject
 ,update_meaning
  from qattributes
GO

CREATE INDEX nuk_qattributes_aud_1 ON qattributes_aud(aud_userid)
GO

CREATE INDEX nuk_qattributes_aud_2 ON qattributes_aud(aud_datetime)
GO

create trigger i_qattributes on qattributes
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into qattributes (
questionid,imageobject,audioobject,videoobject,otherobject,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,imageobject,audioobject,videoobject,otherobject,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into qattributes_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,imageobject
 ,audioobject
 ,videoobject
 ,otherobject
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,imageobject
 ,audioobject
 ,videoobject
 ,otherobject
 ,update_meaning
  from inserted
end
GO

create trigger u_qattributes on qattributes
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update qattributes set
qattributes.questionid = inserted.questionid,qattributes.imageobject = inserted.imageobject,qattributes.audioobject = inserted.audioobject,qattributes.videoobject = inserted.videoobject,qattributes.otherobject = inserted.otherobject,qattributes.update_meaning = inserted.update_meaning,qattributes.last_updated = inserted.last_updated,qattributes.updater_legal_name = inserted.updater_legal_name,qattributes.update_meaning_text = inserted.update_meaning_text,qattributes.last_updater_uid = inserted.last_updater_uid
from qattributes inner join deleted on qattributes.questionid = deleted.questionid inner join inserted on qattributes.questionid = inserted.questionid
insert into qattributes_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,imageobject
 ,audioobject
 ,videoobject
 ,otherobject
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,imageobject
 ,audioobject
 ,videoobject
 ,otherobject
 ,update_meaning
  from inserted
end
GO

create trigger d_qattributes on qattributes
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from qattributes where exists (
select 1 from deleted where qattributes.questionid = deleted.questionid)
insert into qattributes_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,imageobject
 ,audioobject
 ,videoobject
 ,otherobject
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,imageobject
 ,audioobject
 ,videoobject
 ,otherobject
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-qattributes', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1083, '8:953bae171182ab5dc0de47f8d18d9b04', 'enableAuditTable auditTableName=qattributes_aud, tableName=qattributes', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question'
			)
			DROP TRIGGER i_question
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question'
			)
			DROP TRIGGER u_question
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question'
			)
			DROP TRIGGER d_question
GO

CREATE TABLE question_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qtype smallint, difficulty float(53), owner nvarchar(85), editcontrol smallint, hint nvarchar(MAX), prenote nvarchar(MAX), postnote nvarchar(MAX), qtext nvarchar(MAX), plain_text nvarchar(MAX), searchText nvarchar(1000), category smallint, allowPartialCredit char(1), weighting float(53), referenceinfo nvarchar(255), qstatus int, qcomments nvarchar(512), selectfrequency float(53), usageTotal int, usageLimit int, expiry_date datetime, version int, archivereferenceid nvarchar(85), archivecreatedate datetime, writer nvarchar(85), writer_comments nvarchar(255), reviewer nvarchar(85), reviewer_comments nvarchar(255), approver nvarchar(85), approver_comments nvarchar(255), rejectedby nvarchar(85), reject_comments nvarchar(255), edittime nvarchar(85), reviewtime nvarchar(85), approvetime nvarchar(85), rejecttime nvarchar(85), is_ext_flagged char(1), creator_uid nvarchar(85), datecreated datetime, update_meaning nvarchar(8), enable_question_attachment char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_AUD PRIMARY KEY (aud_id))
GO

insert into question_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qtype
 ,difficulty
 ,owner
 ,editcontrol
 ,hint
 ,prenote
 ,postnote
 ,qtext
 ,plain_text
 ,searchText
 ,category
 ,allowPartialCredit
 ,weighting
 ,referenceinfo
 ,qstatus
 ,qcomments
 ,selectfrequency
 ,usageTotal
 ,usageLimit
 ,expiry_date
 ,version
 ,archivereferenceid
 ,archivecreatedate
 ,writer
 ,writer_comments
 ,reviewer
 ,reviewer_comments
 ,approver
 ,approver_comments
 ,rejectedby
 ,reject_comments
 ,edittime
 ,reviewtime
 ,approvetime
 ,rejecttime
 ,is_ext_flagged
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,enable_question_attachment
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qtype
 ,difficulty
 ,owner
 ,editcontrol
 ,hint
 ,prenote
 ,postnote
 ,qtext
 ,plain_text
 ,searchText
 ,category
 ,allowPartialCredit
 ,weighting
 ,referenceinfo
 ,qstatus
 ,qcomments
 ,selectfrequency
 ,usageTotal
 ,usageLimit
 ,expiry_date
 ,version
 ,archivereferenceid
 ,archivecreatedate
 ,writer
 ,writer_comments
 ,reviewer
 ,reviewer_comments
 ,approver
 ,approver_comments
 ,rejectedby
 ,reject_comments
 ,edittime
 ,reviewtime
 ,approvetime
 ,rejecttime
 ,is_ext_flagged
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,enable_question_attachment
  from question
GO

CREATE INDEX nuk_question_aud_1 ON question_aud(aud_userid)
GO

CREATE INDEX nuk_question_aud_2 ON question_aud(aud_datetime)
GO

create trigger i_question on question
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question (
questionid,qtype,difficulty,owner,editcontrol,hint,prenote,postnote,qtext,plain_text,searchText,updater_legal_name,update_meaning_text,category,allowPartialCredit,weighting,referenceinfo,qstatus,qcomments,selectfrequency,usageTotal,usageLimit,expiry_date,version,archivereferenceid,archivecreatedate,writer,writer_comments,reviewer,reviewer_comments,approver,approver_comments,rejectedby,reject_comments,edittime,reviewtime,approvetime,rejecttime,is_ext_flagged,creator_uid,datecreated,last_updated,last_updater_uid,update_meaning,enable_question_attachment) select questionid,qtype,difficulty,owner,editcontrol,hint,prenote,postnote,qtext,plain_text,searchText,updater_legal_name,update_meaning_text,category,allowPartialCredit,weighting,referenceinfo,qstatus,qcomments,selectfrequency,usageTotal,usageLimit,expiry_date,version,archivereferenceid,archivecreatedate,writer,writer_comments,reviewer,reviewer_comments,approver,approver_comments,rejectedby,reject_comments,edittime,reviewtime,approvetime,rejecttime,is_ext_flagged,creator_uid,datecreated,last_updated,last_updater_uid,update_meaning,enable_question_attachment from inserted
insert into question_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qtype
 ,difficulty
 ,owner
 ,editcontrol
 ,hint
 ,prenote
 ,postnote
 ,qtext
 ,plain_text
 ,searchText
 ,category
 ,allowPartialCredit
 ,weighting
 ,referenceinfo
 ,qstatus
 ,qcomments
 ,selectfrequency
 ,usageTotal
 ,usageLimit
 ,expiry_date
 ,version
 ,archivereferenceid
 ,archivecreatedate
 ,writer
 ,writer_comments
 ,reviewer
 ,reviewer_comments
 ,approver
 ,approver_comments
 ,rejectedby
 ,reject_comments
 ,edittime
 ,reviewtime
 ,approvetime
 ,rejecttime
 ,is_ext_flagged
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,enable_question_attachment
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qtype
 ,difficulty
 ,owner
 ,editcontrol
 ,hint
 ,prenote
 ,postnote
 ,qtext
 ,plain_text
 ,searchText
 ,category
 ,allowPartialCredit
 ,weighting
 ,referenceinfo
 ,qstatus
 ,qcomments
 ,selectfrequency
 ,usageTotal
 ,usageLimit
 ,expiry_date
 ,version
 ,archivereferenceid
 ,archivecreatedate
 ,writer
 ,writer_comments
 ,reviewer
 ,reviewer_comments
 ,approver
 ,approver_comments
 ,rejectedby
 ,reject_comments
 ,edittime
 ,reviewtime
 ,approvetime
 ,rejecttime
 ,is_ext_flagged
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,enable_question_attachment
  from inserted
end
GO

create trigger u_question on question
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question set
question.questionid = inserted.questionid,question.qtype = inserted.qtype,question.difficulty = inserted.difficulty,question.owner = inserted.owner,question.editcontrol = inserted.editcontrol,question.hint = inserted.hint,question.prenote = inserted.prenote,question.postnote = inserted.postnote,question.qtext = inserted.qtext,question.plain_text = inserted.plain_text,question.searchText = inserted.searchText,question.updater_legal_name = inserted.updater_legal_name,question.update_meaning_text = inserted.update_meaning_text,question.category = inserted.category,question.allowPartialCredit = inserted.allowPartialCredit,question.weighting = inserted.weighting,question.referenceinfo = inserted.referenceinfo,question.qstatus = inserted.qstatus,question.qcomments = inserted.qcomments,question.selectfrequency = inserted.selectfrequency,question.usageTotal = inserted.usageTotal,question.usageLimit = inserted.usageLimit,question.expiry_date = inserted.expiry_date,question.version = inserted.version,question.archivereferenceid = inserted.archivereferenceid,question.archivecreatedate = inserted.archivecreatedate,question.writer = inserted.writer,question.writer_comments = inserted.writer_comments,question.reviewer = inserted.reviewer,question.reviewer_comments = inserted.reviewer_comments,question.approver = inserted.approver,question.approver_comments = inserted.approver_comments,question.rejectedby = inserted.rejectedby,question.reject_comments = inserted.reject_comments,question.edittime = inserted.edittime,question.reviewtime = inserted.reviewtime,question.approvetime = inserted.approvetime,question.rejecttime = inserted.rejecttime,question.is_ext_flagged = inserted.is_ext_flagged,question.creator_uid = inserted.creator_uid,question.datecreated = inserted.datecreated,question.last_updated = inserted.last_updated,question.last_updater_uid = inserted.last_updater_uid,question.update_meaning = inserted.update_meaning,question.enable_question_attachment = inserted.enable_question_attachment
from question inner join deleted on question.questionid = deleted.questionid inner join inserted on question.questionid = inserted.questionid
insert into question_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qtype
 ,difficulty
 ,owner
 ,editcontrol
 ,hint
 ,prenote
 ,postnote
 ,qtext
 ,plain_text
 ,searchText
 ,category
 ,allowPartialCredit
 ,weighting
 ,referenceinfo
 ,qstatus
 ,qcomments
 ,selectfrequency
 ,usageTotal
 ,usageLimit
 ,expiry_date
 ,version
 ,archivereferenceid
 ,archivecreatedate
 ,writer
 ,writer_comments
 ,reviewer
 ,reviewer_comments
 ,approver
 ,approver_comments
 ,rejectedby
 ,reject_comments
 ,edittime
 ,reviewtime
 ,approvetime
 ,rejecttime
 ,is_ext_flagged
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,enable_question_attachment
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qtype
 ,difficulty
 ,owner
 ,editcontrol
 ,hint
 ,prenote
 ,postnote
 ,qtext
 ,plain_text
 ,searchText
 ,category
 ,allowPartialCredit
 ,weighting
 ,referenceinfo
 ,qstatus
 ,qcomments
 ,selectfrequency
 ,usageTotal
 ,usageLimit
 ,expiry_date
 ,version
 ,archivereferenceid
 ,archivecreatedate
 ,writer
 ,writer_comments
 ,reviewer
 ,reviewer_comments
 ,approver
 ,approver_comments
 ,rejectedby
 ,reject_comments
 ,edittime
 ,reviewtime
 ,approvetime
 ,rejecttime
 ,is_ext_flagged
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,enable_question_attachment
  from inserted
end
GO

create trigger d_question on question
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question where exists (
select 1 from deleted where question.questionid = deleted.questionid)
insert into question_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qtype
 ,difficulty
 ,owner
 ,editcontrol
 ,hint
 ,prenote
 ,postnote
 ,qtext
 ,plain_text
 ,searchText
 ,category
 ,allowPartialCredit
 ,weighting
 ,referenceinfo
 ,qstatus
 ,qcomments
 ,selectfrequency
 ,usageTotal
 ,usageLimit
 ,expiry_date
 ,version
 ,archivereferenceid
 ,archivecreatedate
 ,writer
 ,writer_comments
 ,reviewer
 ,reviewer_comments
 ,approver
 ,approver_comments
 ,rejectedby
 ,reject_comments
 ,edittime
 ,reviewtime
 ,approvetime
 ,rejecttime
 ,is_ext_flagged
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,enable_question_attachment
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qtype
 ,difficulty
 ,owner
 ,editcontrol
 ,hint
 ,prenote
 ,postnote
 ,qtext
 ,plain_text
 ,searchText
 ,category
 ,allowPartialCredit
 ,weighting
 ,referenceinfo
 ,qstatus
 ,qcomments
 ,selectfrequency
 ,usageTotal
 ,usageLimit
 ,expiry_date
 ,version
 ,archivereferenceid
 ,archivecreatedate
 ,writer
 ,writer_comments
 ,reviewer
 ,reviewer_comments
 ,approver
 ,approver_comments
 ,rejectedby
 ,reject_comments
 ,edittime
 ,reviewtime
 ,approvetime
 ,rejecttime
 ,is_ext_flagged
 ,creator_uid
 ,datecreated
 ,update_meaning
 ,enable_question_attachment
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1084, '8:01f70a511a3e9ac7233abe826934a928', 'enableAuditTable auditTableName=question_aud, tableName=question', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_attachment::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_attachment'
			)
			DROP TRIGGER i_question_attachment
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_attachment'
			)
			DROP TRIGGER u_question_attachment
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_attachment'
			)
			DROP TRIGGER d_question_attachment
GO

CREATE TABLE question_attachment_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_attachment_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), instanceid nvarchar(15), sectionnum smallint, questionnum smallint, filename nvarchar(85), display_name nvarchar(85), path nvarchar(255), description nvarchar(255), owner_id nvarchar(85), uploaded_by nvarchar(85), upload_date datetime, last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_ATTACHMENT_AUD PRIMARY KEY (aud_id))
GO

insert into question_attachment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,instanceid
 ,sectionnum
 ,questionnum
 ,filename
 ,display_name
 ,path
 ,description
 ,owner_id
 ,uploaded_by
 ,upload_date
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,instanceid
 ,sectionnum
 ,questionnum
 ,filename
 ,display_name
 ,path
 ,description
 ,owner_id
 ,uploaded_by
 ,upload_date
  from question_attachment
GO

CREATE INDEX nuk_question_attachment_aud_1 ON question_attachment_aud(aud_userid)
GO

CREATE INDEX nuk_question_attachment_aud_2 ON question_attachment_aud(aud_datetime)
GO

create trigger i_question_attachment on question_attachment
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_attachment (
id,instanceid,sectionnum,questionnum,filename,display_name,path,description,owner_id,uploaded_by,upload_date) select id,instanceid,sectionnum,questionnum,filename,display_name,path,description,owner_id,uploaded_by,upload_date from inserted
insert into question_attachment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,instanceid
 ,sectionnum
 ,questionnum
 ,filename
 ,display_name
 ,path
 ,description
 ,owner_id
 ,uploaded_by
 ,upload_date
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,instanceid
 ,sectionnum
 ,questionnum
 ,filename
 ,display_name
 ,path
 ,description
 ,owner_id
 ,uploaded_by
 ,upload_date
  from inserted
end
GO

create trigger u_question_attachment on question_attachment
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_attachment set
question_attachment.id = inserted.id,question_attachment.instanceid = inserted.instanceid,question_attachment.sectionnum = inserted.sectionnum,question_attachment.questionnum = inserted.questionnum,question_attachment.filename = inserted.filename,question_attachment.display_name = inserted.display_name,question_attachment.path = inserted.path,question_attachment.description = inserted.description,question_attachment.owner_id = inserted.owner_id,question_attachment.uploaded_by = inserted.uploaded_by,question_attachment.upload_date = inserted.upload_date
from question_attachment inner join deleted on question_attachment.id = deleted.id inner join inserted on question_attachment.id = inserted.id
insert into question_attachment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,instanceid
 ,sectionnum
 ,questionnum
 ,filename
 ,display_name
 ,path
 ,description
 ,owner_id
 ,uploaded_by
 ,upload_date
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,instanceid
 ,sectionnum
 ,questionnum
 ,filename
 ,display_name
 ,path
 ,description
 ,owner_id
 ,uploaded_by
 ,upload_date
  from inserted
end
GO

create trigger d_question_attachment on question_attachment
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_attachment where exists (
select 1 from deleted where question_attachment.id = deleted.id)
insert into question_attachment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,instanceid
 ,sectionnum
 ,questionnum
 ,filename
 ,display_name
 ,path
 ,description
 ,owner_id
 ,uploaded_by
 ,upload_date
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,instanceid
 ,sectionnum
 ,questionnum
 ,filename
 ,display_name
 ,path
 ,description
 ,owner_id
 ,uploaded_by
 ,upload_date
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_attachment', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1085, '8:639bd837f744ad8c7e29eec4ddaa5f6b', 'enableAuditTable auditTableName=question_attachment_aud, tableName=question_attachment', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type1::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type1'
			)
			DROP TRIGGER i_question_type1
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type1'
			)
			DROP TRIGGER u_question_type1
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type1'
			)
			DROP TRIGGER d_question_type1
GO

CREATE TABLE question_type1_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_type1_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes smallint, nchoices smallint, answer smallint, qtext1 nvarchar(255), qtext2 nvarchar(MAX), hint nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), fixedOrder char(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_TYPE1_AUD PRIMARY KEY (aud_id))
GO

insert into question_type1_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,fixedOrder
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,nchoices
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,fixedOrder
 ,update_meaning
  from question_type1
GO

CREATE INDEX nuk_question_type1_aud_1 ON question_type1_aud(aud_userid)
GO

CREATE INDEX nuk_question_type1_aud_2 ON question_type1_aud(aud_datetime)
GO

create trigger i_question_type1 on question_type1
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type1 (
questionid,qattributes,nchoices,answer,qtext1,qtext2,hint,prenote,postnote,fixedOrder,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,qattributes,nchoices,answer,qtext1,qtext2,hint,prenote,postnote,fixedOrder,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into question_type1_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,fixedOrder
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,nchoices
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,fixedOrder
 ,update_meaning
  from inserted
end
GO

create trigger u_question_type1 on question_type1
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type1 set
question_type1.questionid = inserted.questionid,question_type1.qattributes = inserted.qattributes,question_type1.nchoices = inserted.nchoices,question_type1.answer = inserted.answer,question_type1.qtext1 = inserted.qtext1,question_type1.qtext2 = inserted.qtext2,question_type1.hint = inserted.hint,question_type1.prenote = inserted.prenote,question_type1.postnote = inserted.postnote,question_type1.fixedOrder = inserted.fixedOrder,question_type1.update_meaning = inserted.update_meaning,question_type1.last_updated = inserted.last_updated,question_type1.updater_legal_name = inserted.updater_legal_name,question_type1.update_meaning_text = inserted.update_meaning_text,question_type1.last_updater_uid = inserted.last_updater_uid
from question_type1 inner join deleted on question_type1.questionid = deleted.questionid inner join inserted on question_type1.questionid = inserted.questionid
insert into question_type1_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,fixedOrder
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,nchoices
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,fixedOrder
 ,update_meaning
  from inserted
end
GO

create trigger d_question_type1 on question_type1
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type1 where exists (
select 1 from deleted where question_type1.questionid = deleted.questionid)
insert into question_type1_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,fixedOrder
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,nchoices
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,fixedOrder
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type1', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1086, '8:c2d364b81a7935a0d18f80ba8d688a28', 'enableAuditTable auditTableName=question_type1_aud, tableName=question_type1', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type2::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type2'
			)
			DROP TRIGGER i_question_type2
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type2'
			)
			DROP TRIGGER u_question_type2
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type2'
			)
			DROP TRIGGER d_question_type2
GO

CREATE TABLE question_type2_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_type2_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes smallint, answer smallint, qtext1 nvarchar(255), qtext2 nvarchar(MAX), hint nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_TYPE2_AUD PRIMARY KEY (aud_id))
GO

insert into question_type2_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from question_type2
GO

CREATE INDEX nuk_question_type2_aud_1 ON question_type2_aud(aud_userid)
GO

CREATE INDEX nuk_question_type2_aud_2 ON question_type2_aud(aud_datetime)
GO

create trigger i_question_type2 on question_type2
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type2 (
questionid,qattributes,answer,qtext1,qtext2,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,qattributes,answer,qtext1,qtext2,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into question_type2_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from inserted
end
GO

create trigger u_question_type2 on question_type2
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type2 set
question_type2.questionid = inserted.questionid,question_type2.qattributes = inserted.qattributes,question_type2.answer = inserted.answer,question_type2.qtext1 = inserted.qtext1,question_type2.qtext2 = inserted.qtext2,question_type2.hint = inserted.hint,question_type2.prenote = inserted.prenote,question_type2.postnote = inserted.postnote,question_type2.update_meaning = inserted.update_meaning,question_type2.last_updated = inserted.last_updated,question_type2.updater_legal_name = inserted.updater_legal_name,question_type2.update_meaning_text = inserted.update_meaning_text,question_type2.last_updater_uid = inserted.last_updater_uid
from question_type2 inner join deleted on question_type2.questionid = deleted.questionid inner join inserted on question_type2.questionid = inserted.questionid
insert into question_type2_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from inserted
end
GO

create trigger d_question_type2 on question_type2
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type2 where exists (
select 1 from deleted where question_type2.questionid = deleted.questionid)
insert into question_type2_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,answer
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type2', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1087, '8:f902c76cb2614f1df1d6faef7be3d3aa', 'enableAuditTable auditTableName=question_type2_aud, tableName=question_type2', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type3::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type3'
			)
			DROP TRIGGER i_question_type3
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type3'
			)
			DROP TRIGGER u_question_type3
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type3'
			)
			DROP TRIGGER d_question_type3
GO

CREATE TABLE question_type3_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_type3_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes smallint, nchoices smallint, qtext1 nvarchar(255), qtext2 nvarchar(MAX), hint nvarchar(1000), choice1 nvarchar(1000), choice2 nvarchar(1000), choice3 nvarchar(1000), choice4 nvarchar(1000), choice5 nvarchar(1000), choice6 nvarchar(1000), choice7 nvarchar(1000), choice8 nvarchar(1000), choice9 nvarchar(1000), choice10 nvarchar(1000), match1 nvarchar(1000), match2 nvarchar(1000), match3 nvarchar(1000), match4 nvarchar(1000), match5 nvarchar(1000), match6 nvarchar(1000), match7 nvarchar(1000), match8 nvarchar(1000), match9 nvarchar(1000), match10 nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_TYPE3_AUD PRIMARY KEY (aud_id))
GO

insert into question_type3_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,qtext1
 ,qtext2
 ,hint
 ,choice1
 ,choice2
 ,choice3
 ,choice4
 ,choice5
 ,choice6
 ,choice7
 ,choice8
 ,choice9
 ,choice10
 ,match1
 ,match2
 ,match3
 ,match4
 ,match5
 ,match6
 ,match7
 ,match8
 ,match9
 ,match10
 ,prenote
 ,postnote
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,nchoices
 ,qtext1
 ,qtext2
 ,hint
 ,choice1
 ,choice2
 ,choice3
 ,choice4
 ,choice5
 ,choice6
 ,choice7
 ,choice8
 ,choice9
 ,choice10
 ,match1
 ,match2
 ,match3
 ,match4
 ,match5
 ,match6
 ,match7
 ,match8
 ,match9
 ,match10
 ,prenote
 ,postnote
 ,update_meaning
  from question_type3
GO

CREATE INDEX nuk_question_type3_aud_1 ON question_type3_aud(aud_userid)
GO

CREATE INDEX nuk_question_type3_aud_2 ON question_type3_aud(aud_datetime)
GO

create trigger i_question_type3 on question_type3
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type3 (
questionid,qattributes,nchoices,qtext1,qtext2,hint,choice1,choice2,choice3,choice4,choice5,choice6,choice7,choice8,choice9,choice10,match1,match2,match3,match4,match5,match6,match7,match8,match9,match10,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,qattributes,nchoices,qtext1,qtext2,hint,choice1,choice2,choice3,choice4,choice5,choice6,choice7,choice8,choice9,choice10,match1,match2,match3,match4,match5,match6,match7,match8,match9,match10,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into question_type3_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,qtext1
 ,qtext2
 ,hint
 ,choice1
 ,choice2
 ,choice3
 ,choice4
 ,choice5
 ,choice6
 ,choice7
 ,choice8
 ,choice9
 ,choice10
 ,match1
 ,match2
 ,match3
 ,match4
 ,match5
 ,match6
 ,match7
 ,match8
 ,match9
 ,match10
 ,prenote
 ,postnote
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,nchoices
 ,qtext1
 ,qtext2
 ,hint
 ,choice1
 ,choice2
 ,choice3
 ,choice4
 ,choice5
 ,choice6
 ,choice7
 ,choice8
 ,choice9
 ,choice10
 ,match1
 ,match2
 ,match3
 ,match4
 ,match5
 ,match6
 ,match7
 ,match8
 ,match9
 ,match10
 ,prenote
 ,postnote
 ,update_meaning
  from inserted
end
GO

create trigger u_question_type3 on question_type3
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type3 set
question_type3.questionid = inserted.questionid,question_type3.qattributes = inserted.qattributes,question_type3.nchoices = inserted.nchoices,question_type3.qtext1 = inserted.qtext1,question_type3.qtext2 = inserted.qtext2,question_type3.hint = inserted.hint,question_type3.choice1 = inserted.choice1,question_type3.choice2 = inserted.choice2,question_type3.choice3 = inserted.choice3,question_type3.choice4 = inserted.choice4,question_type3.choice5 = inserted.choice5,question_type3.choice6 = inserted.choice6,question_type3.choice7 = inserted.choice7,question_type3.choice8 = inserted.choice8,question_type3.choice9 = inserted.choice9,question_type3.choice10 = inserted.choice10,question_type3.match1 = inserted.match1,question_type3.match2 = inserted.match2,question_type3.match3 = inserted.match3,question_type3.match4 = inserted.match4,question_type3.match5 = inserted.match5,question_type3.match6 = inserted.match6,question_type3.match7 = inserted.match7,question_type3.match8 = inserted.match8,question_type3.match9 = inserted.match9,question_type3.match10 = inserted.match10,question_type3.prenote = inserted.prenote,question_type3.postnote = inserted.postnote,question_type3.update_meaning = inserted.update_meaning,question_type3.last_updated = inserted.last_updated,question_type3.updater_legal_name = inserted.updater_legal_name,question_type3.update_meaning_text = inserted.update_meaning_text,question_type3.last_updater_uid = inserted.last_updater_uid
from question_type3 inner join deleted on question_type3.questionid = deleted.questionid inner join inserted on question_type3.questionid = inserted.questionid
insert into question_type3_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,qtext1
 ,qtext2
 ,hint
 ,choice1
 ,choice2
 ,choice3
 ,choice4
 ,choice5
 ,choice6
 ,choice7
 ,choice8
 ,choice9
 ,choice10
 ,match1
 ,match2
 ,match3
 ,match4
 ,match5
 ,match6
 ,match7
 ,match8
 ,match9
 ,match10
 ,prenote
 ,postnote
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,nchoices
 ,qtext1
 ,qtext2
 ,hint
 ,choice1
 ,choice2
 ,choice3
 ,choice4
 ,choice5
 ,choice6
 ,choice7
 ,choice8
 ,choice9
 ,choice10
 ,match1
 ,match2
 ,match3
 ,match4
 ,match5
 ,match6
 ,match7
 ,match8
 ,match9
 ,match10
 ,prenote
 ,postnote
 ,update_meaning
  from inserted
end
GO

create trigger d_question_type3 on question_type3
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type3 where exists (
select 1 from deleted where question_type3.questionid = deleted.questionid)
insert into question_type3_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,qtext1
 ,qtext2
 ,hint
 ,choice1
 ,choice2
 ,choice3
 ,choice4
 ,choice5
 ,choice6
 ,choice7
 ,choice8
 ,choice9
 ,choice10
 ,match1
 ,match2
 ,match3
 ,match4
 ,match5
 ,match6
 ,match7
 ,match8
 ,match9
 ,match10
 ,prenote
 ,postnote
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,nchoices
 ,qtext1
 ,qtext2
 ,hint
 ,choice1
 ,choice2
 ,choice3
 ,choice4
 ,choice5
 ,choice6
 ,choice7
 ,choice8
 ,choice9
 ,choice10
 ,match1
 ,match2
 ,match3
 ,match4
 ,match5
 ,match6
 ,match7
 ,match8
 ,match9
 ,match10
 ,prenote
 ,postnote
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type3', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1088, '8:a47a0799e0256d598a8a7a795a6902a7', 'enableAuditTable auditTableName=question_type3_aud, tableName=question_type3', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type4::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type4'
			)
			DROP TRIGGER i_question_type4
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type4'
			)
			DROP TRIGGER u_question_type4
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type4'
			)
			DROP TRIGGER d_question_type4
GO

CREATE TABLE question_type4_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_type4_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes smallint, qtext1 nvarchar(255), qtext2 nvarchar(MAX), hint nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_TYPE4_AUD PRIMARY KEY (aud_id))
GO

insert into question_type4_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from question_type4
GO

CREATE INDEX nuk_question_type4_aud_1 ON question_type4_aud(aud_userid)
GO

CREATE INDEX nuk_question_type4_aud_2 ON question_type4_aud(aud_datetime)
GO

create trigger i_question_type4 on question_type4
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type4 (
questionid,qattributes,qtext1,qtext2,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,qattributes,qtext1,qtext2,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into question_type4_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from inserted
end
GO

create trigger u_question_type4 on question_type4
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type4 set
question_type4.questionid = inserted.questionid,question_type4.qattributes = inserted.qattributes,question_type4.qtext1 = inserted.qtext1,question_type4.qtext2 = inserted.qtext2,question_type4.hint = inserted.hint,question_type4.prenote = inserted.prenote,question_type4.postnote = inserted.postnote,question_type4.update_meaning = inserted.update_meaning,question_type4.last_updated = inserted.last_updated,question_type4.updater_legal_name = inserted.updater_legal_name,question_type4.update_meaning_text = inserted.update_meaning_text,question_type4.last_updater_uid = inserted.last_updater_uid
from question_type4 inner join deleted on question_type4.questionid = deleted.questionid inner join inserted on question_type4.questionid = inserted.questionid
insert into question_type4_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from inserted
end
GO

create trigger d_question_type4 on question_type4
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type4 where exists (
select 1 from deleted where question_type4.questionid = deleted.questionid)
insert into question_type4_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type4', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1089, '8:af23129c0b2f394142a3ca8f2c735bd3', 'enableAuditTable auditTableName=question_type4_aud, tableName=question_type4', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type5::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type5'
			)
			DROP TRIGGER i_question_type5
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type5'
			)
			DROP TRIGGER u_question_type5
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type5'
			)
			DROP TRIGGER d_question_type5
GO

CREATE TABLE question_type5_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_type5_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes smallint, qtext1 nvarchar(255), qtext2 nvarchar(MAX), answer nvarchar(1000), hint nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_TYPE5_AUD PRIMARY KEY (aud_id))
GO

insert into question_type5_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,answer
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,answer
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from question_type5
GO

CREATE INDEX nuk_question_type5_aud_1 ON question_type5_aud(aud_userid)
GO

CREATE INDEX nuk_question_type5_aud_2 ON question_type5_aud(aud_datetime)
GO

create trigger i_question_type5 on question_type5
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type5 (
questionid,qattributes,qtext1,qtext2,answer,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,qattributes,qtext1,qtext2,answer,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into question_type5_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,answer
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,answer
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from inserted
end
GO

create trigger u_question_type5 on question_type5
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type5 set
question_type5.questionid = inserted.questionid,question_type5.qattributes = inserted.qattributes,question_type5.qtext1 = inserted.qtext1,question_type5.qtext2 = inserted.qtext2,question_type5.answer = inserted.answer,question_type5.hint = inserted.hint,question_type5.prenote = inserted.prenote,question_type5.postnote = inserted.postnote,question_type5.update_meaning = inserted.update_meaning,question_type5.last_updated = inserted.last_updated,question_type5.updater_legal_name = inserted.updater_legal_name,question_type5.update_meaning_text = inserted.update_meaning_text,question_type5.last_updater_uid = inserted.last_updater_uid
from question_type5 inner join deleted on question_type5.questionid = deleted.questionid inner join inserted on question_type5.questionid = inserted.questionid
insert into question_type5_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,answer
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,answer
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from inserted
end
GO

create trigger d_question_type5 on question_type5
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type5 where exists (
select 1 from deleted where question_type5.questionid = deleted.questionid)
insert into question_type5_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,answer
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,answer
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type5', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1090, '8:0bb1ec7164639ca186188b1b030f2162', 'enableAuditTable auditTableName=question_type5_aud, tableName=question_type5', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type6::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type6'
			)
			DROP TRIGGER i_question_type6
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type6'
			)
			DROP TRIGGER u_question_type6
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type6'
			)
			DROP TRIGGER d_question_type6
GO

CREATE TABLE question_type6_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_type6_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes smallint, qtext1 nvarchar(255), qtext2 nvarchar(MAX), spread smallint, lowlabel nvarchar(85), highlabel nvarchar(85), hint nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), update_meaning nvarchar(8), autoscore char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_TYPE6_AUD PRIMARY KEY (aud_id))
GO

insert into question_type6_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,spread
 ,lowlabel
 ,highlabel
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,autoscore
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,spread
 ,lowlabel
 ,highlabel
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,autoscore
  from question_type6
GO

CREATE INDEX nuk_question_type6_aud_1 ON question_type6_aud(aud_userid)
GO

CREATE INDEX nuk_question_type6_aud_2 ON question_type6_aud(aud_datetime)
GO

create trigger i_question_type6 on question_type6
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type6 (
questionid,qattributes,qtext1,qtext2,spread,lowlabel,highlabel,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,autoscore) select questionid,qattributes,qtext1,qtext2,spread,lowlabel,highlabel,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,autoscore from inserted
insert into question_type6_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,spread
 ,lowlabel
 ,highlabel
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,autoscore
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,spread
 ,lowlabel
 ,highlabel
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,autoscore
  from inserted
end
GO

create trigger u_question_type6 on question_type6
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type6 set
question_type6.questionid = inserted.questionid,question_type6.qattributes = inserted.qattributes,question_type6.qtext1 = inserted.qtext1,question_type6.qtext2 = inserted.qtext2,question_type6.spread = inserted.spread,question_type6.lowlabel = inserted.lowlabel,question_type6.highlabel = inserted.highlabel,question_type6.hint = inserted.hint,question_type6.prenote = inserted.prenote,question_type6.postnote = inserted.postnote,question_type6.update_meaning = inserted.update_meaning,question_type6.last_updated = inserted.last_updated,question_type6.updater_legal_name = inserted.updater_legal_name,question_type6.update_meaning_text = inserted.update_meaning_text,question_type6.last_updater_uid = inserted.last_updater_uid,question_type6.autoscore = inserted.autoscore
from question_type6 inner join deleted on question_type6.questionid = deleted.questionid inner join inserted on question_type6.questionid = inserted.questionid
insert into question_type6_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,spread
 ,lowlabel
 ,highlabel
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,autoscore
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,spread
 ,lowlabel
 ,highlabel
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,autoscore
  from inserted
end
GO

create trigger d_question_type6 on question_type6
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type6 where exists (
select 1 from deleted where question_type6.questionid = deleted.questionid)
insert into question_type6_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,spread
 ,lowlabel
 ,highlabel
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,autoscore
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext1
 ,qtext2
 ,spread
 ,lowlabel
 ,highlabel
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,autoscore
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type6', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1091, '8:97304a8c4f14c81a5125d5f1ee1721ff', 'enableAuditTable auditTableName=question_type6_aud, tableName=question_type6', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type7::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type7'
			)
			DROP TRIGGER i_question_type7
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type7'
			)
			DROP TRIGGER u_question_type7
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type7'
			)
			DROP TRIGGER d_question_type7
GO

CREATE TABLE question_type7_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_type7_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes smallint, nchoices smallint, fixedOrder nvarchar(1), singleChoice nvarchar(1), qtext1 nvarchar(MAX), hint nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), update_meaning nvarchar(8), answer nvarchar(1000), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_TYPE7_AUD PRIMARY KEY (aud_id))
GO

insert into question_type7_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,fixedOrder
 ,singleChoice
 ,qtext1
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,answer
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,nchoices
 ,fixedOrder
 ,singleChoice
 ,qtext1
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,answer
  from question_type7
GO

CREATE INDEX nuk_question_type7_aud_1 ON question_type7_aud(aud_userid)
GO

CREATE INDEX nuk_question_type7_aud_2 ON question_type7_aud(aud_datetime)
GO

create trigger i_question_type7 on question_type7
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type7 (
questionid,qattributes,nchoices,fixedOrder,singleChoice,qtext1,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,answer) select questionid,qattributes,nchoices,fixedOrder,singleChoice,qtext1,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,answer from inserted
insert into question_type7_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,fixedOrder
 ,singleChoice
 ,qtext1
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,answer
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,nchoices
 ,fixedOrder
 ,singleChoice
 ,qtext1
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,answer
  from inserted
end
GO

create trigger u_question_type7 on question_type7
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type7 set
question_type7.questionid = inserted.questionid,question_type7.qattributes = inserted.qattributes,question_type7.nchoices = inserted.nchoices,question_type7.fixedOrder = inserted.fixedOrder,question_type7.singleChoice = inserted.singleChoice,question_type7.qtext1 = inserted.qtext1,question_type7.hint = inserted.hint,question_type7.prenote = inserted.prenote,question_type7.postnote = inserted.postnote,question_type7.update_meaning = inserted.update_meaning,question_type7.last_updated = inserted.last_updated,question_type7.updater_legal_name = inserted.updater_legal_name,question_type7.update_meaning_text = inserted.update_meaning_text,question_type7.last_updater_uid = inserted.last_updater_uid,question_type7.answer = inserted.answer
from question_type7 inner join deleted on question_type7.questionid = deleted.questionid inner join inserted on question_type7.questionid = inserted.questionid
insert into question_type7_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,fixedOrder
 ,singleChoice
 ,qtext1
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,answer
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,nchoices
 ,fixedOrder
 ,singleChoice
 ,qtext1
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,answer
  from inserted
end
GO

create trigger d_question_type7 on question_type7
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type7 where exists (
select 1 from deleted where question_type7.questionid = deleted.questionid)
insert into question_type7_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,nchoices
 ,fixedOrder
 ,singleChoice
 ,qtext1
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,answer
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,nchoices
 ,fixedOrder
 ,singleChoice
 ,qtext1
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
 ,answer
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type7', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1092, '8:28991952fd183aafb63fee6a950dfff3', 'enableAuditTable auditTableName=question_type7_aud, tableName=question_type7', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type8::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type8'
			)
			DROP TRIGGER i_question_type8
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type8'
			)
			DROP TRIGGER u_question_type8
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type8'
			)
			DROP TRIGGER d_question_type8
GO

CREATE TABLE question_type8_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_type8_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes smallint, qtext nvarchar(MAX), columnheading1 nvarchar(1000), columnheading2 nvarchar(1000), columnheading3 nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), hint nvarchar(1000), spread smallint, lowlabel nvarchar(20), highlabel nvarchar(20), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_TYPE8_AUD PRIMARY KEY (aud_id))
GO

insert into question_type8_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,columnheading1
 ,columnheading2
 ,columnheading3
 ,prenote
 ,postnote
 ,hint
 ,spread
 ,lowlabel
 ,highlabel
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,qtext
 ,columnheading1
 ,columnheading2
 ,columnheading3
 ,prenote
 ,postnote
 ,hint
 ,spread
 ,lowlabel
 ,highlabel
 ,update_meaning
  from question_type8
GO

CREATE INDEX nuk_question_type8_aud_1 ON question_type8_aud(aud_userid)
GO

CREATE INDEX nuk_question_type8_aud_2 ON question_type8_aud(aud_datetime)
GO

create trigger i_question_type8 on question_type8
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type8 (
questionid,qattributes,qtext,columnheading1,columnheading2,columnheading3,prenote,postnote,hint,spread,lowlabel,highlabel,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,qattributes,qtext,columnheading1,columnheading2,columnheading3,prenote,postnote,hint,spread,lowlabel,highlabel,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into question_type8_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,columnheading1
 ,columnheading2
 ,columnheading3
 ,prenote
 ,postnote
 ,hint
 ,spread
 ,lowlabel
 ,highlabel
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext
 ,columnheading1
 ,columnheading2
 ,columnheading3
 ,prenote
 ,postnote
 ,hint
 ,spread
 ,lowlabel
 ,highlabel
 ,update_meaning
  from inserted
end
GO

create trigger u_question_type8 on question_type8
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type8 set
question_type8.questionid = inserted.questionid,question_type8.qattributes = inserted.qattributes,question_type8.qtext = inserted.qtext,question_type8.columnheading1 = inserted.columnheading1,question_type8.columnheading2 = inserted.columnheading2,question_type8.columnheading3 = inserted.columnheading3,question_type8.prenote = inserted.prenote,question_type8.postnote = inserted.postnote,question_type8.hint = inserted.hint,question_type8.spread = inserted.spread,question_type8.lowlabel = inserted.lowlabel,question_type8.highlabel = inserted.highlabel,question_type8.update_meaning = inserted.update_meaning,question_type8.last_updated = inserted.last_updated,question_type8.updater_legal_name = inserted.updater_legal_name,question_type8.update_meaning_text = inserted.update_meaning_text,question_type8.last_updater_uid = inserted.last_updater_uid
from question_type8 inner join deleted on question_type8.questionid = deleted.questionid inner join inserted on question_type8.questionid = inserted.questionid
insert into question_type8_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,columnheading1
 ,columnheading2
 ,columnheading3
 ,prenote
 ,postnote
 ,hint
 ,spread
 ,lowlabel
 ,highlabel
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext
 ,columnheading1
 ,columnheading2
 ,columnheading3
 ,prenote
 ,postnote
 ,hint
 ,spread
 ,lowlabel
 ,highlabel
 ,update_meaning
  from inserted
end
GO

create trigger d_question_type8 on question_type8
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type8 where exists (
select 1 from deleted where question_type8.questionid = deleted.questionid)
insert into question_type8_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,columnheading1
 ,columnheading2
 ,columnheading3
 ,prenote
 ,postnote
 ,hint
 ,spread
 ,lowlabel
 ,highlabel
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext
 ,columnheading1
 ,columnheading2
 ,columnheading3
 ,prenote
 ,postnote
 ,hint
 ,spread
 ,lowlabel
 ,highlabel
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type8', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1093, '8:568f2bcbc85b6a3eec2f9d8b58b8adc0', 'enableAuditTable auditTableName=question_type8_aud, tableName=question_type8', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type8_item::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type8_item'
			)
			DROP TRIGGER i_question_type8_item
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type8_item'
			)
			DROP TRIGGER u_question_type8_item
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type8_item'
			)
			DROP TRIGGER d_question_type8_item
GO

CREATE TABLE question_type8_item_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_type8_item_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qindex smallint, qtext nvarchar(1000), update_meaning nvarchar(8), id nvarchar(100), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_TYPE8_ITEM_AUD PRIMARY KEY (aud_id))
GO

insert into question_type8_item_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qindex
 ,qtext
 ,update_meaning
 ,id
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qindex
 ,qtext
 ,update_meaning
 ,id
  from question_type8_item
GO

CREATE INDEX nuk_question_type8_item_aud_1 ON question_type8_item_aud(aud_userid)
GO

CREATE INDEX nuk_question_type8_item_aud_2 ON question_type8_item_aud(aud_datetime)
GO

create trigger i_question_type8_item on question_type8_item
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type8_item (
questionid,qindex,qtext,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,id) select questionid,qindex,qtext,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,id from inserted
insert into question_type8_item_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qindex
 ,qtext
 ,update_meaning
 ,id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qindex
 ,qtext
 ,update_meaning
 ,id
  from inserted
end
GO

create trigger u_question_type8_item on question_type8_item
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type8_item set
question_type8_item.questionid = inserted.questionid,question_type8_item.qindex = inserted.qindex,question_type8_item.qtext = inserted.qtext,question_type8_item.update_meaning = inserted.update_meaning,question_type8_item.last_updated = inserted.last_updated,question_type8_item.updater_legal_name = inserted.updater_legal_name,question_type8_item.update_meaning_text = inserted.update_meaning_text,question_type8_item.last_updater_uid = inserted.last_updater_uid,question_type8_item.id = inserted.id
from question_type8_item inner join deleted on question_type8_item.id = deleted.id inner join inserted on question_type8_item.id = inserted.id
insert into question_type8_item_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qindex
 ,qtext
 ,update_meaning
 ,id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qindex
 ,qtext
 ,update_meaning
 ,id
  from inserted
end
GO

create trigger d_question_type8_item on question_type8_item
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type8_item where exists (
select 1 from deleted where question_type8_item.id = deleted.id)
insert into question_type8_item_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qindex
 ,qtext
 ,update_meaning
 ,id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qindex
 ,qtext
 ,update_meaning
 ,id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type8_item', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1094, '8:9d85776e8eb9f5898fc55f6a4da57081', 'enableAuditTable auditTableName=question_type8_item_aud, tableName=question_type8_item', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-registeredevents::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_registeredevents'
			)
			DROP TRIGGER i_registeredevents
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_registeredevents'
			)
			DROP TRIGGER u_registeredevents
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_registeredevents'
			)
			DROP TRIGGER d_registeredevents
GO

CREATE TABLE registeredevents_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_registeredevents_aud_aud_datetime DEFAULT GETDATE() NOT NULL, eventid nvarchar(15), event_type char(1), email_message_id nvarchar(15), learningid nvarchar(85), parm1_ndays int, parm2_freq int, parm3_interval int, parm4_nmsgs_limit int, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_REGISTEREDEVENTS_AUD PRIMARY KEY (aud_id))
GO

insert into registeredevents_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,event_type
 ,email_message_id
 ,learningid
 ,parm1_ndays
 ,parm2_freq
 ,parm3_interval
 ,parm4_nmsgs_limit
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,eventid
 ,event_type
 ,email_message_id
 ,learningid
 ,parm1_ndays
 ,parm2_freq
 ,parm3_interval
 ,parm4_nmsgs_limit
 ,update_meaning
  from registeredevents
GO

CREATE INDEX nuk_registeredevents_aud_1 ON registeredevents_aud(aud_userid)
GO

CREATE INDEX nuk_registeredevents_aud_2 ON registeredevents_aud(aud_datetime)
GO

create trigger i_registeredevents on registeredevents
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into registeredevents (
eventid,event_type,email_message_id,learningid,parm1_ndays,parm2_freq,parm3_interval,parm4_nmsgs_limit,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select eventid,event_type,email_message_id,learningid,parm1_ndays,parm2_freq,parm3_interval,parm4_nmsgs_limit,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into registeredevents_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,event_type
 ,email_message_id
 ,learningid
 ,parm1_ndays
 ,parm2_freq
 ,parm3_interval
 ,parm4_nmsgs_limit
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,event_type
 ,email_message_id
 ,learningid
 ,parm1_ndays
 ,parm2_freq
 ,parm3_interval
 ,parm4_nmsgs_limit
 ,update_meaning
  from inserted
end
GO

create trigger u_registeredevents on registeredevents
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update registeredevents set
registeredevents.eventid = inserted.eventid,registeredevents.event_type = inserted.event_type,registeredevents.email_message_id = inserted.email_message_id,registeredevents.learningid = inserted.learningid,registeredevents.parm1_ndays = inserted.parm1_ndays,registeredevents.parm2_freq = inserted.parm2_freq,registeredevents.parm3_interval = inserted.parm3_interval,registeredevents.parm4_nmsgs_limit = inserted.parm4_nmsgs_limit,registeredevents.update_meaning = inserted.update_meaning,registeredevents.last_updated = inserted.last_updated,registeredevents.updater_legal_name = inserted.updater_legal_name,registeredevents.update_meaning_text = inserted.update_meaning_text,registeredevents.last_updater_uid = inserted.last_updater_uid
from registeredevents inner join deleted on registeredevents.eventid = deleted.eventid and registeredevents.event_type = deleted.event_type and registeredevents.email_message_id = deleted.email_message_id and registeredevents.learningid = deleted.learningid inner join inserted on registeredevents.eventid = inserted.eventid and registeredevents.event_type = inserted.event_type and registeredevents.email_message_id = inserted.email_message_id and registeredevents.learningid = inserted.learningid
insert into registeredevents_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,event_type
 ,email_message_id
 ,learningid
 ,parm1_ndays
 ,parm2_freq
 ,parm3_interval
 ,parm4_nmsgs_limit
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,event_type
 ,email_message_id
 ,learningid
 ,parm1_ndays
 ,parm2_freq
 ,parm3_interval
 ,parm4_nmsgs_limit
 ,update_meaning
  from inserted
end
GO

create trigger d_registeredevents on registeredevents
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from registeredevents where exists (
select 1 from deleted where registeredevents.eventid = deleted.eventid and registeredevents.event_type = deleted.event_type and registeredevents.email_message_id = deleted.email_message_id and registeredevents.learningid = deleted.learningid)
insert into registeredevents_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,event_type
 ,email_message_id
 ,learningid
 ,parm1_ndays
 ,parm2_freq
 ,parm3_interval
 ,parm4_nmsgs_limit
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,event_type
 ,email_message_id
 ,learningid
 ,parm1_ndays
 ,parm2_freq
 ,parm3_interval
 ,parm4_nmsgs_limit
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-registeredevents', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1095, '8:0e8328bbe1aeaab13893712dea91ea4d', 'enableAuditTable auditTableName=registeredevents_aud, tableName=registeredevents', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-registration::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_registration'
			)
			DROP TRIGGER i_registration
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_registration'
			)
			DROP TRIGGER u_registration
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_registration'
			)
			DROP TRIGGER d_registration
GO

CREATE TABLE registration_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_registration_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), eventid nvarchar(15), transcriptid nvarchar(15), studentstatus int, datecreated datetime, currTranscriptid nvarchar(15), update_meaning nvarchar(8), user_meta_id nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_REGISTRATION_AUD PRIMARY KEY (aud_id))
GO

insert into registration_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,eventid
 ,transcriptid
 ,studentstatus
 ,datecreated
 ,currTranscriptid
 ,update_meaning
 ,user_meta_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,eventid
 ,transcriptid
 ,studentstatus
 ,datecreated
 ,currTranscriptid
 ,update_meaning
 ,user_meta_id
  from registration
GO

CREATE INDEX nuk_registration_aud_1 ON registration_aud(aud_userid)
GO

CREATE INDEX nuk_registration_aud_2 ON registration_aud(aud_datetime)
GO

create trigger i_registration on registration
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into registration (
id,eventid,transcriptid,studentstatus,datecreated,currTranscriptid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,user_meta_id) select id,eventid,transcriptid,studentstatus,datecreated,currTranscriptid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,user_meta_id from inserted
insert into registration_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,eventid
 ,transcriptid
 ,studentstatus
 ,datecreated
 ,currTranscriptid
 ,update_meaning
 ,user_meta_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,eventid
 ,transcriptid
 ,studentstatus
 ,datecreated
 ,currTranscriptid
 ,update_meaning
 ,user_meta_id
  from inserted
end
GO

create trigger u_registration on registration
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update registration set
registration.id = inserted.id,registration.eventid = inserted.eventid,registration.transcriptid = inserted.transcriptid,registration.studentstatus = inserted.studentstatus,registration.datecreated = inserted.datecreated,registration.currTranscriptid = inserted.currTranscriptid,registration.update_meaning = inserted.update_meaning,registration.last_updated = inserted.last_updated,registration.updater_legal_name = inserted.updater_legal_name,registration.update_meaning_text = inserted.update_meaning_text,registration.last_updater_uid = inserted.last_updater_uid,registration.user_meta_id = inserted.user_meta_id
from registration inner join deleted on registration.id = deleted.id inner join inserted on registration.id = inserted.id
insert into registration_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,eventid
 ,transcriptid
 ,studentstatus
 ,datecreated
 ,currTranscriptid
 ,update_meaning
 ,user_meta_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,eventid
 ,transcriptid
 ,studentstatus
 ,datecreated
 ,currTranscriptid
 ,update_meaning
 ,user_meta_id
  from inserted
end
GO

create trigger d_registration on registration
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from registration where exists (
select 1 from deleted where registration.id = deleted.id)
insert into registration_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,eventid
 ,transcriptid
 ,studentstatus
 ,datecreated
 ,currTranscriptid
 ,update_meaning
 ,user_meta_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,eventid
 ,transcriptid
 ,studentstatus
 ,datecreated
 ,currTranscriptid
 ,update_meaning
 ,user_meta_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-registration', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1096, '8:506302f74af8604547a7ee3b43953ecd', 'enableAuditTable auditTableName=registration_aud, tableName=registration', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-session_cost::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_session_cost'
			)
			DROP TRIGGER i_session_cost
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_session_cost'
			)
			DROP TRIGGER u_session_cost
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_session_cost'
			)
			DROP TRIGGER d_session_cost
GO

CREATE TABLE session_cost_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_session_cost_aud_aud_datetime DEFAULT GETDATE() NOT NULL, session_cost_id nvarchar(15), extra_info nvarchar(50), amount float(53), exchange_rate float(53), cost_category_id nvarchar(15), currency nvarchar(15), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SESSION_COST_AUD PRIMARY KEY (aud_id))
GO

insert into session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,session_cost_id
 ,extra_info
 ,amount
 ,exchange_rate
 ,cost_category_id
 ,currency
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,session_cost_id
 ,extra_info
 ,amount
 ,exchange_rate
 ,cost_category_id
 ,currency
 ,update_meaning
  from session_cost
GO

CREATE INDEX nuk_session_cost_aud_1 ON session_cost_aud(aud_userid)
GO

CREATE INDEX nuk_session_cost_aud_2 ON session_cost_aud(aud_datetime)
GO

create trigger i_session_cost on session_cost
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into session_cost (
session_cost_id,extra_info,amount,exchange_rate,updater_legal_name,update_meaning_text,cost_category_id,currency,update_meaning,last_updated,last_updater_uid) select session_cost_id,extra_info,amount,exchange_rate,updater_legal_name,update_meaning_text,cost_category_id,currency,update_meaning,last_updated,last_updater_uid from inserted
insert into session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,session_cost_id
 ,extra_info
 ,amount
 ,exchange_rate
 ,cost_category_id
 ,currency
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,session_cost_id
 ,extra_info
 ,amount
 ,exchange_rate
 ,cost_category_id
 ,currency
 ,update_meaning
  from inserted
end
GO

create trigger u_session_cost on session_cost
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update session_cost set
session_cost.session_cost_id = inserted.session_cost_id,session_cost.extra_info = inserted.extra_info,session_cost.amount = inserted.amount,session_cost.exchange_rate = inserted.exchange_rate,session_cost.updater_legal_name = inserted.updater_legal_name,session_cost.update_meaning_text = inserted.update_meaning_text,session_cost.cost_category_id = inserted.cost_category_id,session_cost.currency = inserted.currency,session_cost.update_meaning = inserted.update_meaning,session_cost.last_updated = inserted.last_updated,session_cost.last_updater_uid = inserted.last_updater_uid
from session_cost inner join deleted on session_cost.session_cost_id = deleted.session_cost_id inner join inserted on session_cost.session_cost_id = inserted.session_cost_id
insert into session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,session_cost_id
 ,extra_info
 ,amount
 ,exchange_rate
 ,cost_category_id
 ,currency
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,session_cost_id
 ,extra_info
 ,amount
 ,exchange_rate
 ,cost_category_id
 ,currency
 ,update_meaning
  from inserted
end
GO

create trigger d_session_cost on session_cost
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from session_cost where exists (
select 1 from deleted where session_cost.session_cost_id = deleted.session_cost_id)
insert into session_cost_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,session_cost_id
 ,extra_info
 ,amount
 ,exchange_rate
 ,cost_category_id
 ,currency
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,session_cost_id
 ,extra_info
 ,amount
 ,exchange_rate
 ,cost_category_id
 ,currency
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-session_cost', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1097, '8:0398b388be5243cd4d1480b44d11f921', 'enableAuditTable auditTableName=session_cost_aud, tableName=session_cost', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-testinstance::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_testinstance'
			)
			DROP TRIGGER i_testinstance
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_testinstance'
			)
			DROP TRIGGER u_testinstance
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_testinstance'
			)
			DROP TRIGGER d_testinstance
GO

CREATE TABLE testinstance_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_testinstance_aud_aud_datetime DEFAULT GETDATE() NOT NULL, instanceid nvarchar(15), testuse smallint, eventid nvarchar(15), transcriptid nvarchar(15), userid nvarchar(85), testid nvarchar(100), teststatus smallint, teststart datetime, testfinish datetime, score float(53), weightedscore float(53), nquestions int, ncorrect int, reviewable nvarchar(1), sessionID nvarchar(15), questionnum smallint, sectionnum smallint, preview char(1), passFailFlag char(1), maxscore float(53), mekp_sync datetime, is_pre_enrollment char(1), update_meaning nvarchar(8), is_active char(1), next_attempt_date datetime, bundle_id nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TESTINSTANCE_AUD PRIMARY KEY (aud_id))
GO

insert into testinstance_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,testuse
 ,eventid
 ,transcriptid
 ,userid
 ,testid
 ,teststatus
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,ncorrect
 ,reviewable
 ,sessionID
 ,questionnum
 ,sectionnum
 ,preview
 ,passFailFlag
 ,maxscore
 ,mekp_sync
 ,is_pre_enrollment
 ,update_meaning
 ,is_active
 ,next_attempt_date
 ,bundle_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,instanceid
 ,testuse
 ,eventid
 ,transcriptid
 ,userid
 ,testid
 ,teststatus
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,ncorrect
 ,reviewable
 ,sessionID
 ,questionnum
 ,sectionnum
 ,preview
 ,passFailFlag
 ,maxscore
 ,mekp_sync
 ,is_pre_enrollment
 ,update_meaning
 ,is_active
 ,next_attempt_date
 ,bundle_id
  from testinstance
GO

CREATE INDEX nuk_testinstance_aud_1 ON testinstance_aud(aud_userid)
GO

CREATE INDEX nuk_testinstance_aud_2 ON testinstance_aud(aud_datetime)
GO

create trigger i_testinstance on testinstance
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into testinstance (
instanceid,testuse,eventid,transcriptid,userid,testid,teststatus,teststart,testfinish,score,weightedscore,nquestions,ncorrect,reviewable,sessionID,questionnum,sectionnum,preview,passFailFlag,maxscore,mekp_sync,is_pre_enrollment,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,is_active,next_attempt_date,bundle_id) select instanceid,testuse,eventid,transcriptid,userid,testid,teststatus,teststart,testfinish,score,weightedscore,nquestions,ncorrect,reviewable,sessionID,questionnum,sectionnum,preview,passFailFlag,maxscore,mekp_sync,is_pre_enrollment,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,is_active,next_attempt_date,bundle_id from inserted
insert into testinstance_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,testuse
 ,eventid
 ,transcriptid
 ,userid
 ,testid
 ,teststatus
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,ncorrect
 ,reviewable
 ,sessionID
 ,questionnum
 ,sectionnum
 ,preview
 ,passFailFlag
 ,maxscore
 ,mekp_sync
 ,is_pre_enrollment
 ,update_meaning
 ,is_active
 ,next_attempt_date
 ,bundle_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,testuse
 ,eventid
 ,transcriptid
 ,userid
 ,testid
 ,teststatus
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,ncorrect
 ,reviewable
 ,sessionID
 ,questionnum
 ,sectionnum
 ,preview
 ,passFailFlag
 ,maxscore
 ,mekp_sync
 ,is_pre_enrollment
 ,update_meaning
 ,is_active
 ,next_attempt_date
 ,bundle_id
  from inserted
end
GO

create trigger u_testinstance on testinstance
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update testinstance set
testinstance.instanceid = inserted.instanceid,testinstance.testuse = inserted.testuse,testinstance.eventid = inserted.eventid,testinstance.transcriptid = inserted.transcriptid,testinstance.userid = inserted.userid,testinstance.testid = inserted.testid,testinstance.teststatus = inserted.teststatus,testinstance.teststart = inserted.teststart,testinstance.testfinish = inserted.testfinish,testinstance.score = inserted.score,testinstance.weightedscore = inserted.weightedscore,testinstance.nquestions = inserted.nquestions,testinstance.ncorrect = inserted.ncorrect,testinstance.reviewable = inserted.reviewable,testinstance.sessionID = inserted.sessionID,testinstance.questionnum = inserted.questionnum,testinstance.sectionnum = inserted.sectionnum,testinstance.preview = inserted.preview,testinstance.passFailFlag = inserted.passFailFlag,testinstance.maxscore = inserted.maxscore,testinstance.mekp_sync = inserted.mekp_sync,testinstance.is_pre_enrollment = inserted.is_pre_enrollment,testinstance.update_meaning = inserted.update_meaning,testinstance.last_updated = inserted.last_updated,testinstance.updater_legal_name = inserted.updater_legal_name,testinstance.update_meaning_text = inserted.update_meaning_text,testinstance.last_updater_uid = inserted.last_updater_uid,testinstance.is_active = inserted.is_active,testinstance.next_attempt_date = inserted.next_attempt_date,testinstance.bundle_id = inserted.bundle_id
from testinstance inner join deleted on testinstance.instanceid = deleted.instanceid inner join inserted on testinstance.instanceid = inserted.instanceid
insert into testinstance_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,testuse
 ,eventid
 ,transcriptid
 ,userid
 ,testid
 ,teststatus
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,ncorrect
 ,reviewable
 ,sessionID
 ,questionnum
 ,sectionnum
 ,preview
 ,passFailFlag
 ,maxscore
 ,mekp_sync
 ,is_pre_enrollment
 ,update_meaning
 ,is_active
 ,next_attempt_date
 ,bundle_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,testuse
 ,eventid
 ,transcriptid
 ,userid
 ,testid
 ,teststatus
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,ncorrect
 ,reviewable
 ,sessionID
 ,questionnum
 ,sectionnum
 ,preview
 ,passFailFlag
 ,maxscore
 ,mekp_sync
 ,is_pre_enrollment
 ,update_meaning
 ,is_active
 ,next_attempt_date
 ,bundle_id
  from inserted
end
GO

create trigger d_testinstance on testinstance
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from testinstance where exists (
select 1 from deleted where testinstance.instanceid = deleted.instanceid)
insert into testinstance_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,testuse
 ,eventid
 ,transcriptid
 ,userid
 ,testid
 ,teststatus
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,ncorrect
 ,reviewable
 ,sessionID
 ,questionnum
 ,sectionnum
 ,preview
 ,passFailFlag
 ,maxscore
 ,mekp_sync
 ,is_pre_enrollment
 ,update_meaning
 ,is_active
 ,next_attempt_date
 ,bundle_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,testuse
 ,eventid
 ,transcriptid
 ,userid
 ,testid
 ,teststatus
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,ncorrect
 ,reviewable
 ,sessionID
 ,questionnum
 ,sectionnum
 ,preview
 ,passFailFlag
 ,maxscore
 ,mekp_sync
 ,is_pre_enrollment
 ,update_meaning
 ,is_active
 ,next_attempt_date
 ,bundle_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-testinstance', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1098, '8:26c6646a89752a7e5c2bfbc0f4823ba6', 'enableAuditTable auditTableName=testinstance_aud, tableName=testinstance', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-testquestion::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_testquestion'
			)
			DROP TRIGGER i_testquestion
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_testquestion'
			)
			DROP TRIGGER u_testquestion
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_testquestion'
			)
			DROP TRIGGER d_testquestion
GO

CREATE TABLE testquestion_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_testquestion_aud_aud_datetime DEFAULT GETDATE() NOT NULL, instanceid nvarchar(15), sectionnum smallint, questionnum smallint, questionid nvarchar(85), qtype smallint, points float(53), review char(1), version int, comments nvarchar(1000), update_meaning nvarchar(8), elapsedTime decimal(20, 0), weight float(53), guess nvarchar(1000), answer nvarchar(1000), choice_order nvarchar(1000), latest_version_bundle_id nvarchar(85), teststart datetime, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TESTQUESTION_AUD PRIMARY KEY (aud_id))
GO

insert into testquestion_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,qtype
 ,points
 ,review
 ,version
 ,comments
 ,update_meaning
 ,elapsedTime
 ,weight
 ,guess
 ,answer
 ,choice_order
 ,latest_version_bundle_id
 ,teststart
) select 'U', null
, null
, GETDATE(), null
, null
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,qtype
 ,points
 ,review
 ,version
 ,comments
 ,update_meaning
 ,elapsedTime
 ,weight
 ,guess
 ,answer
 ,choice_order
 ,latest_version_bundle_id
 ,teststart
  from testquestion
GO

CREATE INDEX nuk_testquestion_aud_1 ON testquestion_aud(aud_userid)
GO

CREATE INDEX nuk_testquestion_aud_2 ON testquestion_aud(aud_datetime)
GO

create trigger i_testquestion on testquestion
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into testquestion (
instanceid,sectionnum,questionnum,questionid,qtype,points,review,version,comments,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,elapsedTime,weight,guess,answer,choice_order,latest_version_bundle_id,teststart) select instanceid,sectionnum,questionnum,questionid,qtype,points,review,version,comments,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,elapsedTime,weight,guess,answer,choice_order,latest_version_bundle_id,teststart from inserted
insert into testquestion_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,qtype
 ,points
 ,review
 ,version
 ,comments
 ,update_meaning
 ,elapsedTime
 ,weight
 ,guess
 ,answer
 ,choice_order
 ,latest_version_bundle_id
 ,teststart
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,qtype
 ,points
 ,review
 ,version
 ,comments
 ,update_meaning
 ,elapsedTime
 ,weight
 ,guess
 ,answer
 ,choice_order
 ,latest_version_bundle_id
 ,teststart
  from inserted
end
GO

create trigger u_testquestion on testquestion
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update testquestion set
testquestion.instanceid = inserted.instanceid,testquestion.sectionnum = inserted.sectionnum,testquestion.questionnum = inserted.questionnum,testquestion.questionid = inserted.questionid,testquestion.qtype = inserted.qtype,testquestion.points = inserted.points,testquestion.review = inserted.review,testquestion.version = inserted.version,testquestion.comments = inserted.comments,testquestion.update_meaning = inserted.update_meaning,testquestion.last_updated = inserted.last_updated,testquestion.updater_legal_name = inserted.updater_legal_name,testquestion.update_meaning_text = inserted.update_meaning_text,testquestion.last_updater_uid = inserted.last_updater_uid,testquestion.elapsedTime = inserted.elapsedTime,testquestion.weight = inserted.weight,testquestion.guess = inserted.guess,testquestion.answer = inserted.answer,testquestion.choice_order = inserted.choice_order,testquestion.latest_version_bundle_id = inserted.latest_version_bundle_id,testquestion.teststart = inserted.teststart
from testquestion inner join deleted on testquestion.instanceid = deleted.instanceid and testquestion.sectionnum = deleted.sectionnum and testquestion.questionnum = deleted.questionnum inner join inserted on testquestion.instanceid = inserted.instanceid and testquestion.sectionnum = inserted.sectionnum and testquestion.questionnum = inserted.questionnum
insert into testquestion_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,qtype
 ,points
 ,review
 ,version
 ,comments
 ,update_meaning
 ,elapsedTime
 ,weight
 ,guess
 ,answer
 ,choice_order
 ,latest_version_bundle_id
 ,teststart
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,qtype
 ,points
 ,review
 ,version
 ,comments
 ,update_meaning
 ,elapsedTime
 ,weight
 ,guess
 ,answer
 ,choice_order
 ,latest_version_bundle_id
 ,teststart
  from inserted
end
GO

create trigger d_testquestion on testquestion
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from testquestion where exists (
select 1 from deleted where testquestion.instanceid = deleted.instanceid and testquestion.sectionnum = deleted.sectionnum and testquestion.questionnum = deleted.questionnum)
insert into testquestion_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,qtype
 ,points
 ,review
 ,version
 ,comments
 ,update_meaning
 ,elapsedTime
 ,weight
 ,guess
 ,answer
 ,choice_order
 ,latest_version_bundle_id
 ,teststart
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,qtype
 ,points
 ,review
 ,version
 ,comments
 ,update_meaning
 ,elapsedTime
 ,weight
 ,guess
 ,answer
 ,choice_order
 ,latest_version_bundle_id
 ,teststart
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-testquestion', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1099, '8:d485e227d2a50429c9f52ac27481e7fd', 'enableAuditTable auditTableName=testquestion_aud, tableName=testquestion', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-testquestion3::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_testquestion3'
			)
			DROP TRIGGER i_testquestion3
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_testquestion3'
			)
			DROP TRIGGER u_testquestion3
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_testquestion3'
			)
			DROP TRIGGER d_testquestion3
GO

CREATE TABLE testquestion3_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_testquestion3_aud_aud_datetime DEFAULT GETDATE() NOT NULL, instanceid nvarchar(15), sectionnum smallint, questionnum smallint, questionid nvarchar(85), gs1 smallint, gs2 smallint, gs3 smallint, gs4 smallint, gs5 smallint, gs6 smallint, gs7 smallint, gs8 smallint, gs9 smallint, gs10 smallint, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TESTQUESTION3_AUD PRIMARY KEY (aud_id))
GO

insert into testquestion3_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,gs1
 ,gs2
 ,gs3
 ,gs4
 ,gs5
 ,gs6
 ,gs7
 ,gs8
 ,gs9
 ,gs10
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,gs1
 ,gs2
 ,gs3
 ,gs4
 ,gs5
 ,gs6
 ,gs7
 ,gs8
 ,gs9
 ,gs10
 ,update_meaning
  from testquestion3
GO

CREATE INDEX nuk_testquestion3_aud_1 ON testquestion3_aud(aud_userid)
GO

CREATE INDEX nuk_testquestion3_aud_2 ON testquestion3_aud(aud_datetime)
GO

create trigger i_testquestion3 on testquestion3
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into testquestion3 (
instanceid,sectionnum,questionnum,questionid,gs1,gs2,gs3,gs4,gs5,gs6,gs7,gs8,gs9,gs10,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select instanceid,sectionnum,questionnum,questionid,gs1,gs2,gs3,gs4,gs5,gs6,gs7,gs8,gs9,gs10,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into testquestion3_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,gs1
 ,gs2
 ,gs3
 ,gs4
 ,gs5
 ,gs6
 ,gs7
 ,gs8
 ,gs9
 ,gs10
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,gs1
 ,gs2
 ,gs3
 ,gs4
 ,gs5
 ,gs6
 ,gs7
 ,gs8
 ,gs9
 ,gs10
 ,update_meaning
  from inserted
end
GO

create trigger u_testquestion3 on testquestion3
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update testquestion3 set
testquestion3.instanceid = inserted.instanceid,testquestion3.sectionnum = inserted.sectionnum,testquestion3.questionnum = inserted.questionnum,testquestion3.questionid = inserted.questionid,testquestion3.gs1 = inserted.gs1,testquestion3.gs2 = inserted.gs2,testquestion3.gs3 = inserted.gs3,testquestion3.gs4 = inserted.gs4,testquestion3.gs5 = inserted.gs5,testquestion3.gs6 = inserted.gs6,testquestion3.gs7 = inserted.gs7,testquestion3.gs8 = inserted.gs8,testquestion3.gs9 = inserted.gs9,testquestion3.gs10 = inserted.gs10,testquestion3.update_meaning = inserted.update_meaning,testquestion3.last_updated = inserted.last_updated,testquestion3.updater_legal_name = inserted.updater_legal_name,testquestion3.update_meaning_text = inserted.update_meaning_text,testquestion3.last_updater_uid = inserted.last_updater_uid
from testquestion3 inner join deleted on testquestion3.instanceid = deleted.instanceid and testquestion3.sectionnum = deleted.sectionnum and testquestion3.questionnum = deleted.questionnum inner join inserted on testquestion3.instanceid = inserted.instanceid and testquestion3.sectionnum = inserted.sectionnum and testquestion3.questionnum = inserted.questionnum
insert into testquestion3_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,gs1
 ,gs2
 ,gs3
 ,gs4
 ,gs5
 ,gs6
 ,gs7
 ,gs8
 ,gs9
 ,gs10
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,gs1
 ,gs2
 ,gs3
 ,gs4
 ,gs5
 ,gs6
 ,gs7
 ,gs8
 ,gs9
 ,gs10
 ,update_meaning
  from inserted
end
GO

create trigger d_testquestion3 on testquestion3
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from testquestion3 where exists (
select 1 from deleted where testquestion3.instanceid = deleted.instanceid and testquestion3.sectionnum = deleted.sectionnum and testquestion3.questionnum = deleted.questionnum)
insert into testquestion3_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,gs1
 ,gs2
 ,gs3
 ,gs4
 ,gs5
 ,gs6
 ,gs7
 ,gs8
 ,gs9
 ,gs10
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,gs1
 ,gs2
 ,gs3
 ,gs4
 ,gs5
 ,gs6
 ,gs7
 ,gs8
 ,gs9
 ,gs10
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-testquestion3', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1100, '8:bd6a2500232418cd003a9ee97df26f70', 'enableAuditTable auditTableName=testquestion3_aud, tableName=testquestion3', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-testquestion4::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_testquestion4'
			)
			DROP TRIGGER i_testquestion4
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_testquestion4'
			)
			DROP TRIGGER u_testquestion4
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_testquestion4'
			)
			DROP TRIGGER d_testquestion4
GO

CREATE TABLE testquestion4_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_testquestion4_aud_aud_datetime DEFAULT GETDATE() NOT NULL, instanceid nvarchar(15), sectionnum smallint, questionnum smallint, questionid nvarchar(85), text1 nvarchar(MAX), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TESTQUESTION4_AUD PRIMARY KEY (aud_id))
GO

insert into testquestion4_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,text1
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,text1
 ,update_meaning
  from testquestion4
GO

CREATE INDEX nuk_testquestion4_aud_1 ON testquestion4_aud(aud_userid)
GO

CREATE INDEX nuk_testquestion4_aud_2 ON testquestion4_aud(aud_datetime)
GO

create trigger i_testquestion4 on testquestion4
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into testquestion4 (
instanceid,sectionnum,questionnum,questionid,text1,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select instanceid,sectionnum,questionnum,questionid,text1,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into testquestion4_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,text1
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,text1
 ,update_meaning
  from inserted
end
GO

create trigger u_testquestion4 on testquestion4
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update testquestion4 set
testquestion4.instanceid = inserted.instanceid,testquestion4.sectionnum = inserted.sectionnum,testquestion4.questionnum = inserted.questionnum,testquestion4.questionid = inserted.questionid,testquestion4.text1 = inserted.text1,testquestion4.update_meaning = inserted.update_meaning,testquestion4.last_updated = inserted.last_updated,testquestion4.updater_legal_name = inserted.updater_legal_name,testquestion4.update_meaning_text = inserted.update_meaning_text,testquestion4.last_updater_uid = inserted.last_updater_uid
from testquestion4 inner join deleted on testquestion4.instanceid = deleted.instanceid and testquestion4.sectionnum = deleted.sectionnum and testquestion4.questionnum = deleted.questionnum inner join inserted on testquestion4.instanceid = inserted.instanceid and testquestion4.sectionnum = inserted.sectionnum and testquestion4.questionnum = inserted.questionnum
insert into testquestion4_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,text1
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,text1
 ,update_meaning
  from inserted
end
GO

create trigger d_testquestion4 on testquestion4
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from testquestion4 where exists (
select 1 from deleted where testquestion4.instanceid = deleted.instanceid and testquestion4.sectionnum = deleted.sectionnum and testquestion4.questionnum = deleted.questionnum)
insert into testquestion4_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,text1
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,text1
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-testquestion4', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1101, '8:e3993e2e37bfa5a785db7f5f8e722ab5', 'enableAuditTable auditTableName=testquestion4_aud, tableName=testquestion4', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-testquestion5::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_testquestion5'
			)
			DROP TRIGGER i_testquestion5
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_testquestion5'
			)
			DROP TRIGGER u_testquestion5
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_testquestion5'
			)
			DROP TRIGGER d_testquestion5
GO

CREATE TABLE testquestion5_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_testquestion5_aud_aud_datetime DEFAULT GETDATE() NOT NULL, instanceid nvarchar(15), sectionnum smallint, questionnum smallint, questionid nvarchar(85), fib nvarchar(1000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TESTQUESTION5_AUD PRIMARY KEY (aud_id))
GO

insert into testquestion5_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,fib
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,fib
 ,update_meaning
  from testquestion5
GO

CREATE INDEX nuk_testquestion5_aud_1 ON testquestion5_aud(aud_userid)
GO

CREATE INDEX nuk_testquestion5_aud_2 ON testquestion5_aud(aud_datetime)
GO

create trigger i_testquestion5 on testquestion5
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into testquestion5 (
instanceid,sectionnum,questionnum,questionid,fib,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select instanceid,sectionnum,questionnum,questionid,fib,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into testquestion5_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,fib
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,fib
 ,update_meaning
  from inserted
end
GO

create trigger u_testquestion5 on testquestion5
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update testquestion5 set
testquestion5.instanceid = inserted.instanceid,testquestion5.sectionnum = inserted.sectionnum,testquestion5.questionnum = inserted.questionnum,testquestion5.questionid = inserted.questionid,testquestion5.fib = inserted.fib,testquestion5.update_meaning = inserted.update_meaning,testquestion5.last_updated = inserted.last_updated,testquestion5.updater_legal_name = inserted.updater_legal_name,testquestion5.update_meaning_text = inserted.update_meaning_text,testquestion5.last_updater_uid = inserted.last_updater_uid
from testquestion5 inner join deleted on testquestion5.instanceid = deleted.instanceid and testquestion5.sectionnum = deleted.sectionnum and testquestion5.questionnum = deleted.questionnum inner join inserted on testquestion5.instanceid = inserted.instanceid and testquestion5.sectionnum = inserted.sectionnum and testquestion5.questionnum = inserted.questionnum
insert into testquestion5_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,fib
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,fib
 ,update_meaning
  from inserted
end
GO

create trigger d_testquestion5 on testquestion5
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from testquestion5 where exists (
select 1 from deleted where testquestion5.instanceid = deleted.instanceid and testquestion5.sectionnum = deleted.sectionnum and testquestion5.questionnum = deleted.questionnum)
insert into testquestion5_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,fib
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,fib
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-testquestion5', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1102, '8:dbafcfb54b62a8a62c2a49b990523c39', 'enableAuditTable auditTableName=testquestion5_aud, tableName=testquestion5', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-testquestion6::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_testquestion6'
			)
			DROP TRIGGER i_testquestion6
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_testquestion6'
			)
			DROP TRIGGER u_testquestion6
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_testquestion6'
			)
			DROP TRIGGER d_testquestion6
GO

CREATE TABLE testquestion6_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_testquestion6_aud_aud_datetime DEFAULT GETDATE() NOT NULL, instanceid nvarchar(15), sectionnum smallint, questionnum smallint, questionid nvarchar(85), rating smallint, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TESTQUESTION6_AUD PRIMARY KEY (aud_id))
GO

insert into testquestion6_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rating
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rating
 ,update_meaning
  from testquestion6
GO

CREATE INDEX nuk_testquestion6_aud_1 ON testquestion6_aud(aud_userid)
GO

CREATE INDEX nuk_testquestion6_aud_2 ON testquestion6_aud(aud_datetime)
GO

create trigger i_testquestion6 on testquestion6
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into testquestion6 (
instanceid,sectionnum,questionnum,questionid,rating,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select instanceid,sectionnum,questionnum,questionid,rating,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into testquestion6_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rating
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rating
 ,update_meaning
  from inserted
end
GO

create trigger u_testquestion6 on testquestion6
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update testquestion6 set
testquestion6.instanceid = inserted.instanceid,testquestion6.sectionnum = inserted.sectionnum,testquestion6.questionnum = inserted.questionnum,testquestion6.questionid = inserted.questionid,testquestion6.rating = inserted.rating,testquestion6.update_meaning = inserted.update_meaning,testquestion6.last_updated = inserted.last_updated,testquestion6.updater_legal_name = inserted.updater_legal_name,testquestion6.update_meaning_text = inserted.update_meaning_text,testquestion6.last_updater_uid = inserted.last_updater_uid
from testquestion6 inner join deleted on testquestion6.instanceid = deleted.instanceid and testquestion6.sectionnum = deleted.sectionnum and testquestion6.questionnum = deleted.questionnum inner join inserted on testquestion6.instanceid = inserted.instanceid and testquestion6.sectionnum = inserted.sectionnum and testquestion6.questionnum = inserted.questionnum
insert into testquestion6_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rating
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rating
 ,update_meaning
  from inserted
end
GO

create trigger d_testquestion6 on testquestion6
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from testquestion6 where exists (
select 1 from deleted where testquestion6.instanceid = deleted.instanceid and testquestion6.sectionnum = deleted.sectionnum and testquestion6.questionnum = deleted.questionnum)
insert into testquestion6_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rating
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rating
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-testquestion6', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1103, '8:9cd64d31778267e8ad603a7ef21e11ed', 'enableAuditTable auditTableName=testquestion6_aud, tableName=testquestion6', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-testquestion8::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_testquestion8'
			)
			DROP TRIGGER i_testquestion8
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_testquestion8'
			)
			DROP TRIGGER u_testquestion8
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_testquestion8'
			)
			DROP TRIGGER d_testquestion8
GO

CREATE TABLE testquestion8_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_testquestion8_aud_aud_datetime DEFAULT GETDATE() NOT NULL, instanceid nvarchar(15), sectionnum smallint, questionnum smallint, itemindex smallint, questionid nvarchar(85), rating1 smallint, rating2 smallint, rating3 smallint, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TESTQUESTION8_AUD PRIMARY KEY (aud_id))
GO

insert into testquestion8_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,itemindex
 ,questionid
 ,rating1
 ,rating2
 ,rating3
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,instanceid
 ,sectionnum
 ,questionnum
 ,itemindex
 ,questionid
 ,rating1
 ,rating2
 ,rating3
 ,update_meaning
  from testquestion8
GO

CREATE INDEX nuk_testquestion8_aud_1 ON testquestion8_aud(aud_userid)
GO

CREATE INDEX nuk_testquestion8_aud_2 ON testquestion8_aud(aud_datetime)
GO

create trigger i_testquestion8 on testquestion8
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into testquestion8 (
instanceid,sectionnum,questionnum,itemindex,questionid,rating1,rating2,rating3,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select instanceid,sectionnum,questionnum,itemindex,questionid,rating1,rating2,rating3,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into testquestion8_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,itemindex
 ,questionid
 ,rating1
 ,rating2
 ,rating3
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,itemindex
 ,questionid
 ,rating1
 ,rating2
 ,rating3
 ,update_meaning
  from inserted
end
GO

create trigger u_testquestion8 on testquestion8
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update testquestion8 set
testquestion8.instanceid = inserted.instanceid,testquestion8.sectionnum = inserted.sectionnum,testquestion8.questionnum = inserted.questionnum,testquestion8.itemindex = inserted.itemindex,testquestion8.questionid = inserted.questionid,testquestion8.rating1 = inserted.rating1,testquestion8.rating2 = inserted.rating2,testquestion8.rating3 = inserted.rating3,testquestion8.update_meaning = inserted.update_meaning,testquestion8.last_updated = inserted.last_updated,testquestion8.updater_legal_name = inserted.updater_legal_name,testquestion8.update_meaning_text = inserted.update_meaning_text,testquestion8.last_updater_uid = inserted.last_updater_uid
from testquestion8 inner join deleted on testquestion8.instanceid = deleted.instanceid and testquestion8.sectionnum = deleted.sectionnum and testquestion8.questionnum = deleted.questionnum and testquestion8.itemindex = deleted.itemindex inner join inserted on testquestion8.instanceid = inserted.instanceid and testquestion8.sectionnum = inserted.sectionnum and testquestion8.questionnum = inserted.questionnum and testquestion8.itemindex = inserted.itemindex
insert into testquestion8_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,itemindex
 ,questionid
 ,rating1
 ,rating2
 ,rating3
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,itemindex
 ,questionid
 ,rating1
 ,rating2
 ,rating3
 ,update_meaning
  from inserted
end
GO

create trigger d_testquestion8 on testquestion8
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from testquestion8 where exists (
select 1 from deleted where testquestion8.instanceid = deleted.instanceid and testquestion8.sectionnum = deleted.sectionnum and testquestion8.questionnum = deleted.questionnum and testquestion8.itemindex = deleted.itemindex)
insert into testquestion8_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,itemindex
 ,questionid
 ,rating1
 ,rating2
 ,rating3
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,itemindex
 ,questionid
 ,rating1
 ,rating2
 ,rating3
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-testquestion8', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1104, '8:fbc0f038e69f452ac0ec238ecbe24fd2', 'enableAuditTable auditTableName=testquestion8_aud, tableName=testquestion8', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-testsection::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_testsection'
			)
			DROP TRIGGER i_testsection
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_testsection'
			)
			DROP TRIGGER u_testsection
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_testsection'
			)
			DROP TRIGGER d_testsection
GO

CREATE TABLE testsection_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_testsection_aud_aud_datetime DEFAULT GETDATE() NOT NULL, instanceid nvarchar(15), sectionnum smallint, teststart datetime, testfinish datetime, score float(53), weightedscore float(53), nquestions int, maxpoints float(53), ncorrect int, elapsedTime decimal(20, 0), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TESTSECTION_AUD PRIMARY KEY (aud_id))
GO

insert into testsection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,maxpoints
 ,ncorrect
 ,elapsedTime
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,instanceid
 ,sectionnum
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,maxpoints
 ,ncorrect
 ,elapsedTime
 ,update_meaning
  from testsection
GO

CREATE INDEX nuk_testsection_aud_1 ON testsection_aud(aud_userid)
GO

CREATE INDEX nuk_testsection_aud_2 ON testsection_aud(aud_datetime)
GO

create trigger i_testsection on testsection
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into testsection (
instanceid,sectionnum,teststart,testfinish,score,weightedscore,nquestions,maxpoints,ncorrect,elapsedTime,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select instanceid,sectionnum,teststart,testfinish,score,weightedscore,nquestions,maxpoints,ncorrect,elapsedTime,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into testsection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,maxpoints
 ,ncorrect
 ,elapsedTime
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,maxpoints
 ,ncorrect
 ,elapsedTime
 ,update_meaning
  from inserted
end
GO

create trigger u_testsection on testsection
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update testsection set
testsection.instanceid = inserted.instanceid,testsection.sectionnum = inserted.sectionnum,testsection.teststart = inserted.teststart,testsection.testfinish = inserted.testfinish,testsection.score = inserted.score,testsection.weightedscore = inserted.weightedscore,testsection.nquestions = inserted.nquestions,testsection.maxpoints = inserted.maxpoints,testsection.ncorrect = inserted.ncorrect,testsection.elapsedTime = inserted.elapsedTime,testsection.update_meaning = inserted.update_meaning,testsection.last_updated = inserted.last_updated,testsection.updater_legal_name = inserted.updater_legal_name,testsection.update_meaning_text = inserted.update_meaning_text,testsection.last_updater_uid = inserted.last_updater_uid
from testsection inner join deleted on testsection.instanceid = deleted.instanceid and testsection.sectionnum = deleted.sectionnum inner join inserted on testsection.instanceid = inserted.instanceid and testsection.sectionnum = inserted.sectionnum
insert into testsection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,maxpoints
 ,ncorrect
 ,elapsedTime
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,maxpoints
 ,ncorrect
 ,elapsedTime
 ,update_meaning
  from inserted
end
GO

create trigger d_testsection on testsection
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from testsection where exists (
select 1 from deleted where testsection.instanceid = deleted.instanceid and testsection.sectionnum = deleted.sectionnum)
insert into testsection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,maxpoints
 ,ncorrect
 ,elapsedTime
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,teststart
 ,testfinish
 ,score
 ,weightedscore
 ,nquestions
 ,maxpoints
 ,ncorrect
 ,elapsedTime
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-testsection', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1105, '8:ad70f604b5c9963b7977204b8078c8a9', 'enableAuditTable auditTableName=testsection_aud, tableName=testsection', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-tutor::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_tutor'
			)
			DROP TRIGGER i_tutor
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_tutor'
			)
			DROP TRIGGER u_tutor
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_tutor'
			)
			DROP TRIGGER d_tutor
GO

CREATE TABLE tutor_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_tutor_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), learningid nvarchar(85), eventid nvarchar(15), sessionid nvarchar(15), userid nvarchar(85), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TUTOR_AUD PRIMARY KEY (aud_id))
GO

insert into tutor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,eventid
 ,sessionid
 ,userid
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,learningid
 ,eventid
 ,sessionid
 ,userid
 ,update_meaning
  from tutor
GO

CREATE INDEX nuk_tutor_aud_1 ON tutor_aud(aud_userid)
GO

CREATE INDEX nuk_tutor_aud_2 ON tutor_aud(aud_datetime)
GO

create trigger i_tutor on tutor
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into tutor (
id,learningid,eventid,sessionid,userid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select id,learningid,eventid,sessionid,userid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into tutor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,eventid
 ,sessionid
 ,userid
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,eventid
 ,sessionid
 ,userid
 ,update_meaning
  from inserted
end
GO

create trigger u_tutor on tutor
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update tutor set
tutor.id = inserted.id,tutor.learningid = inserted.learningid,tutor.eventid = inserted.eventid,tutor.sessionid = inserted.sessionid,tutor.userid = inserted.userid,tutor.update_meaning = inserted.update_meaning,tutor.last_updated = inserted.last_updated,tutor.updater_legal_name = inserted.updater_legal_name,tutor.update_meaning_text = inserted.update_meaning_text,tutor.last_updater_uid = inserted.last_updater_uid
from tutor inner join deleted on tutor.id = deleted.id inner join inserted on tutor.id = inserted.id
insert into tutor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,eventid
 ,sessionid
 ,userid
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,eventid
 ,sessionid
 ,userid
 ,update_meaning
  from inserted
end
GO

create trigger d_tutor on tutor
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from tutor where exists (
select 1 from deleted where tutor.id = deleted.id)
insert into tutor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,eventid
 ,sessionid
 ,userid
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,eventid
 ,sessionid
 ,userid
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-tutor', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1106, '8:4f65aef0cce2a0947e8a9e3f0b436454', 'enableAuditTable auditTableName=tutor_aud, tableName=tutor', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-withdraw_deduction::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_withdraw_deduction'
			)
			DROP TRIGGER i_withdraw_deduction
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_withdraw_deduction'
			)
			DROP TRIGGER u_withdraw_deduction
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_withdraw_deduction'
			)
			DROP TRIGGER d_withdraw_deduction
GO

CREATE TABLE withdraw_deduction_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_withdraw_deduction_aud_aud_datetime DEFAULT GETDATE() NOT NULL, policy_id nvarchar(15), day_before_start int, deduction float(53), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_WITHDRAW_DEDUCTION_AUD PRIMARY KEY (aud_id))
GO

insert into withdraw_deduction_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
  from withdraw_deduction
GO

CREATE INDEX nuk_withdraw_deduction_aud_1 ON withdraw_deduction_aud(aud_userid)
GO

CREATE INDEX nuk_withdraw_deduction_aud_2 ON withdraw_deduction_aud(aud_datetime)
GO

create trigger i_withdraw_deduction on withdraw_deduction
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into withdraw_deduction (
policy_id,day_before_start,deduction,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select policy_id,day_before_start,deduction,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into withdraw_deduction_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
  from inserted
end
GO

create trigger u_withdraw_deduction on withdraw_deduction
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update withdraw_deduction set
withdraw_deduction.policy_id = inserted.policy_id,withdraw_deduction.day_before_start = inserted.day_before_start,withdraw_deduction.deduction = inserted.deduction,withdraw_deduction.update_meaning = inserted.update_meaning,withdraw_deduction.last_updated = inserted.last_updated,withdraw_deduction.updater_legal_name = inserted.updater_legal_name,withdraw_deduction.update_meaning_text = inserted.update_meaning_text,withdraw_deduction.last_updater_uid = inserted.last_updater_uid
from withdraw_deduction inner join deleted on withdraw_deduction.policy_id = deleted.policy_id and withdraw_deduction.day_before_start = deleted.day_before_start inner join inserted on withdraw_deduction.policy_id = inserted.policy_id and withdraw_deduction.day_before_start = inserted.day_before_start
insert into withdraw_deduction_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
  from inserted
end
GO

create trigger d_withdraw_deduction on withdraw_deduction
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from withdraw_deduction where exists (
select 1 from deleted where withdraw_deduction.policy_id = deleted.policy_id and withdraw_deduction.day_before_start = deleted.day_before_start)
insert into withdraw_deduction_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-withdraw_deduction', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1107, '8:cf28c739a76f9d3746b801bfd60834c5', 'enableAuditTable auditTableName=withdraw_deduction_aud, tableName=withdraw_deduction', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-withdrawnStudents::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_withdrawnStudents'
			)
			DROP TRIGGER i_withdrawnStudents
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_withdrawnStudents'
			)
			DROP TRIGGER u_withdrawnStudents
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_withdrawnStudents'
			)
			DROP TRIGGER d_withdrawnStudents
GO

CREATE TABLE withdrawnStudents_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_withdrawnStudents_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), learningid nvarchar(85), eventid nvarchar(15), userid nvarchar(85), transcriptid nvarchar(15), datecreated datetime, substitute_transcriptid nvarchar(85), update_meaning nvarchar(8), studentstatus int, bundle_id nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_WITHDRAWNSTUDENTS_AUD PRIMARY KEY (aud_id))
GO

insert into withdrawnStudents_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,eventid
 ,userid
 ,transcriptid
 ,datecreated
 ,substitute_transcriptid
 ,update_meaning
 ,studentstatus
 ,bundle_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,learningid
 ,eventid
 ,userid
 ,transcriptid
 ,datecreated
 ,substitute_transcriptid
 ,update_meaning
 ,studentstatus
 ,bundle_id
  from withdrawnStudents
GO

CREATE INDEX nuk_withdrawnStudents_aud_1 ON withdrawnStudents_aud(aud_userid)
GO

CREATE INDEX nuk_withdrawnStudents_aud_2 ON withdrawnStudents_aud(aud_datetime)
GO

create trigger i_withdrawnStudents on withdrawnStudents
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into withdrawnStudents (
id,learningid,eventid,userid,transcriptid,datecreated,substitute_transcriptid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,studentstatus,bundle_id) select id,learningid,eventid,userid,transcriptid,datecreated,substitute_transcriptid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,studentstatus,bundle_id from inserted
insert into withdrawnStudents_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,eventid
 ,userid
 ,transcriptid
 ,datecreated
 ,substitute_transcriptid
 ,update_meaning
 ,studentstatus
 ,bundle_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,eventid
 ,userid
 ,transcriptid
 ,datecreated
 ,substitute_transcriptid
 ,update_meaning
 ,studentstatus
 ,bundle_id
  from inserted
end
GO

create trigger u_withdrawnStudents on withdrawnStudents
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update withdrawnStudents set
withdrawnStudents.id = inserted.id,withdrawnStudents.learningid = inserted.learningid,withdrawnStudents.eventid = inserted.eventid,withdrawnStudents.userid = inserted.userid,withdrawnStudents.transcriptid = inserted.transcriptid,withdrawnStudents.datecreated = inserted.datecreated,withdrawnStudents.substitute_transcriptid = inserted.substitute_transcriptid,withdrawnStudents.update_meaning = inserted.update_meaning,withdrawnStudents.last_updated = inserted.last_updated,withdrawnStudents.updater_legal_name = inserted.updater_legal_name,withdrawnStudents.update_meaning_text = inserted.update_meaning_text,withdrawnStudents.last_updater_uid = inserted.last_updater_uid,withdrawnStudents.studentstatus = inserted.studentstatus,withdrawnStudents.bundle_id = inserted.bundle_id
from withdrawnStudents inner join deleted on withdrawnStudents.id = deleted.id inner join inserted on withdrawnStudents.id = inserted.id
insert into withdrawnStudents_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,eventid
 ,userid
 ,transcriptid
 ,datecreated
 ,substitute_transcriptid
 ,update_meaning
 ,studentstatus
 ,bundle_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,eventid
 ,userid
 ,transcriptid
 ,datecreated
 ,substitute_transcriptid
 ,update_meaning
 ,studentstatus
 ,bundle_id
  from inserted
end
GO

create trigger d_withdrawnStudents on withdrawnStudents
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from withdrawnStudents where exists (
select 1 from deleted where withdrawnStudents.id = deleted.id)
insert into withdrawnStudents_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learningid
 ,eventid
 ,userid
 ,transcriptid
 ,datecreated
 ,substitute_transcriptid
 ,update_meaning
 ,studentstatus
 ,bundle_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learningid
 ,eventid
 ,userid
 ,transcriptid
 ,datecreated
 ,substitute_transcriptid
 ,update_meaning
 ,studentstatus
 ,bundle_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-withdrawnStudents', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1108, '8:8e4a7679f1f6fd7d8f3a32e6c3226970', 'enableAuditTable auditTableName=withdrawnStudents_aud, tableName=withdrawnStudents', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-lo_attribute::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_lo_attribute'
			)
			DROP TRIGGER i_lo_attribute
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_lo_attribute'
			)
			DROP TRIGGER u_lo_attribute
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_lo_attribute'
			)
			DROP TRIGGER d_lo_attribute
GO

CREATE TABLE lo_attribute_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_lo_attribute_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), attribute_id nvarchar(15), attribute_value_data nvarchar(2000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_LO_ATTRIBUTE_AUD PRIMARY KEY (aud_id))
GO

insert into lo_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from lo_attribute
GO

CREATE INDEX nuk_lo_attribute_aud_1 ON lo_attribute_aud(aud_userid)
GO

CREATE INDEX nuk_lo_attribute_aud_2 ON lo_attribute_aud(aud_datetime)
GO

create trigger i_lo_attribute on lo_attribute
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into lo_attribute (
learningid,attribute_id,attribute_value_data,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select learningid,attribute_id,attribute_value_data,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into lo_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from inserted
end
GO

create trigger u_lo_attribute on lo_attribute
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update lo_attribute set
lo_attribute.learningid = inserted.learningid,lo_attribute.attribute_id = inserted.attribute_id,lo_attribute.attribute_value_data = inserted.attribute_value_data,lo_attribute.update_meaning = inserted.update_meaning,lo_attribute.last_updated = inserted.last_updated,lo_attribute.updater_legal_name = inserted.updater_legal_name,lo_attribute.update_meaning_text = inserted.update_meaning_text,lo_attribute.last_updater_uid = inserted.last_updater_uid
from lo_attribute inner join deleted on lo_attribute.learningid = deleted.learningid and lo_attribute.attribute_id = deleted.attribute_id inner join inserted on lo_attribute.learningid = inserted.learningid and lo_attribute.attribute_id = inserted.attribute_id
insert into lo_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from inserted
end
GO

create trigger d_lo_attribute on lo_attribute
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from lo_attribute where exists (
select 1 from deleted where lo_attribute.learningid = deleted.learningid and lo_attribute.attribute_id = deleted.attribute_id)
insert into lo_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-lo_attribute', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1109, '8:619f97335a703f46cac9cc35cc7d801b', 'enableAuditTable auditTableName=lo_attribute_aud, tableName=lo_attribute', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type9::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type9'
			)
			DROP TRIGGER i_question_type9
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type9'
			)
			DROP TRIGGER u_question_type9
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type9'
			)
			DROP TRIGGER d_question_type9
GO

CREATE TABLE question_type9_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_type9_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes smallint, qtext2 nvarchar(MAX), hint nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_TYPE9_AUD PRIMARY KEY (aud_id))
GO

insert into question_type9_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from question_type9
GO

CREATE INDEX nuk_question_type9_aud_1 ON question_type9_aud(aud_userid)
GO

CREATE INDEX nuk_question_type9_aud_2 ON question_type9_aud(aud_datetime)
GO

create trigger i_question_type9 on question_type9
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type9 (
questionid,qattributes,qtext2,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,qattributes,qtext2,hint,prenote,postnote,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into question_type9_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from inserted
end
GO

create trigger u_question_type9 on question_type9
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type9 set
question_type9.questionid = inserted.questionid,question_type9.qattributes = inserted.qattributes,question_type9.qtext2 = inserted.qtext2,question_type9.hint = inserted.hint,question_type9.prenote = inserted.prenote,question_type9.postnote = inserted.postnote,question_type9.update_meaning = inserted.update_meaning,question_type9.last_updated = inserted.last_updated,question_type9.updater_legal_name = inserted.updater_legal_name,question_type9.update_meaning_text = inserted.update_meaning_text,question_type9.last_updater_uid = inserted.last_updater_uid
from question_type9 inner join deleted on question_type9.questionid = deleted.questionid inner join inserted on question_type9.questionid = inserted.questionid
insert into question_type9_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from inserted
end
GO

create trigger d_question_type9 on question_type9
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type9 where exists (
select 1 from deleted where question_type9.questionid = deleted.questionid)
insert into question_type9_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext2
 ,hint
 ,prenote
 ,postnote
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type9', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1110, '8:0a28e3df9ad2654cac9019bf30efbd58', 'enableAuditTable auditTableName=question_type9_aud, tableName=question_type9', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-testquestion9::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_testquestion9'
			)
			DROP TRIGGER i_testquestion9
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_testquestion9'
			)
			DROP TRIGGER u_testquestion9
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_testquestion9'
			)
			DROP TRIGGER d_testquestion9
GO

CREATE TABLE testquestion9_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_testquestion9_aud_aud_datetime DEFAULT GETDATE() NOT NULL, instanceid nvarchar(15), sectionnum smallint, questionnum smallint, questionid nvarchar(85), rid nvarchar(20), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TESTQUESTION9_AUD PRIMARY KEY (aud_id))
GO

insert into testquestion9_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rid
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rid
 ,update_meaning
  from testquestion9
GO

CREATE INDEX nuk_testquestion9_aud_1 ON testquestion9_aud(aud_userid)
GO

CREATE INDEX nuk_testquestion9_aud_2 ON testquestion9_aud(aud_datetime)
GO

create trigger i_testquestion9 on testquestion9
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into testquestion9 (
instanceid,sectionnum,questionnum,questionid,rid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select instanceid,sectionnum,questionnum,questionid,rid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into testquestion9_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rid
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rid
 ,update_meaning
  from inserted
end
GO

create trigger u_testquestion9 on testquestion9
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update testquestion9 set
testquestion9.instanceid = inserted.instanceid,testquestion9.sectionnum = inserted.sectionnum,testquestion9.questionnum = inserted.questionnum,testquestion9.questionid = inserted.questionid,testquestion9.rid = inserted.rid,testquestion9.update_meaning = inserted.update_meaning,testquestion9.last_updated = inserted.last_updated,testquestion9.updater_legal_name = inserted.updater_legal_name,testquestion9.update_meaning_text = inserted.update_meaning_text,testquestion9.last_updater_uid = inserted.last_updater_uid
from testquestion9 inner join deleted on testquestion9.instanceid = deleted.instanceid and testquestion9.sectionnum = deleted.sectionnum and testquestion9.questionnum = deleted.questionnum inner join inserted on testquestion9.instanceid = inserted.instanceid and testquestion9.sectionnum = inserted.sectionnum and testquestion9.questionnum = inserted.questionnum
insert into testquestion9_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rid
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rid
 ,update_meaning
  from inserted
end
GO

create trigger d_testquestion9 on testquestion9
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from testquestion9 where exists (
select 1 from deleted where testquestion9.instanceid = deleted.instanceid and testquestion9.sectionnum = deleted.sectionnum and testquestion9.questionnum = deleted.questionnum)
insert into testquestion9_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rid
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,instanceid
 ,sectionnum
 ,questionnum
 ,questionid
 ,rid
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-testquestion9', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1111, '8:de9f3559083c2ab29f3de4f2f620d5d2', 'enableAuditTable auditTableName=testquestion9_aud, tableName=testquestion9', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-netg_proxied_authentication::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_netg_proxied_authentication'
			)
			DROP TRIGGER i_netg_proxied_authentication
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_netg_proxied_authentication'
			)
			DROP TRIGGER u_netg_proxied_authentication
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_netg_proxied_authentication'
			)
			DROP TRIGGER d_netg_proxied_authentication
GO

CREATE TABLE netg_proxied_auth_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_netg_proxied_auth_aud_aud_datetime DEFAULT GETDATE() NOT NULL, courseid nvarchar(85), publickey nvarchar(32), privatekey nvarchar(32), destination nvarchar(10), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_NETG_PROXIED_AUTH_AUD PRIMARY KEY (aud_id))
GO

insert into netg_proxied_auth_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,publickey
 ,privatekey
 ,destination
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,courseid
 ,publickey
 ,privatekey
 ,destination
 ,update_meaning
  from netg_proxied_authentication
GO

CREATE INDEX nuk_netg_proxied_auth_aud_1 ON netg_proxied_auth_aud(aud_userid)
GO

CREATE INDEX nuk_netg_proxied_auth_aud_2 ON netg_proxied_auth_aud(aud_datetime)
GO

create trigger i_netg_proxied_authentication on netg_proxied_authentication
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into netg_proxied_authentication (
courseid,publickey,privatekey,destination,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select courseid,publickey,privatekey,destination,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into netg_proxied_auth_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,publickey
 ,privatekey
 ,destination
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,publickey
 ,privatekey
 ,destination
 ,update_meaning
  from inserted
end
GO

create trigger u_netg_proxied_authentication on netg_proxied_authentication
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update netg_proxied_authentication set
netg_proxied_authentication.courseid = inserted.courseid,netg_proxied_authentication.publickey = inserted.publickey,netg_proxied_authentication.privatekey = inserted.privatekey,netg_proxied_authentication.destination = inserted.destination,netg_proxied_authentication.update_meaning = inserted.update_meaning,netg_proxied_authentication.last_updated = inserted.last_updated,netg_proxied_authentication.updater_legal_name = inserted.updater_legal_name,netg_proxied_authentication.update_meaning_text = inserted.update_meaning_text,netg_proxied_authentication.last_updater_uid = inserted.last_updater_uid
from netg_proxied_authentication inner join deleted on netg_proxied_authentication.courseid = deleted.courseid inner join inserted on netg_proxied_authentication.courseid = inserted.courseid
insert into netg_proxied_auth_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,publickey
 ,privatekey
 ,destination
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,publickey
 ,privatekey
 ,destination
 ,update_meaning
  from inserted
end
GO

create trigger d_netg_proxied_authentication on netg_proxied_authentication
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from netg_proxied_authentication where exists (
select 1 from deleted where netg_proxied_authentication.courseid = deleted.courseid)
insert into netg_proxied_auth_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,publickey
 ,privatekey
 ,destination
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,publickey
 ,privatekey
 ,destination
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-netg_proxied_authentication', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1112, '8:89a4f1fc4f6ef3145219e14de663c9c5', 'enableAuditTable auditTableName=netg_proxied_auth_aud, tableName=netg_proxied_authentication', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-get_abstract_launcher::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_get_abstract_launcher'
			)
			DROP TRIGGER i_get_abstract_launcher
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_get_abstract_launcher'
			)
			DROP TRIGGER u_get_abstract_launcher
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_get_abstract_launcher'
			)
			DROP TRIGGER d_get_abstract_launcher
GO

CREATE TABLE get_abstr_launcher_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_get_abstr_launcher_aud_aud_datetime DEFAULT GETDATE() NOT NULL, courseid nvarchar(85), uvalue nvarchar(20), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_GET_ABSTR_LAUNCHER_AUD PRIMARY KEY (aud_id))
GO

insert into get_abstr_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,uvalue
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,courseid
 ,uvalue
 ,update_meaning
  from get_abstract_launcher
GO

CREATE INDEX nuk_get_abstr_launcher_aud_1 ON get_abstr_launcher_aud(aud_userid)
GO

CREATE INDEX nuk_get_abstr_launcher_aud_2 ON get_abstr_launcher_aud(aud_datetime)
GO

create trigger i_get_abstract_launcher on get_abstract_launcher
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into get_abstract_launcher (
courseid,uvalue,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select courseid,uvalue,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into get_abstr_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,uvalue
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,uvalue
 ,update_meaning
  from inserted
end
GO

create trigger u_get_abstract_launcher on get_abstract_launcher
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update get_abstract_launcher set
get_abstract_launcher.courseid = inserted.courseid,get_abstract_launcher.uvalue = inserted.uvalue,get_abstract_launcher.update_meaning = inserted.update_meaning,get_abstract_launcher.last_updated = inserted.last_updated,get_abstract_launcher.updater_legal_name = inserted.updater_legal_name,get_abstract_launcher.update_meaning_text = inserted.update_meaning_text,get_abstract_launcher.last_updater_uid = inserted.last_updater_uid
from get_abstract_launcher inner join deleted on get_abstract_launcher.courseid = deleted.courseid inner join inserted on get_abstract_launcher.courseid = inserted.courseid
insert into get_abstr_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,uvalue
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,uvalue
 ,update_meaning
  from inserted
end
GO

create trigger d_get_abstract_launcher on get_abstract_launcher
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from get_abstract_launcher where exists (
select 1 from deleted where get_abstract_launcher.courseid = deleted.courseid)
insert into get_abstr_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,uvalue
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,uvalue
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-get_abstract_launcher', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1113, '8:a2d385f86620865b91b19df4385b5027', 'enableAuditTable auditTableName=get_abstr_launcher_aud, tableName=get_abstract_launcher', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-mastertest_print::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_mastertest_print'
			)
			DROP TRIGGER i_mastertest_print
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_mastertest_print'
			)
			DROP TRIGGER u_mastertest_print
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_mastertest_print'
			)
			DROP TRIGGER d_mastertest_print
GO

CREATE TABLE mastertest_print_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_mastertest_print_aud_aud_datetime DEFAULT GETDATE() NOT NULL, testid nvarchar(100), printTitle nvarchar(255), print_abcd char(1), printAnswersDate datetime, printExamDate datetime, coverSheetId nvarchar(15), printAnswersDateEnd datetime, printExamDateEnd datetime, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_MASTERTEST_PRINT_AUD PRIMARY KEY (aud_id))
GO

insert into mastertest_print_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,printTitle
 ,print_abcd
 ,printAnswersDate
 ,printExamDate
 ,coverSheetId
 ,printAnswersDateEnd
 ,printExamDateEnd
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,testid
 ,printTitle
 ,print_abcd
 ,printAnswersDate
 ,printExamDate
 ,coverSheetId
 ,printAnswersDateEnd
 ,printExamDateEnd
 ,update_meaning
  from mastertest_print
GO

CREATE INDEX nuk_mastertest_print_aud_1 ON mastertest_print_aud(aud_userid)
GO

CREATE INDEX nuk_mastertest_print_aud_2 ON mastertest_print_aud(aud_datetime)
GO

create trigger i_mastertest_print on mastertest_print
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into mastertest_print (
testid,printTitle,print_abcd,printAnswersDate,printExamDate,coverSheetId,printAnswersDateEnd,printExamDateEnd,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select testid,printTitle,print_abcd,printAnswersDate,printExamDate,coverSheetId,printAnswersDateEnd,printExamDateEnd,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into mastertest_print_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,printTitle
 ,print_abcd
 ,printAnswersDate
 ,printExamDate
 ,coverSheetId
 ,printAnswersDateEnd
 ,printExamDateEnd
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,testid
 ,printTitle
 ,print_abcd
 ,printAnswersDate
 ,printExamDate
 ,coverSheetId
 ,printAnswersDateEnd
 ,printExamDateEnd
 ,update_meaning
  from inserted
end
GO

create trigger u_mastertest_print on mastertest_print
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update mastertest_print set
mastertest_print.testid = inserted.testid,mastertest_print.printTitle = inserted.printTitle,mastertest_print.print_abcd = inserted.print_abcd,mastertest_print.printAnswersDate = inserted.printAnswersDate,mastertest_print.printExamDate = inserted.printExamDate,mastertest_print.coverSheetId = inserted.coverSheetId,mastertest_print.printAnswersDateEnd = inserted.printAnswersDateEnd,mastertest_print.printExamDateEnd = inserted.printExamDateEnd,mastertest_print.update_meaning = inserted.update_meaning,mastertest_print.last_updated = inserted.last_updated,mastertest_print.updater_legal_name = inserted.updater_legal_name,mastertest_print.update_meaning_text = inserted.update_meaning_text,mastertest_print.last_updater_uid = inserted.last_updater_uid
from mastertest_print inner join deleted on mastertest_print.testid = deleted.testid inner join inserted on mastertest_print.testid = inserted.testid
insert into mastertest_print_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,printTitle
 ,print_abcd
 ,printAnswersDate
 ,printExamDate
 ,coverSheetId
 ,printAnswersDateEnd
 ,printExamDateEnd
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,testid
 ,printTitle
 ,print_abcd
 ,printAnswersDate
 ,printExamDate
 ,coverSheetId
 ,printAnswersDateEnd
 ,printExamDateEnd
 ,update_meaning
  from inserted
end
GO

create trigger d_mastertest_print on mastertest_print
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from mastertest_print where exists (
select 1 from deleted where mastertest_print.testid = deleted.testid)
insert into mastertest_print_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,printTitle
 ,print_abcd
 ,printAnswersDate
 ,printExamDate
 ,coverSheetId
 ,printAnswersDateEnd
 ,printExamDateEnd
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,testid
 ,printTitle
 ,print_abcd
 ,printAnswersDate
 ,printExamDate
 ,coverSheetId
 ,printAnswersDateEnd
 ,printExamDateEnd
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-mastertest_print', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1114, '8:7604b2c0cff73a4b362b03036af2089f', 'enableAuditTable auditTableName=mastertest_print_aud, tableName=mastertest_print', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-randsection::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_randsection'
			)
			DROP TRIGGER i_randsection
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_randsection'
			)
			DROP TRIGGER u_randsection
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_randsection'
			)
			DROP TRIGGER d_randsection
GO

CREATE TABLE randsection_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_randsection_aud_aud_datetime DEFAULT GETDATE() NOT NULL, testid nvarchar(100), sectionnum smallint, ordernum smallint, poolid int, nquest int, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_RANDSECTION_AUD PRIMARY KEY (aud_id))
GO

insert into randsection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,sectionnum
 ,ordernum
 ,poolid
 ,nquest
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,testid
 ,sectionnum
 ,ordernum
 ,poolid
 ,nquest
 ,update_meaning
  from randsection
GO

CREATE INDEX nuk_randsection_aud_1 ON randsection_aud(aud_userid)
GO

CREATE INDEX nuk_randsection_aud_2 ON randsection_aud(aud_datetime)
GO

create trigger i_randsection on randsection
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into randsection (
testid,sectionnum,ordernum,poolid,nquest,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select testid,sectionnum,ordernum,poolid,nquest,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into randsection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,sectionnum
 ,ordernum
 ,poolid
 ,nquest
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,testid
 ,sectionnum
 ,ordernum
 ,poolid
 ,nquest
 ,update_meaning
  from inserted
end
GO

create trigger u_randsection on randsection
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update randsection set
randsection.testid = inserted.testid,randsection.sectionnum = inserted.sectionnum,randsection.ordernum = inserted.ordernum,randsection.poolid = inserted.poolid,randsection.nquest = inserted.nquest,randsection.update_meaning = inserted.update_meaning,randsection.last_updated = inserted.last_updated,randsection.updater_legal_name = inserted.updater_legal_name,randsection.update_meaning_text = inserted.update_meaning_text,randsection.last_updater_uid = inserted.last_updater_uid
from randsection inner join deleted on randsection.testid = deleted.testid and randsection.sectionnum = deleted.sectionnum and randsection.ordernum = deleted.ordernum inner join inserted on randsection.testid = inserted.testid and randsection.sectionnum = inserted.sectionnum and randsection.ordernum = inserted.ordernum
insert into randsection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,sectionnum
 ,ordernum
 ,poolid
 ,nquest
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,testid
 ,sectionnum
 ,ordernum
 ,poolid
 ,nquest
 ,update_meaning
  from inserted
end
GO

create trigger d_randsection on randsection
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from randsection where exists (
select 1 from deleted where randsection.testid = deleted.testid and randsection.sectionnum = deleted.sectionnum and randsection.ordernum = deleted.ordernum)
insert into randsection_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,testid
 ,sectionnum
 ,ordernum
 ,poolid
 ,nquest
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,testid
 ,sectionnum
 ,ordernum
 ,poolid
 ,nquest
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-randsection', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1115, '8:eb3e1a9e51c1f452c76b82edd4145268', 'enableAuditTable auditTableName=randsection_aud, tableName=randsection', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-globalenglish_launcher::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_globalenglish_launcher'
			)
			DROP TRIGGER i_globalenglish_launcher
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_globalenglish_launcher'
			)
			DROP TRIGGER u_globalenglish_launcher
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_globalenglish_launcher'
			)
			DROP TRIGGER d_globalenglish_launcher
GO

CREATE TABLE g_english_launcher_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_g_english_launcher_aud_aud_datetime DEFAULT GETDATE() NOT NULL, courseid nvarchar(85), keycode nvarchar(85), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_G_ENGLISH_LAUNCHER_AUD PRIMARY KEY (aud_id))
GO

insert into g_english_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,keycode
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,courseid
 ,keycode
 ,update_meaning
  from globalenglish_launcher
GO

CREATE INDEX nuk_g_english_launcher_aud_1 ON g_english_launcher_aud(aud_userid)
GO

CREATE INDEX nuk_g_english_launcher_aud_2 ON g_english_launcher_aud(aud_datetime)
GO

create trigger i_globalenglish_launcher on globalenglish_launcher
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into globalenglish_launcher (
courseid,keycode,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select courseid,keycode,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into g_english_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,keycode
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,keycode
 ,update_meaning
  from inserted
end
GO

create trigger u_globalenglish_launcher on globalenglish_launcher
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update globalenglish_launcher set
globalenglish_launcher.courseid = inserted.courseid,globalenglish_launcher.keycode = inserted.keycode,globalenglish_launcher.update_meaning = inserted.update_meaning,globalenglish_launcher.last_updated = inserted.last_updated,globalenglish_launcher.updater_legal_name = inserted.updater_legal_name,globalenglish_launcher.update_meaning_text = inserted.update_meaning_text,globalenglish_launcher.last_updater_uid = inserted.last_updater_uid
from globalenglish_launcher inner join deleted on globalenglish_launcher.courseid = deleted.courseid inner join inserted on globalenglish_launcher.courseid = inserted.courseid
insert into g_english_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,keycode
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,keycode
 ,update_meaning
  from inserted
end
GO

create trigger d_globalenglish_launcher on globalenglish_launcher
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from globalenglish_launcher where exists (
select 1 from deleted where globalenglish_launcher.courseid = deleted.courseid)
insert into g_english_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,keycode
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,keycode
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-globalenglish_launcher', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1116, '8:c97b5654526671451980b50a89cdd847', 'enableAuditTable auditTableName=g_english_launcher_aud, tableName=globalenglish_launcher', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-safari_launcher::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_safari_launcher'
			)
			DROP TRIGGER i_safari_launcher
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_safari_launcher'
			)
			DROP TRIGGER u_safari_launcher
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_safari_launcher'
			)
			DROP TRIGGER d_safari_launcher
GO

CREATE TABLE safari_launcher_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_safari_launcher_aud_aud_datetime DEFAULT GETDATE() NOT NULL, courseid nvarchar(85), safari_host_url nvarchar(85), ui_code nvarchar(85), target_page nvarchar(85), target_page_param varchar(255), secret_code nvarchar(85), dummy_email_domain nvarchar(85), reset_flag nvarchar(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SAFARI_LAUNCHER_AUD PRIMARY KEY (aud_id))
GO

insert into safari_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,safari_host_url
 ,ui_code
 ,target_page
 ,target_page_param
 ,secret_code
 ,dummy_email_domain
 ,reset_flag
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,courseid
 ,safari_host_url
 ,ui_code
 ,target_page
 ,target_page_param
 ,secret_code
 ,dummy_email_domain
 ,reset_flag
 ,update_meaning
  from safari_launcher
GO

CREATE INDEX nuk_safari_launcher_aud_1 ON safari_launcher_aud(aud_userid)
GO

CREATE INDEX nuk_safari_launcher_aud_2 ON safari_launcher_aud(aud_datetime)
GO

create trigger i_safari_launcher on safari_launcher
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into safari_launcher (
courseid,safari_host_url,ui_code,target_page,target_page_param,secret_code,dummy_email_domain,reset_flag,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select courseid,safari_host_url,ui_code,target_page,target_page_param,secret_code,dummy_email_domain,reset_flag,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into safari_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,safari_host_url
 ,ui_code
 ,target_page
 ,target_page_param
 ,secret_code
 ,dummy_email_domain
 ,reset_flag
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,safari_host_url
 ,ui_code
 ,target_page
 ,target_page_param
 ,secret_code
 ,dummy_email_domain
 ,reset_flag
 ,update_meaning
  from inserted
end
GO

create trigger u_safari_launcher on safari_launcher
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update safari_launcher set
safari_launcher.courseid = inserted.courseid,safari_launcher.safari_host_url = inserted.safari_host_url,safari_launcher.ui_code = inserted.ui_code,safari_launcher.target_page = inserted.target_page,safari_launcher.target_page_param = inserted.target_page_param,safari_launcher.secret_code = inserted.secret_code,safari_launcher.dummy_email_domain = inserted.dummy_email_domain,safari_launcher.reset_flag = inserted.reset_flag,safari_launcher.update_meaning = inserted.update_meaning,safari_launcher.last_updated = inserted.last_updated,safari_launcher.updater_legal_name = inserted.updater_legal_name,safari_launcher.update_meaning_text = inserted.update_meaning_text,safari_launcher.last_updater_uid = inserted.last_updater_uid
from safari_launcher inner join deleted on safari_launcher.courseid = deleted.courseid inner join inserted on safari_launcher.courseid = inserted.courseid
insert into safari_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,safari_host_url
 ,ui_code
 ,target_page
 ,target_page_param
 ,secret_code
 ,dummy_email_domain
 ,reset_flag
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,safari_host_url
 ,ui_code
 ,target_page
 ,target_page_param
 ,secret_code
 ,dummy_email_domain
 ,reset_flag
 ,update_meaning
  from inserted
end
GO

create trigger d_safari_launcher on safari_launcher
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from safari_launcher where exists (
select 1 from deleted where safari_launcher.courseid = deleted.courseid)
insert into safari_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,courseid
 ,safari_host_url
 ,ui_code
 ,target_page
 ,target_page_param
 ,secret_code
 ,dummy_email_domain
 ,reset_flag
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,courseid
 ,safari_host_url
 ,ui_code
 ,target_page
 ,target_page_param
 ,secret_code
 ,dummy_email_domain
 ,reset_flag
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-safari_launcher', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1117, '8:2fca42ea4b51999a24643dd8149bed24', 'enableAuditTable auditTableName=safari_launcher_aud, tableName=safari_launcher', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-vc_launcher_generic::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_vc_launcher_generic'
			)
			DROP TRIGGER i_vc_launcher_generic
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_vc_launcher_generic'
			)
			DROP TRIGGER u_vc_launcher_generic
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_vc_launcher_generic'
			)
			DROP TRIGGER d_vc_launcher_generic
GO

CREATE TABLE vc_launcher_generic_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_vc_launcher_generic_aud_aud_datetime DEFAULT GETDATE() NOT NULL, course_id nvarchar(85), launch_url nvarchar(MAX), launch_program nvarchar(255), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_VC_LAUNCHER_GENERIC_AUD PRIMARY KEY (aud_id))
GO

insert into vc_launcher_generic_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,launch_url
 ,launch_program
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,course_id
 ,launch_url
 ,launch_program
 ,update_meaning
  from vc_launcher_generic
GO

CREATE INDEX nuk_vc_launcher_generic_aud_1 ON vc_launcher_generic_aud(aud_userid)
GO

CREATE INDEX nuk_vc_launcher_generic_aud_2 ON vc_launcher_generic_aud(aud_datetime)
GO

create trigger i_vc_launcher_generic on vc_launcher_generic
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into vc_launcher_generic (
course_id,launch_url,launch_program,update_meaning,last_updated,last_updater_uid,updater_legal_name,update_meaning_text) select course_id,launch_url,launch_program,update_meaning,last_updated,last_updater_uid,updater_legal_name,update_meaning_text from inserted
insert into vc_launcher_generic_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,launch_url
 ,launch_program
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,launch_url
 ,launch_program
 ,update_meaning
  from inserted
end
GO

create trigger u_vc_launcher_generic on vc_launcher_generic
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update vc_launcher_generic set
vc_launcher_generic.course_id = inserted.course_id,vc_launcher_generic.launch_url = inserted.launch_url,vc_launcher_generic.launch_program = inserted.launch_program,vc_launcher_generic.update_meaning = inserted.update_meaning,vc_launcher_generic.last_updated = inserted.last_updated,vc_launcher_generic.last_updater_uid = inserted.last_updater_uid,vc_launcher_generic.updater_legal_name = inserted.updater_legal_name,vc_launcher_generic.update_meaning_text = inserted.update_meaning_text
from vc_launcher_generic inner join deleted on vc_launcher_generic.course_id = deleted.course_id inner join inserted on vc_launcher_generic.course_id = inserted.course_id
insert into vc_launcher_generic_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,launch_url
 ,launch_program
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,launch_url
 ,launch_program
 ,update_meaning
  from inserted
end
GO

create trigger d_vc_launcher_generic on vc_launcher_generic
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from vc_launcher_generic where exists (
select 1 from deleted where vc_launcher_generic.course_id = deleted.course_id)
insert into vc_launcher_generic_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,launch_url
 ,launch_program
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,launch_url
 ,launch_program
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-vc_launcher_generic', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1118, '8:ffd82b84fda3d130bcd99b16f313fb50', 'enableAuditTable auditTableName=vc_launcher_generic_aud, tableName=vc_launcher_generic', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-vc_launcher_webex::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_vc_launcher_webex'
			)
			DROP TRIGGER i_vc_launcher_webex
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_vc_launcher_webex'
			)
			DROP TRIGGER u_vc_launcher_webex
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_vc_launcher_webex'
			)
			DROP TRIGGER d_vc_launcher_webex
GO

CREATE TABLE vc_launcher_webex_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_vc_launcher_webex_aud_aud_datetime DEFAULT GETDATE() NOT NULL, course_id nvarchar(85), webex_id nvarchar(85), meeting_key nvarchar(255), webex_host_id nvarchar(85), webex_host_pwd nvarchar(255), webex_attr1 nvarchar(85), webex_attr2 nvarchar(255), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_VC_LAUNCHER_WEBEX_AUD PRIMARY KEY (aud_id))
GO

insert into vc_launcher_webex_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,webex_id
 ,meeting_key
 ,webex_host_id
 ,webex_host_pwd
 ,webex_attr1
 ,webex_attr2
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,course_id
 ,webex_id
 ,meeting_key
 ,webex_host_id
 ,webex_host_pwd
 ,webex_attr1
 ,webex_attr2
 ,update_meaning
  from vc_launcher_webex
GO

CREATE INDEX nuk_vc_launcher_webex_aud_1 ON vc_launcher_webex_aud(aud_userid)
GO

CREATE INDEX nuk_vc_launcher_webex_aud_2 ON vc_launcher_webex_aud(aud_datetime)
GO

create trigger i_vc_launcher_webex on vc_launcher_webex
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into vc_launcher_webex (
course_id,webex_id,meeting_key,webex_host_id,webex_host_pwd,webex_attr1,webex_attr2,update_meaning,last_updated,last_updater_uid,updater_legal_name,update_meaning_text) select course_id,webex_id,meeting_key,webex_host_id,webex_host_pwd,webex_attr1,webex_attr2,update_meaning,last_updated,last_updater_uid,updater_legal_name,update_meaning_text from inserted
insert into vc_launcher_webex_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,webex_id
 ,meeting_key
 ,webex_host_id
 ,webex_host_pwd
 ,webex_attr1
 ,webex_attr2
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,webex_id
 ,meeting_key
 ,webex_host_id
 ,webex_host_pwd
 ,webex_attr1
 ,webex_attr2
 ,update_meaning
  from inserted
end
GO

create trigger u_vc_launcher_webex on vc_launcher_webex
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update vc_launcher_webex set
vc_launcher_webex.course_id = inserted.course_id,vc_launcher_webex.webex_id = inserted.webex_id,vc_launcher_webex.meeting_key = inserted.meeting_key,vc_launcher_webex.webex_host_id = inserted.webex_host_id,vc_launcher_webex.webex_host_pwd = inserted.webex_host_pwd,vc_launcher_webex.webex_attr1 = inserted.webex_attr1,vc_launcher_webex.webex_attr2 = inserted.webex_attr2,vc_launcher_webex.update_meaning = inserted.update_meaning,vc_launcher_webex.last_updated = inserted.last_updated,vc_launcher_webex.last_updater_uid = inserted.last_updater_uid,vc_launcher_webex.updater_legal_name = inserted.updater_legal_name,vc_launcher_webex.update_meaning_text = inserted.update_meaning_text
from vc_launcher_webex inner join deleted on vc_launcher_webex.course_id = deleted.course_id inner join inserted on vc_launcher_webex.course_id = inserted.course_id
insert into vc_launcher_webex_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,webex_id
 ,meeting_key
 ,webex_host_id
 ,webex_host_pwd
 ,webex_attr1
 ,webex_attr2
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,webex_id
 ,meeting_key
 ,webex_host_id
 ,webex_host_pwd
 ,webex_attr1
 ,webex_attr2
 ,update_meaning
  from inserted
end
GO

create trigger d_vc_launcher_webex on vc_launcher_webex
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from vc_launcher_webex where exists (
select 1 from deleted where vc_launcher_webex.course_id = deleted.course_id)
insert into vc_launcher_webex_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,webex_id
 ,meeting_key
 ,webex_host_id
 ,webex_host_pwd
 ,webex_attr1
 ,webex_attr2
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,webex_id
 ,meeting_key
 ,webex_host_id
 ,webex_host_pwd
 ,webex_attr1
 ,webex_attr2
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-vc_launcher_webex', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1119, '8:98b3e85ac6cbf5c17d445164ba7aba17', 'enableAuditTable auditTableName=vc_launcher_webex_aud, tableName=vc_launcher_webex', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-vc_launcher_session::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_vc_launcher_session'
			)
			DROP TRIGGER i_vc_launcher_session
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_vc_launcher_session'
			)
			DROP TRIGGER u_vc_launcher_session
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_vc_launcher_session'
			)
			DROP TRIGGER d_vc_launcher_session
GO

CREATE TABLE vc_launcher_session_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_vc_launcher_session_aud_aud_datetime DEFAULT GETDATE() NOT NULL, event_id nvarchar(15), course_id nvarchar(85), session_key nvarchar(255), instructor nvarchar(255), last_update datetime, overall_status int, mastery_score nvarchar(20), update_meaning nvarchar(8), overall_status_absent int, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_VC_LAUNCHER_SESSION_AUD PRIMARY KEY (aud_id))
GO

insert into vc_launcher_session_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,event_id
 ,course_id
 ,session_key
 ,instructor
 ,last_update
 ,overall_status
 ,mastery_score
 ,update_meaning
 ,overall_status_absent
) select 'U', null
, null
, GETDATE(), null
, null
 ,event_id
 ,course_id
 ,session_key
 ,instructor
 ,last_update
 ,overall_status
 ,mastery_score
 ,update_meaning
 ,overall_status_absent
  from vc_launcher_session
GO

CREATE INDEX nuk_vc_launcher_session_aud_1 ON vc_launcher_session_aud(aud_userid)
GO

CREATE INDEX nuk_vc_launcher_session_aud_2 ON vc_launcher_session_aud(aud_datetime)
GO

create trigger i_vc_launcher_session on vc_launcher_session
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into vc_launcher_session (
event_id,course_id,session_key,instructor,last_update,overall_status,mastery_score,update_meaning,last_updated,last_updater_uid,updater_legal_name,update_meaning_text,overall_status_absent) select event_id,course_id,session_key,instructor,last_update,overall_status,mastery_score,update_meaning,last_updated,last_updater_uid,updater_legal_name,update_meaning_text,overall_status_absent from inserted
insert into vc_launcher_session_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,event_id
 ,course_id
 ,session_key
 ,instructor
 ,last_update
 ,overall_status
 ,mastery_score
 ,update_meaning
 ,overall_status_absent
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,event_id
 ,course_id
 ,session_key
 ,instructor
 ,last_update
 ,overall_status
 ,mastery_score
 ,update_meaning
 ,overall_status_absent
  from inserted
end
GO

create trigger u_vc_launcher_session on vc_launcher_session
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update vc_launcher_session set
vc_launcher_session.event_id = inserted.event_id,vc_launcher_session.course_id = inserted.course_id,vc_launcher_session.session_key = inserted.session_key,vc_launcher_session.instructor = inserted.instructor,vc_launcher_session.last_update = inserted.last_update,vc_launcher_session.overall_status = inserted.overall_status,vc_launcher_session.mastery_score = inserted.mastery_score,vc_launcher_session.update_meaning = inserted.update_meaning,vc_launcher_session.last_updated = inserted.last_updated,vc_launcher_session.last_updater_uid = inserted.last_updater_uid,vc_launcher_session.updater_legal_name = inserted.updater_legal_name,vc_launcher_session.update_meaning_text = inserted.update_meaning_text,vc_launcher_session.overall_status_absent = inserted.overall_status_absent
from vc_launcher_session inner join deleted on vc_launcher_session.event_id = deleted.event_id inner join inserted on vc_launcher_session.event_id = inserted.event_id
insert into vc_launcher_session_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,event_id
 ,course_id
 ,session_key
 ,instructor
 ,last_update
 ,overall_status
 ,mastery_score
 ,update_meaning
 ,overall_status_absent
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,event_id
 ,course_id
 ,session_key
 ,instructor
 ,last_update
 ,overall_status
 ,mastery_score
 ,update_meaning
 ,overall_status_absent
  from inserted
end
GO

create trigger d_vc_launcher_session on vc_launcher_session
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from vc_launcher_session where exists (
select 1 from deleted where vc_launcher_session.event_id = deleted.event_id)
insert into vc_launcher_session_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,event_id
 ,course_id
 ,session_key
 ,instructor
 ,last_update
 ,overall_status
 ,mastery_score
 ,update_meaning
 ,overall_status_absent
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,event_id
 ,course_id
 ,session_key
 ,instructor
 ,last_update
 ,overall_status
 ,mastery_score
 ,update_meaning
 ,overall_status_absent
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-vc_launcher_session', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1120, '8:d37262f52ace5ba68894c111b0815cd9', 'enableAuditTable auditTableName=vc_launcher_session_aud, tableName=vc_launcher_session', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-content_org_node_objective::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_content_org_node_objective'
			)
			DROP TRIGGER i_content_org_node_objective
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_content_org_node_objective'
			)
			DROP TRIGGER u_content_org_node_objective
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_content_org_node_objective'
			)
			DROP TRIGGER d_content_org_node_objective
GO

CREATE TABLE content_org_node_obj_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_content_org_node_obj_aud_aud_datetime DEFAULT GETDATE() NOT NULL, organization_id nvarchar(15), node_id nvarchar(2000), ordinal int, objective_id nvarchar(2000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CONTENT_ORG_NODE_OBJ_AUD PRIMARY KEY (aud_id))
GO

insert into content_org_node_obj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,organization_id
 ,node_id
 ,ordinal
 ,objective_id
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,organization_id
 ,node_id
 ,ordinal
 ,objective_id
 ,update_meaning
  from content_org_node_objective
GO

CREATE INDEX nuk_content_org_node_obj_aud_1 ON content_org_node_obj_aud(aud_userid)
GO

CREATE INDEX nuk_content_org_node_obj_aud_2 ON content_org_node_obj_aud(aud_datetime)
GO

create trigger i_content_org_node_objective on content_org_node_objective
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into content_org_node_objective (
organization_id,node_id,ordinal,objective_id,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select organization_id,node_id,ordinal,objective_id,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into content_org_node_obj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,organization_id
 ,node_id
 ,ordinal
 ,objective_id
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,organization_id
 ,node_id
 ,ordinal
 ,objective_id
 ,update_meaning
  from inserted
end
GO

create trigger u_content_org_node_objective on content_org_node_objective
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update content_org_node_objective set
content_org_node_objective.organization_id = inserted.organization_id,content_org_node_objective.node_id = inserted.node_id,content_org_node_objective.ordinal = inserted.ordinal,content_org_node_objective.objective_id = inserted.objective_id,content_org_node_objective.update_meaning = inserted.update_meaning,content_org_node_objective.last_updated = inserted.last_updated,content_org_node_objective.updater_legal_name = inserted.updater_legal_name,content_org_node_objective.update_meaning_text = inserted.update_meaning_text,content_org_node_objective.last_updater_uid = inserted.last_updater_uid
from content_org_node_objective inner join deleted on content_org_node_objective.organization_id = deleted.organization_id and content_org_node_objective.node_id = deleted.node_id and content_org_node_objective.ordinal = deleted.ordinal inner join inserted on content_org_node_objective.organization_id = inserted.organization_id and content_org_node_objective.node_id = inserted.node_id and content_org_node_objective.ordinal = inserted.ordinal
insert into content_org_node_obj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,organization_id
 ,node_id
 ,ordinal
 ,objective_id
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,organization_id
 ,node_id
 ,ordinal
 ,objective_id
 ,update_meaning
  from inserted
end
GO

create trigger d_content_org_node_objective on content_org_node_objective
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from content_org_node_objective where exists (
select 1 from deleted where content_org_node_objective.organization_id = deleted.organization_id and content_org_node_objective.node_id = deleted.node_id and content_org_node_objective.ordinal = deleted.ordinal)
insert into content_org_node_obj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,organization_id
 ,node_id
 ,ordinal
 ,objective_id
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,organization_id
 ,node_id
 ,ordinal
 ,objective_id
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-content_org_node_objective', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1121, '8:02056ceedaec5f0aebafaa6106f089bd', 'enableAuditTable auditTableName=content_org_node_obj_aud, tableName=content_org_node_objective', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-course_revision::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_course_revision'
			)
			DROP TRIGGER i_course_revision
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_course_revision'
			)
			DROP TRIGGER u_course_revision
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_course_revision'
			)
			DROP TRIGGER d_course_revision
GO

CREATE TABLE course_revision_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_course_revision_aud_aud_datetime DEFAULT GETDATE() NOT NULL, course_id nvarchar(85), revision_number int, date_revised datetime, launch_interface smallint, organization_id nvarchar(15), item_id nvarchar(15), encoding nvarchar(25), revision_comment nvarchar(MAX), allow_download char(1), publish_for char(1), update_meaning nvarchar(8), available char(1), course_raw_byte_size int, date_effective datetime, date_approved datetime, bundle_id nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSE_REVISION_AUD PRIMARY KEY (aud_id))
GO

insert into course_revision_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,revision_number
 ,date_revised
 ,launch_interface
 ,organization_id
 ,item_id
 ,encoding
 ,revision_comment
 ,allow_download
 ,publish_for
 ,update_meaning
 ,available
 ,course_raw_byte_size
 ,date_effective
 ,date_approved
 ,bundle_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,course_id
 ,revision_number
 ,date_revised
 ,launch_interface
 ,organization_id
 ,item_id
 ,encoding
 ,revision_comment
 ,allow_download
 ,publish_for
 ,update_meaning
 ,available
 ,course_raw_byte_size
 ,date_effective
 ,date_approved
 ,bundle_id
  from course_revision
GO

CREATE INDEX nuk_course_revision_aud_1 ON course_revision_aud(aud_userid)
GO

CREATE INDEX nuk_course_revision_aud_2 ON course_revision_aud(aud_datetime)
GO

create trigger i_course_revision on course_revision
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into course_revision (
course_id,revision_number,date_revised,launch_interface,organization_id,item_id,encoding,revision_comment,allow_download,publish_for,update_meaning,last_updated,last_updater_uid,updater_legal_name,update_meaning_text,available,course_raw_byte_size,date_effective,date_approved,bundle_id) select course_id,revision_number,date_revised,launch_interface,organization_id,item_id,encoding,revision_comment,allow_download,publish_for,update_meaning,last_updated,last_updater_uid,updater_legal_name,update_meaning_text,available,course_raw_byte_size,date_effective,date_approved,bundle_id from inserted
insert into course_revision_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,revision_number
 ,date_revised
 ,launch_interface
 ,organization_id
 ,item_id
 ,encoding
 ,revision_comment
 ,allow_download
 ,publish_for
 ,update_meaning
 ,available
 ,course_raw_byte_size
 ,date_effective
 ,date_approved
 ,bundle_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,revision_number
 ,date_revised
 ,launch_interface
 ,organization_id
 ,item_id
 ,encoding
 ,revision_comment
 ,allow_download
 ,publish_for
 ,update_meaning
 ,available
 ,course_raw_byte_size
 ,date_effective
 ,date_approved
 ,bundle_id
  from inserted
end
GO

create trigger u_course_revision on course_revision
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update course_revision set
course_revision.course_id = inserted.course_id,course_revision.revision_number = inserted.revision_number,course_revision.date_revised = inserted.date_revised,course_revision.launch_interface = inserted.launch_interface,course_revision.organization_id = inserted.organization_id,course_revision.item_id = inserted.item_id,course_revision.encoding = inserted.encoding,course_revision.revision_comment = inserted.revision_comment,course_revision.allow_download = inserted.allow_download,course_revision.publish_for = inserted.publish_for,course_revision.update_meaning = inserted.update_meaning,course_revision.last_updated = inserted.last_updated,course_revision.last_updater_uid = inserted.last_updater_uid,course_revision.updater_legal_name = inserted.updater_legal_name,course_revision.update_meaning_text = inserted.update_meaning_text,course_revision.available = inserted.available,course_revision.course_raw_byte_size = inserted.course_raw_byte_size,course_revision.date_effective = inserted.date_effective,course_revision.date_approved = inserted.date_approved,course_revision.bundle_id = inserted.bundle_id
from course_revision inner join deleted on course_revision.course_id = deleted.course_id and course_revision.revision_number = deleted.revision_number and course_revision.bundle_id = deleted.bundle_id inner join inserted on course_revision.course_id = inserted.course_id and course_revision.revision_number = inserted.revision_number and course_revision.bundle_id = inserted.bundle_id
insert into course_revision_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,revision_number
 ,date_revised
 ,launch_interface
 ,organization_id
 ,item_id
 ,encoding
 ,revision_comment
 ,allow_download
 ,publish_for
 ,update_meaning
 ,available
 ,course_raw_byte_size
 ,date_effective
 ,date_approved
 ,bundle_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,revision_number
 ,date_revised
 ,launch_interface
 ,organization_id
 ,item_id
 ,encoding
 ,revision_comment
 ,allow_download
 ,publish_for
 ,update_meaning
 ,available
 ,course_raw_byte_size
 ,date_effective
 ,date_approved
 ,bundle_id
  from inserted
end
GO

create trigger d_course_revision on course_revision
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from course_revision where exists (
select 1 from deleted where course_revision.course_id = deleted.course_id and course_revision.revision_number = deleted.revision_number and course_revision.bundle_id = deleted.bundle_id)
insert into course_revision_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,revision_number
 ,date_revised
 ,launch_interface
 ,organization_id
 ,item_id
 ,encoding
 ,revision_comment
 ,allow_download
 ,publish_for
 ,update_meaning
 ,available
 ,course_raw_byte_size
 ,date_effective
 ,date_approved
 ,bundle_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,revision_number
 ,date_revised
 ,launch_interface
 ,organization_id
 ,item_id
 ,encoding
 ,revision_comment
 ,allow_download
 ,publish_for
 ,update_meaning
 ,available
 ,course_raw_byte_size
 ,date_effective
 ,date_approved
 ,bundle_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-course_revision', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1122, '8:6a3d54811ad7f3f94afcf09c10dad15c', 'enableAuditTable auditTableName=course_revision_aud, tableName=course_revision', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-ex_q_approval::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_ex_q_approval'
			)
			DROP TRIGGER i_ex_q_approval
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_ex_q_approval'
			)
			DROP TRIGGER u_ex_q_approval
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_ex_q_approval'
			)
			DROP TRIGGER d_ex_q_approval
GO

CREATE TABLE ex_q_approval_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_ex_q_approval_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), question_id nvarchar(85), user_id nvarchar(85), app_comment nvarchar(500), comment_date datetime, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_EX_Q_APPROVAL_AUD PRIMARY KEY (aud_id))
GO

insert into ex_q_approval_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,question_id
 ,user_id
 ,app_comment
 ,comment_date
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,question_id
 ,user_id
 ,app_comment
 ,comment_date
 ,update_meaning
  from ex_q_approval
GO

CREATE INDEX nuk_ex_q_approval_aud_1 ON ex_q_approval_aud(aud_userid)
GO

CREATE INDEX nuk_ex_q_approval_aud_2 ON ex_q_approval_aud(aud_datetime)
GO

create trigger i_ex_q_approval on ex_q_approval
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into ex_q_approval (
id,question_id,user_id,app_comment,comment_date,update_meaning,last_updated,last_updater_uid,updater_legal_name,update_meaning_text) select id,question_id,user_id,app_comment,comment_date,update_meaning,last_updated,last_updater_uid,updater_legal_name,update_meaning_text from inserted
insert into ex_q_approval_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,question_id
 ,user_id
 ,app_comment
 ,comment_date
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,question_id
 ,user_id
 ,app_comment
 ,comment_date
 ,update_meaning
  from inserted
end
GO

create trigger u_ex_q_approval on ex_q_approval
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update ex_q_approval set
ex_q_approval.id = inserted.id,ex_q_approval.question_id = inserted.question_id,ex_q_approval.user_id = inserted.user_id,ex_q_approval.app_comment = inserted.app_comment,ex_q_approval.comment_date = inserted.comment_date,ex_q_approval.update_meaning = inserted.update_meaning,ex_q_approval.last_updated = inserted.last_updated,ex_q_approval.last_updater_uid = inserted.last_updater_uid,ex_q_approval.updater_legal_name = inserted.updater_legal_name,ex_q_approval.update_meaning_text = inserted.update_meaning_text
from ex_q_approval inner join deleted on ex_q_approval.id = deleted.id inner join inserted on ex_q_approval.id = inserted.id
insert into ex_q_approval_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,question_id
 ,user_id
 ,app_comment
 ,comment_date
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,question_id
 ,user_id
 ,app_comment
 ,comment_date
 ,update_meaning
  from inserted
end
GO

create trigger d_ex_q_approval on ex_q_approval
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from ex_q_approval where exists (
select 1 from deleted where ex_q_approval.id = deleted.id)
insert into ex_q_approval_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,question_id
 ,user_id
 ,app_comment
 ,comment_date
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,question_id
 ,user_id
 ,app_comment
 ,comment_date
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-ex_q_approval', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1123, '8:b5d03545d91455e2c268dc070a11ff48', 'enableAuditTable auditTableName=ex_q_approval_aud, tableName=ex_q_approval', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-payment::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_payment'
			)
			DROP TRIGGER i_payment
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_payment'
			)
			DROP TRIGGER u_payment
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_payment'
			)
			DROP TRIGGER d_payment
GO

CREATE TABLE payment_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_payment_aud_aud_datetime DEFAULT GETDATE() NOT NULL, payment_id int, create_date datetime, pay_user_id nvarchar(85), ccy_code char(3), total_amount numeric(15, 2), tax numeric(15, 2), status char(1), settled_date datetime, order_ref nvarchar(50), pay_ref nvarchar(50), order_fulfilled char(1), refunded_date datetime, additional_charge nvarchar(85), is_reviewed char(1), reviewed_by nvarchar(85), reviewed_on datetime, user_ref nvarchar(85), pay_type char(3), sales_order_no nvarchar(85), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_PAYMENT_AUD PRIMARY KEY (aud_id))
GO

insert into payment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,payment_id
 ,create_date
 ,pay_user_id
 ,ccy_code
 ,total_amount
 ,tax
 ,status
 ,settled_date
 ,order_ref
 ,pay_ref
 ,order_fulfilled
 ,refunded_date
 ,additional_charge
 ,is_reviewed
 ,reviewed_by
 ,reviewed_on
 ,user_ref
 ,pay_type
 ,sales_order_no
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,payment_id
 ,create_date
 ,pay_user_id
 ,ccy_code
 ,total_amount
 ,tax
 ,status
 ,settled_date
 ,order_ref
 ,pay_ref
 ,order_fulfilled
 ,refunded_date
 ,additional_charge
 ,is_reviewed
 ,reviewed_by
 ,reviewed_on
 ,user_ref
 ,pay_type
 ,sales_order_no
 ,update_meaning
  from payment
GO

CREATE INDEX nuk_payment_aud_1 ON payment_aud(aud_userid)
GO

CREATE INDEX nuk_payment_aud_2 ON payment_aud(aud_datetime)
GO

create trigger i_payment on payment
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into payment (
payment_id,create_date,pay_user_id,ccy_code,total_amount,tax,status,settled_date,order_ref,pay_ref,order_fulfilled,refunded_date,additional_charge,is_reviewed,reviewed_by,reviewed_on,user_ref,pay_type,sales_order_no,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select payment_id,create_date,pay_user_id,ccy_code,total_amount,tax,status,settled_date,order_ref,pay_ref,order_fulfilled,refunded_date,additional_charge,is_reviewed,reviewed_by,reviewed_on,user_ref,pay_type,sales_order_no,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into payment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,payment_id
 ,create_date
 ,pay_user_id
 ,ccy_code
 ,total_amount
 ,tax
 ,status
 ,settled_date
 ,order_ref
 ,pay_ref
 ,order_fulfilled
 ,refunded_date
 ,additional_charge
 ,is_reviewed
 ,reviewed_by
 ,reviewed_on
 ,user_ref
 ,pay_type
 ,sales_order_no
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,payment_id
 ,create_date
 ,pay_user_id
 ,ccy_code
 ,total_amount
 ,tax
 ,status
 ,settled_date
 ,order_ref
 ,pay_ref
 ,order_fulfilled
 ,refunded_date
 ,additional_charge
 ,is_reviewed
 ,reviewed_by
 ,reviewed_on
 ,user_ref
 ,pay_type
 ,sales_order_no
 ,update_meaning
  from inserted
end
GO

create trigger u_payment on payment
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update payment set
payment.payment_id = inserted.payment_id,payment.create_date = inserted.create_date,payment.pay_user_id = inserted.pay_user_id,payment.ccy_code = inserted.ccy_code,payment.total_amount = inserted.total_amount,payment.tax = inserted.tax,payment.status = inserted.status,payment.settled_date = inserted.settled_date,payment.order_ref = inserted.order_ref,payment.pay_ref = inserted.pay_ref,payment.order_fulfilled = inserted.order_fulfilled,payment.refunded_date = inserted.refunded_date,payment.additional_charge = inserted.additional_charge,payment.is_reviewed = inserted.is_reviewed,payment.reviewed_by = inserted.reviewed_by,payment.reviewed_on = inserted.reviewed_on,payment.user_ref = inserted.user_ref,payment.pay_type = inserted.pay_type,payment.sales_order_no = inserted.sales_order_no,payment.update_meaning = inserted.update_meaning,payment.last_updated = inserted.last_updated,payment.updater_legal_name = inserted.updater_legal_name,payment.update_meaning_text = inserted.update_meaning_text,payment.last_updater_uid = inserted.last_updater_uid
from payment inner join deleted on payment.payment_id = deleted.payment_id inner join inserted on payment.payment_id = inserted.payment_id
insert into payment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,payment_id
 ,create_date
 ,pay_user_id
 ,ccy_code
 ,total_amount
 ,tax
 ,status
 ,settled_date
 ,order_ref
 ,pay_ref
 ,order_fulfilled
 ,refunded_date
 ,additional_charge
 ,is_reviewed
 ,reviewed_by
 ,reviewed_on
 ,user_ref
 ,pay_type
 ,sales_order_no
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,payment_id
 ,create_date
 ,pay_user_id
 ,ccy_code
 ,total_amount
 ,tax
 ,status
 ,settled_date
 ,order_ref
 ,pay_ref
 ,order_fulfilled
 ,refunded_date
 ,additional_charge
 ,is_reviewed
 ,reviewed_by
 ,reviewed_on
 ,user_ref
 ,pay_type
 ,sales_order_no
 ,update_meaning
  from inserted
end
GO

create trigger d_payment on payment
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from payment where exists (
select 1 from deleted where payment.payment_id = deleted.payment_id)
insert into payment_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,payment_id
 ,create_date
 ,pay_user_id
 ,ccy_code
 ,total_amount
 ,tax
 ,status
 ,settled_date
 ,order_ref
 ,pay_ref
 ,order_fulfilled
 ,refunded_date
 ,additional_charge
 ,is_reviewed
 ,reviewed_by
 ,reviewed_on
 ,user_ref
 ,pay_type
 ,sales_order_no
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,payment_id
 ,create_date
 ,pay_user_id
 ,ccy_code
 ,total_amount
 ,tax
 ,status
 ,settled_date
 ,order_ref
 ,pay_ref
 ,order_fulfilled
 ,refunded_date
 ,additional_charge
 ,is_reviewed
 ,reviewed_by
 ,reviewed_on
 ,user_ref
 ,pay_type
 ,sales_order_no
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-payment', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1124, '8:650976489db39d043a072e6270c90db0', 'enableAuditTable auditTableName=payment_aud, tableName=payment', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-lo_opt_pay_items::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_lo_opt_pay_items'
			)
			DROP TRIGGER i_lo_opt_pay_items
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_lo_opt_pay_items'
			)
			DROP TRIGGER u_lo_opt_pay_items
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_lo_opt_pay_items'
			)
			DROP TRIGGER d_lo_opt_pay_items
GO

CREATE TABLE lo_opt_pay_items_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_lo_opt_pay_items_aud_aud_datetime DEFAULT GETDATE() NOT NULL, sessionid nvarchar(85), learningid nvarchar(85), itemid nvarchar(15), offering int, offering_amount numeric(15, 2), payment_method char(1), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_LO_OPT_PAY_ITEMS_AUD PRIMARY KEY (aud_id))
GO

insert into lo_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sessionid
 ,learningid
 ,itemid
 ,offering
 ,offering_amount
 ,payment_method
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,sessionid
 ,learningid
 ,itemid
 ,offering
 ,offering_amount
 ,payment_method
 ,update_meaning
  from lo_opt_pay_items
GO

CREATE INDEX nuk_lo_opt_pay_items_aud_1 ON lo_opt_pay_items_aud(aud_userid)
GO

CREATE INDEX nuk_lo_opt_pay_items_aud_2 ON lo_opt_pay_items_aud(aud_datetime)
GO

create trigger i_lo_opt_pay_items on lo_opt_pay_items
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into lo_opt_pay_items (
sessionid,learningid,itemid,offering,offering_amount,payment_method,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select sessionid,learningid,itemid,offering,offering_amount,payment_method,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into lo_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sessionid
 ,learningid
 ,itemid
 ,offering
 ,offering_amount
 ,payment_method
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,sessionid
 ,learningid
 ,itemid
 ,offering
 ,offering_amount
 ,payment_method
 ,update_meaning
  from inserted
end
GO

create trigger u_lo_opt_pay_items on lo_opt_pay_items
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update lo_opt_pay_items set
lo_opt_pay_items.sessionid = inserted.sessionid,lo_opt_pay_items.learningid = inserted.learningid,lo_opt_pay_items.itemid = inserted.itemid,lo_opt_pay_items.offering = inserted.offering,lo_opt_pay_items.offering_amount = inserted.offering_amount,lo_opt_pay_items.payment_method = inserted.payment_method,lo_opt_pay_items.update_meaning = inserted.update_meaning,lo_opt_pay_items.last_updated = inserted.last_updated,lo_opt_pay_items.updater_legal_name = inserted.updater_legal_name,lo_opt_pay_items.update_meaning_text = inserted.update_meaning_text,lo_opt_pay_items.last_updater_uid = inserted.last_updater_uid
from lo_opt_pay_items inner join deleted on lo_opt_pay_items.sessionid = deleted.sessionid and lo_opt_pay_items.learningid = deleted.learningid and lo_opt_pay_items.itemid = deleted.itemid and lo_opt_pay_items.payment_method = deleted.payment_method inner join inserted on lo_opt_pay_items.sessionid = inserted.sessionid and lo_opt_pay_items.learningid = inserted.learningid and lo_opt_pay_items.itemid = inserted.itemid and lo_opt_pay_items.payment_method = inserted.payment_method
insert into lo_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sessionid
 ,learningid
 ,itemid
 ,offering
 ,offering_amount
 ,payment_method
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,sessionid
 ,learningid
 ,itemid
 ,offering
 ,offering_amount
 ,payment_method
 ,update_meaning
  from inserted
end
GO

create trigger d_lo_opt_pay_items on lo_opt_pay_items
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from lo_opt_pay_items where exists (
select 1 from deleted where lo_opt_pay_items.sessionid = deleted.sessionid and lo_opt_pay_items.learningid = deleted.learningid and lo_opt_pay_items.itemid = deleted.itemid and lo_opt_pay_items.payment_method = deleted.payment_method)
insert into lo_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,sessionid
 ,learningid
 ,itemid
 ,offering
 ,offering_amount
 ,payment_method
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,sessionid
 ,learningid
 ,itemid
 ,offering
 ,offering_amount
 ,payment_method
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-lo_opt_pay_items', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1125, '8:8bbf9e2c62b62a20427fc85eb5bef7bd', 'enableAuditTable auditTableName=lo_opt_pay_items_aud, tableName=lo_opt_pay_items', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-user_opt_pay_items::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_user_opt_pay_items'
			)
			DROP TRIGGER i_user_opt_pay_items
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_user_opt_pay_items'
			)
			DROP TRIGGER u_user_opt_pay_items
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_user_opt_pay_items'
			)
			DROP TRIGGER d_user_opt_pay_items
GO

CREATE TABLE user_opt_pay_items_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_user_opt_pay_items_aud_aud_datetime DEFAULT GETDATE() NOT NULL, user_itemid nvarchar(85), userid nvarchar(85), transcriptid nvarchar(15), itemid nvarchar(15), description nvarchar(255), quantity int, unit_cost numeric(15, 2), paid char(1), paymentid int, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_USER_OPT_PAY_ITEMS_AUD PRIMARY KEY (aud_id))
GO

insert into user_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_itemid
 ,userid
 ,transcriptid
 ,itemid
 ,description
 ,quantity
 ,unit_cost
 ,paid
 ,paymentid
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,user_itemid
 ,userid
 ,transcriptid
 ,itemid
 ,description
 ,quantity
 ,unit_cost
 ,paid
 ,paymentid
 ,update_meaning
  from user_opt_pay_items
GO

CREATE INDEX nuk_user_opt_pay_items_aud_1 ON user_opt_pay_items_aud(aud_userid)
GO

CREATE INDEX nuk_user_opt_pay_items_aud_2 ON user_opt_pay_items_aud(aud_datetime)
GO

create trigger i_user_opt_pay_items on user_opt_pay_items
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into user_opt_pay_items (
user_itemid,userid,transcriptid,itemid,description,quantity,unit_cost,paid,paymentid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select user_itemid,userid,transcriptid,itemid,description,quantity,unit_cost,paid,paymentid,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into user_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_itemid
 ,userid
 ,transcriptid
 ,itemid
 ,description
 ,quantity
 ,unit_cost
 ,paid
 ,paymentid
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,user_itemid
 ,userid
 ,transcriptid
 ,itemid
 ,description
 ,quantity
 ,unit_cost
 ,paid
 ,paymentid
 ,update_meaning
  from inserted
end
GO

create trigger u_user_opt_pay_items on user_opt_pay_items
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update user_opt_pay_items set
user_opt_pay_items.user_itemid = inserted.user_itemid,user_opt_pay_items.userid = inserted.userid,user_opt_pay_items.transcriptid = inserted.transcriptid,user_opt_pay_items.itemid = inserted.itemid,user_opt_pay_items.description = inserted.description,user_opt_pay_items.quantity = inserted.quantity,user_opt_pay_items.unit_cost = inserted.unit_cost,user_opt_pay_items.paid = inserted.paid,user_opt_pay_items.paymentid = inserted.paymentid,user_opt_pay_items.update_meaning = inserted.update_meaning,user_opt_pay_items.last_updated = inserted.last_updated,user_opt_pay_items.updater_legal_name = inserted.updater_legal_name,user_opt_pay_items.update_meaning_text = inserted.update_meaning_text,user_opt_pay_items.last_updater_uid = inserted.last_updater_uid
from user_opt_pay_items inner join deleted on user_opt_pay_items.user_itemid = deleted.user_itemid inner join inserted on user_opt_pay_items.user_itemid = inserted.user_itemid
insert into user_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_itemid
 ,userid
 ,transcriptid
 ,itemid
 ,description
 ,quantity
 ,unit_cost
 ,paid
 ,paymentid
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,user_itemid
 ,userid
 ,transcriptid
 ,itemid
 ,description
 ,quantity
 ,unit_cost
 ,paid
 ,paymentid
 ,update_meaning
  from inserted
end
GO

create trigger d_user_opt_pay_items on user_opt_pay_items
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from user_opt_pay_items where exists (
select 1 from deleted where user_opt_pay_items.user_itemid = deleted.user_itemid)
insert into user_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_itemid
 ,userid
 ,transcriptid
 ,itemid
 ,description
 ,quantity
 ,unit_cost
 ,paid
 ,paymentid
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,user_itemid
 ,userid
 ,transcriptid
 ,itemid
 ,description
 ,quantity
 ,unit_cost
 ,paid
 ,paymentid
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-user_opt_pay_items', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1126, '8:b639e3af995ab44ff7ada299e5e2175e', 'enableAuditTable auditTableName=user_opt_pay_items_aud, tableName=user_opt_pay_items', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type_drag_and_drop::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type_drag_and_drop'
			)
			DROP TRIGGER i_question_type_drag_and_drop
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type_drag_and_drop'
			)
			DROP TRIGGER u_question_type_drag_and_drop
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type_drag_and_drop'
			)
			DROP TRIGGER d_question_type_drag_and_drop
GO

CREATE TABLE q_type_drag_and_drop_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_q_type_drag_and_drop_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes int, qtext nvarchar(MAX), hint nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), num_draggable int, background_url nvarchar(255), background_width int, background_height int, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_Q_TYPE_DRAG_AND_DROP_AUD PRIMARY KEY (aud_id))
GO

insert into q_type_drag_and_drop_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_draggable
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_draggable
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
  from question_type_drag_and_drop
GO

CREATE INDEX nuk_q_type_drag_and_drop_aud_1 ON q_type_drag_and_drop_aud(aud_userid)
GO

CREATE INDEX nuk_q_type_drag_and_drop_aud_2 ON q_type_drag_and_drop_aud(aud_datetime)
GO

create trigger i_question_type_drag_and_drop on question_type_drag_and_drop
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type_drag_and_drop (
questionid,qattributes,qtext,hint,prenote,postnote,num_draggable,background_url,background_width,background_height,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,qattributes,qtext,hint,prenote,postnote,num_draggable,background_url,background_width,background_height,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into q_type_drag_and_drop_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_draggable
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_draggable
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
  from inserted
end
GO

create trigger u_question_type_drag_and_drop on question_type_drag_and_drop
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type_drag_and_drop set
question_type_drag_and_drop.questionid = inserted.questionid,question_type_drag_and_drop.qattributes = inserted.qattributes,question_type_drag_and_drop.qtext = inserted.qtext,question_type_drag_and_drop.hint = inserted.hint,question_type_drag_and_drop.prenote = inserted.prenote,question_type_drag_and_drop.postnote = inserted.postnote,question_type_drag_and_drop.num_draggable = inserted.num_draggable,question_type_drag_and_drop.background_url = inserted.background_url,question_type_drag_and_drop.background_width = inserted.background_width,question_type_drag_and_drop.background_height = inserted.background_height,question_type_drag_and_drop.update_meaning = inserted.update_meaning,question_type_drag_and_drop.last_updated = inserted.last_updated,question_type_drag_and_drop.updater_legal_name = inserted.updater_legal_name,question_type_drag_and_drop.update_meaning_text = inserted.update_meaning_text,question_type_drag_and_drop.last_updater_uid = inserted.last_updater_uid
from question_type_drag_and_drop inner join deleted on question_type_drag_and_drop.questionid = deleted.questionid inner join inserted on question_type_drag_and_drop.questionid = inserted.questionid
insert into q_type_drag_and_drop_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_draggable
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_draggable
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
  from inserted
end
GO

create trigger d_question_type_drag_and_drop on question_type_drag_and_drop
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type_drag_and_drop where exists (
select 1 from deleted where question_type_drag_and_drop.questionid = deleted.questionid)
insert into q_type_drag_and_drop_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_draggable
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_draggable
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type_drag_and_drop', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1127, '8:3524db1948474c5c0dbfa80a5e8911d1', 'enableAuditTable auditTableName=q_type_drag_and_drop_aud, tableName=question_type_drag_and_drop', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-draggable::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_draggable'
			)
			DROP TRIGGER i_draggable
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_draggable'
			)
			DROP TRIGGER u_draggable
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_draggable'
			)
			DROP TRIGGER d_draggable
GO

CREATE TABLE draggable_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_draggable_aud_aud_datetime DEFAULT GETDATE() NOT NULL, draggable_id nvarchar(15), questionid nvarchar(85), display_order int, image_url nvarchar(255), image_width int, image_height int, hot_area_x int, hot_area_y int, hot_area_width int, hot_area_height int, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_DRAGGABLE_AUD PRIMARY KEY (aud_id))
GO

insert into draggable_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,draggable_id
 ,questionid
 ,display_order
 ,image_url
 ,image_width
 ,image_height
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,draggable_id
 ,questionid
 ,display_order
 ,image_url
 ,image_width
 ,image_height
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
  from draggable
GO

CREATE INDEX nuk_draggable_aud_1 ON draggable_aud(aud_userid)
GO

CREATE INDEX nuk_draggable_aud_2 ON draggable_aud(aud_datetime)
GO

create trigger i_draggable on draggable
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into draggable (
draggable_id,questionid,display_order,image_url,image_width,image_height,hot_area_x,hot_area_y,hot_area_width,hot_area_height,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select draggable_id,questionid,display_order,image_url,image_width,image_height,hot_area_x,hot_area_y,hot_area_width,hot_area_height,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into draggable_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,draggable_id
 ,questionid
 ,display_order
 ,image_url
 ,image_width
 ,image_height
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,draggable_id
 ,questionid
 ,display_order
 ,image_url
 ,image_width
 ,image_height
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
  from inserted
end
GO

create trigger u_draggable on draggable
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update draggable set
draggable.draggable_id = inserted.draggable_id,draggable.questionid = inserted.questionid,draggable.display_order = inserted.display_order,draggable.image_url = inserted.image_url,draggable.image_width = inserted.image_width,draggable.image_height = inserted.image_height,draggable.hot_area_x = inserted.hot_area_x,draggable.hot_area_y = inserted.hot_area_y,draggable.hot_area_width = inserted.hot_area_width,draggable.hot_area_height = inserted.hot_area_height,draggable.update_meaning = inserted.update_meaning,draggable.last_updated = inserted.last_updated,draggable.updater_legal_name = inserted.updater_legal_name,draggable.update_meaning_text = inserted.update_meaning_text,draggable.last_updater_uid = inserted.last_updater_uid
from draggable inner join deleted on draggable.draggable_id = deleted.draggable_id inner join inserted on draggable.draggable_id = inserted.draggable_id
insert into draggable_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,draggable_id
 ,questionid
 ,display_order
 ,image_url
 ,image_width
 ,image_height
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,draggable_id
 ,questionid
 ,display_order
 ,image_url
 ,image_width
 ,image_height
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
  from inserted
end
GO

create trigger d_draggable on draggable
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from draggable where exists (
select 1 from deleted where draggable.draggable_id = deleted.draggable_id)
insert into draggable_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,draggable_id
 ,questionid
 ,display_order
 ,image_url
 ,image_width
 ,image_height
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,draggable_id
 ,questionid
 ,display_order
 ,image_url
 ,image_width
 ,image_height
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-draggable', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1128, '8:03c164bd4a351816e1a1863f801f2fdf', 'enableAuditTable auditTableName=draggable_aud, tableName=draggable', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-answer_drag_and_drop::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_answer_drag_and_drop'
			)
			DROP TRIGGER i_answer_drag_and_drop
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_answer_drag_and_drop'
			)
			DROP TRIGGER u_answer_drag_and_drop
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_answer_drag_and_drop'
			)
			DROP TRIGGER d_answer_drag_and_drop
GO

CREATE TABLE answer_drag_and_drop_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_answer_drag_and_drop_aud_aud_datetime DEFAULT GETDATE() NOT NULL, answer_id nvarchar(15), test_instance_id nvarchar(15), section_num int, question_num int, question_id nvarchar(85), draggable_id nvarchar(15), position_x int, position_y int, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_ANSWER_DRAG_AND_DROP_AUD PRIMARY KEY (aud_id))
GO

insert into answer_drag_and_drop_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,draggable_id
 ,position_x
 ,position_y
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,draggable_id
 ,position_x
 ,position_y
 ,update_meaning
  from answer_drag_and_drop
GO

CREATE INDEX nuk_answer_drag_and_drop_aud_1 ON answer_drag_and_drop_aud(aud_userid)
GO

CREATE INDEX nuk_answer_drag_and_drop_aud_2 ON answer_drag_and_drop_aud(aud_datetime)
GO

create trigger i_answer_drag_and_drop on answer_drag_and_drop
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into answer_drag_and_drop (
answer_id,test_instance_id,section_num,question_num,question_id,draggable_id,position_x,position_y,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select answer_id,test_instance_id,section_num,question_num,question_id,draggable_id,position_x,position_y,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into answer_drag_and_drop_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,draggable_id
 ,position_x
 ,position_y
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,draggable_id
 ,position_x
 ,position_y
 ,update_meaning
  from inserted
end
GO

create trigger u_answer_drag_and_drop on answer_drag_and_drop
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update answer_drag_and_drop set
answer_drag_and_drop.answer_id = inserted.answer_id,answer_drag_and_drop.test_instance_id = inserted.test_instance_id,answer_drag_and_drop.section_num = inserted.section_num,answer_drag_and_drop.question_num = inserted.question_num,answer_drag_and_drop.question_id = inserted.question_id,answer_drag_and_drop.draggable_id = inserted.draggable_id,answer_drag_and_drop.position_x = inserted.position_x,answer_drag_and_drop.position_y = inserted.position_y,answer_drag_and_drop.update_meaning = inserted.update_meaning,answer_drag_and_drop.last_updated = inserted.last_updated,answer_drag_and_drop.updater_legal_name = inserted.updater_legal_name,answer_drag_and_drop.update_meaning_text = inserted.update_meaning_text,answer_drag_and_drop.last_updater_uid = inserted.last_updater_uid
from answer_drag_and_drop inner join deleted on answer_drag_and_drop.answer_id = deleted.answer_id inner join inserted on answer_drag_and_drop.answer_id = inserted.answer_id
insert into answer_drag_and_drop_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,draggable_id
 ,position_x
 ,position_y
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,draggable_id
 ,position_x
 ,position_y
 ,update_meaning
  from inserted
end
GO

create trigger d_answer_drag_and_drop on answer_drag_and_drop
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from answer_drag_and_drop where exists (
select 1 from deleted where answer_drag_and_drop.answer_id = deleted.answer_id)
insert into answer_drag_and_drop_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,draggable_id
 ,position_x
 ,position_y
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,draggable_id
 ,position_x
 ,position_y
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-answer_drag_and_drop', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1129, '8:cc943aa7680d1f1ad5e69f0ec54417b4', 'enableAuditTable auditTableName=answer_drag_and_drop_aud, tableName=answer_drag_and_drop', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_type_hotspot::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_type_hotspot'
			)
			DROP TRIGGER i_question_type_hotspot
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_type_hotspot'
			)
			DROP TRIGGER u_question_type_hotspot
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_type_hotspot'
			)
			DROP TRIGGER d_question_type_hotspot
GO

CREATE TABLE q_type_hotspot_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_q_type_hotspot_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), qattributes int, qtext nvarchar(MAX), hint nvarchar(1000), prenote nvarchar(1000), postnote nvarchar(1000), num_hotspot int, background_url nvarchar(255), background_width int, background_height int, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_Q_TYPE_HOTSPOT_AUD PRIMARY KEY (aud_id))
GO

insert into q_type_hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_hotspot
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_hotspot
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
  from question_type_hotspot
GO

CREATE INDEX nuk_q_type_hotspot_aud_1 ON q_type_hotspot_aud(aud_userid)
GO

CREATE INDEX nuk_q_type_hotspot_aud_2 ON q_type_hotspot_aud(aud_datetime)
GO

create trigger i_question_type_hotspot on question_type_hotspot
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_type_hotspot (
questionid,qattributes,qtext,hint,prenote,postnote,num_hotspot,background_url,background_width,background_height,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,qattributes,qtext,hint,prenote,postnote,num_hotspot,background_url,background_width,background_height,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into q_type_hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_hotspot
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_hotspot
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
  from inserted
end
GO

create trigger u_question_type_hotspot on question_type_hotspot
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_type_hotspot set
question_type_hotspot.questionid = inserted.questionid,question_type_hotspot.qattributes = inserted.qattributes,question_type_hotspot.qtext = inserted.qtext,question_type_hotspot.hint = inserted.hint,question_type_hotspot.prenote = inserted.prenote,question_type_hotspot.postnote = inserted.postnote,question_type_hotspot.num_hotspot = inserted.num_hotspot,question_type_hotspot.background_url = inserted.background_url,question_type_hotspot.background_width = inserted.background_width,question_type_hotspot.background_height = inserted.background_height,question_type_hotspot.update_meaning = inserted.update_meaning,question_type_hotspot.last_updated = inserted.last_updated,question_type_hotspot.updater_legal_name = inserted.updater_legal_name,question_type_hotspot.update_meaning_text = inserted.update_meaning_text,question_type_hotspot.last_updater_uid = inserted.last_updater_uid
from question_type_hotspot inner join deleted on question_type_hotspot.questionid = deleted.questionid inner join inserted on question_type_hotspot.questionid = inserted.questionid
insert into q_type_hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_hotspot
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_hotspot
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
  from inserted
end
GO

create trigger d_question_type_hotspot on question_type_hotspot
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_type_hotspot where exists (
select 1 from deleted where question_type_hotspot.questionid = deleted.questionid)
insert into q_type_hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_hotspot
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,qattributes
 ,qtext
 ,hint
 ,prenote
 ,postnote
 ,num_hotspot
 ,background_url
 ,background_width
 ,background_height
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_type_hotspot', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1130, '8:31e0e9e4ec6ef1929ad358a68e91bf23', 'enableAuditTable auditTableName=q_type_hotspot_aud, tableName=question_type_hotspot', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-hotspot::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_hotspot'
			)
			DROP TRIGGER i_hotspot
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_hotspot'
			)
			DROP TRIGGER u_hotspot
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_hotspot'
			)
			DROP TRIGGER d_hotspot
GO

CREATE TABLE hotspot_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_hotspot_aud_aud_datetime DEFAULT GETDATE() NOT NULL, hotspot_id nvarchar(15), questionid nvarchar(85), hot_area_x int, hot_area_y int, hot_area_width int, hot_area_height int, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_HOTSPOT_AUD PRIMARY KEY (aud_id))
GO

insert into hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,hotspot_id
 ,questionid
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,hotspot_id
 ,questionid
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
  from hotspot
GO

CREATE INDEX nuk_hotspot_aud_1 ON hotspot_aud(aud_userid)
GO

CREATE INDEX nuk_hotspot_aud_2 ON hotspot_aud(aud_datetime)
GO

create trigger i_hotspot on hotspot
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into hotspot (
hotspot_id,questionid,hot_area_x,hot_area_y,hot_area_width,hot_area_height,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select hotspot_id,questionid,hot_area_x,hot_area_y,hot_area_width,hot_area_height,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,hotspot_id
 ,questionid
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,hotspot_id
 ,questionid
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
  from inserted
end
GO

create trigger u_hotspot on hotspot
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update hotspot set
hotspot.hotspot_id = inserted.hotspot_id,hotspot.questionid = inserted.questionid,hotspot.hot_area_x = inserted.hot_area_x,hotspot.hot_area_y = inserted.hot_area_y,hotspot.hot_area_width = inserted.hot_area_width,hotspot.hot_area_height = inserted.hot_area_height,hotspot.update_meaning = inserted.update_meaning,hotspot.last_updated = inserted.last_updated,hotspot.updater_legal_name = inserted.updater_legal_name,hotspot.update_meaning_text = inserted.update_meaning_text,hotspot.last_updater_uid = inserted.last_updater_uid
from hotspot inner join deleted on hotspot.hotspot_id = deleted.hotspot_id inner join inserted on hotspot.hotspot_id = inserted.hotspot_id
insert into hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,hotspot_id
 ,questionid
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,hotspot_id
 ,questionid
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
  from inserted
end
GO

create trigger d_hotspot on hotspot
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from hotspot where exists (
select 1 from deleted where hotspot.hotspot_id = deleted.hotspot_id)
insert into hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,hotspot_id
 ,questionid
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,hotspot_id
 ,questionid
 ,hot_area_x
 ,hot_area_y
 ,hot_area_width
 ,hot_area_height
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-hotspot', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1131, '8:b121c1d2f8610bb14a9d4e96c48b2196', 'enableAuditTable auditTableName=hotspot_aud, tableName=hotspot', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-answer_hotspot::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_answer_hotspot'
			)
			DROP TRIGGER i_answer_hotspot
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_answer_hotspot'
			)
			DROP TRIGGER u_answer_hotspot
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_answer_hotspot'
			)
			DROP TRIGGER d_answer_hotspot
GO

CREATE TABLE answer_hotspot_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_answer_hotspot_aud_aud_datetime DEFAULT GETDATE() NOT NULL, answer_id nvarchar(15), test_instance_id nvarchar(15), section_num int, question_num int, question_id nvarchar(85), position_x int, position_y int, update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_ANSWER_HOTSPOT_AUD PRIMARY KEY (aud_id))
GO

insert into answer_hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,position_x
 ,position_y
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,position_x
 ,position_y
 ,update_meaning
  from answer_hotspot
GO

CREATE INDEX nuk_answer_hotspot_aud_1 ON answer_hotspot_aud(aud_userid)
GO

CREATE INDEX nuk_answer_hotspot_aud_2 ON answer_hotspot_aud(aud_datetime)
GO

create trigger i_answer_hotspot on answer_hotspot
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into answer_hotspot (
answer_id,test_instance_id,section_num,question_num,question_id,position_x,position_y,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select answer_id,test_instance_id,section_num,question_num,question_id,position_x,position_y,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into answer_hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,position_x
 ,position_y
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,position_x
 ,position_y
 ,update_meaning
  from inserted
end
GO

create trigger u_answer_hotspot on answer_hotspot
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update answer_hotspot set
answer_hotspot.answer_id = inserted.answer_id,answer_hotspot.test_instance_id = inserted.test_instance_id,answer_hotspot.section_num = inserted.section_num,answer_hotspot.question_num = inserted.question_num,answer_hotspot.question_id = inserted.question_id,answer_hotspot.position_x = inserted.position_x,answer_hotspot.position_y = inserted.position_y,answer_hotspot.update_meaning = inserted.update_meaning,answer_hotspot.last_updated = inserted.last_updated,answer_hotspot.updater_legal_name = inserted.updater_legal_name,answer_hotspot.update_meaning_text = inserted.update_meaning_text,answer_hotspot.last_updater_uid = inserted.last_updater_uid
from answer_hotspot inner join deleted on answer_hotspot.answer_id = deleted.answer_id inner join inserted on answer_hotspot.answer_id = inserted.answer_id
insert into answer_hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,position_x
 ,position_y
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,position_x
 ,position_y
 ,update_meaning
  from inserted
end
GO

create trigger d_answer_hotspot on answer_hotspot
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from answer_hotspot where exists (
select 1 from deleted where answer_hotspot.answer_id = deleted.answer_id)
insert into answer_hotspot_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,position_x
 ,position_y
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,answer_id
 ,test_instance_id
 ,section_num
 ,question_num
 ,question_id
 ,position_x
 ,position_y
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-answer_hotspot', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1132, '8:5ff4d1c1818b9e971a2e2bb67ebca3b6', 'enableAuditTable auditTableName=answer_hotspot_aud, tableName=answer_hotspot', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-custom_course_policy::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_custom_course_policy'
			)
			DROP TRIGGER i_custom_course_policy
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_custom_course_policy'
			)
			DROP TRIGGER u_custom_course_policy
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_custom_course_policy'
			)
			DROP TRIGGER d_custom_course_policy
GO

CREATE TABLE custom_course_policy_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_custom_course_policy_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learning_id nvarchar(85), object_type nvarchar(5), object_id nvarchar(85), policy_id nvarchar(15), update_meaning nvarchar(8), usergroup_policy_precedence int, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CUSTOM_COURSE_POLICY_AUD PRIMARY KEY (aud_id))
GO

insert into custom_course_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learning_id
 ,object_type
 ,object_id
 ,policy_id
 ,update_meaning
 ,usergroup_policy_precedence
) select 'U', null
, null
, GETDATE(), null
, null
 ,learning_id
 ,object_type
 ,object_id
 ,policy_id
 ,update_meaning
 ,usergroup_policy_precedence
  from custom_course_policy
GO

CREATE INDEX nuk_custom_course_policy_aud_1 ON custom_course_policy_aud(aud_userid)
GO

CREATE INDEX nuk_custom_course_policy_aud_2 ON custom_course_policy_aud(aud_datetime)
GO

create trigger i_custom_course_policy on custom_course_policy
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into custom_course_policy (
learning_id,object_type,object_id,policy_id,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,usergroup_policy_precedence) select learning_id,object_type,object_id,policy_id,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,usergroup_policy_precedence from inserted
insert into custom_course_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learning_id
 ,object_type
 ,object_id
 ,policy_id
 ,update_meaning
 ,usergroup_policy_precedence
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learning_id
 ,object_type
 ,object_id
 ,policy_id
 ,update_meaning
 ,usergroup_policy_precedence
  from inserted
end
GO

create trigger u_custom_course_policy on custom_course_policy
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update custom_course_policy set
custom_course_policy.learning_id = inserted.learning_id,custom_course_policy.object_type = inserted.object_type,custom_course_policy.object_id = inserted.object_id,custom_course_policy.policy_id = inserted.policy_id,custom_course_policy.update_meaning = inserted.update_meaning,custom_course_policy.last_updated = inserted.last_updated,custom_course_policy.updater_legal_name = inserted.updater_legal_name,custom_course_policy.update_meaning_text = inserted.update_meaning_text,custom_course_policy.last_updater_uid = inserted.last_updater_uid,custom_course_policy.usergroup_policy_precedence = inserted.usergroup_policy_precedence
from custom_course_policy inner join deleted on custom_course_policy.learning_id = deleted.learning_id and custom_course_policy.object_type = deleted.object_type and custom_course_policy.object_id = deleted.object_id and custom_course_policy.policy_id = deleted.policy_id inner join inserted on custom_course_policy.learning_id = inserted.learning_id and custom_course_policy.object_type = inserted.object_type and custom_course_policy.object_id = inserted.object_id and custom_course_policy.policy_id = inserted.policy_id
insert into custom_course_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learning_id
 ,object_type
 ,object_id
 ,policy_id
 ,update_meaning
 ,usergroup_policy_precedence
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learning_id
 ,object_type
 ,object_id
 ,policy_id
 ,update_meaning
 ,usergroup_policy_precedence
  from inserted
end
GO

create trigger d_custom_course_policy on custom_course_policy
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from custom_course_policy where exists (
select 1 from deleted where custom_course_policy.learning_id = deleted.learning_id and custom_course_policy.object_type = deleted.object_type and custom_course_policy.object_id = deleted.object_id and custom_course_policy.policy_id = deleted.policy_id)
insert into custom_course_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learning_id
 ,object_type
 ,object_id
 ,policy_id
 ,update_meaning
 ,usergroup_policy_precedence
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learning_id
 ,object_type
 ,object_id
 ,policy_id
 ,update_meaning
 ,usergroup_policy_precedence
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-custom_course_policy', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1133, '8:de7b634db6df56b9169d0af46392b0b9', 'enableAuditTable auditTableName=custom_course_policy_aud, tableName=custom_course_policy', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-withdraw_ded_opt_pay_items::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_withdraw_ded_opt_pay_items'
			)
			DROP TRIGGER i_withdraw_ded_opt_pay_items
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_withdraw_ded_opt_pay_items'
			)
			DROP TRIGGER u_withdraw_ded_opt_pay_items
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_withdraw_ded_opt_pay_items'
			)
			DROP TRIGGER d_withdraw_ded_opt_pay_items
GO

CREATE TABLE w_ded_opt_pay_items_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_w_ded_opt_pay_items_aud_aud_datetime DEFAULT GETDATE() NOT NULL, policy_id nvarchar(15), day_before_start int, deduction float(53), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_W_DED_OPT_PAY_ITEMS_AUD PRIMARY KEY (aud_id))
GO

insert into w_ded_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
  from withdraw_ded_opt_pay_items
GO

CREATE INDEX nuk_w_ded_opt_pay_items_aud_1 ON w_ded_opt_pay_items_aud(aud_userid)
GO

CREATE INDEX nuk_w_ded_opt_pay_items_aud_2 ON w_ded_opt_pay_items_aud(aud_datetime)
GO

create trigger i_withdraw_ded_opt_pay_items on withdraw_ded_opt_pay_items
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into withdraw_ded_opt_pay_items (
policy_id,day_before_start,deduction,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select policy_id,day_before_start,deduction,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into w_ded_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
  from inserted
end
GO

create trigger u_withdraw_ded_opt_pay_items on withdraw_ded_opt_pay_items
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update withdraw_ded_opt_pay_items set
withdraw_ded_opt_pay_items.policy_id = inserted.policy_id,withdraw_ded_opt_pay_items.day_before_start = inserted.day_before_start,withdraw_ded_opt_pay_items.deduction = inserted.deduction,withdraw_ded_opt_pay_items.update_meaning = inserted.update_meaning,withdraw_ded_opt_pay_items.last_updated = inserted.last_updated,withdraw_ded_opt_pay_items.updater_legal_name = inserted.updater_legal_name,withdraw_ded_opt_pay_items.update_meaning_text = inserted.update_meaning_text,withdraw_ded_opt_pay_items.last_updater_uid = inserted.last_updater_uid
from withdraw_ded_opt_pay_items inner join deleted on withdraw_ded_opt_pay_items.policy_id = deleted.policy_id and withdraw_ded_opt_pay_items.day_before_start = deleted.day_before_start inner join inserted on withdraw_ded_opt_pay_items.policy_id = inserted.policy_id and withdraw_ded_opt_pay_items.day_before_start = inserted.day_before_start
insert into w_ded_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
  from inserted
end
GO

create trigger d_withdraw_ded_opt_pay_items on withdraw_ded_opt_pay_items
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from withdraw_ded_opt_pay_items where exists (
select 1 from deleted where withdraw_ded_opt_pay_items.policy_id = deleted.policy_id and withdraw_ded_opt_pay_items.day_before_start = deleted.day_before_start)
insert into w_ded_opt_pay_items_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,day_before_start
 ,deduction
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-withdraw_ded_opt_pay_items', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1134, '8:22fcb013f0657c45ca5130d8aaa69410', 'enableAuditTable auditTableName=w_ded_opt_pay_items_aud, tableName=withdraw_ded_opt_pay_items', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-withdraw_reason::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_withdraw_reason'
			)
			DROP TRIGGER i_withdraw_reason
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_withdraw_reason'
			)
			DROP TRIGGER u_withdraw_reason
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_withdraw_reason'
			)
			DROP TRIGGER d_withdraw_reason
GO

CREATE TABLE withdraw_reason_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_withdraw_reason_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), user_id nvarchar(85), transcript_id nvarchar(15), created_date datetime, reason nvarchar(1000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_WITHDRAW_REASON_AUD PRIMARY KEY (aud_id))
GO

insert into withdraw_reason_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,user_id
 ,transcript_id
 ,created_date
 ,reason
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,user_id
 ,transcript_id
 ,created_date
 ,reason
 ,update_meaning
  from withdraw_reason
GO

CREATE INDEX nuk_withdraw_reason_aud_1 ON withdraw_reason_aud(aud_userid)
GO

CREATE INDEX nuk_withdraw_reason_aud_2 ON withdraw_reason_aud(aud_datetime)
GO

create trigger i_withdraw_reason on withdraw_reason
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into withdraw_reason (
id,user_id,transcript_id,created_date,reason,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select id,user_id,transcript_id,created_date,reason,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into withdraw_reason_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,user_id
 ,transcript_id
 ,created_date
 ,reason
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,user_id
 ,transcript_id
 ,created_date
 ,reason
 ,update_meaning
  from inserted
end
GO

create trigger u_withdraw_reason on withdraw_reason
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update withdraw_reason set
withdraw_reason.id = inserted.id,withdraw_reason.user_id = inserted.user_id,withdraw_reason.transcript_id = inserted.transcript_id,withdraw_reason.created_date = inserted.created_date,withdraw_reason.reason = inserted.reason,withdraw_reason.update_meaning = inserted.update_meaning,withdraw_reason.last_updated = inserted.last_updated,withdraw_reason.updater_legal_name = inserted.updater_legal_name,withdraw_reason.update_meaning_text = inserted.update_meaning_text,withdraw_reason.last_updater_uid = inserted.last_updater_uid
from withdraw_reason inner join deleted on withdraw_reason.id = deleted.id inner join inserted on withdraw_reason.id = inserted.id
insert into withdraw_reason_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,user_id
 ,transcript_id
 ,created_date
 ,reason
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,user_id
 ,transcript_id
 ,created_date
 ,reason
 ,update_meaning
  from inserted
end
GO

create trigger d_withdraw_reason on withdraw_reason
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from withdraw_reason where exists (
select 1 from deleted where withdraw_reason.id = deleted.id)
insert into withdraw_reason_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,user_id
 ,transcript_id
 ,created_date
 ,reason
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,user_id
 ,transcript_id
 ,created_date
 ,reason
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-withdraw_reason', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1135, '8:7a43519a49c446d99b2dc25b9e86a5e2', 'enableAuditTable auditTableName=withdraw_reason_aud, tableName=withdraw_reason', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-session_attribute::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_session_attribute'
			)
			DROP TRIGGER i_session_attribute
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_session_attribute'
			)
			DROP TRIGGER u_session_attribute
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_session_attribute'
			)
			DROP TRIGGER d_session_attribute
GO

CREATE TABLE session_attribute_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_session_attribute_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), sessionid nvarchar(85), attribute_id nvarchar(15), attribute_value_data nvarchar(2000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SESSION_ATTRIBUTE_AUD PRIMARY KEY (aud_id))
GO

insert into session_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,sessionid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,sessionid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from session_attribute
GO

CREATE INDEX nuk_session_attribute_aud_1 ON session_attribute_aud(aud_userid)
GO

CREATE INDEX nuk_session_attribute_aud_2 ON session_attribute_aud(aud_datetime)
GO

create trigger i_session_attribute on session_attribute
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into session_attribute (
learningid,sessionid,attribute_id,attribute_value_data,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select learningid,sessionid,attribute_id,attribute_value_data,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into session_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,sessionid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,sessionid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from inserted
end
GO

create trigger u_session_attribute on session_attribute
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update session_attribute set
session_attribute.learningid = inserted.learningid,session_attribute.sessionid = inserted.sessionid,session_attribute.attribute_id = inserted.attribute_id,session_attribute.attribute_value_data = inserted.attribute_value_data,session_attribute.update_meaning = inserted.update_meaning,session_attribute.last_updated = inserted.last_updated,session_attribute.updater_legal_name = inserted.updater_legal_name,session_attribute.update_meaning_text = inserted.update_meaning_text,session_attribute.last_updater_uid = inserted.last_updater_uid
from session_attribute inner join deleted on session_attribute.learningid = deleted.learningid and session_attribute.sessionid = deleted.sessionid and session_attribute.attribute_id = deleted.attribute_id inner join inserted on session_attribute.learningid = inserted.learningid and session_attribute.sessionid = inserted.sessionid and session_attribute.attribute_id = inserted.attribute_id
insert into session_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,sessionid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,sessionid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from inserted
end
GO

create trigger d_session_attribute on session_attribute
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from session_attribute where exists (
select 1 from deleted where session_attribute.learningid = deleted.learningid and session_attribute.sessionid = deleted.sessionid and session_attribute.attribute_id = deleted.attribute_id)
insert into session_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,sessionid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,sessionid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-session_attribute', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1136, '8:c9404419a9efce034c8e70cc697a44a1', 'enableAuditTable auditTableName=session_attribute_aud, tableName=session_attribute', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-transcript_attribute::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_transcript_attribute'
			)
			DROP TRIGGER i_transcript_attribute
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_transcript_attribute'
			)
			DROP TRIGGER u_transcript_attribute
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_transcript_attribute'
			)
			DROP TRIGGER d_transcript_attribute
GO

CREATE TABLE transcript_attribute_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_transcript_attribute_aud_aud_datetime DEFAULT GETDATE() NOT NULL, transcriptid nvarchar(85), attribute_id nvarchar(15), attribute_value_data nvarchar(2000), update_meaning nvarchar(8), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TRANSCRIPT_ATTRIBUTE_AUD PRIMARY KEY (aud_id))
GO

insert into transcript_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'U', null
, null
, GETDATE(), null
, null
 ,transcriptid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from transcript_attribute
GO

CREATE INDEX nuk_transcript_attribute_aud_1 ON transcript_attribute_aud(aud_userid)
GO

CREATE INDEX nuk_transcript_attribute_aud_2 ON transcript_attribute_aud(aud_datetime)
GO

create trigger i_transcript_attribute on transcript_attribute
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into transcript_attribute (
transcriptid,attribute_id,attribute_value_data,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select transcriptid,attribute_id,attribute_value_data,update_meaning,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into transcript_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from inserted
end
GO

create trigger u_transcript_attribute on transcript_attribute
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update transcript_attribute set
transcript_attribute.transcriptid = inserted.transcriptid,transcript_attribute.attribute_id = inserted.attribute_id,transcript_attribute.attribute_value_data = inserted.attribute_value_data,transcript_attribute.update_meaning = inserted.update_meaning,transcript_attribute.last_updated = inserted.last_updated,transcript_attribute.updater_legal_name = inserted.updater_legal_name,transcript_attribute.update_meaning_text = inserted.update_meaning_text,transcript_attribute.last_updater_uid = inserted.last_updater_uid
from transcript_attribute inner join deleted on transcript_attribute.transcriptid = deleted.transcriptid and transcript_attribute.attribute_id = deleted.attribute_id inner join inserted on transcript_attribute.transcriptid = inserted.transcriptid and transcript_attribute.attribute_id = inserted.attribute_id
insert into transcript_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from inserted
end
GO

create trigger d_transcript_attribute on transcript_attribute
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from transcript_attribute where exists (
select 1 from deleted where transcript_attribute.transcriptid = deleted.transcriptid and transcript_attribute.attribute_id = deleted.attribute_id)
insert into transcript_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,attribute_id
 ,attribute_value_data
 ,update_meaning
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-transcript_attribute', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1137, '8:27e0b2a9cb8c669b3f204a33d5d71e9f', 'enableAuditTable auditTableName=transcript_attribute_aud, tableName=transcript_attribute', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-individual_competency::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_individual_competency'
			)
			DROP TRIGGER i_individual_competency
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_individual_competency'
			)
			DROP TRIGGER u_individual_competency
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_individual_competency'
			)
			DROP TRIGGER d_individual_competency
GO

CREATE TABLE individual_comp_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_individual_comp_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), name nvarchar(85), model_id int, description nvarchar(MAX), is_active char(1), reference_code nvarchar(85), allows_manual_award char(1), acquire_method char(1), requires_all char(1), allows_self_award char(1), categoryid varchar(15), creator_uid nvarchar(85), datecreated datetime, n_completions_required int, task_type varchar(30), source_name nvarchar(255), level_group_id nvarchar(15), min_wait_period int, min_wait_unit char(1), auto_revoke char(1), auto_revoke_period int, auto_revoke_unit char(1), auto_revoke_remind_period int, auto_revoke_remind_unit char(1), send_revoked_email char(1), adhoc_exp_period int, adhoc_exp_unit char(1), renewal_period int, renewal_period_unit char(1), expiration_logic char(1), enforce_approval char(1), approval_type char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_INDIVIDUAL_COMP_AUD PRIMARY KEY (aud_id))
GO

insert into individual_comp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,name
 ,model_id
 ,description
 ,is_active
 ,reference_code
 ,allows_manual_award
 ,acquire_method
 ,requires_all
 ,allows_self_award
 ,categoryid
 ,creator_uid
 ,datecreated
 ,n_completions_required
 ,task_type
 ,source_name
 ,level_group_id
 ,min_wait_period
 ,min_wait_unit
 ,auto_revoke
 ,auto_revoke_period
 ,auto_revoke_unit
 ,auto_revoke_remind_period
 ,auto_revoke_remind_unit
 ,send_revoked_email
 ,adhoc_exp_period
 ,adhoc_exp_unit
 ,renewal_period
 ,renewal_period_unit
 ,expiration_logic
 ,enforce_approval
 ,approval_type
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,name
 ,model_id
 ,description
 ,is_active
 ,reference_code
 ,allows_manual_award
 ,acquire_method
 ,requires_all
 ,allows_self_award
 ,categoryid
 ,creator_uid
 ,datecreated
 ,n_completions_required
 ,task_type
 ,source_name
 ,level_group_id
 ,min_wait_period
 ,min_wait_unit
 ,auto_revoke
 ,auto_revoke_period
 ,auto_revoke_unit
 ,auto_revoke_remind_period
 ,auto_revoke_remind_unit
 ,send_revoked_email
 ,adhoc_exp_period
 ,adhoc_exp_unit
 ,renewal_period
 ,renewal_period_unit
 ,expiration_logic
 ,enforce_approval
 ,approval_type
  from individual_competency
GO

CREATE INDEX nuk_individual_comp_aud_1 ON individual_comp_aud(aud_userid)
GO

CREATE INDEX nuk_individual_comp_aud_2 ON individual_comp_aud(aud_datetime)
GO

create trigger i_individual_competency on individual_competency
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into individual_competency (
id,name,model_id,description,is_active,reference_code,allows_manual_award,acquire_method,requires_all,allows_self_award,categoryid,creator_uid,datecreated,last_updated,last_updater_uid,n_completions_required,task_type,source_name,level_group_id,min_wait_period,min_wait_unit,auto_revoke,auto_revoke_period,auto_revoke_unit,auto_revoke_remind_period,auto_revoke_remind_unit,send_revoked_email,updater_legal_name,update_meaning_text,adhoc_exp_period,adhoc_exp_unit,renewal_period,renewal_period_unit,expiration_logic,enforce_approval,approval_type) select id,name,model_id,description,is_active,reference_code,allows_manual_award,acquire_method,requires_all,allows_self_award,categoryid,creator_uid,datecreated,last_updated,last_updater_uid,n_completions_required,task_type,source_name,level_group_id,min_wait_period,min_wait_unit,auto_revoke,auto_revoke_period,auto_revoke_unit,auto_revoke_remind_period,auto_revoke_remind_unit,send_revoked_email,updater_legal_name,update_meaning_text,adhoc_exp_period,adhoc_exp_unit,renewal_period,renewal_period_unit,expiration_logic,enforce_approval,approval_type from inserted
insert into individual_comp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,name
 ,model_id
 ,description
 ,is_active
 ,reference_code
 ,allows_manual_award
 ,acquire_method
 ,requires_all
 ,allows_self_award
 ,categoryid
 ,creator_uid
 ,datecreated
 ,n_completions_required
 ,task_type
 ,source_name
 ,level_group_id
 ,min_wait_period
 ,min_wait_unit
 ,auto_revoke
 ,auto_revoke_period
 ,auto_revoke_unit
 ,auto_revoke_remind_period
 ,auto_revoke_remind_unit
 ,send_revoked_email
 ,adhoc_exp_period
 ,adhoc_exp_unit
 ,renewal_period
 ,renewal_period_unit
 ,expiration_logic
 ,enforce_approval
 ,approval_type
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,name
 ,model_id
 ,description
 ,is_active
 ,reference_code
 ,allows_manual_award
 ,acquire_method
 ,requires_all
 ,allows_self_award
 ,categoryid
 ,creator_uid
 ,datecreated
 ,n_completions_required
 ,task_type
 ,source_name
 ,level_group_id
 ,min_wait_period
 ,min_wait_unit
 ,auto_revoke
 ,auto_revoke_period
 ,auto_revoke_unit
 ,auto_revoke_remind_period
 ,auto_revoke_remind_unit
 ,send_revoked_email
 ,adhoc_exp_period
 ,adhoc_exp_unit
 ,renewal_period
 ,renewal_period_unit
 ,expiration_logic
 ,enforce_approval
 ,approval_type
  from inserted
end
GO

create trigger u_individual_competency on individual_competency
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update individual_competency set
individual_competency.id = inserted.id,individual_competency.name = inserted.name,individual_competency.model_id = inserted.model_id,individual_competency.description = inserted.description,individual_competency.is_active = inserted.is_active,individual_competency.reference_code = inserted.reference_code,individual_competency.allows_manual_award = inserted.allows_manual_award,individual_competency.acquire_method = inserted.acquire_method,individual_competency.requires_all = inserted.requires_all,individual_competency.allows_self_award = inserted.allows_self_award,individual_competency.categoryid = inserted.categoryid,individual_competency.creator_uid = inserted.creator_uid,individual_competency.datecreated = inserted.datecreated,individual_competency.last_updated = inserted.last_updated,individual_competency.last_updater_uid = inserted.last_updater_uid,individual_competency.n_completions_required = inserted.n_completions_required,individual_competency.task_type = inserted.task_type,individual_competency.source_name = inserted.source_name,individual_competency.level_group_id = inserted.level_group_id,individual_competency.min_wait_period = inserted.min_wait_period,individual_competency.min_wait_unit = inserted.min_wait_unit,individual_competency.auto_revoke = inserted.auto_revoke,individual_competency.auto_revoke_period = inserted.auto_revoke_period,individual_competency.auto_revoke_unit = inserted.auto_revoke_unit,individual_competency.auto_revoke_remind_period = inserted.auto_revoke_remind_period,individual_competency.auto_revoke_remind_unit = inserted.auto_revoke_remind_unit,individual_competency.send_revoked_email = inserted.send_revoked_email,individual_competency.updater_legal_name = inserted.updater_legal_name,individual_competency.update_meaning_text = inserted.update_meaning_text,individual_competency.adhoc_exp_period = inserted.adhoc_exp_period,individual_competency.adhoc_exp_unit = inserted.adhoc_exp_unit,individual_competency.renewal_period = inserted.renewal_period,individual_competency.renewal_period_unit = inserted.renewal_period_unit,individual_competency.expiration_logic = inserted.expiration_logic,individual_competency.enforce_approval = inserted.enforce_approval,individual_competency.approval_type = inserted.approval_type
from individual_competency inner join deleted on individual_competency.id = deleted.id inner join inserted on individual_competency.id = inserted.id
insert into individual_comp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,name
 ,model_id
 ,description
 ,is_active
 ,reference_code
 ,allows_manual_award
 ,acquire_method
 ,requires_all
 ,allows_self_award
 ,categoryid
 ,creator_uid
 ,datecreated
 ,n_completions_required
 ,task_type
 ,source_name
 ,level_group_id
 ,min_wait_period
 ,min_wait_unit
 ,auto_revoke
 ,auto_revoke_period
 ,auto_revoke_unit
 ,auto_revoke_remind_period
 ,auto_revoke_remind_unit
 ,send_revoked_email
 ,adhoc_exp_period
 ,adhoc_exp_unit
 ,renewal_period
 ,renewal_period_unit
 ,expiration_logic
 ,enforce_approval
 ,approval_type
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,name
 ,model_id
 ,description
 ,is_active
 ,reference_code
 ,allows_manual_award
 ,acquire_method
 ,requires_all
 ,allows_self_award
 ,categoryid
 ,creator_uid
 ,datecreated
 ,n_completions_required
 ,task_type
 ,source_name
 ,level_group_id
 ,min_wait_period
 ,min_wait_unit
 ,auto_revoke
 ,auto_revoke_period
 ,auto_revoke_unit
 ,auto_revoke_remind_period
 ,auto_revoke_remind_unit
 ,send_revoked_email
 ,adhoc_exp_period
 ,adhoc_exp_unit
 ,renewal_period
 ,renewal_period_unit
 ,expiration_logic
 ,enforce_approval
 ,approval_type
  from inserted
end
GO

create trigger d_individual_competency on individual_competency
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from individual_competency where exists (
select 1 from deleted where individual_competency.id = deleted.id)
insert into individual_comp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,name
 ,model_id
 ,description
 ,is_active
 ,reference_code
 ,allows_manual_award
 ,acquire_method
 ,requires_all
 ,allows_self_award
 ,categoryid
 ,creator_uid
 ,datecreated
 ,n_completions_required
 ,task_type
 ,source_name
 ,level_group_id
 ,min_wait_period
 ,min_wait_unit
 ,auto_revoke
 ,auto_revoke_period
 ,auto_revoke_unit
 ,auto_revoke_remind_period
 ,auto_revoke_remind_unit
 ,send_revoked_email
 ,adhoc_exp_period
 ,adhoc_exp_unit
 ,renewal_period
 ,renewal_period_unit
 ,expiration_logic
 ,enforce_approval
 ,approval_type
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,name
 ,model_id
 ,description
 ,is_active
 ,reference_code
 ,allows_manual_award
 ,acquire_method
 ,requires_all
 ,allows_self_award
 ,categoryid
 ,creator_uid
 ,datecreated
 ,n_completions_required
 ,task_type
 ,source_name
 ,level_group_id
 ,min_wait_period
 ,min_wait_unit
 ,auto_revoke
 ,auto_revoke_period
 ,auto_revoke_unit
 ,auto_revoke_remind_period
 ,auto_revoke_remind_unit
 ,send_revoked_email
 ,adhoc_exp_period
 ,adhoc_exp_unit
 ,renewal_period
 ,renewal_period_unit
 ,expiration_logic
 ,enforce_approval
 ,approval_type
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-individual_competency', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1138, '8:e878c32b28f86500caa3cab8f8468e03', 'enableAuditTable auditTableName=individual_comp_aud, tableName=individual_competency', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-competency_level::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_competency_level'
			)
			DROP TRIGGER i_competency_level
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_competency_level'
			)
			DROP TRIGGER u_competency_level
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_competency_level'
			)
			DROP TRIGGER d_competency_level
GO

CREATE TABLE competency_level_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_competency_level_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), res_id nvarchar(15), competency_id nvarchar(15), desc_text nvarchar(MAX), title nvarchar(255), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COMPETENCY_LEVEL_AUD PRIMARY KEY (aud_id))
GO

insert into competency_level_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,res_id
 ,competency_id
 ,desc_text
 ,title
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,res_id
 ,competency_id
 ,desc_text
 ,title
  from competency_level
GO

CREATE INDEX nuk_competency_level_aud_1 ON competency_level_aud(aud_userid)
GO

CREATE INDEX nuk_competency_level_aud_2 ON competency_level_aud(aud_datetime)
GO

create trigger i_competency_level on competency_level
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into competency_level (
id,res_id,competency_id,desc_text,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,title) select id,res_id,competency_id,desc_text,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,title from inserted
insert into competency_level_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,res_id
 ,competency_id
 ,desc_text
 ,title
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,res_id
 ,competency_id
 ,desc_text
 ,title
  from inserted
end
GO

create trigger u_competency_level on competency_level
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update competency_level set
competency_level.id = inserted.id,competency_level.res_id = inserted.res_id,competency_level.competency_id = inserted.competency_id,competency_level.desc_text = inserted.desc_text,competency_level.last_updated = inserted.last_updated,competency_level.updater_legal_name = inserted.updater_legal_name,competency_level.update_meaning_text = inserted.update_meaning_text,competency_level.last_updater_uid = inserted.last_updater_uid,competency_level.title = inserted.title
from competency_level inner join deleted on competency_level.id = deleted.id inner join inserted on competency_level.id = inserted.id
insert into competency_level_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,res_id
 ,competency_id
 ,desc_text
 ,title
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,res_id
 ,competency_id
 ,desc_text
 ,title
  from inserted
end
GO

create trigger d_competency_level on competency_level
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from competency_level where exists (
select 1 from deleted where competency_level.id = deleted.id)
insert into competency_level_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,res_id
 ,competency_id
 ,desc_text
 ,title
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,res_id
 ,competency_id
 ,desc_text
 ,title
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-competency_level', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1139, '8:fe6d59607d801d502200be5c5417bc85', 'enableAuditTable auditTableName=competency_level_aud, tableName=competency_level', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-course_competency::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_course_competency'
			)
			DROP TRIGGER i_course_competency
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_course_competency'
			)
			DROP TRIGGER u_course_competency
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_course_competency'
			)
			DROP TRIGGER d_course_competency
GO

CREATE TABLE course_competency_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_course_competency_aud_aud_datetime DEFAULT GETDATE() NOT NULL, course_id nvarchar(85), competency_id nvarchar(15), module_order int, competency_target_level_id nvarchar(15), mandatory char(1), course_revision char(1), valid_for_period int, valid_for_unit char(1), assign_date datetime, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSE_COMPETENCY_AUD PRIMARY KEY (aud_id))
GO

insert into course_competency_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,competency_id
 ,module_order
 ,competency_target_level_id
 ,mandatory
 ,course_revision
 ,valid_for_period
 ,valid_for_unit
 ,assign_date
) select 'U', null
, null
, GETDATE(), null
, null
 ,course_id
 ,competency_id
 ,module_order
 ,competency_target_level_id
 ,mandatory
 ,course_revision
 ,valid_for_period
 ,valid_for_unit
 ,assign_date
  from course_competency
GO

CREATE INDEX nuk_course_competency_aud_1 ON course_competency_aud(aud_userid)
GO

CREATE INDEX nuk_course_competency_aud_2 ON course_competency_aud(aud_datetime)
GO

create trigger i_course_competency on course_competency
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into course_competency (
course_id,competency_id,module_order,competency_target_level_id,mandatory,course_revision,valid_for_period,valid_for_unit,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,assign_date) select course_id,competency_id,module_order,competency_target_level_id,mandatory,course_revision,valid_for_period,valid_for_unit,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,assign_date from inserted
insert into course_competency_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,competency_id
 ,module_order
 ,competency_target_level_id
 ,mandatory
 ,course_revision
 ,valid_for_period
 ,valid_for_unit
 ,assign_date
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,competency_id
 ,module_order
 ,competency_target_level_id
 ,mandatory
 ,course_revision
 ,valid_for_period
 ,valid_for_unit
 ,assign_date
  from inserted
end
GO

create trigger u_course_competency on course_competency
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update course_competency set
course_competency.course_id = inserted.course_id,course_competency.competency_id = inserted.competency_id,course_competency.module_order = inserted.module_order,course_competency.competency_target_level_id = inserted.competency_target_level_id,course_competency.mandatory = inserted.mandatory,course_competency.course_revision = inserted.course_revision,course_competency.valid_for_period = inserted.valid_for_period,course_competency.valid_for_unit = inserted.valid_for_unit,course_competency.last_updated = inserted.last_updated,course_competency.updater_legal_name = inserted.updater_legal_name,course_competency.update_meaning_text = inserted.update_meaning_text,course_competency.last_updater_uid = inserted.last_updater_uid,course_competency.assign_date = inserted.assign_date
from course_competency inner join deleted on course_competency.course_id = deleted.course_id and course_competency.competency_id = deleted.competency_id inner join inserted on course_competency.course_id = inserted.course_id and course_competency.competency_id = inserted.competency_id
insert into course_competency_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,competency_id
 ,module_order
 ,competency_target_level_id
 ,mandatory
 ,course_revision
 ,valid_for_period
 ,valid_for_unit
 ,assign_date
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,competency_id
 ,module_order
 ,competency_target_level_id
 ,mandatory
 ,course_revision
 ,valid_for_period
 ,valid_for_unit
 ,assign_date
  from inserted
end
GO

create trigger d_course_competency on course_competency
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from course_competency where exists (
select 1 from deleted where course_competency.course_id = deleted.course_id and course_competency.competency_id = deleted.competency_id)
insert into course_competency_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,competency_id
 ,module_order
 ,competency_target_level_id
 ,mandatory
 ,course_revision
 ,valid_for_period
 ,valid_for_unit
 ,assign_date
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,competency_id
 ,module_order
 ,competency_target_level_id
 ,mandatory
 ,course_revision
 ,valid_for_period
 ,valid_for_unit
 ,assign_date
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-course_competency', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1140, '8:a4969ff4dfa0b4b693b7c6c4dd26f5c4', 'enableAuditTable auditTableName=course_competency_aud, tableName=course_competency', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-job_profile::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_job_profile'
			)
			DROP TRIGGER i_job_profile
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_job_profile'
			)
			DROP TRIGGER u_job_profile
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_job_profile'
			)
			DROP TRIGGER d_job_profile
GO

CREATE TABLE job_profile_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_job_profile_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), name nvarchar(85), poolid int, description nvarchar(MAX), is_active char(1), reference_code nvarchar(85), categoryid varchar(15), allows_manual_assignment char(1), allows_auto_assignment char(1), allows_self_assignment char(1), requires_all char(1), n_competencies_required int, creator_uid nvarchar(85), datecreated datetime, profile_type varchar(30), owner_id nvarchar(85), assign_assignee_email_id nvarchar(15), assign_assignee_type char(1), assign_da_email_id nvarchar(15), assign_da_type char(1), assign_owner_email_id nvarchar(15), assign_owner_type char(1), deassign_assignee_email_id nvarchar(15), deassign_assignee_type char(1), deassign_da_email_id nvarchar(15), deassign_da_type char(1), deassign_owner_email_id nvarchar(15), deassign_owner_type char(1), picture nvarchar(255), allows_assignment_start_date datetime, allows_assignment_end_date datetime, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_JOB_PROFILE_AUD PRIMARY KEY (aud_id))
GO

insert into job_profile_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,name
 ,poolid
 ,description
 ,is_active
 ,reference_code
 ,categoryid
 ,allows_manual_assignment
 ,allows_auto_assignment
 ,allows_self_assignment
 ,requires_all
 ,n_competencies_required
 ,creator_uid
 ,datecreated
 ,profile_type
 ,owner_id
 ,assign_assignee_email_id
 ,assign_assignee_type
 ,assign_da_email_id
 ,assign_da_type
 ,assign_owner_email_id
 ,assign_owner_type
 ,deassign_assignee_email_id
 ,deassign_assignee_type
 ,deassign_da_email_id
 ,deassign_da_type
 ,deassign_owner_email_id
 ,deassign_owner_type
 ,picture
 ,allows_assignment_start_date
 ,allows_assignment_end_date
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,name
 ,poolid
 ,description
 ,is_active
 ,reference_code
 ,categoryid
 ,allows_manual_assignment
 ,allows_auto_assignment
 ,allows_self_assignment
 ,requires_all
 ,n_competencies_required
 ,creator_uid
 ,datecreated
 ,profile_type
 ,owner_id
 ,assign_assignee_email_id
 ,assign_assignee_type
 ,assign_da_email_id
 ,assign_da_type
 ,assign_owner_email_id
 ,assign_owner_type
 ,deassign_assignee_email_id
 ,deassign_assignee_type
 ,deassign_da_email_id
 ,deassign_da_type
 ,deassign_owner_email_id
 ,deassign_owner_type
 ,picture
 ,allows_assignment_start_date
 ,allows_assignment_end_date
  from job_profile
GO

CREATE INDEX nuk_job_profile_aud_1 ON job_profile_aud(aud_userid)
GO

CREATE INDEX nuk_job_profile_aud_2 ON job_profile_aud(aud_datetime)
GO

create trigger i_job_profile on job_profile
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into job_profile (
id,name,poolid,description,is_active,reference_code,categoryid,allows_manual_assignment,allows_auto_assignment,allows_self_assignment,requires_all,n_competencies_required,creator_uid,datecreated,last_updated,last_updater_uid,profile_type,updater_legal_name,update_meaning_text,owner_id,assign_assignee_email_id,assign_assignee_type,assign_da_email_id,assign_da_type,assign_owner_email_id,assign_owner_type,deassign_assignee_email_id,deassign_assignee_type,deassign_da_email_id,deassign_da_type,deassign_owner_email_id,deassign_owner_type,picture,allows_assignment_start_date,allows_assignment_end_date) select id,name,poolid,description,is_active,reference_code,categoryid,allows_manual_assignment,allows_auto_assignment,allows_self_assignment,requires_all,n_competencies_required,creator_uid,datecreated,last_updated,last_updater_uid,profile_type,updater_legal_name,update_meaning_text,owner_id,assign_assignee_email_id,assign_assignee_type,assign_da_email_id,assign_da_type,assign_owner_email_id,assign_owner_type,deassign_assignee_email_id,deassign_assignee_type,deassign_da_email_id,deassign_da_type,deassign_owner_email_id,deassign_owner_type,picture,allows_assignment_start_date,allows_assignment_end_date from inserted
insert into job_profile_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,name
 ,poolid
 ,description
 ,is_active
 ,reference_code
 ,categoryid
 ,allows_manual_assignment
 ,allows_auto_assignment
 ,allows_self_assignment
 ,requires_all
 ,n_competencies_required
 ,creator_uid
 ,datecreated
 ,profile_type
 ,owner_id
 ,assign_assignee_email_id
 ,assign_assignee_type
 ,assign_da_email_id
 ,assign_da_type
 ,assign_owner_email_id
 ,assign_owner_type
 ,deassign_assignee_email_id
 ,deassign_assignee_type
 ,deassign_da_email_id
 ,deassign_da_type
 ,deassign_owner_email_id
 ,deassign_owner_type
 ,picture
 ,allows_assignment_start_date
 ,allows_assignment_end_date
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,name
 ,poolid
 ,description
 ,is_active
 ,reference_code
 ,categoryid
 ,allows_manual_assignment
 ,allows_auto_assignment
 ,allows_self_assignment
 ,requires_all
 ,n_competencies_required
 ,creator_uid
 ,datecreated
 ,profile_type
 ,owner_id
 ,assign_assignee_email_id
 ,assign_assignee_type
 ,assign_da_email_id
 ,assign_da_type
 ,assign_owner_email_id
 ,assign_owner_type
 ,deassign_assignee_email_id
 ,deassign_assignee_type
 ,deassign_da_email_id
 ,deassign_da_type
 ,deassign_owner_email_id
 ,deassign_owner_type
 ,picture
 ,allows_assignment_start_date
 ,allows_assignment_end_date
  from inserted
end
GO

create trigger u_job_profile on job_profile
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update job_profile set
job_profile.id = inserted.id,job_profile.name = inserted.name,job_profile.poolid = inserted.poolid,job_profile.description = inserted.description,job_profile.is_active = inserted.is_active,job_profile.reference_code = inserted.reference_code,job_profile.categoryid = inserted.categoryid,job_profile.allows_manual_assignment = inserted.allows_manual_assignment,job_profile.allows_auto_assignment = inserted.allows_auto_assignment,job_profile.allows_self_assignment = inserted.allows_self_assignment,job_profile.requires_all = inserted.requires_all,job_profile.n_competencies_required = inserted.n_competencies_required,job_profile.creator_uid = inserted.creator_uid,job_profile.datecreated = inserted.datecreated,job_profile.last_updated = inserted.last_updated,job_profile.last_updater_uid = inserted.last_updater_uid,job_profile.profile_type = inserted.profile_type,job_profile.updater_legal_name = inserted.updater_legal_name,job_profile.update_meaning_text = inserted.update_meaning_text,job_profile.owner_id = inserted.owner_id,job_profile.assign_assignee_email_id = inserted.assign_assignee_email_id,job_profile.assign_assignee_type = inserted.assign_assignee_type,job_profile.assign_da_email_id = inserted.assign_da_email_id,job_profile.assign_da_type = inserted.assign_da_type,job_profile.assign_owner_email_id = inserted.assign_owner_email_id,job_profile.assign_owner_type = inserted.assign_owner_type,job_profile.deassign_assignee_email_id = inserted.deassign_assignee_email_id,job_profile.deassign_assignee_type = inserted.deassign_assignee_type,job_profile.deassign_da_email_id = inserted.deassign_da_email_id,job_profile.deassign_da_type = inserted.deassign_da_type,job_profile.deassign_owner_email_id = inserted.deassign_owner_email_id,job_profile.deassign_owner_type = inserted.deassign_owner_type,job_profile.picture = inserted.picture,job_profile.allows_assignment_start_date = inserted.allows_assignment_start_date,job_profile.allows_assignment_end_date = inserted.allows_assignment_end_date
from job_profile inner join deleted on job_profile.id = deleted.id inner join inserted on job_profile.id = inserted.id
insert into job_profile_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,name
 ,poolid
 ,description
 ,is_active
 ,reference_code
 ,categoryid
 ,allows_manual_assignment
 ,allows_auto_assignment
 ,allows_self_assignment
 ,requires_all
 ,n_competencies_required
 ,creator_uid
 ,datecreated
 ,profile_type
 ,owner_id
 ,assign_assignee_email_id
 ,assign_assignee_type
 ,assign_da_email_id
 ,assign_da_type
 ,assign_owner_email_id
 ,assign_owner_type
 ,deassign_assignee_email_id
 ,deassign_assignee_type
 ,deassign_da_email_id
 ,deassign_da_type
 ,deassign_owner_email_id
 ,deassign_owner_type
 ,picture
 ,allows_assignment_start_date
 ,allows_assignment_end_date
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,name
 ,poolid
 ,description
 ,is_active
 ,reference_code
 ,categoryid
 ,allows_manual_assignment
 ,allows_auto_assignment
 ,allows_self_assignment
 ,requires_all
 ,n_competencies_required
 ,creator_uid
 ,datecreated
 ,profile_type
 ,owner_id
 ,assign_assignee_email_id
 ,assign_assignee_type
 ,assign_da_email_id
 ,assign_da_type
 ,assign_owner_email_id
 ,assign_owner_type
 ,deassign_assignee_email_id
 ,deassign_assignee_type
 ,deassign_da_email_id
 ,deassign_da_type
 ,deassign_owner_email_id
 ,deassign_owner_type
 ,picture
 ,allows_assignment_start_date
 ,allows_assignment_end_date
  from inserted
end
GO

create trigger d_job_profile on job_profile
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from job_profile where exists (
select 1 from deleted where job_profile.id = deleted.id)
insert into job_profile_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,name
 ,poolid
 ,description
 ,is_active
 ,reference_code
 ,categoryid
 ,allows_manual_assignment
 ,allows_auto_assignment
 ,allows_self_assignment
 ,requires_all
 ,n_competencies_required
 ,creator_uid
 ,datecreated
 ,profile_type
 ,owner_id
 ,assign_assignee_email_id
 ,assign_assignee_type
 ,assign_da_email_id
 ,assign_da_type
 ,assign_owner_email_id
 ,assign_owner_type
 ,deassign_assignee_email_id
 ,deassign_assignee_type
 ,deassign_da_email_id
 ,deassign_da_type
 ,deassign_owner_email_id
 ,deassign_owner_type
 ,picture
 ,allows_assignment_start_date
 ,allows_assignment_end_date
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,name
 ,poolid
 ,description
 ,is_active
 ,reference_code
 ,categoryid
 ,allows_manual_assignment
 ,allows_auto_assignment
 ,allows_self_assignment
 ,requires_all
 ,n_competencies_required
 ,creator_uid
 ,datecreated
 ,profile_type
 ,owner_id
 ,assign_assignee_email_id
 ,assign_assignee_type
 ,assign_da_email_id
 ,assign_da_type
 ,assign_owner_email_id
 ,assign_owner_type
 ,deassign_assignee_email_id
 ,deassign_assignee_type
 ,deassign_da_email_id
 ,deassign_da_type
 ,deassign_owner_email_id
 ,deassign_owner_type
 ,picture
 ,allows_assignment_start_date
 ,allows_assignment_end_date
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-job_profile', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1141, '8:64845bd647f35a453161cc4ef8e39030', 'enableAuditTable auditTableName=job_profile_aud, tableName=job_profile', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-job_profile_competency::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_job_profile_competency'
			)
			DROP TRIGGER i_job_profile_competency
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_job_profile_competency'
			)
			DROP TRIGGER u_job_profile_competency
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_job_profile_competency'
			)
			DROP TRIGGER d_job_profile_competency
GO

CREATE TABLE job_profile_comp_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_job_profile_comp_aud_aud_datetime DEFAULT GETDATE() NOT NULL, job_profile_id nvarchar(15), competency_id nvarchar(15), competency_order int, mandatory char(1), competency_target_level_id nvarchar(15), competency_quota smallint, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_JOB_PROFILE_COMP_AUD PRIMARY KEY (aud_id))
GO

insert into job_profile_comp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,job_profile_id
 ,competency_id
 ,competency_order
 ,mandatory
 ,competency_target_level_id
 ,competency_quota
) select 'U', null
, null
, GETDATE(), null
, null
 ,job_profile_id
 ,competency_id
 ,competency_order
 ,mandatory
 ,competency_target_level_id
 ,competency_quota
  from job_profile_competency
GO

CREATE INDEX nuk_job_profile_comp_aud_1 ON job_profile_comp_aud(aud_userid)
GO

CREATE INDEX nuk_job_profile_comp_aud_2 ON job_profile_comp_aud(aud_datetime)
GO

create trigger i_job_profile_competency on job_profile_competency
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into job_profile_competency (
job_profile_id,competency_id,competency_order,mandatory,competency_target_level_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,competency_quota) select job_profile_id,competency_id,competency_order,mandatory,competency_target_level_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,competency_quota from inserted
insert into job_profile_comp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,job_profile_id
 ,competency_id
 ,competency_order
 ,mandatory
 ,competency_target_level_id
 ,competency_quota
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,job_profile_id
 ,competency_id
 ,competency_order
 ,mandatory
 ,competency_target_level_id
 ,competency_quota
  from inserted
end
GO

create trigger u_job_profile_competency on job_profile_competency
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update job_profile_competency set
job_profile_competency.job_profile_id = inserted.job_profile_id,job_profile_competency.competency_id = inserted.competency_id,job_profile_competency.competency_order = inserted.competency_order,job_profile_competency.mandatory = inserted.mandatory,job_profile_competency.competency_target_level_id = inserted.competency_target_level_id,job_profile_competency.last_updated = inserted.last_updated,job_profile_competency.updater_legal_name = inserted.updater_legal_name,job_profile_competency.update_meaning_text = inserted.update_meaning_text,job_profile_competency.last_updater_uid = inserted.last_updater_uid,job_profile_competency.competency_quota = inserted.competency_quota
from job_profile_competency inner join deleted on job_profile_competency.job_profile_id = deleted.job_profile_id and job_profile_competency.competency_id = deleted.competency_id inner join inserted on job_profile_competency.job_profile_id = inserted.job_profile_id and job_profile_competency.competency_id = inserted.competency_id
insert into job_profile_comp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,job_profile_id
 ,competency_id
 ,competency_order
 ,mandatory
 ,competency_target_level_id
 ,competency_quota
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,job_profile_id
 ,competency_id
 ,competency_order
 ,mandatory
 ,competency_target_level_id
 ,competency_quota
  from inserted
end
GO

create trigger d_job_profile_competency on job_profile_competency
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from job_profile_competency where exists (
select 1 from deleted where job_profile_competency.job_profile_id = deleted.job_profile_id and job_profile_competency.competency_id = deleted.competency_id)
insert into job_profile_comp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,job_profile_id
 ,competency_id
 ,competency_order
 ,mandatory
 ,competency_target_level_id
 ,competency_quota
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,job_profile_id
 ,competency_id
 ,competency_order
 ,mandatory
 ,competency_target_level_id
 ,competency_quota
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-job_profile_competency', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1142, '8:2aa67daf901bbbd4f42131de9f8ce5da', 'enableAuditTable auditTableName=job_profile_comp_aud, tableName=job_profile_competency', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-user_competency::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_user_competency'
			)
			DROP TRIGGER i_user_competency
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_user_competency'
			)
			DROP TRIGGER u_user_competency
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_user_competency'
			)
			DROP TRIGGER d_user_competency
GO

CREATE TABLE user_competency_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_user_competency_aud_aud_datetime DEFAULT GETDATE() NOT NULL, user_id nvarchar(85), competency_id nvarchar(15), date_assigned datetime, assigned_by nvarchar(85), assessment_mode char(1), assigned_comment nvarchar(1000), competency_level_id nvarchar(15), expire_date datetime, nreminders int, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_USER_COMPETENCY_AUD PRIMARY KEY (aud_id))
GO

insert into user_competency_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,competency_id
 ,date_assigned
 ,assigned_by
 ,assessment_mode
 ,assigned_comment
 ,competency_level_id
 ,expire_date
 ,nreminders
) select 'U', null
, null
, GETDATE(), null
, null
 ,user_id
 ,competency_id
 ,date_assigned
 ,assigned_by
 ,assessment_mode
 ,assigned_comment
 ,competency_level_id
 ,expire_date
 ,nreminders
  from user_competency
GO

CREATE INDEX nuk_user_competency_aud_1 ON user_competency_aud(aud_userid)
GO

CREATE INDEX nuk_user_competency_aud_2 ON user_competency_aud(aud_datetime)
GO

create trigger i_user_competency on user_competency
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into user_competency (
user_id,competency_id,date_assigned,assigned_by,assessment_mode,assigned_comment,competency_level_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,expire_date,nreminders) select user_id,competency_id,date_assigned,assigned_by,assessment_mode,assigned_comment,competency_level_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,expire_date,nreminders from inserted
insert into user_competency_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,competency_id
 ,date_assigned
 ,assigned_by
 ,assessment_mode
 ,assigned_comment
 ,competency_level_id
 ,expire_date
 ,nreminders
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,user_id
 ,competency_id
 ,date_assigned
 ,assigned_by
 ,assessment_mode
 ,assigned_comment
 ,competency_level_id
 ,expire_date
 ,nreminders
  from inserted
end
GO

create trigger u_user_competency on user_competency
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update user_competency set
user_competency.user_id = inserted.user_id,user_competency.competency_id = inserted.competency_id,user_competency.date_assigned = inserted.date_assigned,user_competency.assigned_by = inserted.assigned_by,user_competency.assessment_mode = inserted.assessment_mode,user_competency.assigned_comment = inserted.assigned_comment,user_competency.competency_level_id = inserted.competency_level_id,user_competency.last_updated = inserted.last_updated,user_competency.updater_legal_name = inserted.updater_legal_name,user_competency.update_meaning_text = inserted.update_meaning_text,user_competency.last_updater_uid = inserted.last_updater_uid,user_competency.expire_date = inserted.expire_date,user_competency.nreminders = inserted.nreminders
from user_competency inner join deleted on user_competency.user_id = deleted.user_id and user_competency.competency_id = deleted.competency_id inner join inserted on user_competency.user_id = inserted.user_id and user_competency.competency_id = inserted.competency_id
insert into user_competency_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,competency_id
 ,date_assigned
 ,assigned_by
 ,assessment_mode
 ,assigned_comment
 ,competency_level_id
 ,expire_date
 ,nreminders
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,user_id
 ,competency_id
 ,date_assigned
 ,assigned_by
 ,assessment_mode
 ,assigned_comment
 ,competency_level_id
 ,expire_date
 ,nreminders
  from inserted
end
GO

create trigger d_user_competency on user_competency
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from user_competency where exists (
select 1 from deleted where user_competency.user_id = deleted.user_id and user_competency.competency_id = deleted.competency_id)
insert into user_competency_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,competency_id
 ,date_assigned
 ,assigned_by
 ,assessment_mode
 ,assigned_comment
 ,competency_level_id
 ,expire_date
 ,nreminders
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,user_id
 ,competency_id
 ,date_assigned
 ,assigned_by
 ,assessment_mode
 ,assigned_comment
 ,competency_level_id
 ,expire_date
 ,nreminders
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-user_competency', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1143, '8:aa89f1400faf907433610b2a59a45bfd', 'enableAuditTable auditTableName=user_competency_aud, tableName=user_competency', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-user_job_profile::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_user_job_profile'
			)
			DROP TRIGGER i_user_job_profile
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_user_job_profile'
			)
			DROP TRIGGER u_user_job_profile
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_user_job_profile'
			)
			DROP TRIGGER d_user_job_profile
GO

CREATE TABLE user_job_profile_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_user_job_profile_aud_aud_datetime DEFAULT GETDATE() NOT NULL, user_id nvarchar(85), job_profile_id nvarchar(15), date_assigned datetime, assigned_by nvarchar(85), assign_type char(1), status_flag char(1), status_date datetime, status_percent float(53), assignment_type_id nvarchar(15), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_USER_JOB_PROFILE_AUD PRIMARY KEY (aud_id))
GO

insert into user_job_profile_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,job_profile_id
 ,date_assigned
 ,assigned_by
 ,assign_type
 ,status_flag
 ,status_date
 ,status_percent
 ,assignment_type_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,user_id
 ,job_profile_id
 ,date_assigned
 ,assigned_by
 ,assign_type
 ,status_flag
 ,status_date
 ,status_percent
 ,assignment_type_id
  from user_job_profile
GO

CREATE INDEX nuk_user_job_profile_aud_1 ON user_job_profile_aud(aud_userid)
GO

CREATE INDEX nuk_user_job_profile_aud_2 ON user_job_profile_aud(aud_datetime)
GO

create trigger i_user_job_profile on user_job_profile
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into user_job_profile (
user_id,job_profile_id,date_assigned,assigned_by,assign_type,status_flag,status_date,status_percent,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,assignment_type_id) select user_id,job_profile_id,date_assigned,assigned_by,assign_type,status_flag,status_date,status_percent,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,assignment_type_id from inserted
insert into user_job_profile_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,job_profile_id
 ,date_assigned
 ,assigned_by
 ,assign_type
 ,status_flag
 ,status_date
 ,status_percent
 ,assignment_type_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,user_id
 ,job_profile_id
 ,date_assigned
 ,assigned_by
 ,assign_type
 ,status_flag
 ,status_date
 ,status_percent
 ,assignment_type_id
  from inserted
end
GO

create trigger u_user_job_profile on user_job_profile
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update user_job_profile set
user_job_profile.user_id = inserted.user_id,user_job_profile.job_profile_id = inserted.job_profile_id,user_job_profile.date_assigned = inserted.date_assigned,user_job_profile.assigned_by = inserted.assigned_by,user_job_profile.assign_type = inserted.assign_type,user_job_profile.status_flag = inserted.status_flag,user_job_profile.status_date = inserted.status_date,user_job_profile.status_percent = inserted.status_percent,user_job_profile.last_updated = inserted.last_updated,user_job_profile.updater_legal_name = inserted.updater_legal_name,user_job_profile.update_meaning_text = inserted.update_meaning_text,user_job_profile.last_updater_uid = inserted.last_updater_uid,user_job_profile.assignment_type_id = inserted.assignment_type_id
from user_job_profile inner join deleted on user_job_profile.user_id = deleted.user_id and user_job_profile.job_profile_id = deleted.job_profile_id inner join inserted on user_job_profile.user_id = inserted.user_id and user_job_profile.job_profile_id = inserted.job_profile_id
insert into user_job_profile_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,job_profile_id
 ,date_assigned
 ,assigned_by
 ,assign_type
 ,status_flag
 ,status_date
 ,status_percent
 ,assignment_type_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,user_id
 ,job_profile_id
 ,date_assigned
 ,assigned_by
 ,assign_type
 ,status_flag
 ,status_date
 ,status_percent
 ,assignment_type_id
  from inserted
end
GO

create trigger d_user_job_profile on user_job_profile
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from user_job_profile where exists (
select 1 from deleted where user_job_profile.user_id = deleted.user_id and user_job_profile.job_profile_id = deleted.job_profile_id)
insert into user_job_profile_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,job_profile_id
 ,date_assigned
 ,assigned_by
 ,assign_type
 ,status_flag
 ,status_date
 ,status_percent
 ,assignment_type_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,user_id
 ,job_profile_id
 ,date_assigned
 ,assigned_by
 ,assign_type
 ,status_flag
 ,status_date
 ,status_percent
 ,assignment_type_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-user_job_profile', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1144, '8:760702c863ecdab2581bcabab7ec776a', 'enableAuditTable auditTableName=user_job_profile_aud, tableName=user_job_profile', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-tms_responsibility_level::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_tms_responsibility_level'
			)
			DROP TRIGGER i_tms_responsibility_level
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_tms_responsibility_level'
			)
			DROP TRIGGER u_tms_responsibility_level
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_tms_responsibility_level'
			)
			DROP TRIGGER d_tms_responsibility_level
GO

CREATE TABLE tms_resp_level_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_tms_resp_level_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(15), level_order int, code nvarchar(255), title nvarchar(255), desc_text nvarchar(MAX), level_group_id nvarchar(15), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TMS_RESP_LEVEL_AUD PRIMARY KEY (aud_id))
GO

insert into tms_resp_level_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,level_order
 ,code
 ,title
 ,desc_text
 ,level_group_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,level_order
 ,code
 ,title
 ,desc_text
 ,level_group_id
  from tms_responsibility_level
GO

CREATE INDEX nuk_tms_resp_level_aud_1 ON tms_resp_level_aud(aud_userid)
GO

CREATE INDEX nuk_tms_resp_level_aud_2 ON tms_resp_level_aud(aud_datetime)
GO

create trigger i_tms_responsibility_level on tms_responsibility_level
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into tms_responsibility_level (
id,level_order,code,title,desc_text,level_group_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select id,level_order,code,title,desc_text,level_group_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into tms_resp_level_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,level_order
 ,code
 ,title
 ,desc_text
 ,level_group_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,level_order
 ,code
 ,title
 ,desc_text
 ,level_group_id
  from inserted
end
GO

create trigger u_tms_responsibility_level on tms_responsibility_level
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update tms_responsibility_level set
tms_responsibility_level.id = inserted.id,tms_responsibility_level.level_order = inserted.level_order,tms_responsibility_level.code = inserted.code,tms_responsibility_level.title = inserted.title,tms_responsibility_level.desc_text = inserted.desc_text,tms_responsibility_level.level_group_id = inserted.level_group_id,tms_responsibility_level.last_updated = inserted.last_updated,tms_responsibility_level.updater_legal_name = inserted.updater_legal_name,tms_responsibility_level.update_meaning_text = inserted.update_meaning_text,tms_responsibility_level.last_updater_uid = inserted.last_updater_uid
from tms_responsibility_level inner join deleted on tms_responsibility_level.id = deleted.id inner join inserted on tms_responsibility_level.id = inserted.id
insert into tms_resp_level_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,level_order
 ,code
 ,title
 ,desc_text
 ,level_group_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,level_order
 ,code
 ,title
 ,desc_text
 ,level_group_id
  from inserted
end
GO

create trigger d_tms_responsibility_level on tms_responsibility_level
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from tms_responsibility_level where exists (
select 1 from deleted where tms_responsibility_level.id = deleted.id)
insert into tms_resp_level_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,level_order
 ,code
 ,title
 ,desc_text
 ,level_group_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,level_order
 ,code
 ,title
 ,desc_text
 ,level_group_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-tms_responsibility_level', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1145, '8:3332c9274916108b9841fd3f9cc89fe2', 'enableAuditTable auditTableName=tms_resp_level_aud, tableName=tms_responsibility_level', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-exam_workflow::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_exam_workflow'
			)
			DROP TRIGGER i_exam_workflow
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_exam_workflow'
			)
			DROP TRIGGER u_exam_workflow
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_exam_workflow'
			)
			DROP TRIGGER d_exam_workflow
GO

CREATE TABLE exam_workflow_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_exam_workflow_aud_aud_datetime DEFAULT GETDATE() NOT NULL, ew_id nvarchar(15), display_name nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_EXAM_WORKFLOW_AUD PRIMARY KEY (aud_id))
GO

insert into exam_workflow_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ew_id
 ,display_name
) select 'U', null
, null
, GETDATE(), null
, null
 ,ew_id
 ,display_name
  from exam_workflow
GO

CREATE INDEX nuk_exam_workflow_aud_1 ON exam_workflow_aud(aud_userid)
GO

CREATE INDEX nuk_exam_workflow_aud_2 ON exam_workflow_aud(aud_datetime)
GO

create trigger i_exam_workflow on exam_workflow
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into exam_workflow (
ew_id,display_name,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select ew_id,display_name,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into exam_workflow_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ew_id
 ,display_name
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,ew_id
 ,display_name
  from inserted
end
GO

create trigger u_exam_workflow on exam_workflow
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update exam_workflow set
exam_workflow.ew_id = inserted.ew_id,exam_workflow.display_name = inserted.display_name,exam_workflow.last_updated = inserted.last_updated,exam_workflow.updater_legal_name = inserted.updater_legal_name,exam_workflow.update_meaning_text = inserted.update_meaning_text,exam_workflow.last_updater_uid = inserted.last_updater_uid
from exam_workflow inner join deleted on exam_workflow.ew_id = deleted.ew_id inner join inserted on exam_workflow.ew_id = inserted.ew_id
insert into exam_workflow_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ew_id
 ,display_name
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,ew_id
 ,display_name
  from inserted
end
GO

create trigger d_exam_workflow on exam_workflow
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from exam_workflow where exists (
select 1 from deleted where exam_workflow.ew_id = deleted.ew_id)
insert into exam_workflow_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ew_id
 ,display_name
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,ew_id
 ,display_name
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-exam_workflow', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1146, '8:f9fd8ed331e04cf3e2d812110e44ce42', 'enableAuditTable auditTableName=exam_workflow_aud, tableName=exam_workflow', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-exam_workflow_step::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_exam_workflow_step'
			)
			DROP TRIGGER i_exam_workflow_step
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_exam_workflow_step'
			)
			DROP TRIGGER u_exam_workflow_step
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_exam_workflow_step'
			)
			DROP TRIGGER d_exam_workflow_step
GO

CREATE TABLE exam_workflow_step_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_exam_workflow_step_aud_aud_datetime DEFAULT GETDATE() NOT NULL, ews_id nvarchar(15), ew_id nvarchar(15), testid nvarchar(100), type char(1), description nvarchar(255), target_assessor char(1), email_profile_id nvarchar(15), no_days int, is_after char(1), is_at_course_start char(1), frequency char(1), reminder_send_limit int, step_order int, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_EXAM_WORKFLOW_STEP_AUD PRIMARY KEY (aud_id))
GO

insert into exam_workflow_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ews_id
 ,ew_id
 ,testid
 ,type
 ,description
 ,target_assessor
 ,email_profile_id
 ,no_days
 ,is_after
 ,is_at_course_start
 ,frequency
 ,reminder_send_limit
 ,step_order
) select 'U', null
, null
, GETDATE(), null
, null
 ,ews_id
 ,ew_id
 ,testid
 ,type
 ,description
 ,target_assessor
 ,email_profile_id
 ,no_days
 ,is_after
 ,is_at_course_start
 ,frequency
 ,reminder_send_limit
 ,step_order
  from exam_workflow_step
GO

CREATE INDEX nuk_exam_workflow_step_aud_1 ON exam_workflow_step_aud(aud_userid)
GO

CREATE INDEX nuk_exam_workflow_step_aud_2 ON exam_workflow_step_aud(aud_datetime)
GO

create trigger i_exam_workflow_step on exam_workflow_step
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into exam_workflow_step (
ews_id,ew_id,testid,type,description,target_assessor,email_profile_id,no_days,is_after,is_at_course_start,frequency,reminder_send_limit,step_order,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select ews_id,ew_id,testid,type,description,target_assessor,email_profile_id,no_days,is_after,is_at_course_start,frequency,reminder_send_limit,step_order,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into exam_workflow_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ews_id
 ,ew_id
 ,testid
 ,type
 ,description
 ,target_assessor
 ,email_profile_id
 ,no_days
 ,is_after
 ,is_at_course_start
 ,frequency
 ,reminder_send_limit
 ,step_order
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,ews_id
 ,ew_id
 ,testid
 ,type
 ,description
 ,target_assessor
 ,email_profile_id
 ,no_days
 ,is_after
 ,is_at_course_start
 ,frequency
 ,reminder_send_limit
 ,step_order
  from inserted
end
GO

create trigger u_exam_workflow_step on exam_workflow_step
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update exam_workflow_step set
exam_workflow_step.ews_id = inserted.ews_id,exam_workflow_step.ew_id = inserted.ew_id,exam_workflow_step.testid = inserted.testid,exam_workflow_step.type = inserted.type,exam_workflow_step.description = inserted.description,exam_workflow_step.target_assessor = inserted.target_assessor,exam_workflow_step.email_profile_id = inserted.email_profile_id,exam_workflow_step.no_days = inserted.no_days,exam_workflow_step.is_after = inserted.is_after,exam_workflow_step.is_at_course_start = inserted.is_at_course_start,exam_workflow_step.frequency = inserted.frequency,exam_workflow_step.reminder_send_limit = inserted.reminder_send_limit,exam_workflow_step.step_order = inserted.step_order,exam_workflow_step.last_updated = inserted.last_updated,exam_workflow_step.updater_legal_name = inserted.updater_legal_name,exam_workflow_step.update_meaning_text = inserted.update_meaning_text,exam_workflow_step.last_updater_uid = inserted.last_updater_uid
from exam_workflow_step inner join deleted on exam_workflow_step.ews_id = deleted.ews_id inner join inserted on exam_workflow_step.ews_id = inserted.ews_id
insert into exam_workflow_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ews_id
 ,ew_id
 ,testid
 ,type
 ,description
 ,target_assessor
 ,email_profile_id
 ,no_days
 ,is_after
 ,is_at_course_start
 ,frequency
 ,reminder_send_limit
 ,step_order
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,ews_id
 ,ew_id
 ,testid
 ,type
 ,description
 ,target_assessor
 ,email_profile_id
 ,no_days
 ,is_after
 ,is_at_course_start
 ,frequency
 ,reminder_send_limit
 ,step_order
  from inserted
end
GO

create trigger d_exam_workflow_step on exam_workflow_step
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from exam_workflow_step where exists (
select 1 from deleted where exam_workflow_step.ews_id = deleted.ews_id)
insert into exam_workflow_step_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ews_id
 ,ew_id
 ,testid
 ,type
 ,description
 ,target_assessor
 ,email_profile_id
 ,no_days
 ,is_after
 ,is_at_course_start
 ,frequency
 ,reminder_send_limit
 ,step_order
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,ews_id
 ,ew_id
 ,testid
 ,type
 ,description
 ,target_assessor
 ,email_profile_id
 ,no_days
 ,is_after
 ,is_at_course_start
 ,frequency
 ,reminder_send_limit
 ,step_order
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-exam_workflow_step', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1147, '8:eff0e72b5b9b5ce33319cba414fa848a', 'enableAuditTable auditTableName=exam_workflow_step_aud, tableName=exam_workflow_step', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-task_signoff_config::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_task_signoff_config'
			)
			DROP TRIGGER i_task_signoff_config
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_task_signoff_config'
			)
			DROP TRIGGER u_task_signoff_config
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_task_signoff_config'
			)
			DROP TRIGGER d_task_signoff_config
GO

CREATE TABLE task_signoff_config_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_task_signoff_config_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learning_id nvarchar(85), signoff_type char(1), check_pre_requisites char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TASK_SIGNOFF_CONFIG_AUD PRIMARY KEY (aud_id))
GO

insert into task_signoff_config_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learning_id
 ,signoff_type
 ,check_pre_requisites
) select 'U', null
, null
, GETDATE(), null
, null
 ,learning_id
 ,signoff_type
 ,check_pre_requisites
  from task_signoff_config
GO

CREATE INDEX nuk_task_signoff_config_aud_1 ON task_signoff_config_aud(aud_userid)
GO

CREATE INDEX nuk_task_signoff_config_aud_2 ON task_signoff_config_aud(aud_datetime)
GO

create trigger i_task_signoff_config on task_signoff_config
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into task_signoff_config (
learning_id,signoff_type,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,check_pre_requisites) select learning_id,signoff_type,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,check_pre_requisites from inserted
insert into task_signoff_config_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learning_id
 ,signoff_type
 ,check_pre_requisites
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learning_id
 ,signoff_type
 ,check_pre_requisites
  from inserted
end
GO

create trigger u_task_signoff_config on task_signoff_config
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update task_signoff_config set
task_signoff_config.learning_id = inserted.learning_id,task_signoff_config.signoff_type = inserted.signoff_type,task_signoff_config.last_updated = inserted.last_updated,task_signoff_config.updater_legal_name = inserted.updater_legal_name,task_signoff_config.update_meaning_text = inserted.update_meaning_text,task_signoff_config.last_updater_uid = inserted.last_updater_uid,task_signoff_config.check_pre_requisites = inserted.check_pre_requisites
from task_signoff_config inner join deleted on task_signoff_config.learning_id = deleted.learning_id inner join inserted on task_signoff_config.learning_id = inserted.learning_id
insert into task_signoff_config_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learning_id
 ,signoff_type
 ,check_pre_requisites
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learning_id
 ,signoff_type
 ,check_pre_requisites
  from inserted
end
GO

create trigger d_task_signoff_config on task_signoff_config
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from task_signoff_config where exists (
select 1 from deleted where task_signoff_config.learning_id = deleted.learning_id)
insert into task_signoff_config_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learning_id
 ,signoff_type
 ,check_pre_requisites
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learning_id
 ,signoff_type
 ,check_pre_requisites
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-task_signoff_config', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1148, '8:3025fd2c838365f48ac8e37cfb6d1563', 'enableAuditTable auditTableName=task_signoff_config_aud, tableName=task_signoff_config', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-task_signoff_users::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_task_signoff_users'
			)
			DROP TRIGGER i_task_signoff_users
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_task_signoff_users'
			)
			DROP TRIGGER u_task_signoff_users
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_task_signoff_users'
			)
			DROP TRIGGER d_task_signoff_users
GO

CREATE TABLE task_signoff_users_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_task_signoff_users_aud_aud_datetime DEFAULT GETDATE() NOT NULL, transcript_id nvarchar(15), signoff_user_id nvarchar(85), signoff_date datetime, delegated_to nvarchar(85), delegated_by nvarchar(85), delegate_date datetime, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TASK_SIGNOFF_USERS_AUD PRIMARY KEY (aud_id))
GO

insert into task_signoff_users_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcript_id
 ,signoff_user_id
 ,signoff_date
 ,delegated_to
 ,delegated_by
 ,delegate_date
) select 'U', null
, null
, GETDATE(), null
, null
 ,transcript_id
 ,signoff_user_id
 ,signoff_date
 ,delegated_to
 ,delegated_by
 ,delegate_date
  from task_signoff_users
GO

CREATE INDEX nuk_task_signoff_users_aud_1 ON task_signoff_users_aud(aud_userid)
GO

CREATE INDEX nuk_task_signoff_users_aud_2 ON task_signoff_users_aud(aud_datetime)
GO

create trigger i_task_signoff_users on task_signoff_users
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into task_signoff_users (
transcript_id,signoff_user_id,signoff_date,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,delegated_to,delegated_by,delegate_date) select transcript_id,signoff_user_id,signoff_date,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,delegated_to,delegated_by,delegate_date from inserted
insert into task_signoff_users_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcript_id
 ,signoff_user_id
 ,signoff_date
 ,delegated_to
 ,delegated_by
 ,delegate_date
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,transcript_id
 ,signoff_user_id
 ,signoff_date
 ,delegated_to
 ,delegated_by
 ,delegate_date
  from inserted
end
GO

create trigger u_task_signoff_users on task_signoff_users
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update task_signoff_users set
task_signoff_users.transcript_id = inserted.transcript_id,task_signoff_users.signoff_user_id = inserted.signoff_user_id,task_signoff_users.signoff_date = inserted.signoff_date,task_signoff_users.last_updated = inserted.last_updated,task_signoff_users.updater_legal_name = inserted.updater_legal_name,task_signoff_users.update_meaning_text = inserted.update_meaning_text,task_signoff_users.last_updater_uid = inserted.last_updater_uid,task_signoff_users.delegated_to = inserted.delegated_to,task_signoff_users.delegated_by = inserted.delegated_by,task_signoff_users.delegate_date = inserted.delegate_date
from task_signoff_users inner join deleted on task_signoff_users.transcript_id = deleted.transcript_id inner join inserted on task_signoff_users.transcript_id = inserted.transcript_id
insert into task_signoff_users_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcript_id
 ,signoff_user_id
 ,signoff_date
 ,delegated_to
 ,delegated_by
 ,delegate_date
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,transcript_id
 ,signoff_user_id
 ,signoff_date
 ,delegated_to
 ,delegated_by
 ,delegate_date
  from inserted
end
GO

create trigger d_task_signoff_users on task_signoff_users
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from task_signoff_users where exists (
select 1 from deleted where task_signoff_users.transcript_id = deleted.transcript_id)
insert into task_signoff_users_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcript_id
 ,signoff_user_id
 ,signoff_date
 ,delegated_to
 ,delegated_by
 ,delegate_date
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,transcript_id
 ,signoff_user_id
 ,signoff_date
 ,delegated_to
 ,delegated_by
 ,delegate_date
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-task_signoff_users', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1149, '8:aadfe10b2864a134b8f7f5b632fe19be', 'enableAuditTable auditTableName=task_signoff_users_aud, tableName=task_signoff_users', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-netassessor_launcher::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_netassessor_launcher'
			)
			DROP TRIGGER i_netassessor_launcher
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_netassessor_launcher'
			)
			DROP TRIGGER u_netassessor_launcher
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_netassessor_launcher'
			)
			DROP TRIGGER d_netassessor_launcher
GO

CREATE TABLE netassessor_launcher_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_netassessor_launcher_aud_aud_datetime DEFAULT GETDATE() NOT NULL, learningid nvarchar(85), url nvarchar(85), parameters nvarchar(255), preshared_key nvarchar(85), language nvarchar(85), timezone nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_NETASSESSOR_LAUNCHER_AUD PRIMARY KEY (aud_id))
GO

insert into netassessor_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,url
 ,parameters
 ,preshared_key
 ,language
 ,timezone
) select 'U', null
, null
, GETDATE(), null
, null
 ,learningid
 ,url
 ,parameters
 ,preshared_key
 ,language
 ,timezone
  from netassessor_launcher
GO

CREATE INDEX nuk_netassessor_launcher_aud_1 ON netassessor_launcher_aud(aud_userid)
GO

CREATE INDEX nuk_netassessor_launcher_aud_2 ON netassessor_launcher_aud(aud_datetime)
GO

create trigger i_netassessor_launcher on netassessor_launcher
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into netassessor_launcher (
learningid,url,parameters,preshared_key,language,timezone,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select learningid,url,parameters,preshared_key,language,timezone,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into netassessor_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,url
 ,parameters
 ,preshared_key
 ,language
 ,timezone
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,url
 ,parameters
 ,preshared_key
 ,language
 ,timezone
  from inserted
end
GO

create trigger u_netassessor_launcher on netassessor_launcher
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update netassessor_launcher set
netassessor_launcher.learningid = inserted.learningid,netassessor_launcher.url = inserted.url,netassessor_launcher.parameters = inserted.parameters,netassessor_launcher.preshared_key = inserted.preshared_key,netassessor_launcher.language = inserted.language,netassessor_launcher.timezone = inserted.timezone,netassessor_launcher.last_updated = inserted.last_updated,netassessor_launcher.updater_legal_name = inserted.updater_legal_name,netassessor_launcher.update_meaning_text = inserted.update_meaning_text,netassessor_launcher.last_updater_uid = inserted.last_updater_uid
from netassessor_launcher inner join deleted on netassessor_launcher.learningid = deleted.learningid inner join inserted on netassessor_launcher.learningid = inserted.learningid
insert into netassessor_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,url
 ,parameters
 ,preshared_key
 ,language
 ,timezone
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,url
 ,parameters
 ,preshared_key
 ,language
 ,timezone
  from inserted
end
GO

create trigger d_netassessor_launcher on netassessor_launcher
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from netassessor_launcher where exists (
select 1 from deleted where netassessor_launcher.learningid = deleted.learningid)
insert into netassessor_launcher_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,learningid
 ,url
 ,parameters
 ,preshared_key
 ,language
 ,timezone
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,learningid
 ,url
 ,parameters
 ,preshared_key
 ,language
 ,timezone
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-netassessor_launcher', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1150, '8:47dab5f9b3a7ac4c5d826155cef9a395', 'enableAuditTable auditTableName=netassessor_launcher_aud, tableName=netassessor_launcher', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-code_subject_category::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_code_subject_category'
			)
			DROP TRIGGER i_code_subject_category
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_code_subject_category'
			)
			DROP TRIGGER u_code_subject_category
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_code_subject_category'
			)
			DROP TRIGGER d_code_subject_category
GO

CREATE TABLE code_subject_cat_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_code_subject_cat_aud_aud_datetime DEFAULT GETDATE() NOT NULL, subject_category_id nvarchar(15), description nvarchar(85), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CODE_SUBJECT_CAT_AUD PRIMARY KEY (aud_id))
GO

insert into code_subject_cat_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,subject_category_id
 ,description
) select 'U', null
, null
, GETDATE(), null
, null
 ,subject_category_id
 ,description
  from code_subject_category
GO

CREATE INDEX nuk_code_subject_cat_aud_1 ON code_subject_cat_aud(aud_userid)
GO

CREATE INDEX nuk_code_subject_cat_aud_2 ON code_subject_cat_aud(aud_datetime)
GO

create trigger i_code_subject_category on code_subject_category
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into code_subject_category (
subject_category_id,description) select subject_category_id,description from inserted
insert into code_subject_cat_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,subject_category_id
 ,description
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,subject_category_id
 ,description
  from inserted
end
GO

create trigger u_code_subject_category on code_subject_category
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update code_subject_category set
code_subject_category.subject_category_id = inserted.subject_category_id,code_subject_category.description = inserted.description
from code_subject_category inner join deleted on code_subject_category.subject_category_id = deleted.subject_category_id inner join inserted on code_subject_category.subject_category_id = inserted.subject_category_id
insert into code_subject_cat_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,subject_category_id
 ,description
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,subject_category_id
 ,description
  from inserted
end
GO

create trigger d_code_subject_category on code_subject_category
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from code_subject_category where exists (
select 1 from deleted where code_subject_category.subject_category_id = deleted.subject_category_id)
insert into code_subject_cat_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,subject_category_id
 ,description
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,subject_category_id
 ,description
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-code_subject_category', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1151, '8:f8f13e091905e425766901cf7bbddce9', 'enableAuditTable auditTableName=code_subject_cat_aud, tableName=code_subject_category', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-code_subject::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_code_subject'
			)
			DROP TRIGGER i_code_subject
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_code_subject'
			)
			DROP TRIGGER u_code_subject
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_code_subject'
			)
			DROP TRIGGER d_code_subject
GO

CREATE TABLE code_subject_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_code_subject_aud_aud_datetime DEFAULT GETDATE() NOT NULL, subjectid int, description nvarchar(50), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CODE_SUBJECT_AUD PRIMARY KEY (aud_id))
GO

insert into code_subject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,subjectid
 ,description
) select 'U', null
, null
, GETDATE(), null
, null
 ,subjectid
 ,description
  from code_subject
GO

CREATE INDEX nuk_code_subject_aud_1 ON code_subject_aud(aud_userid)
GO

CREATE INDEX nuk_code_subject_aud_2 ON code_subject_aud(aud_datetime)
GO

create trigger i_code_subject on code_subject
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into code_subject (
subjectid,description) select subjectid,description from inserted
insert into code_subject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,subjectid
 ,description
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,subjectid
 ,description
  from inserted
end
GO

create trigger u_code_subject on code_subject
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update code_subject set
code_subject.subjectid = inserted.subjectid,code_subject.description = inserted.description
from code_subject inner join deleted on code_subject.subjectid = deleted.subjectid inner join inserted on code_subject.subjectid = inserted.subjectid
insert into code_subject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,subjectid
 ,description
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,subjectid
 ,description
  from inserted
end
GO

create trigger d_code_subject on code_subject
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from code_subject where exists (
select 1 from deleted where code_subject.subjectid = deleted.subjectid)
insert into code_subject_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,subjectid
 ,description
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,subjectid
 ,description
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-code_subject', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1152, '8:ada3e4ffc4b4f149a19d71946a075433', 'enableAuditTable auditTableName=code_subject_aud, tableName=code_subject', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-code_vendorname::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_code_vendorname'
			)
			DROP TRIGGER i_code_vendorname
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_code_vendorname'
			)
			DROP TRIGGER u_code_vendorname
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_code_vendorname'
			)
			DROP TRIGGER d_code_vendorname
GO

CREATE TABLE code_vendorname_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_code_vendorname_aud_aud_datetime DEFAULT GETDATE() NOT NULL, vendorname varchar(100), description nvarchar(255), picture nvarchar(500), show_picture char(1), vendor_ref_code nvarchar(100), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CODE_VENDORNAME_AUD PRIMARY KEY (aud_id))
GO

insert into code_vendorname_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,vendorname
 ,description
 ,picture
 ,show_picture
 ,vendor_ref_code
) select 'U', null
, null
, GETDATE(), null
, null
 ,vendorname
 ,description
 ,picture
 ,show_picture
 ,vendor_ref_code
  from code_vendorname
GO

CREATE INDEX nuk_code_vendorname_aud_1 ON code_vendorname_aud(aud_userid)
GO

CREATE INDEX nuk_code_vendorname_aud_2 ON code_vendorname_aud(aud_datetime)
GO

create trigger i_code_vendorname on code_vendorname
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into code_vendorname (
vendorname,description,picture,show_picture,vendor_ref_code) select vendorname,description,picture,show_picture,vendor_ref_code from inserted
insert into code_vendorname_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,vendorname
 ,description
 ,picture
 ,show_picture
 ,vendor_ref_code
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,vendorname
 ,description
 ,picture
 ,show_picture
 ,vendor_ref_code
  from inserted
end
GO

create trigger u_code_vendorname on code_vendorname
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update code_vendorname set
code_vendorname.vendorname = inserted.vendorname,code_vendorname.description = inserted.description,code_vendorname.picture = inserted.picture,code_vendorname.show_picture = inserted.show_picture,code_vendorname.vendor_ref_code = inserted.vendor_ref_code
from code_vendorname inner join deleted on code_vendorname.vendorname = deleted.vendorname inner join inserted on code_vendorname.vendorname = inserted.vendorname
insert into code_vendorname_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,vendorname
 ,description
 ,picture
 ,show_picture
 ,vendor_ref_code
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,vendorname
 ,description
 ,picture
 ,show_picture
 ,vendor_ref_code
  from inserted
end
GO

create trigger d_code_vendorname on code_vendorname
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from code_vendorname where exists (
select 1 from deleted where code_vendorname.vendorname = deleted.vendorname)
insert into code_vendorname_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,vendorname
 ,description
 ,picture
 ,show_picture
 ,vendor_ref_code
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,vendorname
 ,description
 ,picture
 ,show_picture
 ,vendor_ref_code
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-code_vendorname', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1153, '8:0019d954a70708338b8d9fefdbeb15f2', 'enableAuditTable auditTableName=code_vendorname_aud, tableName=code_vendorname', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-code_itemLanguage::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_code_itemLanguage'
			)
			DROP TRIGGER i_code_itemLanguage
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_code_itemLanguage'
			)
			DROP TRIGGER u_code_itemLanguage
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_code_itemLanguage'
			)
			DROP TRIGGER d_code_itemLanguage
GO

CREATE TABLE code_itemLanguage_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_code_itemLanguage_aud_aud_datetime DEFAULT GETDATE() NOT NULL, ilangid smallint, description nvarchar(50), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CODE_ITEMLANGUAGE_AUD PRIMARY KEY (aud_id))
GO

insert into code_itemLanguage_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ilangid
 ,description
) select 'U', null
, null
, GETDATE(), null
, null
 ,ilangid
 ,description
  from code_itemLanguage
GO

CREATE INDEX nuk_code_itemLanguage_aud_1 ON code_itemLanguage_aud(aud_userid)
GO

CREATE INDEX nuk_code_itemLanguage_aud_2 ON code_itemLanguage_aud(aud_datetime)
GO

create trigger i_code_itemLanguage on code_itemLanguage
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into code_itemLanguage (
ilangid,description) select ilangid,description from inserted
insert into code_itemLanguage_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ilangid
 ,description
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,ilangid
 ,description
  from inserted
end
GO

create trigger u_code_itemLanguage on code_itemLanguage
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update code_itemLanguage set
code_itemLanguage.ilangid = inserted.ilangid,code_itemLanguage.description = inserted.description
from code_itemLanguage inner join deleted on code_itemLanguage.ilangid = deleted.ilangid inner join inserted on code_itemLanguage.ilangid = inserted.ilangid
insert into code_itemLanguage_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ilangid
 ,description
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,ilangid
 ,description
  from inserted
end
GO

create trigger d_code_itemLanguage on code_itemLanguage
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from code_itemLanguage where exists (
select 1 from deleted where code_itemLanguage.ilangid = deleted.ilangid)
insert into code_itemLanguage_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,ilangid
 ,description
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,ilangid
 ,description
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-code_itemLanguage', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1154, '8:3832a72a30a218ceff85653c569f018b', 'enableAuditTable auditTableName=code_itemLanguage_aud, tableName=code_itemLanguage', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-logical_domain_config::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_logical_domain_config'
			)
			DROP TRIGGER i_logical_domain_config
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_logical_domain_config'
			)
			DROP TRIGGER u_logical_domain_config
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_logical_domain_config'
			)
			DROP TRIGGER d_logical_domain_config
GO

CREATE TABLE log_dom_conf_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_log_dom_conf_aud_aud_datetime DEFAULT GETDATE() NOT NULL, domain_id nvarchar(15), config_key nvarchar(255), config_value nvarchar(MAX), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_LOG_DOM_CONF_AUD PRIMARY KEY (aud_id))
GO

insert into log_dom_conf_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,domain_id
 ,config_key
 ,config_value
) select 'U', null
, null
, GETDATE(), null
, null
 ,domain_id
 ,config_key
 ,config_value
  from logical_domain_config
GO

CREATE INDEX nuk_log_dom_conf_aud_1 ON log_dom_conf_aud(aud_userid)
GO

CREATE INDEX nuk_log_dom_conf_aud_2 ON log_dom_conf_aud(aud_datetime)
GO

create trigger i_logical_domain_config on logical_domain_config
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into logical_domain_config (
domain_id,config_key,config_value) select domain_id,config_key,config_value from inserted
insert into log_dom_conf_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,domain_id
 ,config_key
 ,config_value
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,domain_id
 ,config_key
 ,config_value
  from inserted
end
GO

create trigger u_logical_domain_config on logical_domain_config
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update logical_domain_config set
logical_domain_config.domain_id = inserted.domain_id,logical_domain_config.config_key = inserted.config_key,logical_domain_config.config_value = inserted.config_value
from logical_domain_config inner join deleted on logical_domain_config.domain_id = deleted.domain_id and logical_domain_config.config_key = deleted.config_key inner join inserted on logical_domain_config.domain_id = inserted.domain_id and logical_domain_config.config_key = inserted.config_key
insert into log_dom_conf_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,domain_id
 ,config_key
 ,config_value
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,domain_id
 ,config_key
 ,config_value
  from inserted
end
GO

create trigger d_logical_domain_config on logical_domain_config
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from logical_domain_config where exists (
select 1 from deleted where logical_domain_config.domain_id = deleted.domain_id and logical_domain_config.config_key = deleted.config_key)
insert into log_dom_conf_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,domain_id
 ,config_key
 ,config_value
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,domain_id
 ,config_key
 ,config_value
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-logical_domain_config', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1155, '8:e97923a18444a47c8310436001544924', 'enableAuditTable auditTableName=log_dom_conf_aud, tableName=logical_domain_config', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-vc_launcher_gtt::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_vc_launcher_gtt'
			)
			DROP TRIGGER i_vc_launcher_gtt
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_vc_launcher_gtt'
			)
			DROP TRIGGER u_vc_launcher_gtt
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_vc_launcher_gtt'
			)
			DROP TRIGGER d_vc_launcher_gtt
GO

CREATE TABLE vc_launcher_gtt_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_vc_launcher_gtt_aud_aud_datetime DEFAULT GETDATE() NOT NULL, course_id nvarchar(85), gtt_app_id nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_VC_LAUNCHER_GTT_AUD PRIMARY KEY (aud_id))
GO

insert into vc_launcher_gtt_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,gtt_app_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,course_id
 ,gtt_app_id
  from vc_launcher_gtt
GO

CREATE INDEX nuk_vc_launcher_gtt_aud_1 ON vc_launcher_gtt_aud(aud_userid)
GO

CREATE INDEX nuk_vc_launcher_gtt_aud_2 ON vc_launcher_gtt_aud(aud_datetime)
GO

create trigger i_vc_launcher_gtt on vc_launcher_gtt
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into vc_launcher_gtt (
course_id,gtt_app_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select course_id,gtt_app_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into vc_launcher_gtt_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,gtt_app_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,gtt_app_id
  from inserted
end
GO

create trigger u_vc_launcher_gtt on vc_launcher_gtt
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update vc_launcher_gtt set
vc_launcher_gtt.course_id = inserted.course_id,vc_launcher_gtt.gtt_app_id = inserted.gtt_app_id,vc_launcher_gtt.last_updated = inserted.last_updated,vc_launcher_gtt.updater_legal_name = inserted.updater_legal_name,vc_launcher_gtt.update_meaning_text = inserted.update_meaning_text,vc_launcher_gtt.last_updater_uid = inserted.last_updater_uid
from vc_launcher_gtt inner join deleted on vc_launcher_gtt.course_id = deleted.course_id inner join inserted on vc_launcher_gtt.course_id = inserted.course_id
insert into vc_launcher_gtt_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,gtt_app_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,gtt_app_id
  from inserted
end
GO

create trigger d_vc_launcher_gtt on vc_launcher_gtt
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from vc_launcher_gtt where exists (
select 1 from deleted where vc_launcher_gtt.course_id = deleted.course_id)
insert into vc_launcher_gtt_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,gtt_app_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,gtt_app_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-vc_launcher_gtt', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1156, '8:14d288613f3b962f4c1bbf87e001e4bf', 'enableAuditTable auditTableName=vc_launcher_gtt_aud, tableName=vc_launcher_gtt', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-vc_launcher_gtt_training::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_vc_launcher_gtt_training'
			)
			DROP TRIGGER i_vc_launcher_gtt_training
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_vc_launcher_gtt_training'
			)
			DROP TRIGGER u_vc_launcher_gtt_training
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_vc_launcher_gtt_training'
			)
			DROP TRIGGER d_vc_launcher_gtt_training
GO

CREATE TABLE vc_launch_gtt_train_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_vc_launch_gtt_train_aud_aud_datetime DEFAULT GETDATE() NOT NULL, eventid nvarchar(15), user_id nvarchar(85), course_id nvarchar(85), training_key nvarchar(85), is_updated char(1), is_organizer_updated char(1), is_training_history_sync char(1), last_sync_date datetime, overall_status int, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_VC_LAUNCH_GTT_TRAIN_AUD PRIMARY KEY (aud_id))
GO

insert into vc_launch_gtt_train_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,user_id
 ,course_id
 ,training_key
 ,is_updated
 ,is_organizer_updated
 ,is_training_history_sync
 ,last_sync_date
 ,overall_status
) select 'U', null
, null
, GETDATE(), null
, null
 ,eventid
 ,user_id
 ,course_id
 ,training_key
 ,is_updated
 ,is_organizer_updated
 ,is_training_history_sync
 ,last_sync_date
 ,overall_status
  from vc_launcher_gtt_training
GO

CREATE INDEX nuk_vc_launch_gtt_train_aud_1 ON vc_launch_gtt_train_aud(aud_userid)
GO

CREATE INDEX nuk_vc_launch_gtt_train_aud_2 ON vc_launch_gtt_train_aud(aud_datetime)
GO

create trigger i_vc_launcher_gtt_training on vc_launcher_gtt_training
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into vc_launcher_gtt_training (
eventid,user_id,course_id,training_key,is_updated,is_organizer_updated,is_training_history_sync,last_sync_date,overall_status,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select eventid,user_id,course_id,training_key,is_updated,is_organizer_updated,is_training_history_sync,last_sync_date,overall_status,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into vc_launch_gtt_train_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,user_id
 ,course_id
 ,training_key
 ,is_updated
 ,is_organizer_updated
 ,is_training_history_sync
 ,last_sync_date
 ,overall_status
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,user_id
 ,course_id
 ,training_key
 ,is_updated
 ,is_organizer_updated
 ,is_training_history_sync
 ,last_sync_date
 ,overall_status
  from inserted
end
GO

create trigger u_vc_launcher_gtt_training on vc_launcher_gtt_training
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update vc_launcher_gtt_training set
vc_launcher_gtt_training.eventid = inserted.eventid,vc_launcher_gtt_training.user_id = inserted.user_id,vc_launcher_gtt_training.course_id = inserted.course_id,vc_launcher_gtt_training.training_key = inserted.training_key,vc_launcher_gtt_training.is_updated = inserted.is_updated,vc_launcher_gtt_training.is_organizer_updated = inserted.is_organizer_updated,vc_launcher_gtt_training.is_training_history_sync = inserted.is_training_history_sync,vc_launcher_gtt_training.last_sync_date = inserted.last_sync_date,vc_launcher_gtt_training.overall_status = inserted.overall_status,vc_launcher_gtt_training.last_updated = inserted.last_updated,vc_launcher_gtt_training.updater_legal_name = inserted.updater_legal_name,vc_launcher_gtt_training.update_meaning_text = inserted.update_meaning_text,vc_launcher_gtt_training.last_updater_uid = inserted.last_updater_uid
from vc_launcher_gtt_training inner join deleted on vc_launcher_gtt_training.eventid = deleted.eventid inner join inserted on vc_launcher_gtt_training.eventid = inserted.eventid
insert into vc_launch_gtt_train_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,user_id
 ,course_id
 ,training_key
 ,is_updated
 ,is_organizer_updated
 ,is_training_history_sync
 ,last_sync_date
 ,overall_status
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,user_id
 ,course_id
 ,training_key
 ,is_updated
 ,is_organizer_updated
 ,is_training_history_sync
 ,last_sync_date
 ,overall_status
  from inserted
end
GO

create trigger d_vc_launcher_gtt_training on vc_launcher_gtt_training
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from vc_launcher_gtt_training where exists (
select 1 from deleted where vc_launcher_gtt_training.eventid = deleted.eventid)
insert into vc_launch_gtt_train_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,eventid
 ,user_id
 ,course_id
 ,training_key
 ,is_updated
 ,is_organizer_updated
 ,is_training_history_sync
 ,last_sync_date
 ,overall_status
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,eventid
 ,user_id
 ,course_id
 ,training_key
 ,is_updated
 ,is_organizer_updated
 ,is_training_history_sync
 ,last_sync_date
 ,overall_status
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-vc_launcher_gtt_training', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1157, '8:a5748466256375962c4b9524c846cd15', 'enableAuditTable auditTableName=vc_launch_gtt_train_aud, tableName=vc_launcher_gtt_training', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-vc_launcher_gtt_organizer::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_vc_launcher_gtt_organizer'
			)
			DROP TRIGGER i_vc_launcher_gtt_organizer
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_vc_launcher_gtt_organizer'
			)
			DROP TRIGGER u_vc_launcher_gtt_organizer
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_vc_launcher_gtt_organizer'
			)
			DROP TRIGGER d_vc_launcher_gtt_organizer
GO

CREATE TABLE vc_launcher_gtt_org_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_vc_launcher_gtt_org_aud_aud_datetime DEFAULT GETDATE() NOT NULL, user_id nvarchar(85), eventid nvarchar(15), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_VC_LAUNCHER_GTT_ORG_AUD PRIMARY KEY (aud_id))
GO

insert into vc_launcher_gtt_org_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,eventid
) select 'U', null
, null
, GETDATE(), null
, null
 ,user_id
 ,eventid
  from vc_launcher_gtt_organizer
GO

CREATE INDEX nuk_vc_launcher_gtt_org_aud_1 ON vc_launcher_gtt_org_aud(aud_userid)
GO

CREATE INDEX nuk_vc_launcher_gtt_org_aud_2 ON vc_launcher_gtt_org_aud(aud_datetime)
GO

create trigger i_vc_launcher_gtt_organizer on vc_launcher_gtt_organizer
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into vc_launcher_gtt_organizer (
user_id,eventid,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select user_id,eventid,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into vc_launcher_gtt_org_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,eventid
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,user_id
 ,eventid
  from inserted
end
GO

create trigger u_vc_launcher_gtt_organizer on vc_launcher_gtt_organizer
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update vc_launcher_gtt_organizer set
vc_launcher_gtt_organizer.user_id = inserted.user_id,vc_launcher_gtt_organizer.eventid = inserted.eventid,vc_launcher_gtt_organizer.last_updated = inserted.last_updated,vc_launcher_gtt_organizer.updater_legal_name = inserted.updater_legal_name,vc_launcher_gtt_organizer.update_meaning_text = inserted.update_meaning_text,vc_launcher_gtt_organizer.last_updater_uid = inserted.last_updater_uid
from vc_launcher_gtt_organizer inner join deleted on vc_launcher_gtt_organizer.user_id = deleted.user_id and vc_launcher_gtt_organizer.eventid = deleted.eventid inner join inserted on vc_launcher_gtt_organizer.user_id = inserted.user_id and vc_launcher_gtt_organizer.eventid = inserted.eventid
insert into vc_launcher_gtt_org_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,eventid
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,user_id
 ,eventid
  from inserted
end
GO

create trigger d_vc_launcher_gtt_organizer on vc_launcher_gtt_organizer
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from vc_launcher_gtt_organizer where exists (
select 1 from deleted where vc_launcher_gtt_organizer.user_id = deleted.user_id and vc_launcher_gtt_organizer.eventid = deleted.eventid)
insert into vc_launcher_gtt_org_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,user_id
 ,eventid
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,user_id
 ,eventid
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-vc_launcher_gtt_organizer', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1158, '8:504c68a4959e167b2c43570347a97f05', 'enableAuditTable auditTableName=vc_launcher_gtt_org_aud, tableName=vc_launcher_gtt_organizer', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-course_competency_exp::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_course_competency_exp'
			)
			DROP TRIGGER i_course_competency_exp
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_course_competency_exp'
			)
			DROP TRIGGER u_course_competency_exp
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_course_competency_exp'
			)
			DROP TRIGGER d_course_competency_exp
GO

CREATE TABLE course_comp_exp_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_course_comp_exp_aud_aud_datetime DEFAULT GETDATE() NOT NULL, course_id nvarchar(85), competency_id nvarchar(15), user_id nvarchar(85), expiry_date datetime, id nvarchar(85), complete_date datetime, last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSE_COMP_EXP_AUD PRIMARY KEY (aud_id))
GO

insert into course_comp_exp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,competency_id
 ,user_id
 ,expiry_date
 ,id
 ,complete_date
) select 'U', null
, null
, GETDATE(), null
, null
 ,course_id
 ,competency_id
 ,user_id
 ,expiry_date
 ,id
 ,complete_date
  from course_competency_exp
GO

CREATE INDEX nuk_course_comp_exp_aud_1 ON course_comp_exp_aud(aud_userid)
GO

CREATE INDEX nuk_course_comp_exp_aud_2 ON course_comp_exp_aud(aud_datetime)
GO

create trigger i_course_competency_exp on course_competency_exp
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into course_competency_exp (
course_id,competency_id,user_id,expiry_date,id,complete_date) select course_id,competency_id,user_id,expiry_date,id,complete_date from inserted
insert into course_comp_exp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,competency_id
 ,user_id
 ,expiry_date
 ,id
 ,complete_date
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,competency_id
 ,user_id
 ,expiry_date
 ,id
 ,complete_date
  from inserted
end
GO

create trigger u_course_competency_exp on course_competency_exp
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update course_competency_exp set
course_competency_exp.course_id = inserted.course_id,course_competency_exp.competency_id = inserted.competency_id,course_competency_exp.user_id = inserted.user_id,course_competency_exp.expiry_date = inserted.expiry_date,course_competency_exp.id = inserted.id,course_competency_exp.complete_date = inserted.complete_date
from course_competency_exp inner join deleted on course_competency_exp.id = deleted.id inner join inserted on course_competency_exp.id = inserted.id
insert into course_comp_exp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,competency_id
 ,user_id
 ,expiry_date
 ,id
 ,complete_date
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,competency_id
 ,user_id
 ,expiry_date
 ,id
 ,complete_date
  from inserted
end
GO

create trigger d_course_competency_exp on course_competency_exp
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from course_competency_exp where exists (
select 1 from deleted where course_competency_exp.id = deleted.id)
insert into course_comp_exp_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,competency_id
 ,user_id
 ,expiry_date
 ,id
 ,complete_date
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,competency_id
 ,user_id
 ,expiry_date
 ,id
 ,complete_date
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-course_competency_exp', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1159, '8:10f82afcbe55e6509c6edf7f12d58b43', 'enableAuditTable auditTableName=course_comp_exp_aud, tableName=course_competency_exp', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-certifications::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_certifications'
			)
			DROP TRIGGER i_certifications
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_certifications'
			)
			DROP TRIGGER u_certifications
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_certifications'
			)
			DROP TRIGGER d_certifications
GO

CREATE TABLE certifications_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_certifications_aud_aud_datetime DEFAULT GETDATE() NOT NULL, certid numeric(8, 0), title nvarchar(1000), certification_code nvarchar(85), description nvarchar(1000), testid nvarchar(100), dateentered datetime, certstatus smallint, valid_period int, testtype nvarchar(1), issuedby nvarchar(50), sendreminderdays int, award_email_profile_id nvarchar(15), poolid int, certtype int, allowUserPrint char(1), templateid nvarchar(15), cert_expire_email_profile_id nvarchar(15), sessionid nvarchar(15), learningid nvarchar(85), creator_uid nvarchar(85), datecreated datetime, expiregraceperiod char(1), fixed_expire_date datetime, award_email_attach_cert varchar(20), expiration_type char(1), renewable char(1), valid_period_unit char(1), renewable_period int, renewable_period_unit char(1), title_key nvarchar(85), description_key nvarchar(85), awardmethod char(1), prev_expire_date_based char(1), test_lang_option nvarchar(85), use_autoenroll_filter char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CERTIFICATIONS_AUD PRIMARY KEY (aud_id))
GO

insert into certifications_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,title
 ,certification_code
 ,description
 ,testid
 ,dateentered
 ,certstatus
 ,valid_period
 ,testtype
 ,issuedby
 ,sendreminderdays
 ,award_email_profile_id
 ,poolid
 ,certtype
 ,allowUserPrint
 ,templateid
 ,cert_expire_email_profile_id
 ,sessionid
 ,learningid
 ,creator_uid
 ,datecreated
 ,expiregraceperiod
 ,fixed_expire_date
 ,award_email_attach_cert
 ,expiration_type
 ,renewable
 ,valid_period_unit
 ,renewable_period
 ,renewable_period_unit
 ,title_key
 ,description_key
 ,awardmethod
 ,prev_expire_date_based
 ,test_lang_option
 ,use_autoenroll_filter
) select 'U', null
, null
, GETDATE(), null
, null
 ,certid
 ,title
 ,certification_code
 ,description
 ,testid
 ,dateentered
 ,certstatus
 ,valid_period
 ,testtype
 ,issuedby
 ,sendreminderdays
 ,award_email_profile_id
 ,poolid
 ,certtype
 ,allowUserPrint
 ,templateid
 ,cert_expire_email_profile_id
 ,sessionid
 ,learningid
 ,creator_uid
 ,datecreated
 ,expiregraceperiod
 ,fixed_expire_date
 ,award_email_attach_cert
 ,expiration_type
 ,renewable
 ,valid_period_unit
 ,renewable_period
 ,renewable_period_unit
 ,title_key
 ,description_key
 ,awardmethod
 ,prev_expire_date_based
 ,test_lang_option
 ,use_autoenroll_filter
  from certifications
GO

CREATE INDEX nuk_certifications_aud_1 ON certifications_aud(aud_userid)
GO

CREATE INDEX nuk_certifications_aud_2 ON certifications_aud(aud_datetime)
GO

create trigger i_certifications on certifications
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into certifications (
certid,title,certification_code,description,testid,dateentered,certstatus,valid_period,testtype,issuedby,sendreminderdays,award_email_profile_id,poolid,certtype,allowUserPrint,templateid,cert_expire_email_profile_id,sessionid,learningid,creator_uid,datecreated,last_updated,last_updater_uid,expiregraceperiod,fixed_expire_date,award_email_attach_cert,expiration_type,renewable,updater_legal_name,update_meaning_text,valid_period_unit,renewable_period,renewable_period_unit,title_key,description_key,awardmethod,prev_expire_date_based,test_lang_option,use_autoenroll_filter) select certid,title,certification_code,description,testid,dateentered,certstatus,valid_period,testtype,issuedby,sendreminderdays,award_email_profile_id,poolid,certtype,allowUserPrint,templateid,cert_expire_email_profile_id,sessionid,learningid,creator_uid,datecreated,last_updated,last_updater_uid,expiregraceperiod,fixed_expire_date,award_email_attach_cert,expiration_type,renewable,updater_legal_name,update_meaning_text,valid_period_unit,renewable_period,renewable_period_unit,title_key,description_key,awardmethod,prev_expire_date_based,test_lang_option,use_autoenroll_filter from inserted
insert into certifications_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,title
 ,certification_code
 ,description
 ,testid
 ,dateentered
 ,certstatus
 ,valid_period
 ,testtype
 ,issuedby
 ,sendreminderdays
 ,award_email_profile_id
 ,poolid
 ,certtype
 ,allowUserPrint
 ,templateid
 ,cert_expire_email_profile_id
 ,sessionid
 ,learningid
 ,creator_uid
 ,datecreated
 ,expiregraceperiod
 ,fixed_expire_date
 ,award_email_attach_cert
 ,expiration_type
 ,renewable
 ,valid_period_unit
 ,renewable_period
 ,renewable_period_unit
 ,title_key
 ,description_key
 ,awardmethod
 ,prev_expire_date_based
 ,test_lang_option
 ,use_autoenroll_filter
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,title
 ,certification_code
 ,description
 ,testid
 ,dateentered
 ,certstatus
 ,valid_period
 ,testtype
 ,issuedby
 ,sendreminderdays
 ,award_email_profile_id
 ,poolid
 ,certtype
 ,allowUserPrint
 ,templateid
 ,cert_expire_email_profile_id
 ,sessionid
 ,learningid
 ,creator_uid
 ,datecreated
 ,expiregraceperiod
 ,fixed_expire_date
 ,award_email_attach_cert
 ,expiration_type
 ,renewable
 ,valid_period_unit
 ,renewable_period
 ,renewable_period_unit
 ,title_key
 ,description_key
 ,awardmethod
 ,prev_expire_date_based
 ,test_lang_option
 ,use_autoenroll_filter
  from inserted
end
GO

create trigger u_certifications on certifications
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update certifications set
certifications.certid = inserted.certid,certifications.title = inserted.title,certifications.certification_code = inserted.certification_code,certifications.description = inserted.description,certifications.testid = inserted.testid,certifications.dateentered = inserted.dateentered,certifications.certstatus = inserted.certstatus,certifications.valid_period = inserted.valid_period,certifications.testtype = inserted.testtype,certifications.issuedby = inserted.issuedby,certifications.sendreminderdays = inserted.sendreminderdays,certifications.award_email_profile_id = inserted.award_email_profile_id,certifications.poolid = inserted.poolid,certifications.certtype = inserted.certtype,certifications.allowUserPrint = inserted.allowUserPrint,certifications.templateid = inserted.templateid,certifications.cert_expire_email_profile_id = inserted.cert_expire_email_profile_id,certifications.sessionid = inserted.sessionid,certifications.learningid = inserted.learningid,certifications.creator_uid = inserted.creator_uid,certifications.datecreated = inserted.datecreated,certifications.last_updated = inserted.last_updated,certifications.last_updater_uid = inserted.last_updater_uid,certifications.expiregraceperiod = inserted.expiregraceperiod,certifications.fixed_expire_date = inserted.fixed_expire_date,certifications.award_email_attach_cert = inserted.award_email_attach_cert,certifications.expiration_type = inserted.expiration_type,certifications.renewable = inserted.renewable,certifications.updater_legal_name = inserted.updater_legal_name,certifications.update_meaning_text = inserted.update_meaning_text,certifications.valid_period_unit = inserted.valid_period_unit,certifications.renewable_period = inserted.renewable_period,certifications.renewable_period_unit = inserted.renewable_period_unit,certifications.title_key = inserted.title_key,certifications.description_key = inserted.description_key,certifications.awardmethod = inserted.awardmethod,certifications.prev_expire_date_based = inserted.prev_expire_date_based,certifications.test_lang_option = inserted.test_lang_option,certifications.use_autoenroll_filter = inserted.use_autoenroll_filter
from certifications inner join deleted on certifications.certid = deleted.certid inner join inserted on certifications.certid = inserted.certid
insert into certifications_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,title
 ,certification_code
 ,description
 ,testid
 ,dateentered
 ,certstatus
 ,valid_period
 ,testtype
 ,issuedby
 ,sendreminderdays
 ,award_email_profile_id
 ,poolid
 ,certtype
 ,allowUserPrint
 ,templateid
 ,cert_expire_email_profile_id
 ,sessionid
 ,learningid
 ,creator_uid
 ,datecreated
 ,expiregraceperiod
 ,fixed_expire_date
 ,award_email_attach_cert
 ,expiration_type
 ,renewable
 ,valid_period_unit
 ,renewable_period
 ,renewable_period_unit
 ,title_key
 ,description_key
 ,awardmethod
 ,prev_expire_date_based
 ,test_lang_option
 ,use_autoenroll_filter
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,title
 ,certification_code
 ,description
 ,testid
 ,dateentered
 ,certstatus
 ,valid_period
 ,testtype
 ,issuedby
 ,sendreminderdays
 ,award_email_profile_id
 ,poolid
 ,certtype
 ,allowUserPrint
 ,templateid
 ,cert_expire_email_profile_id
 ,sessionid
 ,learningid
 ,creator_uid
 ,datecreated
 ,expiregraceperiod
 ,fixed_expire_date
 ,award_email_attach_cert
 ,expiration_type
 ,renewable
 ,valid_period_unit
 ,renewable_period
 ,renewable_period_unit
 ,title_key
 ,description_key
 ,awardmethod
 ,prev_expire_date_based
 ,test_lang_option
 ,use_autoenroll_filter
  from inserted
end
GO

create trigger d_certifications on certifications
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from certifications where exists (
select 1 from deleted where certifications.certid = deleted.certid)
insert into certifications_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,title
 ,certification_code
 ,description
 ,testid
 ,dateentered
 ,certstatus
 ,valid_period
 ,testtype
 ,issuedby
 ,sendreminderdays
 ,award_email_profile_id
 ,poolid
 ,certtype
 ,allowUserPrint
 ,templateid
 ,cert_expire_email_profile_id
 ,sessionid
 ,learningid
 ,creator_uid
 ,datecreated
 ,expiregraceperiod
 ,fixed_expire_date
 ,award_email_attach_cert
 ,expiration_type
 ,renewable
 ,valid_period_unit
 ,renewable_period
 ,renewable_period_unit
 ,title_key
 ,description_key
 ,awardmethod
 ,prev_expire_date_based
 ,test_lang_option
 ,use_autoenroll_filter
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,title
 ,certification_code
 ,description
 ,testid
 ,dateentered
 ,certstatus
 ,valid_period
 ,testtype
 ,issuedby
 ,sendreminderdays
 ,award_email_profile_id
 ,poolid
 ,certtype
 ,allowUserPrint
 ,templateid
 ,cert_expire_email_profile_id
 ,sessionid
 ,learningid
 ,creator_uid
 ,datecreated
 ,expiregraceperiod
 ,fixed_expire_date
 ,award_email_attach_cert
 ,expiration_type
 ,renewable
 ,valid_period_unit
 ,renewable_period
 ,renewable_period_unit
 ,title_key
 ,description_key
 ,awardmethod
 ,prev_expire_date_based
 ,test_lang_option
 ,use_autoenroll_filter
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-certifications', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1160, '8:864e3e1493c58027ad3d7b1276539e8f', 'enableAuditTable auditTableName=certifications_aud, tableName=certifications', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-cert_autoenroll::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_cert_autoenroll'
			)
			DROP TRIGGER i_cert_autoenroll
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_cert_autoenroll'
			)
			DROP TRIGGER u_cert_autoenroll
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_cert_autoenroll'
			)
			DROP TRIGGER d_cert_autoenroll
GO

CREATE TABLE cert_autoenroll_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_cert_autoenroll_aud_aud_datetime DEFAULT GETDATE() NOT NULL, certid numeric(8, 0), targetType nvarchar(3), targetValue nvarchar(85), startdate datetime, enddate datetime, durationenabled char(1), durationamount int, durationunit smallint, durationType nvarchar(10), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CERT_AUTOENROLL_AUD PRIMARY KEY (aud_id))
GO

insert into cert_autoenroll_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,targetType
 ,targetValue
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,durationType
) select 'U', null
, null
, GETDATE(), null
, null
 ,certid
 ,targetType
 ,targetValue
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,durationType
  from cert_autoenroll
GO

CREATE INDEX nuk_cert_autoenroll_aud_1 ON cert_autoenroll_aud(aud_userid)
GO

CREATE INDEX nuk_cert_autoenroll_aud_2 ON cert_autoenroll_aud(aud_datetime)
GO

create trigger i_cert_autoenroll on cert_autoenroll
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into cert_autoenroll (
certid,targetType,targetValue,startdate,enddate,durationenabled,durationamount,durationunit,durationType) select certid,targetType,targetValue,startdate,enddate,durationenabled,durationamount,durationunit,durationType from inserted
insert into cert_autoenroll_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,targetType
 ,targetValue
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,durationType
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,targetType
 ,targetValue
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,durationType
  from inserted
end
GO

create trigger u_cert_autoenroll on cert_autoenroll
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update cert_autoenroll set
cert_autoenroll.certid = inserted.certid,cert_autoenroll.targetType = inserted.targetType,cert_autoenroll.targetValue = inserted.targetValue,cert_autoenroll.startdate = inserted.startdate,cert_autoenroll.enddate = inserted.enddate,cert_autoenroll.durationenabled = inserted.durationenabled,cert_autoenroll.durationamount = inserted.durationamount,cert_autoenroll.durationunit = inserted.durationunit,cert_autoenroll.durationType = inserted.durationType
from cert_autoenroll inner join deleted on cert_autoenroll.certid = deleted.certid and cert_autoenroll.targetType = deleted.targetType and cert_autoenroll.targetValue = deleted.targetValue inner join inserted on cert_autoenroll.certid = inserted.certid and cert_autoenroll.targetType = inserted.targetType and cert_autoenroll.targetValue = inserted.targetValue
insert into cert_autoenroll_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,targetType
 ,targetValue
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,durationType
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,targetType
 ,targetValue
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,durationType
  from inserted
end
GO

create trigger d_cert_autoenroll on cert_autoenroll
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from cert_autoenroll where exists (
select 1 from deleted where cert_autoenroll.certid = deleted.certid and cert_autoenroll.targetType = deleted.targetType and cert_autoenroll.targetValue = deleted.targetValue)
insert into cert_autoenroll_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,targetType
 ,targetValue
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,durationType
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,targetType
 ,targetValue
 ,startdate
 ,enddate
 ,durationenabled
 ,durationamount
 ,durationunit
 ,durationType
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-cert_autoenroll', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1161, '8:fc3ce9c2f53dd49ce9ab794e78612000', 'enableAuditTable auditTableName=cert_autoenroll_aud, tableName=cert_autoenroll', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-cert_renewal::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_cert_renewal'
			)
			DROP TRIGGER i_cert_renewal
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_cert_renewal'
			)
			DROP TRIGGER u_cert_renewal
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_cert_renewal'
			)
			DROP TRIGGER d_cert_renewal
GO

CREATE TABLE cert_renewal_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_cert_renewal_aud_aud_datetime DEFAULT GETDATE() NOT NULL, certid numeric(8, 0), renewal_type nvarchar(85), renewal_regulation nvarchar(85), prior_grace_n_days int, post_grace_n_days int, course_n_months_valid int, last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CERT_RENEWAL_AUD PRIMARY KEY (aud_id))
GO

insert into cert_renewal_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,renewal_type
 ,renewal_regulation
 ,prior_grace_n_days
 ,post_grace_n_days
 ,course_n_months_valid
) select 'U', null
, null
, GETDATE(), null
, null
 ,certid
 ,renewal_type
 ,renewal_regulation
 ,prior_grace_n_days
 ,post_grace_n_days
 ,course_n_months_valid
  from cert_renewal
GO

CREATE INDEX nuk_cert_renewal_aud_1 ON cert_renewal_aud(aud_userid)
GO

CREATE INDEX nuk_cert_renewal_aud_2 ON cert_renewal_aud(aud_datetime)
GO

create trigger i_cert_renewal on cert_renewal
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into cert_renewal (
certid,renewal_type,renewal_regulation,prior_grace_n_days,post_grace_n_days,course_n_months_valid,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select certid,renewal_type,renewal_regulation,prior_grace_n_days,post_grace_n_days,course_n_months_valid,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into cert_renewal_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,renewal_type
 ,renewal_regulation
 ,prior_grace_n_days
 ,post_grace_n_days
 ,course_n_months_valid
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,renewal_type
 ,renewal_regulation
 ,prior_grace_n_days
 ,post_grace_n_days
 ,course_n_months_valid
  from inserted
end
GO

create trigger u_cert_renewal on cert_renewal
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update cert_renewal set
cert_renewal.certid = inserted.certid,cert_renewal.renewal_type = inserted.renewal_type,cert_renewal.renewal_regulation = inserted.renewal_regulation,cert_renewal.prior_grace_n_days = inserted.prior_grace_n_days,cert_renewal.post_grace_n_days = inserted.post_grace_n_days,cert_renewal.course_n_months_valid = inserted.course_n_months_valid,cert_renewal.last_updated = inserted.last_updated,cert_renewal.updater_legal_name = inserted.updater_legal_name,cert_renewal.update_meaning_text = inserted.update_meaning_text,cert_renewal.last_updater_uid = inserted.last_updater_uid
from cert_renewal inner join deleted on cert_renewal.certid = deleted.certid inner join inserted on cert_renewal.certid = inserted.certid
insert into cert_renewal_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,renewal_type
 ,renewal_regulation
 ,prior_grace_n_days
 ,post_grace_n_days
 ,course_n_months_valid
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,renewal_type
 ,renewal_regulation
 ,prior_grace_n_days
 ,post_grace_n_days
 ,course_n_months_valid
  from inserted
end
GO

create trigger d_cert_renewal on cert_renewal
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from cert_renewal where exists (
select 1 from deleted where cert_renewal.certid = deleted.certid)
insert into cert_renewal_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,renewal_type
 ,renewal_regulation
 ,prior_grace_n_days
 ,post_grace_n_days
 ,course_n_months_valid
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,renewal_type
 ,renewal_regulation
 ,prior_grace_n_days
 ,post_grace_n_days
 ,course_n_months_valid
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-cert_renewal', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1162, '8:d6b0b29b2931856dd3d084025e90908a', 'enableAuditTable auditTableName=cert_renewal_aud, tableName=cert_renewal', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-certusers::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_certusers'
			)
			DROP TRIGGER i_certusers
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_certusers'
			)
			DROP TRIGGER u_certusers
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_certusers'
			)
			DROP TRIGGER d_certusers
GO

CREATE TABLE certusers_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_certusers_aud_aud_datetime DEFAULT GETDATE() NOT NULL, userid nvarchar(85), certid numeric(8, 0), dateachieved datetime, comments nvarchar(255), awardedby nvarchar(85), expiredate datetime, nreminders int, status char(1), testinstanceid nvarchar(15), learningid nvarchar(85), awardid nvarchar(85), cert_code nvarchar(85), cert_title nvarchar(4000), user_currentpid nvarchar(85), course_name nvarchar(4000), course_duration_comments nvarchar(255), course_startdate datetime, course_enddate datetime, user_locale smallint, course_module_description nvarchar(MAX), course_session_title nvarchar(255), course_facility_code nvarchar(255), tran_updater_legal_name nvarchar(250), tran_update_meaning_text nvarchar(500), tran_last_updated datetime, course_performance_grade smallint, user_givenname nvarchar(85), user_familyname nvarchar(85), user_employeeno nvarchar(85), user_jobtitle nvarchar(85), user_dateofbirth datetime, user_address1 nvarchar(150), user_address2 nvarchar(150), user_city nvarchar(50), task_approver_givenname nvarchar(85), task_approver_familyname nvarchar(85), cert_template_id nvarchar(85), display_learning_id nvarchar(85), cert_description nvarchar(4000), tran_score nvarchar(20), tran_credits float(53), user_department_name nvarchar(85), self_award_certificate char(1), selfaward_attach_id nvarchar(85), is_latest char(1), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CERTUSERS_AUD PRIMARY KEY (aud_id))
GO

insert into certusers_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,userid
 ,certid
 ,dateachieved
 ,comments
 ,awardedby
 ,expiredate
 ,nreminders
 ,status
 ,testinstanceid
 ,learningid
 ,awardid
 ,cert_code
 ,cert_title
 ,user_currentpid
 ,course_name
 ,course_duration_comments
 ,course_startdate
 ,course_enddate
 ,user_locale
 ,course_module_description
 ,course_session_title
 ,course_facility_code
 ,tran_updater_legal_name
 ,tran_update_meaning_text
 ,tran_last_updated
 ,course_performance_grade
 ,user_givenname
 ,user_familyname
 ,user_employeeno
 ,user_jobtitle
 ,user_dateofbirth
 ,user_address1
 ,user_address2
 ,user_city
 ,task_approver_givenname
 ,task_approver_familyname
 ,cert_template_id
 ,display_learning_id
 ,cert_description
 ,tran_score
 ,tran_credits
 ,user_department_name
 ,self_award_certificate
 ,selfaward_attach_id
 ,is_latest
) select 'U', null
, null
, GETDATE(), null
, null
 ,userid
 ,certid
 ,dateachieved
 ,comments
 ,awardedby
 ,expiredate
 ,nreminders
 ,status
 ,testinstanceid
 ,learningid
 ,awardid
 ,cert_code
 ,cert_title
 ,user_currentpid
 ,course_name
 ,course_duration_comments
 ,course_startdate
 ,course_enddate
 ,user_locale
 ,course_module_description
 ,course_session_title
 ,course_facility_code
 ,tran_updater_legal_name
 ,tran_update_meaning_text
 ,tran_last_updated
 ,course_performance_grade
 ,user_givenname
 ,user_familyname
 ,user_employeeno
 ,user_jobtitle
 ,user_dateofbirth
 ,user_address1
 ,user_address2
 ,user_city
 ,task_approver_givenname
 ,task_approver_familyname
 ,cert_template_id
 ,display_learning_id
 ,cert_description
 ,tran_score
 ,tran_credits
 ,user_department_name
 ,self_award_certificate
 ,selfaward_attach_id
 ,is_latest
  from certusers
GO

CREATE INDEX nuk_certusers_aud_1 ON certusers_aud(aud_userid)
GO

CREATE INDEX nuk_certusers_aud_2 ON certusers_aud(aud_datetime)
GO

create trigger i_certusers on certusers
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into certusers (
userid,certid,dateachieved,comments,awardedby,expiredate,nreminders,status,testinstanceid,learningid,awardid,last_updated,last_updater_uid,updater_legal_name,update_meaning_text,cert_code,cert_title,user_currentpid,course_name,course_duration_comments,course_startdate,course_enddate,user_locale,course_module_description,course_session_title,course_facility_code,tran_updater_legal_name,tran_update_meaning_text,tran_last_updated,course_performance_grade,user_givenname,user_familyname,user_employeeno,user_jobtitle,user_dateofbirth,user_address1,user_address2,user_city,task_approver_givenname,task_approver_familyname,cert_template_id,display_learning_id,cert_description,tran_score,tran_credits,user_department_name,self_award_certificate,selfaward_attach_id,is_latest) select userid,certid,dateachieved,comments,awardedby,expiredate,nreminders,status,testinstanceid,learningid,awardid,last_updated,last_updater_uid,updater_legal_name,update_meaning_text,cert_code,cert_title,user_currentpid,course_name,course_duration_comments,course_startdate,course_enddate,user_locale,course_module_description,course_session_title,course_facility_code,tran_updater_legal_name,tran_update_meaning_text,tran_last_updated,course_performance_grade,user_givenname,user_familyname,user_employeeno,user_jobtitle,user_dateofbirth,user_address1,user_address2,user_city,task_approver_givenname,task_approver_familyname,cert_template_id,display_learning_id,cert_description,tran_score,tran_credits,user_department_name,self_award_certificate,selfaward_attach_id,is_latest from inserted
insert into certusers_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,userid
 ,certid
 ,dateachieved
 ,comments
 ,awardedby
 ,expiredate
 ,nreminders
 ,status
 ,testinstanceid
 ,learningid
 ,awardid
 ,cert_code
 ,cert_title
 ,user_currentpid
 ,course_name
 ,course_duration_comments
 ,course_startdate
 ,course_enddate
 ,user_locale
 ,course_module_description
 ,course_session_title
 ,course_facility_code
 ,tran_updater_legal_name
 ,tran_update_meaning_text
 ,tran_last_updated
 ,course_performance_grade
 ,user_givenname
 ,user_familyname
 ,user_employeeno
 ,user_jobtitle
 ,user_dateofbirth
 ,user_address1
 ,user_address2
 ,user_city
 ,task_approver_givenname
 ,task_approver_familyname
 ,cert_template_id
 ,display_learning_id
 ,cert_description
 ,tran_score
 ,tran_credits
 ,user_department_name
 ,self_award_certificate
 ,selfaward_attach_id
 ,is_latest
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,userid
 ,certid
 ,dateachieved
 ,comments
 ,awardedby
 ,expiredate
 ,nreminders
 ,status
 ,testinstanceid
 ,learningid
 ,awardid
 ,cert_code
 ,cert_title
 ,user_currentpid
 ,course_name
 ,course_duration_comments
 ,course_startdate
 ,course_enddate
 ,user_locale
 ,course_module_description
 ,course_session_title
 ,course_facility_code
 ,tran_updater_legal_name
 ,tran_update_meaning_text
 ,tran_last_updated
 ,course_performance_grade
 ,user_givenname
 ,user_familyname
 ,user_employeeno
 ,user_jobtitle
 ,user_dateofbirth
 ,user_address1
 ,user_address2
 ,user_city
 ,task_approver_givenname
 ,task_approver_familyname
 ,cert_template_id
 ,display_learning_id
 ,cert_description
 ,tran_score
 ,tran_credits
 ,user_department_name
 ,self_award_certificate
 ,selfaward_attach_id
 ,is_latest
  from inserted
end
GO

create trigger u_certusers on certusers
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update certusers set
certusers.userid = inserted.userid,certusers.certid = inserted.certid,certusers.dateachieved = inserted.dateachieved,certusers.comments = inserted.comments,certusers.awardedby = inserted.awardedby,certusers.expiredate = inserted.expiredate,certusers.nreminders = inserted.nreminders,certusers.status = inserted.status,certusers.testinstanceid = inserted.testinstanceid,certusers.learningid = inserted.learningid,certusers.awardid = inserted.awardid,certusers.last_updated = inserted.last_updated,certusers.last_updater_uid = inserted.last_updater_uid,certusers.updater_legal_name = inserted.updater_legal_name,certusers.update_meaning_text = inserted.update_meaning_text,certusers.cert_code = inserted.cert_code,certusers.cert_title = inserted.cert_title,certusers.user_currentpid = inserted.user_currentpid,certusers.course_name = inserted.course_name,certusers.course_duration_comments = inserted.course_duration_comments,certusers.course_startdate = inserted.course_startdate,certusers.course_enddate = inserted.course_enddate,certusers.user_locale = inserted.user_locale,certusers.course_module_description = inserted.course_module_description,certusers.course_session_title = inserted.course_session_title,certusers.course_facility_code = inserted.course_facility_code,certusers.tran_updater_legal_name = inserted.tran_updater_legal_name,certusers.tran_update_meaning_text = inserted.tran_update_meaning_text,certusers.tran_last_updated = inserted.tran_last_updated,certusers.course_performance_grade = inserted.course_performance_grade,certusers.user_givenname = inserted.user_givenname,certusers.user_familyname = inserted.user_familyname,certusers.user_employeeno = inserted.user_employeeno,certusers.user_jobtitle = inserted.user_jobtitle,certusers.user_dateofbirth = inserted.user_dateofbirth,certusers.user_address1 = inserted.user_address1,certusers.user_address2 = inserted.user_address2,certusers.user_city = inserted.user_city,certusers.task_approver_givenname = inserted.task_approver_givenname,certusers.task_approver_familyname = inserted.task_approver_familyname,certusers.cert_template_id = inserted.cert_template_id,certusers.display_learning_id = inserted.display_learning_id,certusers.cert_description = inserted.cert_description,certusers.tran_score = inserted.tran_score,certusers.tran_credits = inserted.tran_credits,certusers.user_department_name = inserted.user_department_name,certusers.self_award_certificate = inserted.self_award_certificate,certusers.selfaward_attach_id = inserted.selfaward_attach_id,certusers.is_latest = inserted.is_latest
from certusers inner join deleted on certusers.awardid = deleted.awardid inner join inserted on certusers.awardid = inserted.awardid
insert into certusers_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,userid
 ,certid
 ,dateachieved
 ,comments
 ,awardedby
 ,expiredate
 ,nreminders
 ,status
 ,testinstanceid
 ,learningid
 ,awardid
 ,cert_code
 ,cert_title
 ,user_currentpid
 ,course_name
 ,course_duration_comments
 ,course_startdate
 ,course_enddate
 ,user_locale
 ,course_module_description
 ,course_session_title
 ,course_facility_code
 ,tran_updater_legal_name
 ,tran_update_meaning_text
 ,tran_last_updated
 ,course_performance_grade
 ,user_givenname
 ,user_familyname
 ,user_employeeno
 ,user_jobtitle
 ,user_dateofbirth
 ,user_address1
 ,user_address2
 ,user_city
 ,task_approver_givenname
 ,task_approver_familyname
 ,cert_template_id
 ,display_learning_id
 ,cert_description
 ,tran_score
 ,tran_credits
 ,user_department_name
 ,self_award_certificate
 ,selfaward_attach_id
 ,is_latest
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,userid
 ,certid
 ,dateachieved
 ,comments
 ,awardedby
 ,expiredate
 ,nreminders
 ,status
 ,testinstanceid
 ,learningid
 ,awardid
 ,cert_code
 ,cert_title
 ,user_currentpid
 ,course_name
 ,course_duration_comments
 ,course_startdate
 ,course_enddate
 ,user_locale
 ,course_module_description
 ,course_session_title
 ,course_facility_code
 ,tran_updater_legal_name
 ,tran_update_meaning_text
 ,tran_last_updated
 ,course_performance_grade
 ,user_givenname
 ,user_familyname
 ,user_employeeno
 ,user_jobtitle
 ,user_dateofbirth
 ,user_address1
 ,user_address2
 ,user_city
 ,task_approver_givenname
 ,task_approver_familyname
 ,cert_template_id
 ,display_learning_id
 ,cert_description
 ,tran_score
 ,tran_credits
 ,user_department_name
 ,self_award_certificate
 ,selfaward_attach_id
 ,is_latest
  from inserted
end
GO

create trigger d_certusers on certusers
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from certusers where exists (
select 1 from deleted where certusers.awardid = deleted.awardid)
insert into certusers_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,userid
 ,certid
 ,dateachieved
 ,comments
 ,awardedby
 ,expiredate
 ,nreminders
 ,status
 ,testinstanceid
 ,learningid
 ,awardid
 ,cert_code
 ,cert_title
 ,user_currentpid
 ,course_name
 ,course_duration_comments
 ,course_startdate
 ,course_enddate
 ,user_locale
 ,course_module_description
 ,course_session_title
 ,course_facility_code
 ,tran_updater_legal_name
 ,tran_update_meaning_text
 ,tran_last_updated
 ,course_performance_grade
 ,user_givenname
 ,user_familyname
 ,user_employeeno
 ,user_jobtitle
 ,user_dateofbirth
 ,user_address1
 ,user_address2
 ,user_city
 ,task_approver_givenname
 ,task_approver_familyname
 ,cert_template_id
 ,display_learning_id
 ,cert_description
 ,tran_score
 ,tran_credits
 ,user_department_name
 ,self_award_certificate
 ,selfaward_attach_id
 ,is_latest
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,userid
 ,certid
 ,dateachieved
 ,comments
 ,awardedby
 ,expiredate
 ,nreminders
 ,status
 ,testinstanceid
 ,learningid
 ,awardid
 ,cert_code
 ,cert_title
 ,user_currentpid
 ,course_name
 ,course_duration_comments
 ,course_startdate
 ,course_enddate
 ,user_locale
 ,course_module_description
 ,course_session_title
 ,course_facility_code
 ,tran_updater_legal_name
 ,tran_update_meaning_text
 ,tran_last_updated
 ,course_performance_grade
 ,user_givenname
 ,user_familyname
 ,user_employeeno
 ,user_jobtitle
 ,user_dateofbirth
 ,user_address1
 ,user_address2
 ,user_city
 ,task_approver_givenname
 ,task_approver_familyname
 ,cert_template_id
 ,display_learning_id
 ,cert_description
 ,tran_score
 ,tran_credits
 ,user_department_name
 ,self_award_certificate
 ,selfaward_attach_id
 ,is_latest
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-certusers', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1163, '8:bdf9c0545135214f87cbb9a7976cc95f', 'enableAuditTable auditTableName=certusers_aud, tableName=certusers', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-checklist_item::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_checklist_item'
			)
			DROP TRIGGER i_checklist_item
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_checklist_item'
			)
			DROP TRIGGER u_checklist_item
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_checklist_item'
			)
			DROP TRIGGER d_checklist_item
GO

CREATE TABLE checklist_item_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_checklist_item_aud_aud_datetime DEFAULT GETDATE() NOT NULL, itemid nvarchar(85), learningid nvarchar(85), sessionid nvarchar(15), important char(1), description nvarchar(255), deadline datetime, creator_id nvarchar(85), completion_status char(1), date_completed datetime, date_created datetime, owner_id nvarchar(85), assigned_by nvarchar(85), reminder_days int, reminder_sent char(1), relative_days int, relative_days_option char(1), checklist_type char(1), completed_by nvarchar(85), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CHECKLIST_ITEM_AUD PRIMARY KEY (aud_id))
GO

insert into checklist_item_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,itemid
 ,learningid
 ,sessionid
 ,important
 ,description
 ,deadline
 ,creator_id
 ,completion_status
 ,date_completed
 ,date_created
 ,owner_id
 ,assigned_by
 ,reminder_days
 ,reminder_sent
 ,relative_days
 ,relative_days_option
 ,checklist_type
 ,completed_by
) select 'U', null
, null
, GETDATE(), null
, null
 ,itemid
 ,learningid
 ,sessionid
 ,important
 ,description
 ,deadline
 ,creator_id
 ,completion_status
 ,date_completed
 ,date_created
 ,owner_id
 ,assigned_by
 ,reminder_days
 ,reminder_sent
 ,relative_days
 ,relative_days_option
 ,checklist_type
 ,completed_by
  from checklist_item
GO

CREATE INDEX nuk_checklist_item_aud_1 ON checklist_item_aud(aud_userid)
GO

CREATE INDEX nuk_checklist_item_aud_2 ON checklist_item_aud(aud_datetime)
GO

create trigger i_checklist_item on checklist_item
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into checklist_item (
itemid,learningid,sessionid,important,description,deadline,creator_id,completion_status,date_completed,date_created,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,owner_id,assigned_by,reminder_days,reminder_sent,relative_days,relative_days_option,checklist_type,completed_by) select itemid,learningid,sessionid,important,description,deadline,creator_id,completion_status,date_completed,date_created,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,owner_id,assigned_by,reminder_days,reminder_sent,relative_days,relative_days_option,checklist_type,completed_by from inserted
insert into checklist_item_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,itemid
 ,learningid
 ,sessionid
 ,important
 ,description
 ,deadline
 ,creator_id
 ,completion_status
 ,date_completed
 ,date_created
 ,owner_id
 ,assigned_by
 ,reminder_days
 ,reminder_sent
 ,relative_days
 ,relative_days_option
 ,checklist_type
 ,completed_by
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,itemid
 ,learningid
 ,sessionid
 ,important
 ,description
 ,deadline
 ,creator_id
 ,completion_status
 ,date_completed
 ,date_created
 ,owner_id
 ,assigned_by
 ,reminder_days
 ,reminder_sent
 ,relative_days
 ,relative_days_option
 ,checklist_type
 ,completed_by
  from inserted
end
GO

create trigger u_checklist_item on checklist_item
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update checklist_item set
checklist_item.itemid = inserted.itemid,checklist_item.learningid = inserted.learningid,checklist_item.sessionid = inserted.sessionid,checklist_item.important = inserted.important,checklist_item.description = inserted.description,checklist_item.deadline = inserted.deadline,checklist_item.creator_id = inserted.creator_id,checklist_item.completion_status = inserted.completion_status,checklist_item.date_completed = inserted.date_completed,checklist_item.date_created = inserted.date_created,checklist_item.last_updated = inserted.last_updated,checklist_item.updater_legal_name = inserted.updater_legal_name,checklist_item.update_meaning_text = inserted.update_meaning_text,checklist_item.last_updater_uid = inserted.last_updater_uid,checklist_item.owner_id = inserted.owner_id,checklist_item.assigned_by = inserted.assigned_by,checklist_item.reminder_days = inserted.reminder_days,checklist_item.reminder_sent = inserted.reminder_sent,checklist_item.relative_days = inserted.relative_days,checklist_item.relative_days_option = inserted.relative_days_option,checklist_item.checklist_type = inserted.checklist_type,checklist_item.completed_by = inserted.completed_by
from checklist_item inner join deleted on checklist_item.itemid = deleted.itemid inner join inserted on checklist_item.itemid = inserted.itemid
insert into checklist_item_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,itemid
 ,learningid
 ,sessionid
 ,important
 ,description
 ,deadline
 ,creator_id
 ,completion_status
 ,date_completed
 ,date_created
 ,owner_id
 ,assigned_by
 ,reminder_days
 ,reminder_sent
 ,relative_days
 ,relative_days_option
 ,checklist_type
 ,completed_by
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,itemid
 ,learningid
 ,sessionid
 ,important
 ,description
 ,deadline
 ,creator_id
 ,completion_status
 ,date_completed
 ,date_created
 ,owner_id
 ,assigned_by
 ,reminder_days
 ,reminder_sent
 ,relative_days
 ,relative_days_option
 ,checklist_type
 ,completed_by
  from inserted
end
GO

create trigger d_checklist_item on checklist_item
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from checklist_item where exists (
select 1 from deleted where checklist_item.itemid = deleted.itemid)
insert into checklist_item_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,itemid
 ,learningid
 ,sessionid
 ,important
 ,description
 ,deadline
 ,creator_id
 ,completion_status
 ,date_completed
 ,date_created
 ,owner_id
 ,assigned_by
 ,reminder_days
 ,reminder_sent
 ,relative_days
 ,relative_days_option
 ,checklist_type
 ,completed_by
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,itemid
 ,learningid
 ,sessionid
 ,important
 ,description
 ,deadline
 ,creator_id
 ,completion_status
 ,date_completed
 ,date_created
 ,owner_id
 ,assigned_by
 ,reminder_days
 ,reminder_sent
 ,relative_days
 ,relative_days_option
 ,checklist_type
 ,completed_by
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-checklist_item', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1164, '8:21f320a4cec0882b22f428e5cdbc5b38', 'enableAuditTable auditTableName=checklist_item_aud, tableName=checklist_item', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-submod_tran_subt::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_submod_tran_subt'
			)
			DROP TRIGGER i_submod_tran_subt
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_submod_tran_subt'
			)
			DROP TRIGGER u_submod_tran_subt
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_submod_tran_subt'
			)
			DROP TRIGGER d_submod_tran_subt
GO

CREATE TABLE submod_tran_subt_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_submod_tran_subt_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), learner_id nvarchar(85), substitute_tran_id nvarchar(15), substitute_learning_id nvarchar(85), target_tran_id nvarchar(15), target_learning_id nvarchar(85), program_tran_id nvarchar(15), program_learning_id nvarchar(85), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SUBMOD_TRAN_SUBT_AUD PRIMARY KEY (aud_id))
GO

insert into submod_tran_subt_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learner_id
 ,substitute_tran_id
 ,substitute_learning_id
 ,target_tran_id
 ,target_learning_id
 ,program_tran_id
 ,program_learning_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,learner_id
 ,substitute_tran_id
 ,substitute_learning_id
 ,target_tran_id
 ,target_learning_id
 ,program_tran_id
 ,program_learning_id
  from submod_tran_subt
GO

CREATE INDEX nuk_submod_tran_subt_aud_1 ON submod_tran_subt_aud(aud_userid)
GO

CREATE INDEX nuk_submod_tran_subt_aud_2 ON submod_tran_subt_aud(aud_datetime)
GO

create trigger i_submod_tran_subt on submod_tran_subt
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into submod_tran_subt (
id,learner_id,substitute_tran_id,substitute_learning_id,target_tran_id,target_learning_id,program_tran_id,program_learning_id) select id,learner_id,substitute_tran_id,substitute_learning_id,target_tran_id,target_learning_id,program_tran_id,program_learning_id from inserted
insert into submod_tran_subt_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learner_id
 ,substitute_tran_id
 ,substitute_learning_id
 ,target_tran_id
 ,target_learning_id
 ,program_tran_id
 ,program_learning_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learner_id
 ,substitute_tran_id
 ,substitute_learning_id
 ,target_tran_id
 ,target_learning_id
 ,program_tran_id
 ,program_learning_id
  from inserted
end
GO

create trigger u_submod_tran_subt on submod_tran_subt
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update submod_tran_subt set
submod_tran_subt.id = inserted.id,submod_tran_subt.learner_id = inserted.learner_id,submod_tran_subt.substitute_tran_id = inserted.substitute_tran_id,submod_tran_subt.substitute_learning_id = inserted.substitute_learning_id,submod_tran_subt.target_tran_id = inserted.target_tran_id,submod_tran_subt.target_learning_id = inserted.target_learning_id,submod_tran_subt.program_tran_id = inserted.program_tran_id,submod_tran_subt.program_learning_id = inserted.program_learning_id
from submod_tran_subt inner join deleted on submod_tran_subt.id = deleted.id inner join inserted on submod_tran_subt.id = inserted.id
insert into submod_tran_subt_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learner_id
 ,substitute_tran_id
 ,substitute_learning_id
 ,target_tran_id
 ,target_learning_id
 ,program_tran_id
 ,program_learning_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learner_id
 ,substitute_tran_id
 ,substitute_learning_id
 ,target_tran_id
 ,target_learning_id
 ,program_tran_id
 ,program_learning_id
  from inserted
end
GO

create trigger d_submod_tran_subt on submod_tran_subt
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from submod_tran_subt where exists (
select 1 from deleted where submod_tran_subt.id = deleted.id)
insert into submod_tran_subt_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learner_id
 ,substitute_tran_id
 ,substitute_learning_id
 ,target_tran_id
 ,target_learning_id
 ,program_tran_id
 ,program_learning_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learner_id
 ,substitute_tran_id
 ,substitute_learning_id
 ,target_tran_id
 ,target_learning_id
 ,program_tran_id
 ,program_learning_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-submod_tran_subt', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1165, '8:504728dccd09177fd8c6ea237bda6bb4', 'enableAuditTable auditTableName=submod_tran_subt_aud, tableName=submod_tran_subt', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-course_competency_exp_tran::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_course_competency_exp_tran'
			)
			DROP TRIGGER i_course_competency_exp_tran
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_course_competency_exp_tran'
			)
			DROP TRIGGER u_course_competency_exp_tran
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_course_competency_exp_tran'
			)
			DROP TRIGGER d_course_competency_exp_tran
GO

CREATE TABLE course_comp_exp_tran_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_course_comp_exp_tran_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), course_comp_exp_id nvarchar(85), transcript_id nvarchar(15), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSE_COMP_EXP_TRAN_AUD PRIMARY KEY (aud_id))
GO

insert into course_comp_exp_tran_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,course_comp_exp_id
 ,transcript_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,course_comp_exp_id
 ,transcript_id
  from course_competency_exp_tran
GO

CREATE INDEX nuk_course_comp_exp_tran_aud_1 ON course_comp_exp_tran_aud(aud_userid)
GO

CREATE INDEX nuk_course_comp_exp_tran_aud_2 ON course_comp_exp_tran_aud(aud_datetime)
GO

create trigger i_course_competency_exp_tran on course_competency_exp_tran
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into course_competency_exp_tran (
id,course_comp_exp_id,transcript_id) select id,course_comp_exp_id,transcript_id from inserted
insert into course_comp_exp_tran_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,course_comp_exp_id
 ,transcript_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,course_comp_exp_id
 ,transcript_id
  from inserted
end
GO

create trigger u_course_competency_exp_tran on course_competency_exp_tran
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update course_competency_exp_tran set
course_competency_exp_tran.id = inserted.id,course_competency_exp_tran.course_comp_exp_id = inserted.course_comp_exp_id,course_competency_exp_tran.transcript_id = inserted.transcript_id
from course_competency_exp_tran inner join deleted on course_competency_exp_tran.id = deleted.id inner join inserted on course_competency_exp_tran.id = inserted.id
insert into course_comp_exp_tran_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,course_comp_exp_id
 ,transcript_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,course_comp_exp_id
 ,transcript_id
  from inserted
end
GO

create trigger d_course_competency_exp_tran on course_competency_exp_tran
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from course_competency_exp_tran where exists (
select 1 from deleted where course_competency_exp_tran.id = deleted.id)
insert into course_comp_exp_tran_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,course_comp_exp_id
 ,transcript_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,course_comp_exp_id
 ,transcript_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-course_competency_exp_tran', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1166, '8:2700ef9576602033e1d7d6a8c5f3c095', 'enableAuditTable auditTableName=course_comp_exp_tran_aud, tableName=course_competency_exp_tran', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_choices::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_choices'
			)
			DROP TRIGGER i_question_choices
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_choices'
			)
			DROP TRIGGER u_question_choices
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_choices'
			)
			DROP TRIGGER d_question_choices
GO

CREATE TABLE question_choices_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_choices_aud_aud_datetime DEFAULT GETDATE() NOT NULL, questionid nvarchar(85), displayorder int, choice nvarchar(1000), choiceid nvarchar(85), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_CHOICES_AUD PRIMARY KEY (aud_id))
GO

insert into question_choices_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,displayorder
 ,choice
 ,choiceid
) select 'U', null
, null
, GETDATE(), null
, null
 ,questionid
 ,displayorder
 ,choice
 ,choiceid
  from question_choices
GO

CREATE INDEX nuk_question_choices_aud_1 ON question_choices_aud(aud_userid)
GO

CREATE INDEX nuk_question_choices_aud_2 ON question_choices_aud(aud_datetime)
GO

create trigger i_question_choices on question_choices
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_choices (
questionid,displayorder,choice,choiceid,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select questionid,displayorder,choice,choiceid,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into question_choices_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,displayorder
 ,choice
 ,choiceid
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,displayorder
 ,choice
 ,choiceid
  from inserted
end
GO

create trigger u_question_choices on question_choices
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_choices set
question_choices.questionid = inserted.questionid,question_choices.displayorder = inserted.displayorder,question_choices.choice = inserted.choice,question_choices.choiceid = inserted.choiceid,question_choices.last_updated = inserted.last_updated,question_choices.updater_legal_name = inserted.updater_legal_name,question_choices.update_meaning_text = inserted.update_meaning_text,question_choices.last_updater_uid = inserted.last_updater_uid
from question_choices inner join deleted on question_choices.choiceid = deleted.choiceid inner join inserted on question_choices.choiceid = inserted.choiceid
insert into question_choices_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,displayorder
 ,choice
 ,choiceid
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,displayorder
 ,choice
 ,choiceid
  from inserted
end
GO

create trigger d_question_choices on question_choices
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_choices where exists (
select 1 from deleted where question_choices.choiceid = deleted.choiceid)
insert into question_choices_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,questionid
 ,displayorder
 ,choice
 ,choiceid
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,questionid
 ,displayorder
 ,choice
 ,choiceid
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_choices', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1167, '8:f4237775ab08dc2888d033f5e8f1dbaa', 'enableAuditTable auditTableName=question_choices_aud, tableName=question_choices', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-transcript_substatus::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_transcript_substatus'
			)
			DROP TRIGGER i_transcript_substatus
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_transcript_substatus'
			)
			DROP TRIGGER u_transcript_substatus
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_transcript_substatus'
			)
			DROP TRIGGER d_transcript_substatus
GO

CREATE TABLE transcript_substatus_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_transcript_substatus_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), transcript_status int, substatus_code nvarchar(255), substatus_name nvarchar(255), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TRANSCRIPT_SUBSTATUS_AUD PRIMARY KEY (aud_id))
GO

insert into transcript_substatus_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,transcript_status
 ,substatus_code
 ,substatus_name
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,transcript_status
 ,substatus_code
 ,substatus_name
  from transcript_substatus
GO

CREATE INDEX nuk_transcript_substatus_aud_1 ON transcript_substatus_aud(aud_userid)
GO

CREATE INDEX nuk_transcript_substatus_aud_2 ON transcript_substatus_aud(aud_datetime)
GO

create trigger i_transcript_substatus on transcript_substatus
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into transcript_substatus (
id,transcript_status,substatus_code,substatus_name,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select id,transcript_status,substatus_code,substatus_name,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into transcript_substatus_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,transcript_status
 ,substatus_code
 ,substatus_name
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,transcript_status
 ,substatus_code
 ,substatus_name
  from inserted
end
GO

create trigger u_transcript_substatus on transcript_substatus
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update transcript_substatus set
transcript_substatus.id = inserted.id,transcript_substatus.transcript_status = inserted.transcript_status,transcript_substatus.substatus_code = inserted.substatus_code,transcript_substatus.substatus_name = inserted.substatus_name,transcript_substatus.last_updated = inserted.last_updated,transcript_substatus.updater_legal_name = inserted.updater_legal_name,transcript_substatus.update_meaning_text = inserted.update_meaning_text,transcript_substatus.last_updater_uid = inserted.last_updater_uid
from transcript_substatus inner join deleted on transcript_substatus.id = deleted.id inner join inserted on transcript_substatus.id = inserted.id
insert into transcript_substatus_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,transcript_status
 ,substatus_code
 ,substatus_name
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,transcript_status
 ,substatus_code
 ,substatus_name
  from inserted
end
GO

create trigger d_transcript_substatus on transcript_substatus
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from transcript_substatus where exists (
select 1 from deleted where transcript_substatus.id = deleted.id)
insert into transcript_substatus_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,transcript_status
 ,substatus_code
 ,substatus_name
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,transcript_status
 ,substatus_code
 ,substatus_name
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-transcript_substatus', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1168, '8:96544b6cf869c12cb4a0a5f4765c7833', 'enableAuditTable auditTableName=transcript_substatus_aud, tableName=transcript_substatus', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-equivalency_rules::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_equivalency_rules'
			)
			DROP TRIGGER i_equivalency_rules
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_equivalency_rules'
			)
			DROP TRIGGER u_equivalency_rules
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_equivalency_rules'
			)
			DROP TRIGGER d_equivalency_rules
GO

CREATE TABLE equivalency_rules_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_equivalency_rules_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), rule_group_id nvarchar(85), substitute_id nvarchar(85), target_id nvarchar(85), create_date datetime, created_by nvarchar(85), count int, contains_program char(1), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_EQUIVALENCY_RULES_AUD PRIMARY KEY (aud_id))
GO

insert into equivalency_rules_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,rule_group_id
 ,substitute_id
 ,target_id
 ,create_date
 ,created_by
 ,count
 ,contains_program
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,rule_group_id
 ,substitute_id
 ,target_id
 ,create_date
 ,created_by
 ,count
 ,contains_program
  from equivalency_rules
GO

CREATE INDEX nuk_equivalency_rules_aud_1 ON equivalency_rules_aud(aud_userid)
GO

CREATE INDEX nuk_equivalency_rules_aud_2 ON equivalency_rules_aud(aud_datetime)
GO

create trigger i_equivalency_rules on equivalency_rules
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into equivalency_rules (
id,rule_group_id,substitute_id,target_id,create_date,created_by,count,contains_program,last_updated,last_updater_uid,update_meaning_text,updater_legal_name) select id,rule_group_id,substitute_id,target_id,create_date,created_by,count,contains_program,last_updated,last_updater_uid,update_meaning_text,updater_legal_name from inserted
insert into equivalency_rules_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,rule_group_id
 ,substitute_id
 ,target_id
 ,create_date
 ,created_by
 ,count
 ,contains_program
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,rule_group_id
 ,substitute_id
 ,target_id
 ,create_date
 ,created_by
 ,count
 ,contains_program
  from inserted
end
GO

create trigger u_equivalency_rules on equivalency_rules
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update equivalency_rules set
equivalency_rules.id = inserted.id,equivalency_rules.rule_group_id = inserted.rule_group_id,equivalency_rules.substitute_id = inserted.substitute_id,equivalency_rules.target_id = inserted.target_id,equivalency_rules.create_date = inserted.create_date,equivalency_rules.created_by = inserted.created_by,equivalency_rules.count = inserted.count,equivalency_rules.contains_program = inserted.contains_program,equivalency_rules.last_updated = inserted.last_updated,equivalency_rules.last_updater_uid = inserted.last_updater_uid,equivalency_rules.update_meaning_text = inserted.update_meaning_text,equivalency_rules.updater_legal_name = inserted.updater_legal_name
from equivalency_rules inner join deleted on equivalency_rules.id = deleted.id inner join inserted on equivalency_rules.id = inserted.id
insert into equivalency_rules_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,rule_group_id
 ,substitute_id
 ,target_id
 ,create_date
 ,created_by
 ,count
 ,contains_program
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,rule_group_id
 ,substitute_id
 ,target_id
 ,create_date
 ,created_by
 ,count
 ,contains_program
  from inserted
end
GO

create trigger d_equivalency_rules on equivalency_rules
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from equivalency_rules where exists (
select 1 from deleted where equivalency_rules.id = deleted.id)
insert into equivalency_rules_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,rule_group_id
 ,substitute_id
 ,target_id
 ,create_date
 ,created_by
 ,count
 ,contains_program
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,rule_group_id
 ,substitute_id
 ,target_id
 ,create_date
 ,created_by
 ,count
 ,contains_program
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-equivalency_rules', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1169, '8:6aaf3c3decf996238854bcf7fe3bc9d4', 'enableAuditTable auditTableName=equivalency_rules_aud, tableName=equivalency_rules', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-permissions::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_permissions'
			)
			DROP TRIGGER i_permissions
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_permissions'
			)
			DROP TRIGGER u_permissions
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_permissions'
			)
			DROP TRIGGER d_permissions
GO

CREATE TABLE permissions_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_permissions_aud_aud_datetime DEFAULT GETDATE() NOT NULL, objectid nvarchar(120), objecttype nvarchar(5), identityid nvarchar(200), permissioncode int, identitytype nvarchar(45), operator nvarchar(3), is_pts_objecttype char(1), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_PERMISSIONS_AUD PRIMARY KEY (aud_id))
GO

insert into permissions_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,objectid
 ,objecttype
 ,identityid
 ,permissioncode
 ,identitytype
 ,operator
 ,is_pts_objecttype
) select 'U', null
, null
, GETDATE(), null
, null
 ,objectid
 ,objecttype
 ,identityid
 ,permissioncode
 ,identitytype
 ,operator
 ,is_pts_objecttype
  from permissions
GO

CREATE INDEX nuk_permissions_aud_1 ON permissions_aud(aud_userid)
GO

CREATE INDEX nuk_permissions_aud_2 ON permissions_aud(aud_datetime)
GO

create trigger i_permissions on permissions
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into permissions (
objectid,objecttype,identityid,permissioncode,identitytype,operator,last_updated,last_updater_uid,update_meaning_text,updater_legal_name,is_pts_objecttype) select objectid,objecttype,identityid,permissioncode,identitytype,operator,last_updated,last_updater_uid,update_meaning_text,updater_legal_name,is_pts_objecttype from inserted
insert into permissions_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,objectid
 ,objecttype
 ,identityid
 ,permissioncode
 ,identitytype
 ,operator
 ,is_pts_objecttype
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,objectid
 ,objecttype
 ,identityid
 ,permissioncode
 ,identitytype
 ,operator
 ,is_pts_objecttype
  from inserted
end
GO

create trigger u_permissions on permissions
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update permissions set
permissions.objectid = inserted.objectid,permissions.objecttype = inserted.objecttype,permissions.identityid = inserted.identityid,permissions.permissioncode = inserted.permissioncode,permissions.identitytype = inserted.identitytype,permissions.operator = inserted.operator,permissions.last_updated = inserted.last_updated,permissions.last_updater_uid = inserted.last_updater_uid,permissions.update_meaning_text = inserted.update_meaning_text,permissions.updater_legal_name = inserted.updater_legal_name,permissions.is_pts_objecttype = inserted.is_pts_objecttype
from permissions inner join deleted on permissions.objectid = deleted.objectid and permissions.objecttype = deleted.objecttype and permissions.identityid = deleted.identityid and permissions.permissioncode = deleted.permissioncode and permissions.identitytype = deleted.identitytype and permissions.is_pts_objecttype = deleted.is_pts_objecttype inner join inserted on permissions.objectid = inserted.objectid and permissions.objecttype = inserted.objecttype and permissions.identityid = inserted.identityid and permissions.permissioncode = inserted.permissioncode and permissions.identitytype = inserted.identitytype and permissions.is_pts_objecttype = inserted.is_pts_objecttype
insert into permissions_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,objectid
 ,objecttype
 ,identityid
 ,permissioncode
 ,identitytype
 ,operator
 ,is_pts_objecttype
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,objectid
 ,objecttype
 ,identityid
 ,permissioncode
 ,identitytype
 ,operator
 ,is_pts_objecttype
  from inserted
end
GO

create trigger d_permissions on permissions
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from permissions where exists (
select 1 from deleted where permissions.objectid = deleted.objectid and permissions.objecttype = deleted.objecttype and permissions.identityid = deleted.identityid and permissions.permissioncode = deleted.permissioncode and permissions.identitytype = deleted.identitytype and permissions.is_pts_objecttype = deleted.is_pts_objecttype)
insert into permissions_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,objectid
 ,objecttype
 ,identityid
 ,permissioncode
 ,identitytype
 ,operator
 ,is_pts_objecttype
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,objectid
 ,objecttype
 ,identityid
 ,permissioncode
 ,identitytype
 ,operator
 ,is_pts_objecttype
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-permissions', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1170, '8:f2a49002d28ab47748263054c4d0d822', 'enableAuditTable auditTableName=permissions_aud, tableName=permissions', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-resource_string::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_resource_string'
			)
			DROP TRIGGER i_resource_string
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_resource_string'
			)
			DROP TRIGGER u_resource_string
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_resource_string'
			)
			DROP TRIGGER d_resource_string
GO

CREATE TABLE resource_string_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_resource_string_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), resource_key nvarchar(85), bundle_id nvarchar(85), value_varchar nvarchar(4000), value_ntext nvarchar(MAX), reference_id nvarchar(100), field nvarchar(100), lucene_object_id nvarchar(100), lucene_should_use_ntext char(1), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_RESOURCE_STRING_AUD PRIMARY KEY (aud_id))
GO

insert into resource_string_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,resource_key
 ,bundle_id
 ,value_varchar
 ,value_ntext
 ,reference_id
 ,field
 ,lucene_object_id
 ,lucene_should_use_ntext
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,resource_key
 ,bundle_id
 ,value_varchar
 ,value_ntext
 ,reference_id
 ,field
 ,lucene_object_id
 ,lucene_should_use_ntext
  from resource_string
GO

CREATE INDEX nuk_resource_string_aud_1 ON resource_string_aud(aud_userid)
GO

CREATE INDEX nuk_resource_string_aud_2 ON resource_string_aud(aud_datetime)
GO

create trigger i_resource_string on resource_string
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into resource_string (
id,resource_key,bundle_id,value_varchar,value_ntext,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,reference_id,field,lucene_object_id,lucene_should_use_ntext) select id,resource_key,bundle_id,value_varchar,value_ntext,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,reference_id,field,lucene_object_id,lucene_should_use_ntext from inserted
insert into resource_string_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,resource_key
 ,bundle_id
 ,value_varchar
 ,value_ntext
 ,reference_id
 ,field
 ,lucene_object_id
 ,lucene_should_use_ntext
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,resource_key
 ,bundle_id
 ,value_varchar
 ,value_ntext
 ,reference_id
 ,field
 ,lucene_object_id
 ,lucene_should_use_ntext
  from inserted
end
GO

create trigger u_resource_string on resource_string
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update resource_string set
resource_string.id = inserted.id,resource_string.resource_key = inserted.resource_key,resource_string.bundle_id = inserted.bundle_id,resource_string.value_varchar = inserted.value_varchar,resource_string.value_ntext = inserted.value_ntext,resource_string.last_updated = inserted.last_updated,resource_string.updater_legal_name = inserted.updater_legal_name,resource_string.update_meaning_text = inserted.update_meaning_text,resource_string.last_updater_uid = inserted.last_updater_uid,resource_string.reference_id = inserted.reference_id,resource_string.field = inserted.field,resource_string.lucene_object_id = inserted.lucene_object_id,resource_string.lucene_should_use_ntext = inserted.lucene_should_use_ntext
from resource_string inner join deleted on resource_string.id = deleted.id inner join inserted on resource_string.id = inserted.id
insert into resource_string_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,resource_key
 ,bundle_id
 ,value_varchar
 ,value_ntext
 ,reference_id
 ,field
 ,lucene_object_id
 ,lucene_should_use_ntext
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,resource_key
 ,bundle_id
 ,value_varchar
 ,value_ntext
 ,reference_id
 ,field
 ,lucene_object_id
 ,lucene_should_use_ntext
  from inserted
end
GO

create trigger d_resource_string on resource_string
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from resource_string where exists (
select 1 from deleted where resource_string.id = deleted.id)
insert into resource_string_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,resource_key
 ,bundle_id
 ,value_varchar
 ,value_ntext
 ,reference_id
 ,field
 ,lucene_object_id
 ,lucene_should_use_ntext
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,resource_key
 ,bundle_id
 ,value_varchar
 ,value_ntext
 ,reference_id
 ,field
 ,lucene_object_id
 ,lucene_should_use_ntext
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-resource_string', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1171, '8:d92486c19bd6f5d1a47647c520b1a09e', 'enableAuditTable auditTableName=resource_string_aud, tableName=resource_string', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-language_bundle::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_language_bundle'
			)
			DROP TRIGGER i_language_bundle
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_language_bundle'
			)
			DROP TRIGGER u_language_bundle
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_language_bundle'
			)
			DROP TRIGGER d_language_bundle
GO

CREATE TABLE language_bundle_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_language_bundle_aud_aud_datetime DEFAULT GETDATE() NOT NULL, bundle_id nvarchar(85), object_id nvarchar(85), object_type nvarchar(5), locale nvarchar(85), ilangid smallint, is_primary char(1), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_LANGUAGE_BUNDLE_AUD PRIMARY KEY (aud_id))
GO

insert into language_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,object_id
 ,object_type
 ,locale
 ,ilangid
 ,is_primary
) select 'U', null
, null
, GETDATE(), null
, null
 ,bundle_id
 ,object_id
 ,object_type
 ,locale
 ,ilangid
 ,is_primary
  from language_bundle
GO

CREATE INDEX nuk_language_bundle_aud_1 ON language_bundle_aud(aud_userid)
GO

CREATE INDEX nuk_language_bundle_aud_2 ON language_bundle_aud(aud_datetime)
GO

create trigger i_language_bundle on language_bundle
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into language_bundle (
bundle_id,object_id,object_type,locale,ilangid,is_primary,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select bundle_id,object_id,object_type,locale,ilangid,is_primary,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into language_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,object_id
 ,object_type
 ,locale
 ,ilangid
 ,is_primary
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,bundle_id
 ,object_id
 ,object_type
 ,locale
 ,ilangid
 ,is_primary
  from inserted
end
GO

create trigger u_language_bundle on language_bundle
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update language_bundle set
language_bundle.bundle_id = inserted.bundle_id,language_bundle.object_id = inserted.object_id,language_bundle.object_type = inserted.object_type,language_bundle.locale = inserted.locale,language_bundle.ilangid = inserted.ilangid,language_bundle.is_primary = inserted.is_primary,language_bundle.last_updated = inserted.last_updated,language_bundle.updater_legal_name = inserted.updater_legal_name,language_bundle.update_meaning_text = inserted.update_meaning_text,language_bundle.last_updater_uid = inserted.last_updater_uid
from language_bundle inner join deleted on language_bundle.bundle_id = deleted.bundle_id inner join inserted on language_bundle.bundle_id = inserted.bundle_id
insert into language_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,object_id
 ,object_type
 ,locale
 ,ilangid
 ,is_primary
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,bundle_id
 ,object_id
 ,object_type
 ,locale
 ,ilangid
 ,is_primary
  from inserted
end
GO

create trigger d_language_bundle on language_bundle
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from language_bundle where exists (
select 1 from deleted where language_bundle.bundle_id = deleted.bundle_id)
insert into language_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,object_id
 ,object_type
 ,locale
 ,ilangid
 ,is_primary
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,bundle_id
 ,object_id
 ,object_type
 ,locale
 ,ilangid
 ,is_primary
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-language_bundle', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1172, '8:c9df389303a412c805ea125371d428a0', 'enableAuditTable auditTableName=language_bundle_aud, tableName=language_bundle', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-course_bundle::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_course_bundle'
			)
			DROP TRIGGER i_course_bundle
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_course_bundle'
			)
			DROP TRIGGER u_course_bundle
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_course_bundle'
			)
			DROP TRIGGER d_course_bundle
GO

CREATE TABLE course_bundle_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_course_bundle_aud_aud_datetime DEFAULT GETDATE() NOT NULL, bundle_id nvarchar(85), courseid nvarchar(85), effective_revision int, approved_revision int, launchInterface smallint, organizationID nvarchar(15), itemID nvarchar(15), launchpage nvarchar(MAX), launchParms nvarchar(255), accumulateTime char(1), skillsoft_course_type int, bookmark char(1), navigationTreeVisible nvarchar(15), previousNextButtonsVisible char(1), launched_win_width int, launched_win_height int, ieCompatibilityMode char(1), instantAccess char(1), show_toolbars char(1), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COURSE_BUNDLE_AUD PRIMARY KEY (aud_id))
GO

insert into course_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,courseid
 ,effective_revision
 ,approved_revision
 ,launchInterface
 ,organizationID
 ,itemID
 ,launchpage
 ,launchParms
 ,accumulateTime
 ,skillsoft_course_type
 ,bookmark
 ,navigationTreeVisible
 ,previousNextButtonsVisible
 ,launched_win_width
 ,launched_win_height
 ,ieCompatibilityMode
 ,instantAccess
 ,show_toolbars
) select 'U', null
, null
, GETDATE(), null
, null
 ,bundle_id
 ,courseid
 ,effective_revision
 ,approved_revision
 ,launchInterface
 ,organizationID
 ,itemID
 ,launchpage
 ,launchParms
 ,accumulateTime
 ,skillsoft_course_type
 ,bookmark
 ,navigationTreeVisible
 ,previousNextButtonsVisible
 ,launched_win_width
 ,launched_win_height
 ,ieCompatibilityMode
 ,instantAccess
 ,show_toolbars
  from course_bundle
GO

CREATE INDEX nuk_course_bundle_aud_1 ON course_bundle_aud(aud_userid)
GO

CREATE INDEX nuk_course_bundle_aud_2 ON course_bundle_aud(aud_datetime)
GO

create trigger i_course_bundle on course_bundle
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into course_bundle (
bundle_id,courseid,effective_revision,approved_revision,launchInterface,organizationID,itemID,launchpage,launchParms,accumulateTime,skillsoft_course_type,bookmark,navigationTreeVisible,previousNextButtonsVisible,launched_win_width,launched_win_height,ieCompatibilityMode,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,instantAccess,show_toolbars) select bundle_id,courseid,effective_revision,approved_revision,launchInterface,organizationID,itemID,launchpage,launchParms,accumulateTime,skillsoft_course_type,bookmark,navigationTreeVisible,previousNextButtonsVisible,launched_win_width,launched_win_height,ieCompatibilityMode,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,instantAccess,show_toolbars from inserted
insert into course_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,courseid
 ,effective_revision
 ,approved_revision
 ,launchInterface
 ,organizationID
 ,itemID
 ,launchpage
 ,launchParms
 ,accumulateTime
 ,skillsoft_course_type
 ,bookmark
 ,navigationTreeVisible
 ,previousNextButtonsVisible
 ,launched_win_width
 ,launched_win_height
 ,ieCompatibilityMode
 ,instantAccess
 ,show_toolbars
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,bundle_id
 ,courseid
 ,effective_revision
 ,approved_revision
 ,launchInterface
 ,organizationID
 ,itemID
 ,launchpage
 ,launchParms
 ,accumulateTime
 ,skillsoft_course_type
 ,bookmark
 ,navigationTreeVisible
 ,previousNextButtonsVisible
 ,launched_win_width
 ,launched_win_height
 ,ieCompatibilityMode
 ,instantAccess
 ,show_toolbars
  from inserted
end
GO

create trigger u_course_bundle on course_bundle
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update course_bundle set
course_bundle.bundle_id = inserted.bundle_id,course_bundle.courseid = inserted.courseid,course_bundle.effective_revision = inserted.effective_revision,course_bundle.approved_revision = inserted.approved_revision,course_bundle.launchInterface = inserted.launchInterface,course_bundle.organizationID = inserted.organizationID,course_bundle.itemID = inserted.itemID,course_bundle.launchpage = inserted.launchpage,course_bundle.launchParms = inserted.launchParms,course_bundle.accumulateTime = inserted.accumulateTime,course_bundle.skillsoft_course_type = inserted.skillsoft_course_type,course_bundle.bookmark = inserted.bookmark,course_bundle.navigationTreeVisible = inserted.navigationTreeVisible,course_bundle.previousNextButtonsVisible = inserted.previousNextButtonsVisible,course_bundle.launched_win_width = inserted.launched_win_width,course_bundle.launched_win_height = inserted.launched_win_height,course_bundle.ieCompatibilityMode = inserted.ieCompatibilityMode,course_bundle.last_updated = inserted.last_updated,course_bundle.updater_legal_name = inserted.updater_legal_name,course_bundle.update_meaning_text = inserted.update_meaning_text,course_bundle.last_updater_uid = inserted.last_updater_uid,course_bundle.instantAccess = inserted.instantAccess,course_bundle.show_toolbars = inserted.show_toolbars
from course_bundle inner join deleted on course_bundle.bundle_id = deleted.bundle_id inner join inserted on course_bundle.bundle_id = inserted.bundle_id
insert into course_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,courseid
 ,effective_revision
 ,approved_revision
 ,launchInterface
 ,organizationID
 ,itemID
 ,launchpage
 ,launchParms
 ,accumulateTime
 ,skillsoft_course_type
 ,bookmark
 ,navigationTreeVisible
 ,previousNextButtonsVisible
 ,launched_win_width
 ,launched_win_height
 ,ieCompatibilityMode
 ,instantAccess
 ,show_toolbars
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,bundle_id
 ,courseid
 ,effective_revision
 ,approved_revision
 ,launchInterface
 ,organizationID
 ,itemID
 ,launchpage
 ,launchParms
 ,accumulateTime
 ,skillsoft_course_type
 ,bookmark
 ,navigationTreeVisible
 ,previousNextButtonsVisible
 ,launched_win_width
 ,launched_win_height
 ,ieCompatibilityMode
 ,instantAccess
 ,show_toolbars
  from inserted
end
GO

create trigger d_course_bundle on course_bundle
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from course_bundle where exists (
select 1 from deleted where course_bundle.bundle_id = deleted.bundle_id)
insert into course_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,courseid
 ,effective_revision
 ,approved_revision
 ,launchInterface
 ,organizationID
 ,itemID
 ,launchpage
 ,launchParms
 ,accumulateTime
 ,skillsoft_course_type
 ,bookmark
 ,navigationTreeVisible
 ,previousNextButtonsVisible
 ,launched_win_width
 ,launched_win_height
 ,ieCompatibilityMode
 ,instantAccess
 ,show_toolbars
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,bundle_id
 ,courseid
 ,effective_revision
 ,approved_revision
 ,launchInterface
 ,organizationID
 ,itemID
 ,launchpage
 ,launchParms
 ,accumulateTime
 ,skillsoft_course_type
 ,bookmark
 ,navigationTreeVisible
 ,previousNextButtonsVisible
 ,launched_win_width
 ,launched_win_height
 ,ieCompatibilityMode
 ,instantAccess
 ,show_toolbars
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-course_bundle', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1173, '8:253eae9bb2b859f162ba79eacaa1081d', 'enableAuditTable auditTableName=course_bundle_aud, tableName=course_bundle', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-cert_schedule::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_cert_schedule'
			)
			DROP TRIGGER i_cert_schedule
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_cert_schedule'
			)
			DROP TRIGGER u_cert_schedule
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_cert_schedule'
			)
			DROP TRIGGER d_cert_schedule
GO

CREATE TABLE cert_schedule_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_cert_schedule_aud_aud_datetime DEFAULT GETDATE() NOT NULL, certid numeric(8, 0), awarddate datetime, last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CERT_SCHEDULE_AUD PRIMARY KEY (aud_id))
GO

insert into cert_schedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,awarddate
) select 'U', null
, null
, GETDATE(), null
, null
 ,certid
 ,awarddate
  from cert_schedule
GO

CREATE INDEX nuk_cert_schedule_aud_1 ON cert_schedule_aud(aud_userid)
GO

CREATE INDEX nuk_cert_schedule_aud_2 ON cert_schedule_aud(aud_datetime)
GO

create trigger i_cert_schedule on cert_schedule
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into cert_schedule (
certid,awarddate,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select certid,awarddate,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into cert_schedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,awarddate
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,awarddate
  from inserted
end
GO

create trigger u_cert_schedule on cert_schedule
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update cert_schedule set
cert_schedule.certid = inserted.certid,cert_schedule.awarddate = inserted.awarddate,cert_schedule.last_updated = inserted.last_updated,cert_schedule.updater_legal_name = inserted.updater_legal_name,cert_schedule.update_meaning_text = inserted.update_meaning_text,cert_schedule.last_updater_uid = inserted.last_updater_uid
from cert_schedule inner join deleted on cert_schedule.certid = deleted.certid and cert_schedule.awarddate = deleted.awarddate inner join inserted on cert_schedule.certid = inserted.certid and cert_schedule.awarddate = inserted.awarddate
insert into cert_schedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,awarddate
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,awarddate
  from inserted
end
GO

create trigger d_cert_schedule on cert_schedule
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from cert_schedule where exists (
select 1 from deleted where cert_schedule.certid = deleted.certid and cert_schedule.awarddate = deleted.awarddate)
insert into cert_schedule_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,certid
 ,awarddate
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,certid
 ,awarddate
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-cert_schedule', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1174, '8:7b9411323f00eb39485abceda8de99d2', 'enableAuditTable auditTableName=cert_schedule_aud, tableName=cert_schedule', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-certusers_pending::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_certusers_pending'
			)
			DROP TRIGGER i_certusers_pending
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_certusers_pending'
			)
			DROP TRIGGER u_certusers_pending
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_certusers_pending'
			)
			DROP TRIGGER d_certusers_pending
GO

CREATE TABLE certusers_pending_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_certusers_pending_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), userid nvarchar(85), certid numeric(8, 0), awarddate datetime, awardedby nvarchar(85), comments nvarchar(255), certstatus char(1), testinstanceid nvarchar(15), learningid nvarchar(85), awardstatus char(1), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CERTUSERS_PENDING_AUD PRIMARY KEY (aud_id))
GO

insert into certusers_pending_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,userid
 ,certid
 ,awarddate
 ,awardedby
 ,comments
 ,certstatus
 ,testinstanceid
 ,learningid
 ,awardstatus
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,userid
 ,certid
 ,awarddate
 ,awardedby
 ,comments
 ,certstatus
 ,testinstanceid
 ,learningid
 ,awardstatus
  from certusers_pending
GO

CREATE INDEX nuk_certusers_pending_aud_1 ON certusers_pending_aud(aud_userid)
GO

CREATE INDEX nuk_certusers_pending_aud_2 ON certusers_pending_aud(aud_datetime)
GO

create trigger i_certusers_pending on certusers_pending
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into certusers_pending (
id,userid,certid,awarddate,awardedby,comments,certstatus,testinstanceid,learningid,awardstatus,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select id,userid,certid,awarddate,awardedby,comments,certstatus,testinstanceid,learningid,awardstatus,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into certusers_pending_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,userid
 ,certid
 ,awarddate
 ,awardedby
 ,comments
 ,certstatus
 ,testinstanceid
 ,learningid
 ,awardstatus
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,userid
 ,certid
 ,awarddate
 ,awardedby
 ,comments
 ,certstatus
 ,testinstanceid
 ,learningid
 ,awardstatus
  from inserted
end
GO

create trigger u_certusers_pending on certusers_pending
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update certusers_pending set
certusers_pending.id = inserted.id,certusers_pending.userid = inserted.userid,certusers_pending.certid = inserted.certid,certusers_pending.awarddate = inserted.awarddate,certusers_pending.awardedby = inserted.awardedby,certusers_pending.comments = inserted.comments,certusers_pending.certstatus = inserted.certstatus,certusers_pending.testinstanceid = inserted.testinstanceid,certusers_pending.learningid = inserted.learningid,certusers_pending.awardstatus = inserted.awardstatus,certusers_pending.last_updated = inserted.last_updated,certusers_pending.updater_legal_name = inserted.updater_legal_name,certusers_pending.update_meaning_text = inserted.update_meaning_text,certusers_pending.last_updater_uid = inserted.last_updater_uid
from certusers_pending inner join deleted on certusers_pending.id = deleted.id inner join inserted on certusers_pending.id = inserted.id
insert into certusers_pending_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,userid
 ,certid
 ,awarddate
 ,awardedby
 ,comments
 ,certstatus
 ,testinstanceid
 ,learningid
 ,awardstatus
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,userid
 ,certid
 ,awarddate
 ,awardedby
 ,comments
 ,certstatus
 ,testinstanceid
 ,learningid
 ,awardstatus
  from inserted
end
GO

create trigger d_certusers_pending on certusers_pending
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from certusers_pending where exists (
select 1 from deleted where certusers_pending.id = deleted.id)
insert into certusers_pending_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,userid
 ,certid
 ,awarddate
 ,awardedby
 ,comments
 ,certstatus
 ,testinstanceid
 ,learningid
 ,awardstatus
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,userid
 ,certid
 ,awarddate
 ,awardedby
 ,comments
 ,certstatus
 ,testinstanceid
 ,learningid
 ,awardstatus
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-certusers_pending', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1175, '8:ab9236e4bdfde4adc9fc786401cab8eb', 'enableAuditTable auditTableName=certusers_pending_aud, tableName=certusers_pending', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-transcript_stat_log::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_transcript_stat_log'
			)
			DROP TRIGGER i_transcript_stat_log
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_transcript_stat_log'
			)
			DROP TRIGGER u_transcript_stat_log
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_transcript_stat_log'
			)
			DROP TRIGGER d_transcript_stat_log
GO

CREATE TABLE transcript_stat_log_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_transcript_stat_log_aud_aud_datetime DEFAULT GETDATE() NOT NULL, transcriptid nvarchar(15), seq int, logdate datetime, fromstatus int, tostatus int, comments nvarchar(MAX), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TRANSCRIPT_STAT_LOG_AUD PRIMARY KEY (aud_id))
GO

insert into transcript_stat_log_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,seq
 ,logdate
 ,fromstatus
 ,tostatus
 ,comments
) select 'U', null
, null
, GETDATE(), null
, null
 ,transcriptid
 ,seq
 ,logdate
 ,fromstatus
 ,tostatus
 ,comments
  from transcript_stat_log
GO

CREATE INDEX nuk_transcript_stat_log_aud_1 ON transcript_stat_log_aud(aud_userid)
GO

CREATE INDEX nuk_transcript_stat_log_aud_2 ON transcript_stat_log_aud(aud_datetime)
GO

create trigger i_transcript_stat_log on transcript_stat_log
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into transcript_stat_log (
transcriptid,seq,logdate,fromstatus,tostatus,comments,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select transcriptid,seq,logdate,fromstatus,tostatus,comments,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into transcript_stat_log_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,seq
 ,logdate
 ,fromstatus
 ,tostatus
 ,comments
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,seq
 ,logdate
 ,fromstatus
 ,tostatus
 ,comments
  from inserted
end
GO

create trigger u_transcript_stat_log on transcript_stat_log
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update transcript_stat_log set
transcript_stat_log.transcriptid = inserted.transcriptid,transcript_stat_log.seq = inserted.seq,transcript_stat_log.logdate = inserted.logdate,transcript_stat_log.fromstatus = inserted.fromstatus,transcript_stat_log.tostatus = inserted.tostatus,transcript_stat_log.comments = inserted.comments,transcript_stat_log.last_updated = inserted.last_updated,transcript_stat_log.updater_legal_name = inserted.updater_legal_name,transcript_stat_log.update_meaning_text = inserted.update_meaning_text,transcript_stat_log.last_updater_uid = inserted.last_updater_uid
from transcript_stat_log inner join deleted on transcript_stat_log.transcriptid = deleted.transcriptid and transcript_stat_log.seq = deleted.seq inner join inserted on transcript_stat_log.transcriptid = inserted.transcriptid and transcript_stat_log.seq = inserted.seq
insert into transcript_stat_log_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,seq
 ,logdate
 ,fromstatus
 ,tostatus
 ,comments
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,seq
 ,logdate
 ,fromstatus
 ,tostatus
 ,comments
  from inserted
end
GO

create trigger d_transcript_stat_log on transcript_stat_log
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from transcript_stat_log where exists (
select 1 from deleted where transcript_stat_log.transcriptid = deleted.transcriptid and transcript_stat_log.seq = deleted.seq)
insert into transcript_stat_log_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,seq
 ,logdate
 ,fromstatus
 ,tostatus
 ,comments
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,seq
 ,logdate
 ,fromstatus
 ,tostatus
 ,comments
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-transcript_stat_log', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1176, '8:491971e3b64263345b4dc8cffe35d971', 'enableAuditTable auditTableName=transcript_stat_log_aud, tableName=transcript_stat_log', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-comp_approval_queue::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_comp_approval_queue'
			)
			DROP TRIGGER i_comp_approval_queue
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_comp_approval_queue'
			)
			DROP TRIGGER u_comp_approval_queue
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_comp_approval_queue'
			)
			DROP TRIGGER d_comp_approval_queue
GO

CREATE TABLE comp_approval_queue_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_comp_approval_queue_aud_aud_datetime DEFAULT GETDATE() NOT NULL, competency_id nvarchar(15), user_id nvarchar(85), seq int, approver_id nvarchar(85), approval_date datetime, approver_remarks nvarchar(MAX), status char(1), requester_id nvarchar(85), request_date datetime, requester_remarks nvarchar(MAX), current_level_id nvarchar(15), target_level_id nvarchar(15), target_level_expire datetime, request_type char(1), current_level_expire datetime, last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COMP_APPROVAL_QUEUE_AUD PRIMARY KEY (aud_id))
GO

insert into comp_approval_queue_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,competency_id
 ,user_id
 ,seq
 ,approver_id
 ,approval_date
 ,approver_remarks
 ,status
 ,requester_id
 ,request_date
 ,requester_remarks
 ,current_level_id
 ,target_level_id
 ,target_level_expire
 ,request_type
 ,current_level_expire
) select 'U', null
, null
, GETDATE(), null
, null
 ,competency_id
 ,user_id
 ,seq
 ,approver_id
 ,approval_date
 ,approver_remarks
 ,status
 ,requester_id
 ,request_date
 ,requester_remarks
 ,current_level_id
 ,target_level_id
 ,target_level_expire
 ,request_type
 ,current_level_expire
  from comp_approval_queue
GO

CREATE INDEX nuk_comp_approval_queue_aud_1 ON comp_approval_queue_aud(aud_userid)
GO

CREATE INDEX nuk_comp_approval_queue_aud_2 ON comp_approval_queue_aud(aud_datetime)
GO

create trigger i_comp_approval_queue on comp_approval_queue
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into comp_approval_queue (
competency_id,user_id,seq,approver_id,approval_date,approver_remarks,status,requester_id,request_date,requester_remarks,current_level_id,target_level_id,target_level_expire,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,request_type,current_level_expire) select competency_id,user_id,seq,approver_id,approval_date,approver_remarks,status,requester_id,request_date,requester_remarks,current_level_id,target_level_id,target_level_expire,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,request_type,current_level_expire from inserted
insert into comp_approval_queue_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,competency_id
 ,user_id
 ,seq
 ,approver_id
 ,approval_date
 ,approver_remarks
 ,status
 ,requester_id
 ,request_date
 ,requester_remarks
 ,current_level_id
 ,target_level_id
 ,target_level_expire
 ,request_type
 ,current_level_expire
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,competency_id
 ,user_id
 ,seq
 ,approver_id
 ,approval_date
 ,approver_remarks
 ,status
 ,requester_id
 ,request_date
 ,requester_remarks
 ,current_level_id
 ,target_level_id
 ,target_level_expire
 ,request_type
 ,current_level_expire
  from inserted
end
GO

create trigger u_comp_approval_queue on comp_approval_queue
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update comp_approval_queue set
comp_approval_queue.competency_id = inserted.competency_id,comp_approval_queue.user_id = inserted.user_id,comp_approval_queue.seq = inserted.seq,comp_approval_queue.approver_id = inserted.approver_id,comp_approval_queue.approval_date = inserted.approval_date,comp_approval_queue.approver_remarks = inserted.approver_remarks,comp_approval_queue.status = inserted.status,comp_approval_queue.requester_id = inserted.requester_id,comp_approval_queue.request_date = inserted.request_date,comp_approval_queue.requester_remarks = inserted.requester_remarks,comp_approval_queue.current_level_id = inserted.current_level_id,comp_approval_queue.target_level_id = inserted.target_level_id,comp_approval_queue.target_level_expire = inserted.target_level_expire,comp_approval_queue.last_updated = inserted.last_updated,comp_approval_queue.updater_legal_name = inserted.updater_legal_name,comp_approval_queue.update_meaning_text = inserted.update_meaning_text,comp_approval_queue.last_updater_uid = inserted.last_updater_uid,comp_approval_queue.request_type = inserted.request_type,comp_approval_queue.current_level_expire = inserted.current_level_expire
from comp_approval_queue inner join deleted on comp_approval_queue.competency_id = deleted.competency_id and comp_approval_queue.user_id = deleted.user_id and comp_approval_queue.seq = deleted.seq inner join inserted on comp_approval_queue.competency_id = inserted.competency_id and comp_approval_queue.user_id = inserted.user_id and comp_approval_queue.seq = inserted.seq
insert into comp_approval_queue_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,competency_id
 ,user_id
 ,seq
 ,approver_id
 ,approval_date
 ,approver_remarks
 ,status
 ,requester_id
 ,request_date
 ,requester_remarks
 ,current_level_id
 ,target_level_id
 ,target_level_expire
 ,request_type
 ,current_level_expire
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,competency_id
 ,user_id
 ,seq
 ,approver_id
 ,approval_date
 ,approver_remarks
 ,status
 ,requester_id
 ,request_date
 ,requester_remarks
 ,current_level_id
 ,target_level_id
 ,target_level_expire
 ,request_type
 ,current_level_expire
  from inserted
end
GO

create trigger d_comp_approval_queue on comp_approval_queue
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from comp_approval_queue where exists (
select 1 from deleted where comp_approval_queue.competency_id = deleted.competency_id and comp_approval_queue.user_id = deleted.user_id and comp_approval_queue.seq = deleted.seq)
insert into comp_approval_queue_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,competency_id
 ,user_id
 ,seq
 ,approver_id
 ,approval_date
 ,approver_remarks
 ,status
 ,requester_id
 ,request_date
 ,requester_remarks
 ,current_level_id
 ,target_level_id
 ,target_level_expire
 ,request_type
 ,current_level_expire
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,competency_id
 ,user_id
 ,seq
 ,approver_id
 ,approval_date
 ,approver_remarks
 ,status
 ,requester_id
 ,request_date
 ,requester_remarks
 ,current_level_id
 ,target_level_id
 ,target_level_expire
 ,request_type
 ,current_level_expire
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-comp_approval_queue', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1177, '8:74b60a8db53b82d8f0c680da85fdbc0d', 'enableAuditTable auditTableName=comp_approval_queue_aud, tableName=comp_approval_queue', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-comp_level_validity::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_comp_level_validity'
			)
			DROP TRIGGER i_comp_level_validity
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_comp_level_validity'
			)
			DROP TRIGGER u_comp_level_validity
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_comp_level_validity'
			)
			DROP TRIGGER d_comp_level_validity
GO

CREATE TABLE comp_level_validity_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_comp_level_validity_aud_aud_datetime DEFAULT GETDATE() NOT NULL, competency_level_id nvarchar(15), orgid nvarchar(15), valid_period int, valid_period_unit char(1), expire_email_profile_id nvarchar(15), sticky char(1), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_COMP_LEVEL_VALIDITY_AUD PRIMARY KEY (aud_id))
GO

insert into comp_level_validity_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,competency_level_id
 ,orgid
 ,valid_period
 ,valid_period_unit
 ,expire_email_profile_id
 ,sticky
) select 'U', null
, null
, GETDATE(), null
, null
 ,competency_level_id
 ,orgid
 ,valid_period
 ,valid_period_unit
 ,expire_email_profile_id
 ,sticky
  from comp_level_validity
GO

CREATE INDEX nuk_comp_level_validity_aud_1 ON comp_level_validity_aud(aud_userid)
GO

CREATE INDEX nuk_comp_level_validity_aud_2 ON comp_level_validity_aud(aud_datetime)
GO

create trigger i_comp_level_validity on comp_level_validity
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into comp_level_validity (
competency_level_id,orgid,valid_period,valid_period_unit,expire_email_profile_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,sticky) select competency_level_id,orgid,valid_period,valid_period_unit,expire_email_profile_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid,sticky from inserted
insert into comp_level_validity_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,competency_level_id
 ,orgid
 ,valid_period
 ,valid_period_unit
 ,expire_email_profile_id
 ,sticky
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,competency_level_id
 ,orgid
 ,valid_period
 ,valid_period_unit
 ,expire_email_profile_id
 ,sticky
  from inserted
end
GO

create trigger u_comp_level_validity on comp_level_validity
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update comp_level_validity set
comp_level_validity.competency_level_id = inserted.competency_level_id,comp_level_validity.orgid = inserted.orgid,comp_level_validity.valid_period = inserted.valid_period,comp_level_validity.valid_period_unit = inserted.valid_period_unit,comp_level_validity.expire_email_profile_id = inserted.expire_email_profile_id,comp_level_validity.last_updated = inserted.last_updated,comp_level_validity.updater_legal_name = inserted.updater_legal_name,comp_level_validity.update_meaning_text = inserted.update_meaning_text,comp_level_validity.last_updater_uid = inserted.last_updater_uid,comp_level_validity.sticky = inserted.sticky
from comp_level_validity inner join deleted on comp_level_validity.competency_level_id = deleted.competency_level_id and comp_level_validity.orgid = deleted.orgid inner join inserted on comp_level_validity.competency_level_id = inserted.competency_level_id and comp_level_validity.orgid = inserted.orgid
insert into comp_level_validity_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,competency_level_id
 ,orgid
 ,valid_period
 ,valid_period_unit
 ,expire_email_profile_id
 ,sticky
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,competency_level_id
 ,orgid
 ,valid_period
 ,valid_period_unit
 ,expire_email_profile_id
 ,sticky
  from inserted
end
GO

create trigger d_comp_level_validity on comp_level_validity
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from comp_level_validity where exists (
select 1 from deleted where comp_level_validity.competency_level_id = deleted.competency_level_id and comp_level_validity.orgid = deleted.orgid)
insert into comp_level_validity_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,competency_level_id
 ,orgid
 ,valid_period
 ,valid_period_unit
 ,expire_email_profile_id
 ,sticky
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,competency_level_id
 ,orgid
 ,valid_period
 ,valid_period_unit
 ,expire_email_profile_id
 ,sticky
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-comp_level_validity', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1178, '8:694b894afab73409a4c3e43966b0b388', 'enableAuditTable auditTableName=comp_level_validity_aud, tableName=comp_level_validity', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-mastersection_attr::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_mastersection_attr'
			)
			DROP TRIGGER i_mastersection_attr
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_mastersection_attr'
			)
			DROP TRIGGER u_mastersection_attr
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_mastersection_attr'
			)
			DROP TRIGGER d_mastersection_attr
GO

CREATE TABLE mastersection_attr_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_mastersection_attr_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), section_id nvarchar(15), attribute_id nvarchar(15), attribute_value_data nvarchar(2000), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_MASTERSECTION_ATTR_AUD PRIMARY KEY (aud_id))
GO

insert into mastersection_attr_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,section_id
 ,attribute_id
 ,attribute_value_data
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,section_id
 ,attribute_id
 ,attribute_value_data
  from mastersection_attr
GO

CREATE INDEX nuk_mastersection_attr_aud_1 ON mastersection_attr_aud(aud_userid)
GO

CREATE INDEX nuk_mastersection_attr_aud_2 ON mastersection_attr_aud(aud_datetime)
GO

create trigger i_mastersection_attr on mastersection_attr
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into mastersection_attr (
id,section_id,attribute_id,attribute_value_data,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select id,section_id,attribute_id,attribute_value_data,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into mastersection_attr_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,section_id
 ,attribute_id
 ,attribute_value_data
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,section_id
 ,attribute_id
 ,attribute_value_data
  from inserted
end
GO

create trigger u_mastersection_attr on mastersection_attr
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update mastersection_attr set
mastersection_attr.id = inserted.id,mastersection_attr.section_id = inserted.section_id,mastersection_attr.attribute_id = inserted.attribute_id,mastersection_attr.attribute_value_data = inserted.attribute_value_data,mastersection_attr.last_updated = inserted.last_updated,mastersection_attr.updater_legal_name = inserted.updater_legal_name,mastersection_attr.update_meaning_text = inserted.update_meaning_text,mastersection_attr.last_updater_uid = inserted.last_updater_uid
from mastersection_attr inner join deleted on mastersection_attr.id = deleted.id inner join inserted on mastersection_attr.id = inserted.id
insert into mastersection_attr_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,section_id
 ,attribute_id
 ,attribute_value_data
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,section_id
 ,attribute_id
 ,attribute_value_data
  from inserted
end
GO

create trigger d_mastersection_attr on mastersection_attr
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from mastersection_attr where exists (
select 1 from deleted where mastersection_attr.id = deleted.id)
insert into mastersection_attr_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,section_id
 ,attribute_id
 ,attribute_value_data
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,section_id
 ,attribute_id
 ,attribute_value_data
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-mastersection_attr', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1179, '8:3bbdea59f31ff5a20b119e77c88bdd7e', 'enableAuditTable auditTableName=mastersection_attr_aud, tableName=mastersection_attr', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_attribute::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_attribute'
			)
			DROP TRIGGER i_question_attribute
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_attribute'
			)
			DROP TRIGGER u_question_attribute
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_attribute'
			)
			DROP TRIGGER d_question_attribute
GO

CREATE TABLE question_attribute_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_attribute_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), question_id nvarchar(85), attribute_id nvarchar(15), attribute_value_data nvarchar(2000), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_ATTRIBUTE_AUD PRIMARY KEY (aud_id))
GO

insert into question_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,question_id
 ,attribute_id
 ,attribute_value_data
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,question_id
 ,attribute_id
 ,attribute_value_data
  from question_attribute
GO

CREATE INDEX nuk_question_attribute_aud_1 ON question_attribute_aud(aud_userid)
GO

CREATE INDEX nuk_question_attribute_aud_2 ON question_attribute_aud(aud_datetime)
GO

create trigger i_question_attribute on question_attribute
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_attribute (
id,question_id,attribute_id,attribute_value_data,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select id,question_id,attribute_id,attribute_value_data,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into question_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,question_id
 ,attribute_id
 ,attribute_value_data
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,question_id
 ,attribute_id
 ,attribute_value_data
  from inserted
end
GO

create trigger u_question_attribute on question_attribute
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_attribute set
question_attribute.id = inserted.id,question_attribute.question_id = inserted.question_id,question_attribute.attribute_id = inserted.attribute_id,question_attribute.attribute_value_data = inserted.attribute_value_data,question_attribute.last_updated = inserted.last_updated,question_attribute.updater_legal_name = inserted.updater_legal_name,question_attribute.update_meaning_text = inserted.update_meaning_text,question_attribute.last_updater_uid = inserted.last_updater_uid
from question_attribute inner join deleted on question_attribute.id = deleted.id inner join inserted on question_attribute.id = inserted.id
insert into question_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,question_id
 ,attribute_id
 ,attribute_value_data
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,question_id
 ,attribute_id
 ,attribute_value_data
  from inserted
end
GO

create trigger d_question_attribute on question_attribute
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_attribute where exists (
select 1 from deleted where question_attribute.id = deleted.id)
insert into question_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,question_id
 ,attribute_id
 ,attribute_value_data
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,question_id
 ,attribute_id
 ,attribute_value_data
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_attribute', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1180, '8:37a2d6401f3717fea2f5dd1a66b45ab9', 'enableAuditTable auditTableName=question_attribute_aud, tableName=question_attribute', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-question_bundle::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_question_bundle'
			)
			DROP TRIGGER i_question_bundle
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_question_bundle'
			)
			DROP TRIGGER u_question_bundle
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_question_bundle'
			)
			DROP TRIGGER d_question_bundle
GO

CREATE TABLE question_bundle_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_question_bundle_aud_aud_datetime DEFAULT GETDATE() NOT NULL, bundle_id nvarchar(85), questionid nvarchar(85), latest_version_bundle_id nvarchar(85), version int, last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_QUESTION_BUNDLE_AUD PRIMARY KEY (aud_id))
GO

insert into question_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,questionid
 ,latest_version_bundle_id
 ,version
) select 'U', null
, null
, GETDATE(), null
, null
 ,bundle_id
 ,questionid
 ,latest_version_bundle_id
 ,version
  from question_bundle
GO

CREATE INDEX nuk_question_bundle_aud_1 ON question_bundle_aud(aud_userid)
GO

CREATE INDEX nuk_question_bundle_aud_2 ON question_bundle_aud(aud_datetime)
GO

create trigger i_question_bundle on question_bundle
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into question_bundle (
bundle_id,questionid,latest_version_bundle_id,version,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select bundle_id,questionid,latest_version_bundle_id,version,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into question_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,questionid
 ,latest_version_bundle_id
 ,version
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,bundle_id
 ,questionid
 ,latest_version_bundle_id
 ,version
  from inserted
end
GO

create trigger u_question_bundle on question_bundle
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update question_bundle set
question_bundle.bundle_id = inserted.bundle_id,question_bundle.questionid = inserted.questionid,question_bundle.latest_version_bundle_id = inserted.latest_version_bundle_id,question_bundle.version = inserted.version,question_bundle.last_updated = inserted.last_updated,question_bundle.updater_legal_name = inserted.updater_legal_name,question_bundle.update_meaning_text = inserted.update_meaning_text,question_bundle.last_updater_uid = inserted.last_updater_uid
from question_bundle inner join deleted on question_bundle.bundle_id = deleted.bundle_id inner join inserted on question_bundle.bundle_id = inserted.bundle_id
insert into question_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,questionid
 ,latest_version_bundle_id
 ,version
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,bundle_id
 ,questionid
 ,latest_version_bundle_id
 ,version
  from inserted
end
GO

create trigger d_question_bundle on question_bundle
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from question_bundle where exists (
select 1 from deleted where question_bundle.bundle_id = deleted.bundle_id)
insert into question_bundle_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,bundle_id
 ,questionid
 ,latest_version_bundle_id
 ,version
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,bundle_id
 ,questionid
 ,latest_version_bundle_id
 ,version
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-question_bundle', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1181, '8:bd5495c443d28573dfcd88487bd23f3d', 'enableAuditTable auditTableName=question_bundle_aud, tableName=question_bundle', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-certusers_course_objectives::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_certusers_course_objectives'
			)
			DROP TRIGGER i_certusers_course_objectives
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_certusers_course_objectives'
			)
			DROP TRIGGER u_certusers_course_objectives
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_certusers_course_objectives'
			)
			DROP TRIGGER d_certusers_course_objectives
GO

CREATE TABLE certusers_course_obj_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_certusers_course_obj_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), certusers_awardid nvarchar(85), objective_description nvarchar(4000), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CERTUSERS_COURSE_OBJ_AUD PRIMARY KEY (aud_id))
GO

insert into certusers_course_obj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,objective_description
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,certusers_awardid
 ,objective_description
  from certusers_course_objectives
GO

CREATE INDEX nuk_certusers_course_obj_aud_1 ON certusers_course_obj_aud(aud_userid)
GO

CREATE INDEX nuk_certusers_course_obj_aud_2 ON certusers_course_obj_aud(aud_datetime)
GO

create trigger i_certusers_course_objectives on certusers_course_objectives
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into certusers_course_objectives (
id,certusers_awardid,objective_description) select id,certusers_awardid,objective_description from inserted
insert into certusers_course_obj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,objective_description
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,certusers_awardid
 ,objective_description
  from inserted
end
GO

create trigger u_certusers_course_objectives on certusers_course_objectives
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update certusers_course_objectives set
certusers_course_objectives.id = inserted.id,certusers_course_objectives.certusers_awardid = inserted.certusers_awardid,certusers_course_objectives.objective_description = inserted.objective_description
from certusers_course_objectives inner join deleted on certusers_course_objectives.id = deleted.id inner join inserted on certusers_course_objectives.id = inserted.id
insert into certusers_course_obj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,objective_description
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,certusers_awardid
 ,objective_description
  from inserted
end
GO

create trigger d_certusers_course_objectives on certusers_course_objectives
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from certusers_course_objectives where exists (
select 1 from deleted where certusers_course_objectives.id = deleted.id)
insert into certusers_course_obj_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,objective_description
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,certusers_awardid
 ,objective_description
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-certusers_course_objectives', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1182, '8:b4dbf16acebc5b5118769a204cea7735', 'enableAuditTable auditTableName=certusers_course_obj_aud, tableName=certusers_course_objectives', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-certusers_attribute::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_certusers_attribute'
			)
			DROP TRIGGER i_certusers_attribute
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_certusers_attribute'
			)
			DROP TRIGGER u_certusers_attribute
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_certusers_attribute'
			)
			DROP TRIGGER d_certusers_attribute
GO

CREATE TABLE certusers_attribute_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_certusers_attribute_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), certusers_awardid nvarchar(85), attribute_type char(2), attribute_no int, attribute_code nvarchar(2000), attribute_value nvarchar(2000), attribute_id nvarchar(15), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CERTUSERS_ATTRIBUTE_AUD PRIMARY KEY (aud_id))
GO

insert into certusers_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,attribute_type
 ,attribute_no
 ,attribute_code
 ,attribute_value
 ,attribute_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,certusers_awardid
 ,attribute_type
 ,attribute_no
 ,attribute_code
 ,attribute_value
 ,attribute_id
  from certusers_attribute
GO

CREATE INDEX nuk_certusers_attribute_aud_1 ON certusers_attribute_aud(aud_userid)
GO

CREATE INDEX nuk_certusers_attribute_aud_2 ON certusers_attribute_aud(aud_datetime)
GO

create trigger i_certusers_attribute on certusers_attribute
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into certusers_attribute (
id,certusers_awardid,attribute_type,attribute_no,attribute_code,attribute_value,attribute_id) select id,certusers_awardid,attribute_type,attribute_no,attribute_code,attribute_value,attribute_id from inserted
insert into certusers_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,attribute_type
 ,attribute_no
 ,attribute_code
 ,attribute_value
 ,attribute_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,certusers_awardid
 ,attribute_type
 ,attribute_no
 ,attribute_code
 ,attribute_value
 ,attribute_id
  from inserted
end
GO

create trigger u_certusers_attribute on certusers_attribute
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update certusers_attribute set
certusers_attribute.id = inserted.id,certusers_attribute.certusers_awardid = inserted.certusers_awardid,certusers_attribute.attribute_type = inserted.attribute_type,certusers_attribute.attribute_no = inserted.attribute_no,certusers_attribute.attribute_code = inserted.attribute_code,certusers_attribute.attribute_value = inserted.attribute_value,certusers_attribute.attribute_id = inserted.attribute_id
from certusers_attribute inner join deleted on certusers_attribute.id = deleted.id inner join inserted on certusers_attribute.id = inserted.id
insert into certusers_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,attribute_type
 ,attribute_no
 ,attribute_code
 ,attribute_value
 ,attribute_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,certusers_awardid
 ,attribute_type
 ,attribute_no
 ,attribute_code
 ,attribute_value
 ,attribute_id
  from inserted
end
GO

create trigger d_certusers_attribute on certusers_attribute
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from certusers_attribute where exists (
select 1 from deleted where certusers_attribute.id = deleted.id)
insert into certusers_attribute_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,attribute_type
 ,attribute_no
 ,attribute_code
 ,attribute_value
 ,attribute_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,certusers_awardid
 ,attribute_type
 ,attribute_no
 ,attribute_code
 ,attribute_value
 ,attribute_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-certusers_attribute', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1183, '8:894d0cf1e6828200385048b7397602a9', 'enableAuditTable auditTableName=certusers_attribute_aud, tableName=certusers_attribute', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-certusers_instructor::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_certusers_instructor'
			)
			DROP TRIGGER i_certusers_instructor
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_certusers_instructor'
			)
			DROP TRIGGER u_certusers_instructor
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_certusers_instructor'
			)
			DROP TRIGGER d_certusers_instructor
GO

CREATE TABLE certusers_instructor_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_certusers_instructor_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), certusers_awardid nvarchar(85), instructor_givenname nvarchar(85), instructor_familyname nvarchar(85), instructor_jobtitle nvarchar(85), instructor_department nvarchar(85), instructor_da_givenname nvarchar(85), instructor_da_familyname nvarchar(85), instructor_da_jobtitle nvarchar(85), instructor_da_department nvarchar(85), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CERTUSERS_INSTRUCTOR_AUD PRIMARY KEY (aud_id))
GO

insert into certusers_instructor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,instructor_givenname
 ,instructor_familyname
 ,instructor_jobtitle
 ,instructor_department
 ,instructor_da_givenname
 ,instructor_da_familyname
 ,instructor_da_jobtitle
 ,instructor_da_department
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,certusers_awardid
 ,instructor_givenname
 ,instructor_familyname
 ,instructor_jobtitle
 ,instructor_department
 ,instructor_da_givenname
 ,instructor_da_familyname
 ,instructor_da_jobtitle
 ,instructor_da_department
  from certusers_instructor
GO

CREATE INDEX nuk_certusers_instructor_aud_1 ON certusers_instructor_aud(aud_userid)
GO

CREATE INDEX nuk_certusers_instructor_aud_2 ON certusers_instructor_aud(aud_datetime)
GO

create trigger i_certusers_instructor on certusers_instructor
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into certusers_instructor (
id,certusers_awardid,instructor_givenname,instructor_familyname,instructor_jobtitle,instructor_department,instructor_da_givenname,instructor_da_familyname,instructor_da_jobtitle,instructor_da_department) select id,certusers_awardid,instructor_givenname,instructor_familyname,instructor_jobtitle,instructor_department,instructor_da_givenname,instructor_da_familyname,instructor_da_jobtitle,instructor_da_department from inserted
insert into certusers_instructor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,instructor_givenname
 ,instructor_familyname
 ,instructor_jobtitle
 ,instructor_department
 ,instructor_da_givenname
 ,instructor_da_familyname
 ,instructor_da_jobtitle
 ,instructor_da_department
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,certusers_awardid
 ,instructor_givenname
 ,instructor_familyname
 ,instructor_jobtitle
 ,instructor_department
 ,instructor_da_givenname
 ,instructor_da_familyname
 ,instructor_da_jobtitle
 ,instructor_da_department
  from inserted
end
GO

create trigger u_certusers_instructor on certusers_instructor
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update certusers_instructor set
certusers_instructor.id = inserted.id,certusers_instructor.certusers_awardid = inserted.certusers_awardid,certusers_instructor.instructor_givenname = inserted.instructor_givenname,certusers_instructor.instructor_familyname = inserted.instructor_familyname,certusers_instructor.instructor_jobtitle = inserted.instructor_jobtitle,certusers_instructor.instructor_department = inserted.instructor_department,certusers_instructor.instructor_da_givenname = inserted.instructor_da_givenname,certusers_instructor.instructor_da_familyname = inserted.instructor_da_familyname,certusers_instructor.instructor_da_jobtitle = inserted.instructor_da_jobtitle,certusers_instructor.instructor_da_department = inserted.instructor_da_department
from certusers_instructor inner join deleted on certusers_instructor.id = deleted.id inner join inserted on certusers_instructor.id = inserted.id
insert into certusers_instructor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,instructor_givenname
 ,instructor_familyname
 ,instructor_jobtitle
 ,instructor_department
 ,instructor_da_givenname
 ,instructor_da_familyname
 ,instructor_da_jobtitle
 ,instructor_da_department
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,certusers_awardid
 ,instructor_givenname
 ,instructor_familyname
 ,instructor_jobtitle
 ,instructor_department
 ,instructor_da_givenname
 ,instructor_da_familyname
 ,instructor_da_jobtitle
 ,instructor_da_department
  from inserted
end
GO

create trigger d_certusers_instructor on certusers_instructor
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from certusers_instructor where exists (
select 1 from deleted where certusers_instructor.id = deleted.id)
insert into certusers_instructor_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,certusers_awardid
 ,instructor_givenname
 ,instructor_familyname
 ,instructor_jobtitle
 ,instructor_department
 ,instructor_da_givenname
 ,instructor_da_familyname
 ,instructor_da_jobtitle
 ,instructor_da_department
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,certusers_awardid
 ,instructor_givenname
 ,instructor_familyname
 ,instructor_jobtitle
 ,instructor_department
 ,instructor_da_givenname
 ,instructor_da_familyname
 ,instructor_da_jobtitle
 ,instructor_da_department
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-certusers_instructor', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1184, '8:aef6a80e0267250e5f37d50bbd62a9a7', 'enableAuditTable auditTableName=certusers_instructor_aud, tableName=certusers_instructor', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-submod_tran_deadline::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_submod_tran_deadline'
			)
			DROP TRIGGER i_submod_tran_deadline
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_submod_tran_deadline'
			)
			DROP TRIGGER u_submod_tran_deadline
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_submod_tran_deadline'
			)
			DROP TRIGGER d_submod_tran_deadline
GO

CREATE TABLE submod_tran_deadline_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_submod_tran_deadline_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), master_transcriptid nvarchar(15), program_id nvarchar(85), program_session_id nvarchar(15), submod_completion_deadline datetime, last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SUBMOD_TRAN_DEADLINE_AUD PRIMARY KEY (aud_id))
GO

insert into submod_tran_deadline_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,master_transcriptid
 ,program_id
 ,program_session_id
 ,submod_completion_deadline
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,master_transcriptid
 ,program_id
 ,program_session_id
 ,submod_completion_deadline
  from submod_tran_deadline
GO

CREATE INDEX nuk_submod_tran_deadline_aud_1 ON submod_tran_deadline_aud(aud_userid)
GO

CREATE INDEX nuk_submod_tran_deadline_aud_2 ON submod_tran_deadline_aud(aud_datetime)
GO

create trigger i_submod_tran_deadline on submod_tran_deadline
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into submod_tran_deadline (
id,master_transcriptid,program_id,program_session_id,submod_completion_deadline) select id,master_transcriptid,program_id,program_session_id,submod_completion_deadline from inserted
insert into submod_tran_deadline_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,master_transcriptid
 ,program_id
 ,program_session_id
 ,submod_completion_deadline
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,master_transcriptid
 ,program_id
 ,program_session_id
 ,submod_completion_deadline
  from inserted
end
GO

create trigger u_submod_tran_deadline on submod_tran_deadline
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update submod_tran_deadline set
submod_tran_deadline.id = inserted.id,submod_tran_deadline.master_transcriptid = inserted.master_transcriptid,submod_tran_deadline.program_id = inserted.program_id,submod_tran_deadline.program_session_id = inserted.program_session_id,submod_tran_deadline.submod_completion_deadline = inserted.submod_completion_deadline
from submod_tran_deadline inner join deleted on submod_tran_deadline.id = deleted.id inner join inserted on submod_tran_deadline.id = inserted.id
insert into submod_tran_deadline_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,master_transcriptid
 ,program_id
 ,program_session_id
 ,submod_completion_deadline
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,master_transcriptid
 ,program_id
 ,program_session_id
 ,submod_completion_deadline
  from inserted
end
GO

create trigger d_submod_tran_deadline on submod_tran_deadline
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from submod_tran_deadline where exists (
select 1 from deleted where submod_tran_deadline.id = deleted.id)
insert into submod_tran_deadline_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,master_transcriptid
 ,program_id
 ,program_session_id
 ,submod_completion_deadline
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,master_transcriptid
 ,program_id
 ,program_session_id
 ,submod_completion_deadline
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-submod_tran_deadline', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1185, '8:9f2db007f007416d8e668a8f99dbe967', 'enableAuditTable auditTableName=submod_tran_deadline_aud, tableName=submod_tran_deadline', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-permission_template::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_permission_template'
			)
			DROP TRIGGER i_permission_template
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_permission_template'
			)
			DROP TRIGGER u_permission_template
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_permission_template'
			)
			DROP TRIGGER d_permission_template
GO

CREATE TABLE permission_template_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_permission_template_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), template_code nvarchar(85), template_name nvarchar(255), is_auto_generated char(1), criteria_hash int, last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_PERMISSION_TEMPLATE_AUD PRIMARY KEY (aud_id))
GO

insert into permission_template_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,template_code
 ,template_name
 ,is_auto_generated
 ,criteria_hash
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,template_code
 ,template_name
 ,is_auto_generated
 ,criteria_hash
  from permission_template
GO

CREATE INDEX nuk_permission_template_aud_1 ON permission_template_aud(aud_userid)
GO

CREATE INDEX nuk_permission_template_aud_2 ON permission_template_aud(aud_datetime)
GO

create trigger i_permission_template on permission_template
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into permission_template (
id,template_code,template_name,is_auto_generated,criteria_hash) select id,template_code,template_name,is_auto_generated,criteria_hash from inserted
insert into permission_template_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,template_code
 ,template_name
 ,is_auto_generated
 ,criteria_hash
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,template_code
 ,template_name
 ,is_auto_generated
 ,criteria_hash
  from inserted
end
GO

create trigger u_permission_template on permission_template
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update permission_template set
permission_template.id = inserted.id,permission_template.template_code = inserted.template_code,permission_template.template_name = inserted.template_name,permission_template.is_auto_generated = inserted.is_auto_generated,permission_template.criteria_hash = inserted.criteria_hash
from permission_template inner join deleted on permission_template.id = deleted.id inner join inserted on permission_template.id = inserted.id
insert into permission_template_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,template_code
 ,template_name
 ,is_auto_generated
 ,criteria_hash
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,template_code
 ,template_name
 ,is_auto_generated
 ,criteria_hash
  from inserted
end
GO

create trigger d_permission_template on permission_template
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from permission_template where exists (
select 1 from deleted where permission_template.id = deleted.id)
insert into permission_template_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,template_code
 ,template_name
 ,is_auto_generated
 ,criteria_hash
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,template_code
 ,template_name
 ,is_auto_generated
 ,criteria_hash
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-permission_template', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1186, '8:92778f5e5931d004373cc0ea9936b46c', 'enableAuditTable auditTableName=permission_template_aud, tableName=permission_template', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-permission_mapping::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_permission_mapping'
			)
			DROP TRIGGER i_permission_mapping
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_permission_mapping'
			)
			DROP TRIGGER u_permission_mapping
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_permission_mapping'
			)
			DROP TRIGGER d_permission_mapping
GO

CREATE TABLE permission_mapping_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_permission_mapping_aud_aud_datetime DEFAULT GETDATE() NOT NULL, objectid nvarchar(120), objecttype nvarchar(5), permissioncode int, resolved_objectid nvarchar(120), is_pts_objecttype char(1), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_PERMISSION_MAPPING_AUD PRIMARY KEY (aud_id))
GO

insert into permission_mapping_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,objectid
 ,objecttype
 ,permissioncode
 ,resolved_objectid
 ,is_pts_objecttype
) select 'U', null
, null
, GETDATE(), null
, null
 ,objectid
 ,objecttype
 ,permissioncode
 ,resolved_objectid
 ,is_pts_objecttype
  from permission_mapping
GO

CREATE INDEX nuk_permission_mapping_aud_1 ON permission_mapping_aud(aud_userid)
GO

CREATE INDEX nuk_permission_mapping_aud_2 ON permission_mapping_aud(aud_datetime)
GO

create trigger i_permission_mapping on permission_mapping
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into permission_mapping (
objectid,objecttype,permissioncode,resolved_objectid,is_pts_objecttype) select objectid,objecttype,permissioncode,resolved_objectid,is_pts_objecttype from inserted
insert into permission_mapping_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,objectid
 ,objecttype
 ,permissioncode
 ,resolved_objectid
 ,is_pts_objecttype
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,objectid
 ,objecttype
 ,permissioncode
 ,resolved_objectid
 ,is_pts_objecttype
  from inserted
end
GO

create trigger u_permission_mapping on permission_mapping
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update permission_mapping set
permission_mapping.objectid = inserted.objectid,permission_mapping.objecttype = inserted.objecttype,permission_mapping.permissioncode = inserted.permissioncode,permission_mapping.resolved_objectid = inserted.resolved_objectid,permission_mapping.is_pts_objecttype = inserted.is_pts_objecttype
from permission_mapping inner join deleted on permission_mapping.objecttype = deleted.objecttype and permission_mapping.permissioncode = deleted.permissioncode and permission_mapping.objectid = deleted.objectid inner join inserted on permission_mapping.objecttype = inserted.objecttype and permission_mapping.permissioncode = inserted.permissioncode and permission_mapping.objectid = inserted.objectid
insert into permission_mapping_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,objectid
 ,objecttype
 ,permissioncode
 ,resolved_objectid
 ,is_pts_objecttype
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,objectid
 ,objecttype
 ,permissioncode
 ,resolved_objectid
 ,is_pts_objecttype
  from inserted
end
GO

create trigger d_permission_mapping on permission_mapping
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from permission_mapping where exists (
select 1 from deleted where permission_mapping.objecttype = deleted.objecttype and permission_mapping.permissioncode = deleted.permissioncode and permission_mapping.objectid = deleted.objectid)
insert into permission_mapping_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,objectid
 ,objecttype
 ,permissioncode
 ,resolved_objectid
 ,is_pts_objecttype
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,objectid
 ,objecttype
 ,permissioncode
 ,resolved_objectid
 ,is_pts_objecttype
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-permission_mapping', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1187, '8:6759ac74c4d5095481febaff5b232ef4', 'enableAuditTable auditTableName=permission_mapping_aud, tableName=permission_mapping', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-autoassign_org_attr::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_autoassign_org_attr'
			)
			DROP TRIGGER i_autoassign_org_attr
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_autoassign_org_attr'
			)
			DROP TRIGGER u_autoassign_org_attr
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_autoassign_org_attr'
			)
			DROP TRIGGER d_autoassign_org_attr
GO

CREATE TABLE autoassign_org_attr_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_autoassign_org_attr_aud_aud_datetime DEFAULT GETDATE() NOT NULL, assign_object_id nvarchar(200), learning_id nvarchar(85), attribute_id nvarchar(15), attribute_value_data nvarchar(2000), autoassign_source char(1), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_AUTOASSIGN_ORG_ATTR_AUD PRIMARY KEY (aud_id))
GO

insert into autoassign_org_attr_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,assign_object_id
 ,learning_id
 ,attribute_id
 ,attribute_value_data
 ,autoassign_source
) select 'U', null
, null
, GETDATE(), null
, null
 ,assign_object_id
 ,learning_id
 ,attribute_id
 ,attribute_value_data
 ,autoassign_source
  from autoassign_org_attr
GO

CREATE INDEX nuk_autoassign_org_attr_aud_1 ON autoassign_org_attr_aud(aud_userid)
GO

CREATE INDEX nuk_autoassign_org_attr_aud_2 ON autoassign_org_attr_aud(aud_datetime)
GO

create trigger i_autoassign_org_attr on autoassign_org_attr
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into autoassign_org_attr (
assign_object_id,learning_id,attribute_id,attribute_value_data,autoassign_source) select assign_object_id,learning_id,attribute_id,attribute_value_data,autoassign_source from inserted
insert into autoassign_org_attr_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,assign_object_id
 ,learning_id
 ,attribute_id
 ,attribute_value_data
 ,autoassign_source
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,assign_object_id
 ,learning_id
 ,attribute_id
 ,attribute_value_data
 ,autoassign_source
  from inserted
end
GO

create trigger u_autoassign_org_attr on autoassign_org_attr
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update autoassign_org_attr set
autoassign_org_attr.assign_object_id = inserted.assign_object_id,autoassign_org_attr.learning_id = inserted.learning_id,autoassign_org_attr.attribute_id = inserted.attribute_id,autoassign_org_attr.attribute_value_data = inserted.attribute_value_data,autoassign_org_attr.autoassign_source = inserted.autoassign_source
from autoassign_org_attr inner join deleted on autoassign_org_attr.autoassign_source = deleted.autoassign_source and autoassign_org_attr.attribute_id = deleted.attribute_id and autoassign_org_attr.assign_object_id = deleted.assign_object_id and autoassign_org_attr.learning_id = deleted.learning_id inner join inserted on autoassign_org_attr.autoassign_source = inserted.autoassign_source and autoassign_org_attr.attribute_id = inserted.attribute_id and autoassign_org_attr.assign_object_id = inserted.assign_object_id and autoassign_org_attr.learning_id = inserted.learning_id
insert into autoassign_org_attr_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,assign_object_id
 ,learning_id
 ,attribute_id
 ,attribute_value_data
 ,autoassign_source
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,assign_object_id
 ,learning_id
 ,attribute_id
 ,attribute_value_data
 ,autoassign_source
  from inserted
end
GO

create trigger d_autoassign_org_attr on autoassign_org_attr
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from autoassign_org_attr where exists (
select 1 from deleted where autoassign_org_attr.autoassign_source = deleted.autoassign_source and autoassign_org_attr.attribute_id = deleted.attribute_id and autoassign_org_attr.assign_object_id = deleted.assign_object_id and autoassign_org_attr.learning_id = deleted.learning_id)
insert into autoassign_org_attr_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,assign_object_id
 ,learning_id
 ,attribute_id
 ,attribute_value_data
 ,autoassign_source
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,assign_object_id
 ,learning_id
 ,attribute_id
 ,attribute_value_data
 ,autoassign_source
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-autoassign_org_attr', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1188, '8:93bf572c2078b892ac37a102f67b015d', 'enableAuditTable auditTableName=autoassign_org_attr_aud, tableName=autoassign_org_attr', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-withdrawal_enrollment_policy::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_withdrawal_enrollment_policy'
			)
			DROP TRIGGER i_withdrawal_enrollment_policy
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_withdrawal_enrollment_policy'
			)
			DROP TRIGGER u_withdrawal_enrollment_policy
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_withdrawal_enrollment_policy'
			)
			DROP TRIGGER d_withdrawal_enrollment_policy
GO

CREATE TABLE withdrawal_en_policy_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_withdrawal_en_policy_aud_aud_datetime DEFAULT GETDATE() NOT NULL, policy_id nvarchar(15), enable_withdrawal char(1), allow_request_cancel char(1), approverid nvarchar(85), regcontrol smallint, email_profile_id nvarchar(15), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_WITHDRAWAL_EN_POLICY_AUD PRIMARY KEY (aud_id))
GO

insert into withdrawal_en_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,enable_withdrawal
 ,allow_request_cancel
 ,approverid
 ,regcontrol
 ,email_profile_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,policy_id
 ,enable_withdrawal
 ,allow_request_cancel
 ,approverid
 ,regcontrol
 ,email_profile_id
  from withdrawal_enrollment_policy
GO

CREATE INDEX nuk_withdrawal_en_policy_aud_1 ON withdrawal_en_policy_aud(aud_userid)
GO

CREATE INDEX nuk_withdrawal_en_policy_aud_2 ON withdrawal_en_policy_aud(aud_datetime)
GO

create trigger i_withdrawal_enrollment_policy on withdrawal_enrollment_policy
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into withdrawal_enrollment_policy (
policy_id,enable_withdrawal,allow_request_cancel,approverid,regcontrol,email_profile_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select policy_id,enable_withdrawal,allow_request_cancel,approverid,regcontrol,email_profile_id,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into withdrawal_en_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,enable_withdrawal
 ,allow_request_cancel
 ,approverid
 ,regcontrol
 ,email_profile_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,enable_withdrawal
 ,allow_request_cancel
 ,approverid
 ,regcontrol
 ,email_profile_id
  from inserted
end
GO

create trigger u_withdrawal_enrollment_policy on withdrawal_enrollment_policy
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update withdrawal_enrollment_policy set
withdrawal_enrollment_policy.policy_id = inserted.policy_id,withdrawal_enrollment_policy.enable_withdrawal = inserted.enable_withdrawal,withdrawal_enrollment_policy.allow_request_cancel = inserted.allow_request_cancel,withdrawal_enrollment_policy.approverid = inserted.approverid,withdrawal_enrollment_policy.regcontrol = inserted.regcontrol,withdrawal_enrollment_policy.email_profile_id = inserted.email_profile_id,withdrawal_enrollment_policy.last_updated = inserted.last_updated,withdrawal_enrollment_policy.updater_legal_name = inserted.updater_legal_name,withdrawal_enrollment_policy.update_meaning_text = inserted.update_meaning_text,withdrawal_enrollment_policy.last_updater_uid = inserted.last_updater_uid
from withdrawal_enrollment_policy inner join deleted on withdrawal_enrollment_policy.policy_id = deleted.policy_id inner join inserted on withdrawal_enrollment_policy.policy_id = inserted.policy_id
insert into withdrawal_en_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,enable_withdrawal
 ,allow_request_cancel
 ,approverid
 ,regcontrol
 ,email_profile_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,enable_withdrawal
 ,allow_request_cancel
 ,approverid
 ,regcontrol
 ,email_profile_id
  from inserted
end
GO

create trigger d_withdrawal_enrollment_policy on withdrawal_enrollment_policy
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from withdrawal_enrollment_policy where exists (
select 1 from deleted where withdrawal_enrollment_policy.policy_id = deleted.policy_id)
insert into withdrawal_en_policy_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,policy_id
 ,enable_withdrawal
 ,allow_request_cancel
 ,approverid
 ,regcontrol
 ,email_profile_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,policy_id
 ,enable_withdrawal
 ,allow_request_cancel
 ,approverid
 ,regcontrol
 ,email_profile_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-withdrawal_enrollment_policy', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1189, '8:30d75ed67fa7a1021d84c0500192fe0f', 'enableAuditTable auditTableName=withdrawal_en_policy_aud, tableName=withdrawal_enrollment_policy', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-withdrawal_approval_queue::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_withdrawal_approval_queue'
			)
			DROP TRIGGER i_withdrawal_approval_queue
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_withdrawal_approval_queue'
			)
			DROP TRIGGER u_withdrawal_approval_queue
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_withdrawal_approval_queue'
			)
			DROP TRIGGER d_withdrawal_approval_queue
GO

CREATE TABLE withdrawal_app_q_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_withdrawal_app_q_aud_aud_datetime DEFAULT GETDATE() NOT NULL, transcriptid nvarchar(15), policy_id nvarchar(15), request_date datetime, reason nvarchar(1000), status char(1), approver_id nvarchar(85), approver_remarks nvarchar(255), approval_date datetime, last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_WITHDRAWAL_APP_Q_AUD PRIMARY KEY (aud_id))
GO

insert into withdrawal_app_q_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,policy_id
 ,request_date
 ,reason
 ,status
 ,approver_id
 ,approver_remarks
 ,approval_date
) select 'U', null
, null
, GETDATE(), null
, null
 ,transcriptid
 ,policy_id
 ,request_date
 ,reason
 ,status
 ,approver_id
 ,approver_remarks
 ,approval_date
  from withdrawal_approval_queue
GO

CREATE INDEX nuk_withdrawal_app_q_aud_1 ON withdrawal_app_q_aud(aud_userid)
GO

CREATE INDEX nuk_withdrawal_app_q_aud_2 ON withdrawal_app_q_aud(aud_datetime)
GO

create trigger i_withdrawal_approval_queue on withdrawal_approval_queue
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into withdrawal_approval_queue (
transcriptid,policy_id,request_date,reason,status,approver_id,approver_remarks,approval_date,last_updated,updater_legal_name,update_meaning_text,last_updater_uid) select transcriptid,policy_id,request_date,reason,status,approver_id,approver_remarks,approval_date,last_updated,updater_legal_name,update_meaning_text,last_updater_uid from inserted
insert into withdrawal_app_q_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,policy_id
 ,request_date
 ,reason
 ,status
 ,approver_id
 ,approver_remarks
 ,approval_date
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,policy_id
 ,request_date
 ,reason
 ,status
 ,approver_id
 ,approver_remarks
 ,approval_date
  from inserted
end
GO

create trigger u_withdrawal_approval_queue on withdrawal_approval_queue
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update withdrawal_approval_queue set
withdrawal_approval_queue.transcriptid = inserted.transcriptid,withdrawal_approval_queue.policy_id = inserted.policy_id,withdrawal_approval_queue.request_date = inserted.request_date,withdrawal_approval_queue.reason = inserted.reason,withdrawal_approval_queue.status = inserted.status,withdrawal_approval_queue.approver_id = inserted.approver_id,withdrawal_approval_queue.approver_remarks = inserted.approver_remarks,withdrawal_approval_queue.approval_date = inserted.approval_date,withdrawal_approval_queue.last_updated = inserted.last_updated,withdrawal_approval_queue.updater_legal_name = inserted.updater_legal_name,withdrawal_approval_queue.update_meaning_text = inserted.update_meaning_text,withdrawal_approval_queue.last_updater_uid = inserted.last_updater_uid
from withdrawal_approval_queue inner join deleted on withdrawal_approval_queue.transcriptid = deleted.transcriptid inner join inserted on withdrawal_approval_queue.transcriptid = inserted.transcriptid
insert into withdrawal_app_q_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,policy_id
 ,request_date
 ,reason
 ,status
 ,approver_id
 ,approver_remarks
 ,approval_date
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,policy_id
 ,request_date
 ,reason
 ,status
 ,approver_id
 ,approver_remarks
 ,approval_date
  from inserted
end
GO

create trigger d_withdrawal_approval_queue on withdrawal_approval_queue
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from withdrawal_approval_queue where exists (
select 1 from deleted where withdrawal_approval_queue.transcriptid = deleted.transcriptid)
insert into withdrawal_app_q_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,transcriptid
 ,policy_id
 ,request_date
 ,reason
 ,status
 ,approver_id
 ,approver_remarks
 ,approval_date
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,transcriptid
 ,policy_id
 ,request_date
 ,reason
 ,status
 ,approver_id
 ,approver_remarks
 ,approval_date
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-withdrawal_approval_queue', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1190, '8:da2c7b1f3aa2eaefe369f9562853001a', 'enableAuditTable auditTableName=withdrawal_app_q_aud, tableName=withdrawal_approval_queue', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-tincan_lo_activity::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_tincan_lo_activity'
			)
			DROP TRIGGER i_tincan_lo_activity
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_tincan_lo_activity'
			)
			DROP TRIGGER u_tincan_lo_activity
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_tincan_lo_activity'
			)
			DROP TRIGGER d_tincan_lo_activity
GO

CREATE TABLE tincan_lo_activity_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_tincan_lo_activity_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), learning_id nvarchar(85), session_id nvarchar(15), tincan_activity_id nvarchar(2000), order_number smallint, tincan_activity_id_hash_sha256 char(64), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_TINCAN_LO_ACTIVITY_AUD PRIMARY KEY (aud_id))
GO

insert into tincan_lo_activity_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learning_id
 ,session_id
 ,tincan_activity_id
 ,order_number
 ,tincan_activity_id_hash_sha256
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,learning_id
 ,session_id
 ,tincan_activity_id
 ,order_number
 ,tincan_activity_id_hash_sha256
  from tincan_lo_activity
GO

CREATE INDEX nuk_tincan_lo_activity_aud_1 ON tincan_lo_activity_aud(aud_userid)
GO

CREATE INDEX nuk_tincan_lo_activity_aud_2 ON tincan_lo_activity_aud(aud_datetime)
GO

create trigger i_tincan_lo_activity on tincan_lo_activity
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into tincan_lo_activity (
id,learning_id,session_id,tincan_activity_id,order_number,tincan_activity_id_hash_sha256) select id,learning_id,session_id,tincan_activity_id,order_number,tincan_activity_id_hash_sha256 from inserted
insert into tincan_lo_activity_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learning_id
 ,session_id
 ,tincan_activity_id
 ,order_number
 ,tincan_activity_id_hash_sha256
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learning_id
 ,session_id
 ,tincan_activity_id
 ,order_number
 ,tincan_activity_id_hash_sha256
  from inserted
end
GO

create trigger u_tincan_lo_activity on tincan_lo_activity
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update tincan_lo_activity set
tincan_lo_activity.id = inserted.id,tincan_lo_activity.learning_id = inserted.learning_id,tincan_lo_activity.session_id = inserted.session_id,tincan_lo_activity.tincan_activity_id = inserted.tincan_activity_id,tincan_lo_activity.order_number = inserted.order_number,tincan_lo_activity.tincan_activity_id_hash_sha256 = inserted.tincan_activity_id_hash_sha256
from tincan_lo_activity inner join deleted on tincan_lo_activity.id = deleted.id inner join inserted on tincan_lo_activity.id = inserted.id
insert into tincan_lo_activity_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learning_id
 ,session_id
 ,tincan_activity_id
 ,order_number
 ,tincan_activity_id_hash_sha256
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learning_id
 ,session_id
 ,tincan_activity_id
 ,order_number
 ,tincan_activity_id_hash_sha256
  from inserted
end
GO

create trigger d_tincan_lo_activity on tincan_lo_activity
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from tincan_lo_activity where exists (
select 1 from deleted where tincan_lo_activity.id = deleted.id)
insert into tincan_lo_activity_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,learning_id
 ,session_id
 ,tincan_activity_id
 ,order_number
 ,tincan_activity_id_hash_sha256
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,learning_id
 ,session_id
 ,tincan_activity_id
 ,order_number
 ,tincan_activity_id_hash_sha256
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-tincan_lo_activity', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1191, '8:a638e965a9083312124a0f4a147bdaee', 'enableAuditTable auditTableName=tincan_lo_activity_aud, tableName=tincan_lo_activity', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-certusers_selfaward::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_certusers_selfaward'
			)
			DROP TRIGGER i_certusers_selfaward
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_certusers_selfaward'
			)
			DROP TRIGGER u_certusers_selfaward
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_certusers_selfaward'
			)
			DROP TRIGGER d_certusers_selfaward
GO

CREATE TABLE certusers_selfaward_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_certusers_selfaward_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), user_id nvarchar(85), cert_id numeric(8, 0), status char(1), comments nvarchar(255), date_achieved datetime, expire_date datetime, cert_code nvarchar(85), cert_title nvarchar(4000), approver_name nvarchar(85), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_CERTUSERS_SELFAWARD_AUD PRIMARY KEY (aud_id))
GO

insert into certusers_selfaward_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,user_id
 ,cert_id
 ,status
 ,comments
 ,date_achieved
 ,expire_date
 ,cert_code
 ,cert_title
 ,approver_name
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,user_id
 ,cert_id
 ,status
 ,comments
 ,date_achieved
 ,expire_date
 ,cert_code
 ,cert_title
 ,approver_name
  from certusers_selfaward
GO

CREATE INDEX nuk_certusers_selfaward_aud_1 ON certusers_selfaward_aud(aud_userid)
GO

CREATE INDEX nuk_certusers_selfaward_aud_2 ON certusers_selfaward_aud(aud_datetime)
GO

create trigger i_certusers_selfaward on certusers_selfaward
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into certusers_selfaward (
id,user_id,cert_id,status,comments,date_achieved,expire_date,cert_code,cert_title,approver_name,last_updated,last_updater_uid,updater_legal_name,update_meaning_text) select id,user_id,cert_id,status,comments,date_achieved,expire_date,cert_code,cert_title,approver_name,last_updated,last_updater_uid,updater_legal_name,update_meaning_text from inserted
insert into certusers_selfaward_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,user_id
 ,cert_id
 ,status
 ,comments
 ,date_achieved
 ,expire_date
 ,cert_code
 ,cert_title
 ,approver_name
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,user_id
 ,cert_id
 ,status
 ,comments
 ,date_achieved
 ,expire_date
 ,cert_code
 ,cert_title
 ,approver_name
  from inserted
end
GO

create trigger u_certusers_selfaward on certusers_selfaward
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update certusers_selfaward set
certusers_selfaward.id = inserted.id,certusers_selfaward.user_id = inserted.user_id,certusers_selfaward.cert_id = inserted.cert_id,certusers_selfaward.status = inserted.status,certusers_selfaward.comments = inserted.comments,certusers_selfaward.date_achieved = inserted.date_achieved,certusers_selfaward.expire_date = inserted.expire_date,certusers_selfaward.cert_code = inserted.cert_code,certusers_selfaward.cert_title = inserted.cert_title,certusers_selfaward.approver_name = inserted.approver_name,certusers_selfaward.last_updated = inserted.last_updated,certusers_selfaward.last_updater_uid = inserted.last_updater_uid,certusers_selfaward.updater_legal_name = inserted.updater_legal_name,certusers_selfaward.update_meaning_text = inserted.update_meaning_text
from certusers_selfaward inner join deleted on certusers_selfaward.id = deleted.id inner join inserted on certusers_selfaward.id = inserted.id
insert into certusers_selfaward_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,user_id
 ,cert_id
 ,status
 ,comments
 ,date_achieved
 ,expire_date
 ,cert_code
 ,cert_title
 ,approver_name
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,user_id
 ,cert_id
 ,status
 ,comments
 ,date_achieved
 ,expire_date
 ,cert_code
 ,cert_title
 ,approver_name
  from inserted
end
GO

create trigger d_certusers_selfaward on certusers_selfaward
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from certusers_selfaward where exists (
select 1 from deleted where certusers_selfaward.id = deleted.id)
insert into certusers_selfaward_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,user_id
 ,cert_id
 ,status
 ,comments
 ,date_achieved
 ,expire_date
 ,cert_code
 ,cert_title
 ,approver_name
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,user_id
 ,cert_id
 ,status
 ,comments
 ,date_achieved
 ,expire_date
 ,cert_code
 ,cert_title
 ,approver_name
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-certusers_selfaward', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1192, '8:38b05c21eb5c2465b2143607894c8f58', 'enableAuditTable auditTableName=certusers_selfaward_aud, tableName=certusers_selfaward', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-selfaward_attach::dennis.cheung
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_selfaward_attach'
			)
			DROP TRIGGER i_selfaward_attach
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_selfaward_attach'
			)
			DROP TRIGGER u_selfaward_attach
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_selfaward_attach'
			)
			DROP TRIGGER d_selfaward_attach
GO

CREATE TABLE selfaward_attach_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_selfaward_attach_aud_aud_datetime DEFAULT GETDATE() NOT NULL, id nvarchar(85), file_name nvarchar(255), display_name nvarchar(255), path nvarchar(300), url_path nvarchar(255), upload_date datetime, uploaded_by nvarchar(85), last_updated datetime, update_meaning_text nvarchar(500), last_updater_uid nvarchar(85), updater_legal_name nvarchar(250), CONSTRAINT PK_SELFAWARD_ATTACH_AUD PRIMARY KEY (aud_id))
GO

insert into selfaward_attach_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,file_name
 ,display_name
 ,path
 ,url_path
 ,upload_date
 ,uploaded_by
) select 'U', null
, null
, GETDATE(), null
, null
 ,id
 ,file_name
 ,display_name
 ,path
 ,url_path
 ,upload_date
 ,uploaded_by
  from selfaward_attach
GO

CREATE INDEX nuk_selfaward_attach_aud_1 ON selfaward_attach_aud(aud_userid)
GO

CREATE INDEX nuk_selfaward_attach_aud_2 ON selfaward_attach_aud(aud_datetime)
GO

create trigger i_selfaward_attach on selfaward_attach
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into selfaward_attach (
id,file_name,display_name,path,url_path,upload_date,uploaded_by) select id,file_name,display_name,path,url_path,upload_date,uploaded_by from inserted
insert into selfaward_attach_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,file_name
 ,display_name
 ,path
 ,url_path
 ,upload_date
 ,uploaded_by
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,file_name
 ,display_name
 ,path
 ,url_path
 ,upload_date
 ,uploaded_by
  from inserted
end
GO

create trigger u_selfaward_attach on selfaward_attach
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update selfaward_attach set
selfaward_attach.id = inserted.id,selfaward_attach.file_name = inserted.file_name,selfaward_attach.display_name = inserted.display_name,selfaward_attach.path = inserted.path,selfaward_attach.url_path = inserted.url_path,selfaward_attach.upload_date = inserted.upload_date,selfaward_attach.uploaded_by = inserted.uploaded_by
from selfaward_attach inner join deleted on selfaward_attach.id = deleted.id inner join inserted on selfaward_attach.id = inserted.id
insert into selfaward_attach_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,file_name
 ,display_name
 ,path
 ,url_path
 ,upload_date
 ,uploaded_by
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,file_name
 ,display_name
 ,path
 ,url_path
 ,upload_date
 ,uploaded_by
  from inserted
end
GO

create trigger d_selfaward_attach on selfaward_attach
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from selfaward_attach where exists (
select 1 from deleted where selfaward_attach.id = deleted.id)
insert into selfaward_attach_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,id
 ,file_name
 ,display_name
 ,path
 ,url_path
 ,upload_date
 ,uploaded_by
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,id
 ,file_name
 ,display_name
 ,path
 ,url_path
 ,upload_date
 ,uploaded_by
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-selfaward_attach', 'dennis.cheung', 'nschema/audit-table-enable.xml', GETDATE(), 1193, '8:fed1502aad1b7b650f9bdbe6b26bde74', 'enableAuditTable auditTableName=selfaward_attach_aud, tableName=selfaward_attach', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-vc_launcher_vitero::nelson.yip
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_vc_launcher_vitero'
			)
			DROP TRIGGER i_vc_launcher_vitero
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_vc_launcher_vitero'
			)
			DROP TRIGGER u_vc_launcher_vitero
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_vc_launcher_vitero'
			)
			DROP TRIGGER d_vc_launcher_vitero
GO

CREATE TABLE vc_launcher_vitero_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_vc_launcher_vitero_aud_aud_datetime DEFAULT GETDATE() NOT NULL, course_id nvarchar(85), account_id nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(1000), CONSTRAINT PK_VC_LAUNCHER_VITERO_AUD PRIMARY KEY (aud_id))
GO

insert into vc_launcher_vitero_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,account_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,course_id
 ,account_id
  from vc_launcher_vitero
GO

CREATE INDEX nuk_vc_launcher_vitero_aud_1 ON vc_launcher_vitero_aud(aud_userid)
GO

CREATE INDEX nuk_vc_launcher_vitero_aud_2 ON vc_launcher_vitero_aud(aud_datetime)
GO

create trigger i_vc_launcher_vitero on vc_launcher_vitero
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into vc_launcher_vitero (
course_id,account_id,last_updater_uid,last_updated,updater_legal_name,update_meaning_text) select course_id,account_id,last_updater_uid,last_updated,updater_legal_name,update_meaning_text from inserted
insert into vc_launcher_vitero_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,account_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,account_id
  from inserted
end
GO

create trigger u_vc_launcher_vitero on vc_launcher_vitero
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update vc_launcher_vitero set
vc_launcher_vitero.course_id = inserted.course_id,vc_launcher_vitero.account_id = inserted.account_id,vc_launcher_vitero.last_updater_uid = inserted.last_updater_uid,vc_launcher_vitero.last_updated = inserted.last_updated,vc_launcher_vitero.updater_legal_name = inserted.updater_legal_name,vc_launcher_vitero.update_meaning_text = inserted.update_meaning_text
from vc_launcher_vitero inner join deleted on vc_launcher_vitero.course_id = deleted.course_id inner join inserted on vc_launcher_vitero.course_id = inserted.course_id
insert into vc_launcher_vitero_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,account_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,account_id
  from inserted
end
GO

create trigger d_vc_launcher_vitero on vc_launcher_vitero
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from vc_launcher_vitero where exists (
select 1 from deleted where vc_launcher_vitero.course_id = deleted.course_id)
insert into vc_launcher_vitero_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,account_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,account_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-vc_launcher_vitero', 'nelson.yip', 'nschema/audit-table-enable.xml', GETDATE(), 1194, '8:24026f499944614e694979e07add8599', 'enableAuditTable auditTableName=vc_launcher_vitero_aud, tableName=vc_launcher_vitero', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::enforceAuditTables-vc_launcher_ms_teams::paul.strugnell
-- WARNING The following SQL may change each run and therefore is possibly incorrect and/or invalid:
IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='i_vc_launcher_ms_teams'
			)
			DROP TRIGGER i_vc_launcher_ms_teams
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='u_vc_launcher_ms_teams'
			)
			DROP TRIGGER u_vc_launcher_ms_teams
GO

IF EXISTS (
			SELECT 1
			FROM sys.objects
			WHERE type = 'TR' AND name ='d_vc_launcher_ms_teams'
			)
			DROP TRIGGER d_vc_launcher_ms_teams
GO

CREATE TABLE vc_launcher_ms_teams_aud (aud_id int IDENTITY (1, 1) NOT NULL, aud_action char(1), aud_userid nvarchar(85), aud_datetime datetime CONSTRAINT DF_vc_launcher_ms_teams_aud_aud_datetime DEFAULT GETDATE() NOT NULL, course_id nvarchar(85), account_id nvarchar(85), last_updated datetime, update_meaning_text nvarchar(MAX), last_updater_uid nvarchar(85), updater_legal_name nvarchar(1000), CONSTRAINT PK_VC_LAUNCHER_MS_TEAMS_AUD PRIMARY KEY (aud_id))
GO

insert into vc_launcher_ms_teams_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,account_id
) select 'U', null
, null
, GETDATE(), null
, null
 ,course_id
 ,account_id
  from vc_launcher_ms_teams
GO

CREATE INDEX nuk_vc_launcher_ms_teams_aud_1 ON vc_launcher_ms_teams_aud(aud_userid)
GO

CREATE INDEX nuk_vc_launcher_ms_teams_aud_2 ON vc_launcher_ms_teams_aud(aud_datetime)
GO

create trigger i_vc_launcher_ms_teams on vc_launcher_ms_teams
instead of insert as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
insert into vc_launcher_ms_teams (
course_id,account_id,last_updater_uid,last_updated,updater_legal_name,update_meaning_text) select course_id,account_id,last_updater_uid,last_updated,updater_legal_name,update_meaning_text from inserted
insert into vc_launcher_ms_teams_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,account_id
) select 'I', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,account_id
  from inserted
end
GO

create trigger u_vc_launcher_ms_teams on vc_launcher_ms_teams
instead of update as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
update vc_launcher_ms_teams set
vc_launcher_ms_teams.course_id = inserted.course_id,vc_launcher_ms_teams.account_id = inserted.account_id,vc_launcher_ms_teams.last_updater_uid = inserted.last_updater_uid,vc_launcher_ms_teams.last_updated = inserted.last_updated,vc_launcher_ms_teams.updater_legal_name = inserted.updater_legal_name,vc_launcher_ms_teams.update_meaning_text = inserted.update_meaning_text
from vc_launcher_ms_teams inner join deleted on vc_launcher_ms_teams.course_id = deleted.course_id inner join inserted on vc_launcher_ms_teams.course_id = inserted.course_id
insert into vc_launcher_ms_teams_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,account_id
) select 'U', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,account_id
  from inserted
end
GO

create trigger d_vc_launcher_ms_teams on vc_launcher_ms_teams
instead of delete as begin
declare @ctx nvarchar(95)
declare @userid nvarchar(85)
declare @meaning nvarchar(500)
declare @legalname nvarchar(250)
select @userid = userid, 
@meaning = update_meaning_text, 
@legalname = updater_legal_name 
from e_signature_context where spid = @@SPID
delete from vc_launcher_ms_teams where exists (
select 1 from deleted where vc_launcher_ms_teams.course_id = deleted.course_id)
insert into vc_launcher_ms_teams_aud (
  aud_action
 ,aud_userid
 ,update_meaning_text
 ,last_updated
 ,updater_legal_name
 ,last_updater_uid
 ,course_id
 ,account_id
) select 'D', @userid, @meaning, GETDATE(), @legalname, @userid ,course_id
 ,account_id
  from deleted
end
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('enforceAuditTables-vc_launcher_ms_teams', 'paul.strugnell', 'nschema/audit-table-enable.xml', GETDATE(), 1195, '8:a9ed0525def104bdbbf0f83072e6310e', 'enableAuditTable auditTableName=vc_launcher_ms_teams_aud, tableName=vc_launcher_ms_teams', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::20180312-kk-1::Krupa.Kamat
-- GDPR Story Audit Tables
CREATE NONCLUSTERED INDEX NUK_ADESAUD_LSTUPDUID ON AICC_des_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_ALAUOPTA_LUPID ON AICC_launch_options_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_ANSDROPA_TID ON answer_drag_and_drop_aud(test_instance_id)
GO

CREATE NONCLUSTERED INDEX NUK_ANSDROPAUD_LUPID ON answer_drag_and_drop_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_ANSHSTA_TID ON answer_hotspot_aud(test_instance_id)
GO

CREATE NONCLUSTERED INDEX NUK_ANSHSTA_LUPID ON answer_hotspot_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_APPRQUEA_TID ON approval_queue_aud(transcriptid)
GO

CREATE NONCLUSTERED INDEX NUK_APPQUEA_LUPID ON approval_queue_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_APPQUEA_TID ON approval_queue_step_aud(transcriptid)
GO

CREATE NONCLUSTERED INDEX NUK_AUDA_LUPID ON audience_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_AENROLLA_LUPID ON autoenroll_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CERTRENA_LUPID ON cert_renewal_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CERTSA_LUPID ON cert_schedule_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CERTA_LUPID ON certifications_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CUSEA_LUPID ON certusers_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CUSERSA_ABY ON certusers_aud(awardedby)
GO

CREATE NONCLUSTERED INDEX NUK_CUATTRA_AID ON certusers_attribute_aud(certusers_awardid)
GO

CREATE NONCLUSTERED INDEX NUK_CUINSTUD_AID ON certusers_instructor_aud(certusers_awardid)
GO

CREATE NONCLUSTERED INDEX NUK_CUSERPENDA_LUPID ON certusers_pending_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CUPENDA_UID ON certusers_pending_aud(userid)
GO

CREATE NONCLUSTERED INDEX NUK_CITEMA_LUPID ON checklist_item_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CAPPRQUEA_USERID ON comp_approval_queue_aud(user_id)
GO

CREATE NONCLUSTERED INDEX NUK_CAPPQUEA_LUPID ON comp_approval_queue_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CLEVA_LUPID ON comp_level_validity_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_COMLEVA_LUPID ON competency_level_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CLISTA_LUPID ON contactList_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CLISTA_USERID ON contactList_aud(userid)
GO

CREATE NONCLUSTERED INDEX NUK_CONITEM_LUPID ON ContentItem_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CITEMA_ITID ON ContentItem_aud(itemID)
GO

CREATE NONCLUSTERED INDEX NUK_COOBJEA_LUPID ON ContentObject_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_COBJEA_OID ON ContentObject_aud(ownerID)
GO

CREATE NONCLUSTERED INDEX NUK_CONORGAA_LUPID ON ContentOrganization_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CORGAA_OWNERID ON ContentOrganization_aud(ownerID)
GO

CREATE NONCLUSTERED INDEX NUK_CONPA_LUPID ON ContentPackage_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CONPAA_OID ON ContentPackage_aud(ownerID)
GO

CREATE NONCLUSTERED INDEX NUK_COUA_LUPID ON course_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_COUA_ITEMID ON course_aud(itemID)
GO

CREATE NONCLUSTERED INDEX NUK_COUBUNA_LUPID ON course_bundle_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_COUCOMPA_LUPID ON course_competency_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_COUREVA_LUPID ON course_revision_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_COUSCA_LUPID ON course_session_cost_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_COUACCA_LUPID ON courseAccessLevel_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_COUDOWNA_LUPID ON courseDownloads_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CRTEA_LUPID ON coursetest_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CSCHA_LUPID ON cschedule_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CSCHEA_AID1 ON cschedule_aud(approverid1)
GO

CREATE NONCLUSTERED INDEX NUK_CSCHEA_AID2 ON cschedule_aud(approverid2)
GO

CREATE NONCLUSTERED INDEX NUK_CURRCOUA_LUPID ON currcourses_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CURRIA_LUPID ON curriculum_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_CURRIA_AID1 ON curriculum_aud(approverid1)
GO

CREATE NONCLUSTERED INDEX NUK_CURRIA_AID2 ON curriculum_aud(approverid2)
GO

CREATE NONCLUSTERED INDEX NUK_CUSCOURPOLA_LUPID ON custom_course_policy_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_DRAG_LUPID ON draggable_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_EPOLA_LUPID ON enrollment_policy_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_EQURULA_LUPID ON equivalency_rules_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_EQURULA_CRBY ON equivalency_rules_aud(created_by)
GO

CREATE NONCLUSTERED INDEX NUK_EVALA_LUPID ON evaluation_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_EVALA_UID ON evaluation_aud(userid)
GO

CREATE NONCLUSTERED INDEX NUK_EXAPPA_LUPID ON ex_q_approval_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_EXAPPA_USERID ON ex_q_approval_aud(user_id)
GO

CREATE NONCLUSTERED INDEX NUK_ECOMA_LUPID ON exam_comment_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_EWORKA_LUPID ON exam_workflow_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_EXWORKSA_LUPID ON exam_workflow_step_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_EXTTRAA_LUPID ON external_training_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_EXTRAA_USERID ON external_training_aud(userid)
GO

CREATE NONCLUSTERED INDEX NUK_HOMEA_LUPID ON homework_file_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_HOMEWA_OID ON homework_file_aud(ownerid)
GO

CREATE NONCLUSTERED INDEX NUK_EXTTRAINA_TID ON homework_file_aud(to_userid)
GO

CREATE NONCLUSTERED INDEX NUK_HSTA_LUPID ON hotspot_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_ICOMA_LUPID ON iComment_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_ICOMA_UID ON iComment_aud(userid)
GO

CREATE NONCLUSTERED INDEX NUK_ICOMA_TID ON iComment_aud(transcriptid)
GO

CREATE NONCLUSTERED INDEX NUK_JPROFA_LUPID ON job_profile_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_JPROA_CUID ON job_profile_aud(creator_uid)
GO

CREATE NONCLUSTERED INDEX NUK_JPROFA_OID ON job_profile_aud(owner_id)
GO

CREATE NONCLUSTERED INDEX NUK_LABUNA_LUPID ON language_bundle_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_LRNOBJA_LUPID ON learningObject_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_LRNOBJA_CUID ON learningObject_aud(creator_uid)
GO

CREATE NONCLUSTERED INDEX NUK_LOATTRIA_LUPID ON lo_attribute_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_LOPTPAYA_LUPID ON lo_opt_pay_items_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_LOCOSTSA_LUPID ON locosts_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_MQUESA_LUPID ON masterquestion_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_MSECA_LUPID ON mastersection_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_MSECATTA_LUPID ON mastersection_attr_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_MTESTA_LUPID ON mastertest_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_MTESTA_OWN ON mastertest_aud(owner)
GO

CREATE NONCLUSTERED INDEX NUK_MTESTA_CUID ON mastertest_aud(creator_uid)
GO

CREATE NONCLUSTERED INDEX NUK_MPRINT_LUPID ON mastertest_print_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_NETAAUD_LUPID ON netassessor_launcher_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_OBJTOPA_LUPID ON objectives_topics_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_OTOBJA_LUPID ON otherObjects_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_PAYA_LUPID ON payment_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_PAYA_UID ON payment_aud(pay_user_id)
GO

CREATE NONCLUSTERED INDEX NUK_PAYA_REVBY ON payment_aud(reviewed_by)
GO

CREATE NONCLUSTERED INDEX NUK_PERA_LUPID ON permissions_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_PERA_IID ON permissions_aud(identityid)
GO

CREATE NONCLUSTERED INDEX NUK_PREREQA_LUPID ON prereq_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QATTRA_LUPID ON qattributes_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUESTA_LUPID ON question_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUESTA_OR ON question_aud(owner)
GO

CREATE NONCLUSTERED INDEX NUK_QUESTA_WR ON question_aud(writer)
GO

CREATE NONCLUSTERED INDEX NUK_QUESA_CUID ON question_aud(creator_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEATTA_LUPID ON question_attribute_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUESBUNA_LUPID ON question_bundle_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUESCHA_LUPID ON question_choices_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEST1A_LUPID ON question_type1_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEST2A_LUPID ON question_type2_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEST3A_LUPID ON question_type3_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEST4A_LUPID ON question_type4_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEST5A_LUPID ON question_type5_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEST6A_LUPID ON question_type6_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEST7A_LUPID ON question_type7_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEST8A_LUPID ON question_type8_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEST8IA_LUPID ON question_type8_item_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_QUEST9A_LUPID ON question_type9_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_RANDSA_LUPID ON randsection_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_REGEVA_LUPID ON registeredevents_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_REGA_LUPID ON registration_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_REGA_LTRANID ON registration_aud(transcriptid)
GO

CREATE NONCLUSTERED INDEX NUK_RESSTRA_LUPID ON resource_string_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_ROLUPCONA_LUPID ON RollupCondition_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_ROLLUPA_LUPID ON RollupRule_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_SAFLAUNA_LUPID ON safari_launcher_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_SEQOBJMA_LUPID ON SeqObjectiveMap_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_SEQRUCONA_LUPID ON SeqRuleCondition_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_SEQOBJA_LUPID ON SequenceObjective_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_SEQRUA_LUPID ON SequenceRule_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_SEQA_LUPID ON Sequencing_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_SESATRA_LUPID ON session_attribute_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_SECOA_LUPID ON session_cost_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_SESDETA_LUPID ON sessiondetail_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_SESDETA_AID1 ON sessiondetail_aud(approverid1)
GO

CREATE NONCLUSTERED INDEX NUK_SESDETA_AID2 ON sessiondetail_aud(approverid2)
GO

CREATE NONCLUSTERED INDEX NUK_SUBTRADA_TID ON submod_tran_deadline_aud(master_transcriptid)
GO

CREATE NONCLUSTERED INDEX NUK_SUBTRATA_LID ON submod_tran_subt_aud(learner_id)
GO

CREATE NONCLUSTERED INDEX NUK_SUBTRATA_SID ON submod_tran_subt_aud(substitute_tran_id)
GO

CREATE NONCLUSTERED INDEX NUK_TKSIGNCA_LUPID ON task_signoff_config_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TKSIGNA_LUPID ON task_signoff_users_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TKSIGNA_SID ON task_signoff_users_aud(signoff_user_id)
GO

CREATE NONCLUSTERED INDEX NUK_TKSIGNA_DELTO ON task_signoff_users_aud(delegated_to)
GO

CREATE NONCLUSTERED INDEX NUK_TESTINSA_LUPID ON testinstance_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUEA_LUPID ON testquestion_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUEA_INID ON testquestion_aud(instanceid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUE3A_LUPID ON testquestion3_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUE3A_INSTID ON testquestion3_aud(instanceid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUE4A_INID ON testquestion4_aud(instanceid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUE5A_LUPID ON testquestion5_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TE5A_INID ON testquestion5_aud(instanceid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUE6A_LUPID ON testquestion6_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUE6A_INID ON testquestion6_aud(instanceid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUE8A_LSTID ON testquestion8_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUE8AUD_INID ON testquestion8_aud(instanceid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUE9A_LUPID ON testquestion9_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TQUE9A_INID ON testquestion9_aud(instanceid)
GO

CREATE NONCLUSTERED INDEX NUK_TSECA_LUPID ON testsection_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TSEC_INID ON testsection_aud(instanceid)
GO

CREATE NONCLUSTERED INDEX NUK_TRANSA_LUPID ON transcript_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TRANSA_UID ON transcript_aud(userid)
GO

CREATE NONCLUSTERED INDEX NUK_TRANSA_CUID ON transcript_aud(creator_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TATA_LUPID ON transcript_attribute_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TSTATA_LUPID ON transcript_stat_log_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TSLOGA_TID ON transcript_stat_log_aud(transcriptid)
GO

CREATE NONCLUSTERED INDEX NUK_TSUBA_LUPID ON transcript_substatus_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TUTORA_LUPID ON tutor_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_TUTORA_UID ON tutor_aud(userid)
GO

CREATE NONCLUSTERED INDEX NUK_UCOMPA_LUPID ON user_competency_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_UCOMPEA_UID ON user_competency_aud(user_id)
GO

CREATE NONCLUSTERED INDEX NUK_UCOMA_ABY ON user_competency_aud(assigned_by)
GO

CREATE NONCLUSTERED INDEX NUK_UJPROFA_LUPID ON user_job_profile_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_UJPROA_UID ON user_job_profile_aud(user_id)
GO

CREATE NONCLUSTERED INDEX NUK_UJPROFA_ABY ON user_job_profile_aud(assigned_by)
GO

CREATE NONCLUSTERED INDEX NUK_UOPPAYA_LUPID ON user_opt_pay_items_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_UOPTPAYA_UID ON user_opt_pay_items_aud(userid)
GO

CREATE NONCLUSTERED INDEX NUK_UOPTPAYA_TID ON user_opt_pay_items_aud(transcriptid)
GO

CREATE NONCLUSTERED INDEX NUK_VCLAUGEN_LUPID ON vc_launcher_generic_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_VCLAUNA_LUPID ON vc_launcher_gtt_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_VCLAUSEA_LUPID ON vc_launcher_session_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_VCLAUWA_LUPID ON vc_launcher_webex_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_WITHDEDA_LUPID ON withdraw_deduction_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_WITHRAA_LUPID ON withdraw_reason_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_WITHREAA_UID ON withdraw_reason_aud(user_id)
GO

CREATE NONCLUSTERED INDEX NUK_WITHREAA_TID ON withdraw_reason_aud(transcript_id)
GO

CREATE NONCLUSTERED INDEX NUK_WITHSA_LUPID ON withdrawnStudents_aud(last_updater_uid)
GO

CREATE NONCLUSTERED INDEX NUK_WITHSA_UID ON withdrawnStudents_aud(userid)
GO

CREATE NONCLUSTERED INDEX NUK_WITHSA_TID ON withdrawnStudents_aud(transcriptid)
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('20180312-kk-1', 'Krupa.Kamat', 'nschema/audit-table-enable.xml', GETDATE(), 1196, '8:b81246817433ab1e4be05c1bf15a2f40', 'createIndex indexName=NUK_ADESAUD_LSTUPDUID, tableName=AICC_des_aud; createIndex indexName=NUK_ALAUOPTA_LUPID, tableName=AICC_launch_options_aud; createIndex indexName=NUK_ANSDROPA_TID, tableName=answer_drag_and_drop_aud; createIndex indexName=NUK...', 'GDPR Story Audit Tables', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::20180526-ny-1::nelson.yip
CREATE NONCLUSTERED INDEX NUK_VCLAUVITAUD_LUPDID ON vc_launcher_vitero_aud(last_updater_uid)
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('20180526-ny-1', 'nelson.yip', 'nschema/audit-table-enable.xml', GETDATE(), 1197, '8:501bd2748d37b1585d9da533f2c4d478', 'createIndex indexName=NUK_VCLAUVITAUD_LUPDID, tableName=vc_launcher_vitero_aud', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Changeset nschema/audit-table-enable.xml::20200309-ps-1::paul.strugnell
CREATE NONCLUSTERED INDEX NUK_VCLAUMSTAUD_LUPDID ON vc_launcher_ms_teams_aud(last_updater_uid)
GO

INSERT INTO DATABASECHANGELOG (ID, AUTHOR, FILENAME, DATEEXECUTED, ORDEREXECUTED, MD5SUM, DESCRIPTION, COMMENTS, EXECTYPE, CONTEXTS, LABELS, LIQUIBASE, DEPLOYMENT_ID) VALUES ('20200309-ps-1', 'paul.strugnell', 'nschema/audit-table-enable.xml', GETDATE(), 1198, '8:0a1a69bca0a8f34b4fdf54a7ecd0e18a', 'createIndex indexName=NUK_VCLAUMSTAUD_LUPDID, tableName=vc_launcher_ms_teams_aud', '', 'EXECUTED', 'audit', NULL, '4.8.0', '8833558541')
GO

-- Release Database Lock
UPDATE DATABASECHANGELOGLOCK SET LOCKED = 0, LOCKEDBY = NULL, LOCKGRANTED = NULL WHERE ID = 1
GO

